% SelectAllMark
%
% Input  : none
% Output : none
% Example: SelectAllMark;

% Script for SelectAllMark
% History?F03.11.20 Ver2.01  Kusabuka?@multi probe (unused allmark button)

% added by Xu Cui

if info(dis_no).measure_mode(1)==1;%***** Stim Mode *****
    markname = 'ABCDEFGHIJ';
else
    markname = '123456789M';
end

figurePosition = [600,   100,    200 + floor((mark.num-1)/20)*120,    10 * 20 + 450];
figureBKcolor=get(0,'Defaultuicontrolbackgroundcolor');
f = figure('unit','pixel','position',figurePosition,'Color',figureBKcolor,'defaultuicontrolBackgroundColor', figureBKcolor,...
        'Name','Select Marker (Event)', 'NumberTitle','off','resize','on', 'visible','on');

checkbox = [];    
if ~isfield(mark, 'contrast')
    mark.contrast = zeros(size(mark.ave));
elseif length(mark.contrast) ~= length(mark.ave)
    mark.contrast = zeros(size(mark.ave));    
end
for ii=1:size(mark.point,1)
    
    if mark.contrast(ii) == 1
        bkcolor = 'g';
    elseif mark.contrast(ii) == -1
        bkcolor = 'r';        
    else
        bkcolor = figureBKcolor;
    end
    if info(dis_no).measure_mode(1)==1;%***** Stim Mode *****
        prefix = '';
    else
        prefix = 'F';
    end
    checkbox(ii) = uicontrol(f,'style','checkbox',... 
        'unit','pixel',...
        'string', sprintf('%d     %s%s     %.1f', mark.point(ii,1), prefix, markname(mark.point(ii,1)), mark.point(ii,2)/10),...
        'horizontal', 'right',...
        'backgroundcolor', bkcolor, ...
        'value', mark.ave(ii),...
        'position',[50 + floor((ii-1)/20)*120, figurePosition(4) - mod(ii-1,20)*20 - 30, 150, 20]);
end
uicontrol(f,'style','text',... 
        'unit','pixel',...
        'string', 'Custom event',...
        'horizontal', 'center',...
        'position',[10, 200, 100, 20]);
eventVariableEdit = uicontrol(f,'style','edit',... 
        'unit','pixel',...
        'string', 'e',...
        'horizontal', 'center',...
        'backgroundcolor', 'w',...
        'position',[120, 200, 50, 20]);
uicontrol(f,'style','push',... 
        'unit','pixel',...
        'string', 'Get',...
        'horizontal', 'right',...
        'position',[170, 200, 50, 20],...
        'callback', 'event=evalin(''base'',get(eventVariableEdit,''string''));event(:,2) = event(:,2)*10; mark.point=event;count=size(mark.point,1);mark.num=count;mark.move=zeros(1,count);mark.ave=ones(1,count);mark.contrast=zeros(1,count);mark=rmfield(mark,''char'');close(gcf);SelectAllMark;');    
uicontrol(f,'style','push',... 
        'unit','pixel',...
        'string', '?',...
        'horizontal', 'right',...
        'position',[220, 200, 50, 20],...
        'callback', 'disp(''e is a variable in your work space and it has to be a Nx2 matrix. N is number of events. The first column is event type, can be 1,2,3,... The 2nd column is event timing in seconds. Please note, in topo, time 0s means the start of prescan, and time 10s means the end of prescan. If you get timing data using readHitachData.m, you need add 10s.'')');        
uicontrol(f,'style','checkbox',... 
        'unit','pixel',...
        'string', 'Select All/None',...
        'horizontal', 'right',...
        'position',[50, 170, 150, 20],...
        'callback', 'for ii=1:length(checkbox); set(checkbox(ii),''value'', get(gco, ''value'')); end');
uicontrol(f,'style','push',... 
        'unit','pixel',...
        'string', 'Select',...
        'horizontal', 'right',...
        'position',[50, 150, 50, 20],...
        'callback', 'for ii=1:length(checkbox); if mark.point(ii,1)==str2num(get(eventEdit, ''string'')); set(checkbox(ii),''value'', 1); end; end;');    
eventEdit = uicontrol(f,'style','edit',... 
        'unit','pixel',...
        'string', '1',...
        'horizontal', 'center',...
        'backgroundcolor', 'w',...
        'position',[100, 150, 50, 20]);
uicontrol(f,'style','text',... 
        'unit','pixel',...
        'string', 'Contrast',...
        'horizontal', 'center',...
        'position',[50, 110, 50, 20]);
contrastP = uicontrol(f,'style','push',... 
        'unit','pixel',...
        'string', '+',...
        'horizontal', 'right',...
        'position',[50, 90, 50, 20],...
        'callback', 'for ii=1:length(checkbox); if mark.point(ii,1)==str2num(get(contrastPEdit, ''string'')); if all(get(checkbox(ii),''backgroundcolor'')==[0 1 0]); set(checkbox(ii),''backgroundcolor'', figureBKcolor); else; set(checkbox(ii),''backgroundcolor'', ''g''); end; end; end');    
contrastPEdit = uicontrol(f,'style','edit',... 
        'unit','pixel',...
        'string', '1',...
        'horizontal', 'center',...
        'backgroundcolor', 'w',...        
        'position',[100, 90, 50, 20]);
contrastN = uicontrol(f,'style','push',... 
        'unit','pixel',...
        'string', '-',...
        'horizontal', 'right',...
        'position',[50, 70, 50, 20],...
        'callback', 'for ii=1:length(checkbox); if mark.point(ii,1)==str2num(get(contrastNEdit, ''string'')); if all(get(checkbox(ii),''backgroundcolor'')==[1 0 0]); set(checkbox(ii),''backgroundcolor'', figureBKcolor); else; set(checkbox(ii),''backgroundcolor'', ''r''); end; end; end');
contrastNEdit = uicontrol(f,'style','edit',... 
        'unit','pixel',...
        'string', '2',...
        'horizontal', 'center',...
        'backgroundcolor', 'w',...        
        'position',[100, 70, 50, 20]);    
uicontrol(f,'style','push',... 
        'unit','pixel',...
        'string', 'OK',...
        'horizontal', 'right',...
        'position',[50, 20, 100, 30],...
        'callback', 'for ii=1:length(checkbox); mark.ave(ii) = get(checkbox(ii), ''value''); tmp = get(checkbox(ii), ''backgroundcolor''); if all(tmp==[0 1 0]);  mark.contrast(ii) = 1; elseif all(tmp==[1 0 0]);  mark.contrast(ii) = -1; else; mark.contrast(ii)=0;end; end; input_mark; close(f)');    

if length(unique(mark.point(:,1))) == 1
    set(contrastP, 'enable', 'off');
    set(contrastPEdit, 'enable', 'off');
    set(contrastN, 'enable', 'off');
    set(contrastNEdit, 'enable', 'off');    
end
    
