% ad_fit_graph
%
% Input  : info,ad_data,mark,para,Sel_graph
% Output : None
% Example: ad_fit_graph(info,ad_data,mark,para,Sel_graph); 

%*******************************************************
%*           Plot AD Fitting Graph Function            *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF02.11.11 Ver1.01  Futahaxhi KL conversion function is added.
% HistoryF03.05.06 Ver2.00  Isawa     A  display is changed into point->sec.
% HistoryF03.11.18 Ver2.01  Kusabuka  multi probe 
% HistoryF04.02.14 Ver2.04  Kusabuka  err suuport

function ad_fit_graph(info,ad_data,mark,para,para_p,Sel_graph); 

%fprintf('ad_fit_graph\n');

if para.sel_move == 0;
   add_mark  = find(mark.ave==1);
else;
   add_mark  = find(mark.ave==1 & mark.move==0);
end;
if isempty(add_mark)==1;
   warndlg('Please Select Mark!','Warning');
   err_flg=1;
end;
m_cnt=length(add_mark);
% %********** mark stim time cheak ***********
% info(Sel_graph).measure_mode(1)==1;
% for cnt=1:length(add_mark);
%    stim_time(cnt)=mark.point(add_mark(cnt),3)-mark.point(add_mark(cnt),2);
%   if cnt > 1;
%      if stim_time(cnt-1) ~= stim_time(cnt);
%         warndlg('Stimulus time is different.!','Warning');
%         err_flg=1;
%         return;
%      end;
%    end;
% end;      

if info(Sel_graph).measure_mode(1)==1;block = mark.point(add_mark(1),3)-mark.point(add_mark(1),2)+para.pre+para.post+para.relax;end;
if info(Sel_graph).measure_mode(1)==2;block = 1+para.pre+para.post+para.relax;end;
%del_fig(22+(Sel_graph-1),22+(Sel_graph-1));
fit_fig = figure(22+(Sel_graph-1));
clf;
plotedit(fit_fig,'hidetoolsmenu');
set(fit_fig,'Name',sprintf('A/D Fitting Graph Probe %d',Sel_graph),'ToolBar','none');
set(fit_fig,'Units','points');
posi = get(fit_fig,'Position');
% Ver 2.00 ->
% In order to change a display with [sec], it x-label-creates.
TimeMin = 0;
TimeMax = block;
TimeStep = floor((TimeMax-TimeMin)/4);
for i=0:4;
   lab(i+1) = (TimeMin*(info(Sel_graph).smpl_period/1000) + (TimeStep*(info(Sel_graph).smpl_period/1000)) * i);
end;
clear i;

for i = 1:m_cnt;
   %********* 780nm **********
   subplot(m_cnt,2,2*i-1);
   box on;
   plot([para.pre para.pre],[-10 10],'Color',[0.1 0.1 0.1]);
   hold on;
%   if i==1;title(['780nm[V]:',['AD',int2str(info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1)]],'Fontsize',8);end;
   if i==1;title([ad_data(Sel_graph).title1,'nm[V]:',['AD',int2str(info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1)]],'Fontsize',8);end;
   if info(Sel_graph).measure_mode(1)==1;
      % Ver 2.00 ->
      %The drawing range of y-axis is changed into the data range from fixation.
      plot([block-para.relax-para.post block-para.relax-para.post],[min(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1,i))-0.1 max(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1,i))+0.1],'Color',[0.1 0.1 0.1]);
      %plot([block-para.relax-para.post block-para.relax-para.post],[-10 10],'Color',[0.1 0.1 0.1]);
      % Ver 2.00 <-
   end;
   
   plot(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1,i),'k');
   plot(ad_data(Sel_graph).fit(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1,i),'r');
   axis([0 block min(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1,i))-0.1 max(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch-1)+1,i))+0.1]);

   ylabel(strcat('Mark:',int2str(i)),'Fontsize',para_p.fsize);
%   set(gca,'XLim',[TimeMin TimeMax]);
   set(gca,'xtick',TimeMin:TimeStep:TimeMax);
   set(gca,'xticklabel',lab);
   set(gca,'Fontsize',para_p.fsize);
   % Ver 2.00 ->
   % A display is changed with [sec].
   %xlabel('point');
   if i == m_cnt;
      xlabel('sec','Fontsize',para_p.fsize);
   end;
   hold off;
   clear gco;

   %********* 830nm ********** 
%   gco = axes(mark.num,2,2*i);
   subplot(m_cnt,2,2*i);

   box on;
   plot([para.pre para.pre],[-10 10],'Color',[0.1 0.1 0.1]);
   hold on;
%   if i==1;title(['830nm[V]:',['AD',int2str(info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1)]],'Fontsize',8);end;   
   if i==1;title([ad_data(Sel_graph).title2,'nm[V]:',['AD',int2str(info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1)]],'Fontsize',8);end;   
   if info(Sel_graph).measure_mode(1)==1;
      % Ver 2.00 ->
      % The drawing range of y-axis changed into the data range from fixation.
      plot([block-para.relax-para.post block-para.relax-para.post],[min(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1,i))-0.1 max(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1,i))+0.1],'Color',[0.1 0.1 0.1]);
      %plot([block-para.relax-para.post block-para.relax-para.post],[-10 10],'Color',[0.1 0.1 0.1]);
      % Ver 2.00 <-
   end;      
    
   plot(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1,i),'k');
   plot(ad_data(Sel_graph).fit(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1,i),'r');
   axis([0 block min(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1,i))-0.1 max(ad_data(Sel_graph).seg(:,info(Sel_graph).adnmpn(2*info(Sel_graph).sel_ch)+1,i))+0.1]);   

   ylabel(strcat('Mark:',int2str(i)),'Fontsize',para_p.fsize);
%   set(gca,'XLim',[TimeMin TimeMax]);
   set(gca,'xtick',TimeMin:TimeStep:TimeMax);
   set(gca,'xticklabel',lab);
   set(gca,'Fontsize',para_p.fsize);
   % Ver 2.00 ->
   % A display is changed with [sec].
   %xlabel('point');
   if i == m_cnt;
      xlabel('sec','Fontsize',para_p.fsize);
   end;
   hold off;   
end;

%************** file out **************
ad_graph_h(Sel_graph).fit.fout = uicontrol('Parent',fit_fig,...
          'Units','points',...
          'BackgroundColor',[0.75 0.75 0.75], ...
          'Position',[posi(3)-35 0 35 14],...
          'String','FileOut',...
          'Callback',['if move_stop == 1;',...
                        'Sel_graph=get(gca,''Parent'')-(22-1);',...
                        'fout_fit(info,para,para_p,mark,ad_data,Sel_graph);',...
                      'else;',...
                        'warndlg(''Please push a stop button.'',''Warning !!'');',...
                      'end;',...
          ],...
          'Tag','Pushbutton1');

clear gco;
