% ad_graph
%
% Input  : info,ad_data,mark,para_p
% Output : ad_graph_h
% Example: [ad_graph_h] = ad_graph(info,ad_data,mark,para_p)

%*******************************************************
%*               Plot AD Graph Function                *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% History?F02.11.11 Ver1.01 futahasi  KL conversion function is added.
% History?F03.05.06 Ver2.00 Isawa     disp point->sec
% History?F03.11.12 Ver2.01 Kusabuka  multi probe
% History?F04.06.17 Ver2.03 Kusabuka  no load Message add

function [ad_graph_h] = ad_graph(info,ad_data,mark,para_p);
wh = waitbar(0,'Please wait...');
%*************** Timecourse graph ****************
data_cnt = 0;

%fprintf('ad_graph\n');
del_fig(2,6);

for p_cnt=1:para_p.max_prb;					% Probe loop
   waitbar(p_cnt/para_p.max_prb,wh);
   Sel_graph=p_cnt;
      ad_graph_h(Sel_graph).ad.min      = 0;
      ad_graph_h(Sel_graph).ad.max      = 5;
      ad_graph_h(Sel_graph).time.min = 0;
      ad_graph_h(Sel_graph).time.max = 0;

%fprintf('Sel_graph=%d\n',Sel_graph);
   if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
   elseif(p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) |(p_cnt==4 & para_p.load_prb4 ~=1) |(p_cnt==5 & para_p.load_prb5 ~=1);    
   else;
      [ad_graph_h] = ad_posi_set(info,ad_graph_h,Sel_graph);   % ad graph position
      %**************** init ******************
      ad_graph_h(Sel_graph).time.min = 1;
      ad_graph_h(Sel_graph).time.max = info(p_cnt).datanum;
      
      % Figure Fixation
      data_cnt = data_cnt+1;
      ad_graph_fig = figure(2+(p_cnt-1));
      clf;
      set(ad_graph_fig,'Name',sprintf('AD Graph Probe %d',p_cnt));
      plotedit(ad_graph_fig,'hidetoolsmenu');
      set(ad_graph_fig,'Units','points');
      ad_posi = get(ad_graph_fig,'Position');
%       ad_posi(1) = ad_posi(1)+((p_cnt-1)*10);
%       ad_posi(4) = ad_posi(4)+ad_posi(4)*0.1;
      
      %************** Axes control ******************
      % Only the control which attached the tag of 'axes' and 'axes_ext' is set up.
      TimeMin = ad_graph_h(Sel_graph).time.min*(info(p_cnt).smpl_period/1000);
      TimeMax = ad_graph_h(Sel_graph).time.max*(info(p_cnt).smpl_period/1000);
      TimeStep = floor(((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)*(info(p_cnt).smpl_period/1000))/4);
      for i=0:4;
         lab(i+1) = TimeMin + TimeStep * i;
      end;
%       h=get(gcf,'children');
%       for i=1:size(h);
%          tag = get(h(i),'Tag');
%          if strcmp('axes',tag) == 1;
%             set(h(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
%             set(h(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
%             set(h(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
%             set(h(i),'xticklabel','');
%             set(h(i),'fontsize',5)
%          end;
%          if strcmp('axes_ext',tag) == 1;
%             set(h(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
%             set(h(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
%             set(h(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
%             set(h(i),'xticklabel',lab);
%             set(h(i),'fontsize',5)
%          end;
%       end;


      %***** AD Data *****
      for i=1:info(p_cnt).ad_ch_max;
         ad_graph_h(Sel_graph).map_gco(i) = axes('Position',ad_graph_h(p_cnt).ad_pos(i).p);
         hold on;
         plot(ad_data(p_cnt).raw(:,i),'k');
         % A tag is attached and put on graph.
         set(ad_graph_h(Sel_graph).map_gco(i),'Tag','axes');
         box on;

         if i==1;work=sprintf('%s nm[V]',ad_data(p_cnt).title1);title(work,'FontSize',10);end;
         if i==2;work=sprintf('%s nm[V]',ad_data(p_cnt).title2);title(work,'FontSize',10);end;
         
         % The font size of y-label is specified.
         if i == 1 | i == 2;
            ylabel(['AD',int2str(i)],'FontSize',para_p.fsize);
         else;
            ylabel(int2str(i),'FontSize',para_p.fsize);
         end;
         % x-label is deleted in order to consider only the graph displayed at the bottom as a display.
         %xlabel('point');
         %xlabel('sec');
         for j=1:mark.num;
            if mark.point(j)==1;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[0 1 0]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[0 1 0]);end;
            elseif mark.point(j)==2;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[1 1 0]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[1 1 0]);end;
            elseif mark.point(j)==3;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[0 1 1]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[0 1 1]);end;
            elseif mark.point(j)==4;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[1 0.7 0]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[1 0.7 0]);end;
            elseif mark.point(j)==5;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[0.7 0.35 0.35]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[0.7 0.35 0.35]);end;
            elseif mark.point(j)==6;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[0 0.54 1]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[0 0.54 1]);end;
            elseif mark.point(j)==7;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[1 0.3 0]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[1 0.3 0]);end;
            elseif mark.point(j)==8;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[0.5 0.5 0]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[0.5 0.5 0]);end;
            elseif mark.point(j)==9;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[0 0.5 0.5]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[0 0.5 0.5]);end;
            elseif mark.point(j)==10;
               plot([mark.point(j,2)' mark.point(j,2)'],[0 5],'Color',[1 0 1]);
               if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[0 5],'Color',[1 0 1]);end;
            end;
         end;
            set(ad_graph_h(Sel_graph).map_gco(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(ad_graph_h(Sel_graph).map_gco(i),'xtick',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(ad_graph_h(Sel_graph).map_gco(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
            set(ad_graph_h(Sel_graph).map_gco(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
            set(ad_graph_h(Sel_graph).map_gco(i),'xticklabel','');
            set(ad_graph_h(Sel_graph).map_gco(i),'fontsize',para_p.fsize)
%         axis([info(p_cnt).smpl_period info(p_cnt).datanum ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
         box off;
         hold off;  
      end;

      %***** External Data *****
      if info(p_cnt).probe_mode == 4;  % 3x11
%         ad_graph_h(Sel_graph).map_gco(i) = axes(53,2,i);
         for i=105:106;
            ad_graph_h(Sel_graph).map_gco_ext(i) = axes('Position',ad_graph_h(p_cnt).ad_pos(i).p);
            hold on;
            plot(ad_data(p_cnt).raw(:,i),'k');
            % A tag is attached and put on graph
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'Tag','axes_ext');
            % box on chenge
            box on;
            %hold on;  
            % Font size is specified
            if i==105;ylabel('Ext1','FontSize',para_p.fsize);end;
            if i==106;ylabel('Ext2','FontSize',para_p.fsize);end;

            % Ver 2.00 <-
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'xticklabel','');
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'fontsize',para_p.fsize)
%            axis([0 info(p_cnt).datanum 0 5]);
            box off;
            hold off;
         end;
      elseif info(p_cnt).probe_mode == 5;  % 3x10
         for i=95:96;
            ad_graph_h(Sel_graph).map_gco_ext(i) = axes('Position',ad_graph_h(p_cnt).ad_pos(i).p);
            hold on;
            plot(ad_data(p_cnt).raw(:,i),'k');
            % A tag is attached and put on graph
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'Tag','axes_ext');
            % box on chenge
            box on;
            %hold on;  
            % Font size is specified
            if i==95;ylabel('Ext1','FontSize',para_p.fsize);end;
            if i==96;ylabel('Ext2','FontSize',para_p.fsize);end;

            % Ver 2.00 <-
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'xticklabel','');
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'fontsize',para_p.fsize)
            box off;
            hold off;
         end;
      else;
%         ad_graph_h(Sel_graph).map_gco(i) = axes(25,2,i);
         for i=49:50;
            % Ver 2.00 ->
            ad_graph_h(Sel_graph).map_gco_ext(i) = axes('Position',ad_graph_h(p_cnt).ad_pos(i).p);
            %axes(25,2,i);
            % Ver 2.00 <-
            hold on;
            plot(ad_data(p_cnt).raw(:,i),'k');
           % A tag is attached and put on graph
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'Tag','axes_ext');
            % box on chenge
            box on;
            %hold on;  
            % Font size is specified
            if i==49;ylabel('Ext1','FontSize',para_p.fsize);end;
            if i==50;ylabel('Ext2','FontSize',para_p.fsize);end;    

            % Ver 2.00 <-
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'xticklabel','');
            set(ad_graph_h(Sel_graph).map_gco_ext(i),'fontsize',para_p.fsize)
%            axis([0 info(p_cnt).datanum 0 5]);
            box off;
            hold off;
         end;   
      end;

      %************** Text Edit ******************
      ad_graph_h(Sel_graph).unit.y_min = uicontrol('Parent',ad_graph_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 ad_posi(4)/2-ad_posi(4)/4 40 14],...
               'Style','edit',...
               'String',ad_graph_h(Sel_graph).ad.min,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(2-1);',...             % graph No.
   			               'val=str2num(get(ad_graph_h(Sel_graph).unit.y_min,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(ad_graph_h(Sel_graph).unit.y_min,''string''));',...
                              'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val >= ad_graph_h(Sel_graph).ad.max | val < 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'ad_graph_h(Sel_graph).ad.min=val;',...   % Ver 2.00 <-
                                 'for i=1:info(Sel_graph).ad_ch_max+2;',...
                                    'set(h(i),''YLim'',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);',...
                                 'end;',...
                              'end;',...
                              'set(ad_graph_h(Sel_graph).unit.y_min,''string'', ad_graph_h(Sel_graph).ad.min);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(ad_graph_h(Sel_graph).unit.y_min,''string'', ad_graph_h(Sel_graph).ad.min);',...
                           'end;',...
                           'clear h;clear i;clear val;'],...
               'Tag','EditText1');

      ad_graph_h(Sel_graph).unit.y_unit = uicontrol('Parent',ad_graph_fig,...
               'Units','points',...
               'Position',[1 ad_posi(4)/2+ad_posi(4)/4+14 40 10],...
               'BackgroundColor',[0.8 0.8 0.8],...
	            'Style','text',...
               'String','V',...% Ver 2.00 -><-
	            'Tag','tag2');

      ad_graph_h(Sel_graph).unit.y_max = uicontrol('Parent',ad_graph_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 ad_posi(4)/2+ad_posi(4)/4 40 14],...
               'Style','edit',...
               'String',ad_graph_h(Sel_graph).ad.max,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(2-1);',...             % graph No.
                           'val=str2num(get(ad_graph_h(Sel_graph).unit.y_max,''string''));',... % Ver 2.00 ->
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(ad_graph_h(Sel_graph).unit.y_max,''string''));',...
                              'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val <= ad_graph_h(Sel_graph).ad.min | val > 5;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'ad_graph_h(Sel_graph).ad.max=val;',... % Ver 2.00 <-
                                 'for i=1:info(Sel_graph).ad_ch_max+2;',...
                                    'set(h(i),''YLim'',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);',...
                                 'end;',...
                              'end;',...
                              'set(ad_graph_h(Sel_graph).unit.y_max,''string'', ad_graph_h(Sel_graph).ad.max);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(ad_graph_h(Sel_graph).unit.y_max,''string'', ad_graph_h(Sel_graph).ad.max);',...
                           'end;',...
                           'clear h;clear i;clear val;'],...
               'Tag','EditText2');
%               'Position',[2 265 30 15],...

      ad_graph_h(Sel_graph).unit.t_min = uicontrol('Parent',ad_graph_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[ad_posi(3)/2-ad_posi(3)/4 2 40 14],...
               'Style','edit',...
               'String',ad_graph_h(Sel_graph).time.min*info(Sel_graph).smpl_period/1000,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(2-1);',...
                           'val=str2num(get(ad_graph_h(Sel_graph).unit.t_min,''string''));',... % Ver 2.00 ->
                           'if length(val) ~= 0;',...
                              'val = round(val*10)/10;',...
                              'val=val/(info(Sel_graph).smpl_period/1000);',...
                              'ret=strchknum(get(ad_graph_h(Sel_graph).unit.t_min,''string''));',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val >= ad_graph_h(Sel_graph).time.max | val < 1;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'ad_graph_h(Sel_graph).time.min=val;',...
                                 'TimeMin = ad_graph_h(Sel_graph).time.min*(info(Sel_graph).smpl_period/1000);',...  
                                 'TimeMax = ad_graph_h(Sel_graph).time.max*(info(Sel_graph).smpl_period/1000);',...
                                 'TimeStep = floor(((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)*(info(Sel_graph).smpl_period/1000))/4);',...
                                 'for i=0:4; lab(i+1) = TimeMin + TimeStep * i;end;',...
                                 'for i=1:info(Sel_graph).ad_ch_max+2;',...
                                     'set(h(i),''YLim'',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);',...
                                     'set(h(i),''XLim'',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);',...
                                     'set(h(i),''xtick'',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);',...
                                     'if i>2;set(h(i),''xticklabel'','''');',...
                                     'else;set(h(i),''xticklabel'',lab);',...
                                     'end;',...
                                 'end;',...
                              'end;',...
                               'set(ad_graph_h(Sel_graph).unit.t_min,''string'', ad_graph_h(Sel_graph).time.min*info(Sel_graph).smpl_period/1000);',...
                              'clear ret;',...
                           'else;',...
                               'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                               'set(ad_graph_h(Sel_graph).unit.t_min,''string'', ad_graph_h(Sel_graph).time.min*info(Sel_graph).smpl_period/1000);',...
                           'end;',...
                           'clear h;clear i;clear TimeMax; clear TimeMin; clear TimeStep; clear lab; clear val;'],...   % Ver 2.00 <-
                           'Tag','EditText1');
%                                         'if i>2; set(h(i),''xticklabel'','''');',...
%                                         'else; set(h(i),''xticklabel'',lab);',...
%                                        'end;',...

      ad_graph_h(Sel_graph).unit.t_max = uicontrol('Parent',ad_graph_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[ad_posi(3)/2+ad_posi(3)/4 2 40 14],...
               'Style','edit',...
               'String',ad_graph_h(Sel_graph).time.max*info(Sel_graph).smpl_period/1000,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(2-1);',...
                           'val=str2num(get(ad_graph_h(Sel_graph).unit.t_max,''string''));',... % Ver 2.00 ->
                           'if length(val) ~= 0;',...
                              'val = round(val*10)/10;',...
                              'val=val/(info(Sel_graph).smpl_period/1000);',...
                              'ret=strchknum(get(ad_graph_h(Sel_graph).unit.t_max,''string''));',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val <= ad_graph_h(Sel_graph).time.min | val > info(Sel_graph).datanum;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'ad_graph_h(Sel_graph).time.max=val;',...
                                 'TimeMin = ad_graph_h(Sel_graph).time.min*(info(Sel_graph).smpl_period/1000);',...  
                                 'TimeMax = ad_graph_h(Sel_graph).time.max*(info(Sel_graph).smpl_period/1000);',...
                                 'TimeStep = floor(((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)*(info(Sel_graph).smpl_period/1000))/4);',...
                                 'for i=0:4; lab(i+1) = TimeMin + TimeStep * i; end;',...
                                 'for i=1:info(Sel_graph).ad_ch_max+2;',...
                                    'set(h(i),''YLim'',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);',...
                                    'set(h(i),''XLim'',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);',...
                                    'set(h(i),''xtick'',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);',...
                                    'if i>2;set(h(i),''xticklabel'','''');',...
                                    'else;set(h(i),''xticklabel'',lab);',...
                                    'end;',...
                                 'end;',...
                              'end;',...
                              'set(ad_graph_h(Sel_graph).unit.t_max,''string'', ad_graph_h(Sel_graph).time.max*info(Sel_graph).smpl_period/1000);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(ad_graph_h(Sel_graph).unit.t_max,''string'', ad_graph_h(Sel_graph).time.max*info(Sel_graph).smpl_period/1000);',...
                           'end;',...
                           'clear h;clear i;clear TimeMax; clear TimeMin; clear TimeStep; clear lab; clear val;'],...   % Ver 2.00 <-
                        'Tag','EditText2');
%                                     'if i>2;set(h(i),''xticklabel'','''');',...
%                                     'else;set(h(i),''xticklabel'',lab);',...
%                                     'end;',...

      ad_graph_h(Sel_graph).unit.t_unit = uicontrol('Parent',ad_graph_fig,...
                        'Units','points',...
                        'Position',[ad_posi(3)/2 2 30 10],...
                        'BackgroundColor',[0.8 0.8 0.8],...
	                     'Style','text',...
                        'String','sec',...% Ver 2.00 -><-
	                     'Tag','tag2');
      % Ver 2.00 ->
      % Diaplay at [sec]
%       %************** Axes control ******************
%       % Only the control which attached the tag of 'axes' and 'axes_ext' is set up.
      TimeMin = ad_graph_h(Sel_graph).time.min*(info(p_cnt).smpl_period/1000);
      TimeMax = ad_graph_h(Sel_graph).time.max*(info(p_cnt).smpl_period/1000);
      TimeStep = floor(((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)*(info(p_cnt).smpl_period/1000))/4);
      for i=0:4;
         lab(i+1) = TimeMin + TimeStep * i;
      end;
      h=get(gcf,'children');
      for i=1:size(h);
         tag = get(h(i),'Tag');
         if strcmp('axes',tag) == 1;
            set(h(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(h(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
            set(h(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
            set(h(i),'xticklabel','');
            set(h(i),'fontsize',para_p.fsize)
         end;
         if strcmp('axes_ext',tag) == 1;
            set(h(i),'YLim',[ad_graph_h(Sel_graph).ad.min ad_graph_h(Sel_graph).ad.max]);
            set(h(i),'XLim',[ad_graph_h(Sel_graph).time.min ad_graph_h(Sel_graph).time.max]);
            set(h(i),'xtick',ad_graph_h(Sel_graph).time.min:floor((ad_graph_h(Sel_graph).time.max-ad_graph_h(Sel_graph).time.min)/4):ad_graph_h(Sel_graph).time.max);
            set(h(i),'xticklabel',lab);
            set(h(i),'fontsize',para_p.fsize)
         end;
      end;
      
      %************** file out **************
      ad_graph_h(Sel_graph).unit.fout = uicontrol('Parent',ad_graph_fig,...
          'Units','points',...
          'BackgroundColor',[0.75 0.75 0.75], ...
          'Position',[ad_posi(3)-35 0 35 14],...
          'String','FileOut',...
          'Callback',['if move_stop == 1;',...
                        'Sel_graph=get(gca,''Parent'')-(2-1);',...
                        'fout_ad(info,para,para_p,mark,ad_data,Sel_graph);',...
                      'else;',...
                        'warndlg(''Please push a stop button.'',''Warning !!'');',...
                      'end;',...
          ],...
          'Tag','Pushbutton1');
      %************** refresh **************
      ad_graph_h(Sel_graph).unit.ad_ref = uicontrol('Parent',ad_graph_fig, ...
               'Units','points', ...
               'BackgroundColor',[1.0 0.9 0.1], ...
               'Position',[1 1 35 14], ...
               'String','Refresh',...
               'Callback',['ad_posi=get(gcf,''Position'');',...
                           'Sel_graph=get(gca,''Parent'')-1;',...
                           'set(ad_graph_h(Sel_graph).unit.y_unit,''Position'',[1 ad_posi(4)/2+ad_posi(4)/4+14 40 10]);',...
                           'set(ad_graph_h(Sel_graph).unit.y_max,''Position'',[1 ad_posi(4)/2+ad_posi(4)/4 40 14]);',...
                           'set(ad_graph_h(Sel_graph).unit.y_min,''Position'',[1 ad_posi(4)/2-ad_posi(4)/4 40 14]);',...
                           'set(ad_graph_h(Sel_graph).unit.t_max,''Position'',[ad_posi(3)/2+ad_posi(3)/4 2 40 14]);',...
                           'set(ad_graph_h(Sel_graph).unit.t_min,''Position'',[ad_posi(3)/2-ad_posi(3)/4 2 40 14]);',...
                           'set(ad_graph_h(Sel_graph).unit.t_unit,''Position'',[ad_posi(3)/2 2 30 10]);',...
                           'set(ad_graph_h(Sel_graph).unit.fout,''Position'',[ad_posi(3)-35 0 35 14]);',...
                           'clear ad_posi;',...
                          ],...
                'Tag','Pushbutton3');
      clear h; clear tag;
      clear TimeMax; clear TimeMin; clear TimeStep; clear lab;
   end;
end;
close(wh);
clear wh;
if  (para_p.load_prb1 == 0 & para_p.load_prb2 ==0 & para_p.load_prb3 ==0 ...
       & para_p.load_prb4 == 0 & para_p.load_prb5 ==0);
   warndlg('Please read data.','Warning'); 
   return;
elseif data_cnt == 0;
   warndlg('Warning Probe Select!  Please choose the Probe No.','Warning');
end;

%added by xu cui

for p_cnt=1:para_p.max_prb;
    if info(p_cnt).ad_ch_max
        f = figure('name', ['Probe set ' num2str(p_cnt)]);
        Maximize(f);
    end
    for i=1:info(p_cnt).ad_ch_max;
        scrollsubplot(6, 2, i);
        plot(ad_data(p_cnt).raw(:,i),'k');
        if mod(i,2)==1
            ylabel(['CH ' num2str(floor((i+1)/2)) ', 695'])
        else
            ylabel(['CH ' num2str(floor((i+1)/2)) ', 830'])
        end
        %legend(num2str(floor((i+1)/2)))
    end
end
for p_cnt=1:para_p.max_prb;
    if info(p_cnt).ad_ch_max
        f = figure('name', ['FFT: Probe set ' num2str(p_cnt)]);
        Maximize(f);
    end
    for i=1:info(p_cnt).ad_ch_max;
        scrollsubplot(6, 2, i);
        y = ad_data(p_cnt).raw(:,i);
        z = abs(fft(y - mean(y)));
        %z = z.^2;
        x = [0:length(z)-1]/length(z) * 10;
        plot(x(1:floor(length(x)/2)),z(1:floor(length(x)/2)),'k');
        if mod(i,2)==1
            ylabel(['CH ' num2str(floor((i+1)/2)) ', 695'])
        else
            ylabel(['CH ' num2str(floor((i+1)/2)) ', 830'])
        end
        %legend(num2str(floor((i+1)/2)))
    end
end