% calc_cont
%
% Input  : info,ad_data,para,para_p
% Output : hb_data,para_p,err_flg
% Example: [hb_data,para_p,err_flg] = calc_cont(info,ad_data,para,para_p);

%*******************************************************
%*         Make Continuous Hb Data Function            *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% History?F03.11.07 Ver2.01  Kusabuka multi probe 
% History?F04.06.17 Ver2.03 Kusabuka  no load Message add

function [hb_data,para_p,err_flg] = calc_cont(info,ad_data,para,para_p); 
wh = waitbar(0,'Please wait...');
clear hb_data;

data_cnt = 0;
err_flg=0;
%hb_data = struct('ana_mode',{'','','','',''},'calc_flg',{'','','','',''},'raw',{'','','','',''},'fil',{'','','','',''});
hb_data = struct('ana_mode',{'','','','',''},'calc_flg',{'','','','',''});
%fprintf('calc_cont\n');
for p_cnt=1:para_p.max_prb;
   hb_data(p_cnt).ana_mode = 1;
   hb_data(p_cnt).calc_flg = 1;
   waitbar(p_cnt/para_p.max_prb,wh);
   if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | ...
         (p_cnt==3 & para_p.sel_prb3 ~=1) | (p_cnt==4 & para_p.sel_prb4 ~=1) | ...
         (p_cnt==5 & para_p.sel_prb5 ~=1);
   elseif (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | ...
         (p_cnt==3 & para_p.load_prb3 ~=1) |(p_cnt==4 & para_p.load_prb4 ~=1) |...
         (p_cnt==5 & para_p.load_prb5 ~=1);
   elseif para.base_ed > info(p_cnt).datanum;
      warndlg('Input Base End time is too long!','Warning');
      err_flg=1;
      break;
   elseif para.base_st > para.base_ed ;
      warndlg('Input Base time is wrong.!','Warning');
      err_flg=1;
      break;
   else
      if p_cnt==1;  para_p.cal_flg1 = 1;end;
      if p_cnt==2;  para_p.cal_flg2 = 1;end;
      if p_cnt==3;  para_p.cal_flg3 = 1;end;
      if p_cnt==4;  para_p.cal_flg4 = 1;end;
      if p_cnt==5;  para_p.cal_flg5 = 1;end;
      %********** Cal Cont Hb Data **********
      data_cnt = data_cnt+1;
      fprintf('Probe %d calculation.\n',p_cnt);
      for hb_ch = 1:(info(p_cnt).ad_ch_max/2);
         clear ad_ch_780;
         clear ad_ch_830;
         clear data_fit_780;
         clear data_fit_830;

         ad_ch_780 = info(p_cnt).adnmpn(2*hb_ch-1)+1;
         ad_ch_830 = info(p_cnt).adnmpn(2*hb_ch)+1;
   


         wlen_780     = round(info(p_cnt).wlen(ad_ch_780));
         wlen_830     = round(info(p_cnt).wlen(ad_ch_830));
         data_fit_780 = mean(ad_data(p_cnt).raw([para.base_st:para.base_ed],ad_ch_780));
         data_fit_830 = mean(ad_data(p_cnt).raw([para.base_st:para.base_ed],ad_ch_830));
   
         eoxy_780 = para.e_coef(find(para.e_coef(:,1)==wlen_780),3);
         eoxy_830 = para.e_coef(find(para.e_coef(:,1)==wlen_830),3);
         edeo_780 = para.e_coef(find(para.e_coef(:,1)==wlen_780),2);
         edeo_830 = para.e_coef(find(para.e_coef(:,1)==wlen_830),2);
   
         for j = 1:info(p_cnt).datanum;
            %****** 780nm Fitting ******
            if ((ad_data(p_cnt).raw(j,ad_ch_780)>0 & data_fit_780>0) | (ad_data(p_cnt).raw(j,ad_ch_780)<0 & data_fit_780<0));
               a_780 = log(data_fit_780/ad_data(p_cnt).raw(j,ad_ch_780));
            else;
               a_780 = 0;
            end;
      
            %****** 830nm Fitting ******
            if ((ad_data(p_cnt).raw(j,ad_ch_830)>0 & data_fit_830>0) | (ad_data(p_cnt).raw(j,ad_ch_830)<0 & data_fit_830<0));
               a_830 = log(data_fit_830/ad_data(p_cnt).raw(j,ad_ch_830));
            else;
               a_830 = 0;
            end;
      
            %****** Oxy Hb ******
            if ((eoxy_780*edeo_830 - eoxy_830*edeo_780)==0);
               hb_data(p_cnt).raw(1,j,hb_ch) = 0;
            else;
               hb_data(p_cnt).raw(1,j,hb_ch) = (a_780*edeo_830 - a_830*edeo_780)/(eoxy_780*edeo_830 - eoxy_830*edeo_780);
            end;
      
            %****** Deoxy Hb ******
            if ((edeo_780*eoxy_830 - edeo_830*eoxy_780)==0);
               hb_data(p_cnt).raw(2,j,hb_ch) = 0;
            else;
               hb_data(p_cnt).raw(2,j,hb_ch) = (a_780*eoxy_830 - a_830*eoxy_780)/(edeo_780*eoxy_830 - edeo_830*eoxy_780);
            end;      
         end;
      end;
      % added by xu cui to remove over all average for motion test task, should be removed after analysis 
%       numCh = size(hb_data(p_cnt).raw,3);
%       overallave1 = mean(hb_data(p_cnt).raw(1,:,:),3);
%       hb_data(p_cnt).raw(1,:,:) = hb_data(p_cnt).raw(1,:,:) - repmat(overallave1, [1, 1, numCh]);
%       overallave2 = mean(hb_data(p_cnt).raw(2,:,:),3);
%       hb_data(p_cnt).raw(2,:,:) = hb_data(p_cnt).raw(2,:,:) - repmat(overallave2, [1, 1, numCh]);
      
      % end of adding
      
      %****** Total Hb ******
      hb_data(p_cnt).raw(3,:,:) = hb_data(p_cnt).raw(1,:,:) + hb_data(p_cnt).raw(2,:,:);

      %***************** Calc Filter *******************
      Fs = 1000/info(p_cnt).smpl_period;

      if para.high_flg==1 & para.low_flg==1; %**** Band Pass ****
         hb_data(p_cnt).calc_flg = 2;
         [b,a]=ellip(4,0.1,40,[para.high_val para.low_val]*2/Fs);
         [H,w]=freqz(b,a,512);
         for i=1:info(p_cnt).ad_ch_max/2;
            hb_data(p_cnt).fil(1,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(1,:,i));
            hb_data(p_cnt).fil(2,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(2,:,i));
            hb_data(p_cnt).fil(3,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(3,:,i));
         end;  
      end;

      if para.high_flg==1 & para.low_flg==0; %**** High Pass ****
         hb_data(p_cnt).calc_flg = 2;
         [b,a]=ellip(4,0.1,40,[para.high_val]*2/Fs,'high');
         [H,w]=freqz(b,a,512);
         for i=1:info(p_cnt).ad_ch_max/2;
            hb_data(p_cnt).fil(1,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(1,:,i));
            hb_data(p_cnt).fil(2,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(2,:,i));
            hb_data(p_cnt).fil(3,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(3,:,i));
         end;   
      end;

      if para.high_flg==0 & para.low_flg==1; %**** Low Pass ****
         hb_data(p_cnt).calc_flg = 2;
         [b,a]=ellip(4,0.1,40,[para.low_val]*2/Fs);
         [H,w]=freqz(b,a,512);
         for i=1:info(p_cnt).ad_ch_max/2;
            hb_data(p_cnt).fil(1,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(1,:,i));
            hb_data(p_cnt).fil(2,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(2,:,i));
            hb_data(p_cnt).fil(3,:,i) = filtfilt(b,a,hb_data(p_cnt).raw(3,:,i));
         end;
      end;
      
      %**** Moving Average ****
      if para.moveave_flg==1;
         if Fs*para.move_val*3 > length(hb_data(p_cnt).raw(1,:,1));
            warndlg('Data must have length more than 3 times filter order.','Warning !!');
            err_flg=4;
            break;
         end;
         a=1;
         % ceil
         b(1:ceil(Fs*para.move_val))=1/(Fs*para.move_val);
         hb_data(p_cnt).calc_flg = 2;
         %*** It is a moving average after a filter. ****
         if para.high_flg==1 | para.low_flg==1;
            for ch=1:info(p_cnt).ad_ch_max/2;
               hb_data(p_cnt).fil(1,:,ch) = filtfilt(b,a,hb_data(p_cnt).fil(1,:,ch));
               hb_data(p_cnt).fil(2,:,ch) = filtfilt(b,a,hb_data(p_cnt).fil(2,:,ch));
               hb_data(p_cnt).fil(3,:,ch) = filtfilt(b,a,hb_data(p_cnt).fil(3,:,ch));
            end;
         else;            %*** It is a moving average to RawData. ****
            for ch=1:info(p_cnt).ad_ch_max/2;
               hb_data(p_cnt).fil(1,:,ch) = filtfilt(b,a,hb_data(p_cnt).raw(1,:,ch));
               hb_data(p_cnt).fil(2,:,ch) = filtfilt(b,a,hb_data(p_cnt).raw(2,:,ch));
               hb_data(p_cnt).fil(3,:,ch) = filtfilt(b,a,hb_data(p_cnt).raw(3,:,ch));
            end;
         end;
      end;
   end;
end;
close(wh);
clear wh;

if  (para_p.load_prb1 == 0 & para_p.load_prb2 ==0 & para_p.load_prb3 ==0 ...
       & para_p.load_prb4 == 0 & para_p.load_prb5 ==0);
   warndlg('Please read data.','Warning'); 
   return;
elseif data_cnt == 0 & err_flg==0;
   warndlg('Warning Probe Select!  Please choose the proper Probe No.','Warning');
   return;
end;

