% makr_line
%
% Input  : info,mark,para,hb_data,para_p,Sel_graph
% Output : para,hb_data,hb_graph_h,hb_map_h
% Example: [para,hb_data,hb_graph_h,hb_map_h] = drow_graph(info,mark,para,hb_data,para_p,Sel_graph); 
%*******************************************************
%*               Plot mark lineFunction                *
%*                   Hiroaki Kusabuka                  *
%*                  HITACHI MECICAL                    *
%*******************************************************
% History:05.07.12 Ver2.05  Kusabuka  mojule
function [hb_graph_h] = drow_graph(info,para,para_p,mark,hb_data,hb_graph_h,p_cnt,i); 
%fprintf('drow_graph\n');

   set(gcf,'CurrentAxes',hb_graph_h(p_cnt).map_gco(i))
   hold on;
   if para.high_flg == 1 | para.low_flg == 1 | para.moveave_flg == 1;
      if hb_data(p_cnt).calc_flg~=2;
         warndlg('Please set and re-calculate a filter.','Warning');
         return;
      end;
      if isfield(hb_data(p_cnt),'fil' ) ~= 1;
         warndlg('Please set and re-calculate a filter.','Warning');
         return;
      end;
      hb_graph_h(p_cnt).fil_graph(1,i) = plot(hb_data(p_cnt).fil(1,:,i),'r');
      hb_graph_h(p_cnt).fil_graph(2,i) = plot(hb_data(p_cnt).fil(2,:,i),'b');
      hb_graph_h(p_cnt).fil_graph(3,i) = plot(hb_data(p_cnt).fil(3,:,i),'g');
   else;
      hb_graph_h(p_cnt).raw_graph(1,i) = plot(hb_data(p_cnt).raw(1,:,i),'r');
      hb_graph_h(p_cnt).raw_graph(2,i) = plot(hb_data(p_cnt).raw(2,:,i),'b');
      hb_graph_h(p_cnt).raw_graph(3,i) = plot(hb_data(p_cnt).raw(3,:,i),'g');
   end;
   
   if hb_graph_h(p_cnt).oxy_val == 1;
      if hb_data(p_cnt).calc_flg ==2;
         set(hb_graph_h(p_cnt).fil_graph(1,i),'Visible','on');
      else;
         set(hb_graph_h(p_cnt).raw_graph(1,i),'Visible','on');
      end;
   end;
   if hb_graph_h(p_cnt).deoxy_val == 1;
      if hb_data(p_cnt).calc_flg ==2;
         set(hb_graph_h(p_cnt).fil_graph(2,i),'Visible','on');
      else;
         set(hb_graph_h(p_cnt).raw_graph(2,i),'Visible','on');
      end;
   end;
   if hb_graph_h(p_cnt).total_val == 1;
      if hb_data(p_cnt).calc_flg ==2;
         set(hb_graph_h(p_cnt).fil_graph(3,i),'Visible','on');
      else;
         set(hb_graph_h(p_cnt).raw_graph(3,i),'Visible','on');
      end;
   end;
   plot([para.sel_point para.sel_point],[hb_graph_h(p_cnt).hb_min hb_graph_h(p_cnt).hb_max],':m');

hold off;

return;
  
