%*******************************************************
%*                    RAW File Out                     *
%*                     (HTS) H.K                       *
%*                     2007/3/1                        *
%*******************************************************
function fout_raw(info,para,para_p,mark,ad_data,p_cnt);

[fname, putname]=uiputfile('*_ad.csv','Input file name');
if fname==0;
   clear fname;
   clear putname;
   return;
end;
%*** File out ***
if info(1).sys_ver >= 7;
   match=findstr(fname,'_ad.csv');
   work=sprintf('%s',fname(1:match(length(match))-1));
   fname=work;
end;
clear work;clear match;
% 
% for p_cnt=1:para_p.max_prb;  % for 5 probe
%    if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
%    elseif (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) | (p_cnt==4 & para_p.load_prb4 ~=1) | (p_cnt==5 & para_p.load_prb5 ~=1);
%    else;

      % File check
      raw_name1=sprintf('%s%s_Probe%d_ad.csv',putname,fname,p_cnt);
      fp1 = fopen(raw_name1,'r+');
      if fp1 ~= -1;
         warndlg(['The file of the same name already exists.',fname],'Warning !!');
         fclose(fp1);
         clear ans;
         clear j;clear cnt;
         clear fp1;clear fig_no;
         clear raw_name1;clear fname;clear putname;
         return;
      end;
      
      % File open
      fp1 = fopen(raw_name1,'w');
      if fp1 ==-1; 
         warndlg(['File open err.Please check disk.'],'Warning !!');
         clear ans;
         clear cnt;clear j;
         clear fp1;clear fig_no;
         clear raw_name1;clear raw_name2;clear raw_name3;clear fname;clear putname;
         return;
      end;

      %***** Text Fileout ******
      fprintf(fp1,'Header,AD Data\n');
    
%      fprintf(fp1,'File Version,2.08\n');
      fprintf(fp1,'File Version,%f\n',info(p_cnt).version);
      %****** Patient Information ********
      fprintf(fp1,'Patient Information\n');
      fprintf(fp1,'ID,%s\n',deblank(info(p_cnt).id));                % ID
      fprintf(fp1,'Name,%s\n',deblank(info(p_cnt).name));            % Name
      fprintf(fp1,'Comment,%s\n',info(p_cnt).comment);      % Comment
      fprintf(fp1,'Age,%s',info(p_cnt).age);                % age
      fprintf(fp1,'Sex,%s',info(p_cnt).sex);                % sex
      fprintf(fp1,'Analyze Information\n');                 % Analyze Information
      fprintf(fp1,'AnalyzeMode,%s\n',para.analyze_org);     % AnalyzeMode
      fprintf(fp1,'Pre Time[s],%-4.1f\n',para.pre_org*info(p_cnt).smpl_period/1000);            % Pre Time[s]
      fprintf(fp1,'Post Time[s],%-4.1f\n',para.post_org*info(p_cnt).smpl_period/1000);          % Post Time[s]
%**********************************
% relax ?
%**********************************
      fprintf(fp1,'Recovery Time[s],%-4.1f\n',para.relax_org*info(p_cnt).smpl_period/1000);     % Recovery Time[s]
%      fprintf(fp1,'Base Time[s],%-4.1f\n',para.base*info(p_cnt).smpl_period/1000);          % Base Time[s]
%      fprintf(fp2,'Base Time[s],%-4.1f\n',para.base*info(p_cnt).smpl_period/1000);
%      fprintf(fp3,'Base Time[s],%-4.1f\n',para.base*info(p_cnt).smpl_period/1000);
      fprintf(fp1,'Base Start[s],%-4.1f\n',para.base_st*info(p_cnt).smpl_period/1000);      % Base Start[s]
      fprintf(fp1,'Base End[s],%-4.1f\n',para.base_ed*info(p_cnt).smpl_period/1000);        % Base End[s]
      fprintf(fp1,'Fitting Degree,%s\n','');        % Fitting
%      fprintf(fp1,'%s\n','');        % Fitting no dout
      % filter
      if para.high_flg == 1 | para.low_flg == 1 | para.moveave_flg == 1;
         fprintf(fp1,'HighPass filter');
         if para.high_flg == 1;
            fprintf(fp1,',%f\n',para.high_val);
         else;
            fprintf(fp1,',%f\n',0);
         end;
         fprintf(fp1,'LowPass filter');
         if para.low_flg == 1;
            fprintf(fp1,',%f\n',para.low_val);
         else;
            fprintf(fp1,',%f\n',0);
         end;
         fprintf(fp1,'Moving Average');         % Moving Average
         if para.moveave_flg == 1;
            fprintf(fp1,',%f\n',para.move_val);
         else;
            fprintf(fp1,',%f\n',0);
         end;
      else;
         fprintf(fp1,'HighPass filter,0\n');
         fprintf(fp1,'LowPass filter,0\n');
         fprintf(fp1,'Moving Average,0\n');
      end;

      if para.sel_move == 1;
         fprintf(fp1,'Body move,ON\n');
      else;
         fprintf(fp1,'Body move,OFF\n');
      end;
      %****************************
      % Measure Info
      %****************************
      fprintf(fp1,'Measure Information\n');
      fprintf(fp1,'Date,%s\n',deblank(info(p_cnt).date));          % date
      if info(p_cnt).probe_mode==1;work=sprintf('%s','3x3');end;   % 3x3
      if info(p_cnt).probe_mode==2;work=sprintf('%s','4x4');end;   % 4x4
      if info(p_cnt).probe_mode==3;work=sprintf('%s','3x5');end;   % 3x5
      if info(p_cnt).probe_mode==4;work=sprintf('%s','3x11');end;  % 3x11
      if info(p_cnt).probe_mode==5;work=sprintf('%s','3x10');end;  % 3x10
      fprintf(fp1,'Wave[nm],%s,%s\n',ad_data(p_cnt).title1,ad_data(p_cnt).title2);        % Wave[nm],
      fprintf(fp1,'Mode,%s\n',work);        % mode
      fprintf(fp1,'Wave Length,');                                  % Wave Length
      cnt=0;
      for num=1:info(p_cnt).ad_ch_max;
         if (rem(num,2)) == 1;   % amari
            cnt = cnt+1; 
         end;
         
         fprintf(fp1,'CH%d(%5.1f),',cnt,info(p_cnt).wlen(num));
      end;
      fprintf(fp1,'\n');
      fprintf(fp1,'Analog Gain\n');
      fprintf(fp1,'Digital Gain\n');
      
      fprintf(fp1,'Sampling Period[s],%f\n',info(p_cnt).smpl_period/1000);        % mode
      if info(p_cnt).measure_mode(1)==1; %****** Stim Mode *******
         work =sprintf('%s','STIM');
      elseif info(p_cnt).measure_mode(1)==2; %****** Stim Mode *******
         work =sprintf('%s','Event');
      end;
      fprintf(fp1,'StimType,%s\n',work);

      if para_p.del_ch == 1;                    %* ch delete
         fprintf(fp1,'Exception Ch,ON\n');
      else;
         fprintf(fp1,'Exception Ch,OFF\n');
      end;
      fprintf(fp1,'Exception,');
      for i=1:info(p_cnt).ad_ch_max/2;
         fprintf(fp1,' %d',info(p_cnt).err_ch(i));
      end; 
      fprintf(fp1,'\n');

      fprintf(fp1,'Wave Length,');                                  % Wave Length
      cnt=0;
      for num=1:info(p_cnt).ad_ch_max;
         if (rem(num,2)) == 1;   % amari
            cnt = cnt+1; 
         end;
         fprintf(fp1,'CH%d(%5.1f),',cnt,info(p_cnt).wlen(num));
      end;
      fprintf(fp1,'bodymove,');
      fprintf(fp1,'mark');
      fprintf(fp1,'\n');

      % etg-100
      if info(1).flg == 1;
%         for num=1:ceil(length(ad_data(p_cnt).raw));
         data_len = size(ad_data(p_cnt).raw);
         for num=1:data_len(1);
            mark = ad_data(p_cnt).raw(num,65); % mark
            if info(p_cnt).ad_ch_max/2 == 24;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 bodymove mark
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                              num,ad_data(p_cnt).raw(num,1:48),0,mark);
            elseif info(p_cnt).ad_ch_max/2 == 22;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44  bodymove mark
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                              num,ad_data(p_cnt).raw(num,1:44),0,mark);
            elseif info(p_cnt).ad_ch_max/2 == 52;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99100101102103104 
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                              num,ad_data(p_cnt).raw(num,1:104),0,mark);
            elseif info(p_cnt).ad_ch_max/2 == 47;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                              num,ad_data(p_cnt).raw(num,1:94),0,mark);
            end;
         end;
      else;       % 4000 7000
%         for num=1:ceil(length(ad_data(p_cnt).raw));
         data_len = size(ad_data(p_cnt).raw);
         for num=1:data_len(1);
            if info(p_cnt).ad_ch_max/2 == 24;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 bodymode mark 
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                              num,ad_data(p_cnt).raw(num,1:48),ad_data(p_cnt).raw(num,50),ad_data(p_cnt).raw(num,51));
%                              num,ad_data(p_cnt).raw(num,1:48),ad_data(p_cnt).raw(num,50),ad_data(p_cnt).raw(num,51),ad_data(p_cnt).raw(num,52),ad_data(p_cnt).raw(num,53));
            elseif info(p_cnt).ad_ch_max/2 == 22;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                            num,ad_data(p_cnt).raw(num,1:44),ad_data(p_cnt).raw(num,50),ad_data(p_cnt).raw(num,51));
%                            num,ad_data(p_cnt).raw(num,1:44),ad_data(p_cnt).raw(num,50),ad_data(p_cnt).raw(num,51),ad_data(p_cnt).raw(num,52),ad_data(p_cnt).raw(num,53));
%                            num,ad_data(p_cnt).raw(num,1:44),ad_data(p_cnt).raw(num,46),ad_data(p_cnt).raw(num,47),ad_data(p_cnt).raw(num,48),ad_data(p_cnt).raw(num,49));
            elseif info(p_cnt).ad_ch_max/2 == 52;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99100101102103104
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                           num,ad_data(p_cnt).raw(num,1:104),ad_data(p_cnt).raw(num,106),ad_data(p_cnt).raw(num,107));
%                           num,ad_data(p_cnt).raw(num,1:104),ad_data(p_cnt).raw(num,106),ad_data(p_cnt).raw(num,107),ad_data(p_cnt).raw(num,108),ad_data(p_cnt).raw(num,109));
            elseif info(p_cnt).ad_ch_max/2 == 47;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 
               fprintf(fp1,'%d,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%d,%d\n',...
                           num,ad_data(p_cnt).raw(num,1:94),ad_data(p_cnt).raw(num,96),ad_data(p_cnt).raw(num,97));
%                           num,ad_data(p_cnt).raw(num,1:94),ad_data(p_cnt).raw(num,96),ad_data(p_cnt).raw(num,97),ad_data(p_cnt).raw(num,98),ad_data(p_cnt).raw(num,99));
            end;
         end;         
      end;

      fclose(fp1);
%    end;
% end;
clear num;clear ch;
clear raw_oxy;clear raw_deo;clear raw_tot;
clear w;clear Fs;
