%*******************************************************
%*                    FFT File Out                     *
%*                  Shingo Kawasaki                    *
%*                     2006/3/1                        *
%*******************************************************
function fout_fft(info,para,para_p,fft_data,p_cnt);

if para.high_flg == 1 | para.low_flg == 1 | para.moveave_flg == 1;
   if isfield(fft_data(p_cnt),'fft_fil' ) ~= 1;
      warndlg('Please set and re-calculate a filter.','Warning');
      return;
   end;
end;
   
[fname, putname]=uiputfile('*_fft_oxy.csv','Input file name');
if fname==0;
   clear fname;
   clear putname;
   return;
end;
%*** File out ***
if info(1).sys_ver >= 7;
   match=findstr(fname,'_fft_oxy.csv');
   work=sprintf('%s',fname(1:match(length(match))-1));
   fname=work;
end;
clear work;clear match;
% 
% for p_cnt=1:para_p.max_prb;  % for 5 probe
%    if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
%    elseif (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) | (p_cnt==4 & para_p.load_prb4 ~=1) | (p_cnt==5 & para_p.load_prb5 ~=1);
%    else;
      w = fft_data(p_cnt).fft_w;
      % File check
      fft_name1=sprintf('%s%s_Probe%d_fft_oxy.csv',putname,fname,p_cnt);
      fp1 = fopen(fft_name1,'r+');
      if fp1 ~= -1;
         warndlg(['The file of the same name already exists.',fname],'Warning !!');
         fclose(fp1);
         clear ans;
         clear j;clear cnt;
         clear fp1;clear fig_no;
         clear fft_name1;clear fname;clear putname;
         return;
      end;
      fft_name2=sprintf('%s%s_Probe%d_fft_deoxy.csv',putname,fname,p_cnt);
      fp2 = fopen(fft_name2,'r+');
      if fp2 ~= -1;
         warndlg(['The file of the same name already exists.',fname],'Warning !!');
         fclose(fp1);
         fclose(fp2);
         clear ans;
         clear j;clear cnt;
         clear fp1;clear fp2;clear fig_no;
         clear fft_name1;clear fft_name2;clear fname;clear putname;
         return;
      end;
      fft_name3=sprintf('%s%s_Probe%d_fft_total.csv',putname,fname,p_cnt);
      fp3 = fopen(fft_name3,'r+');
      if fp3 ~= -1;
         warndlg(['The file of the same name already exists.',fname],'Warning !!');
         fclose(fp1);
         fclose(fp2);
         fclose(fp3);
         clear ans;
         clear j;clear cnt;
         clear fp1;clear fp2;clear fp3;clear fig_no;
         clear fft_name1;clear fft_name2;clear fft_name3;clear fname;clear putname;
         return;
      end;
      
      % File open
      fp1 = fopen(fft_name1,'w');
      if fp1 ==-1; 
         warndlg(['File open err.Please check disk.'],'Warning !!');
         clear ans;
         clear cnt;clear j;
         clear fp1;clear fig_no;
         clear fft_name1;clear fft_name2;clear fft_name3;clear fname;clear putname;
         return;
      end;
      fp2 = fopen(fft_name2,'w');
      if fp2 ==-1; 
         warndlg(['File open err.Please check disk.'],'Warning !!');
         delete(fft_name);
         clear ans;
         clear cnt;clear j;
         clear fp;clear fig_no;
         clear fft_name;clear fname;clear putname;
         return;
      end;
      fp3 = fopen(fft_name3,'w');
      if fp3 ==-1; 
         warndlg(['File open err.Please check disk.'],'Warning !!');
         delete(fft_name);
         clear ans;
         clear cnt;clear j;
         clear fp;clear fig_no;
         clear fft_name;clear fname;clear putname;
         return;
      end;

   %***** Text Fileout ******
      fprintf(fp1,'FFT Power,(Oxy Hb)\n');
      fprintf(fp2,'FFT Power,(Deoxy Hb)\n');
      fprintf(fp3,'FFT Power,(Total Hb)\n');
      if para.high_flg == 1 | para.low_flg == 1 | para.moveave_flg == 1;
         fprintf(fp1,'HighPass filter');
         fprintf(fp2,'HighPass filter');
         fprintf(fp3,'HighPass filter');
         if para.high_flg == 1;
            fprintf(fp1,',%f\n',para.high_val);
            fprintf(fp2,',%f\n',para.high_val);
            fprintf(fp3,',%f\n',para.high_val);
         else;
            fprintf(fp1,',%f\n',0);
            fprintf(fp2,',%f\n',0);
            fprintf(fp3,',%f\n',0);
         end;
         fprintf(fp1,'LowPass filter');
         fprintf(fp2,'LowPass filter');
         fprintf(fp3,'LowPass filter');
         if para.low_flg == 1;
            fprintf(fp1,',%f\n',para.low_val);
            fprintf(fp2,',%f\n',para.low_val);
            fprintf(fp3,',%f\n',para.low_val);
         else;
            fprintf(fp1,',%f\n',0);
            fprintf(fp2,',%f\n',0);
            fprintf(fp3,',%f\n',0);
         end;
         fprintf(fp1,'Moving Average');
         fprintf(fp2,'Moving Average');
         fprintf(fp3,'Moving Average');
         if para.moveave_flg == 1;
            fprintf(fp1,',%f\n',para.move_val);
            fprintf(fp2,',%f\n',para.move_val);
            fprintf(fp3,',%f\n',para.move_val);
         else;
            fprintf(fp1,',%f\n',0);
            fprintf(fp2,',%f\n',0);
            fprintf(fp3,',%f\n',0);
         end;
      else;
         fprintf(fp1,'HighPass filter,0\n');
         fprintf(fp2,'HighPass filter,0\n');
         fprintf(fp3,'HighPass filter,0\n');
         fprintf(fp1,'LowPass filter,0\n');
         fprintf(fp2,'LowPass filter,0\n');
         fprintf(fp3,'LowPass filter,0\n');
         fprintf(fp1,'Moving Average,0\n');
         fprintf(fp2,'Moving Average,0\n');
         fprintf(fp3,'Moving Average,0\n');
      end;

      if para.sel_move == 1;
         fprintf(fp1,'Body move,ON\n');
         fprintf(fp2,'Body move,ON\n');
         fprintf(fp3,'Body move,ON\n');
      else;
         fprintf(fp1,'Body move,OFF\n');
         fprintf(fp2,'Body move,OFF\n');
         fprintf(fp3,'Body move,OFF\n');
      end;
      if para_p.del_ch == 1;
         fprintf(fp1,'Exception Ch,ON\n');
         fprintf(fp2,'Exception Ch,ON\n');
         fprintf(fp3,'Exception Ch,ON\n');
      else;
         fprintf(fp1,'Exception Ch,OFF\n');
         fprintf(fp2,'Exception Ch,OFF\n');
         fprintf(fp3,'Exception Ch,OFF\n');
      end;
      fprintf(fp1,'Exception,');
      fprintf(fp2,'Exception,');
      fprintf(fp3,'Exception,');
      for i=1:info(p_cnt).ad_ch_max/2;
         fprintf(fp1,' %d',info(p_cnt).err_ch(i));
         fprintf(fp2,' %d',info(p_cnt).err_ch(i));
         fprintf(fp3,' %d',info(p_cnt).err_ch(i));
      end;
      fprintf(fp1,'\n');
      fprintf(fp2,'\n');
      fprintf(fp3,'\n');
      if info(p_cnt).ad_ch_max/2 == 24;
         fprintf(fp1,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24\n');
         fprintf(fp2,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24\n');
         fprintf(fp3,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24\n');
      elseif info(p_cnt).ad_ch_max/2 == 22;
         fprintf(fp1,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22\n');
         fprintf(fp2,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22\n');
         fprintf(fp3,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22\n');
      elseif info(p_cnt).ad_ch_max/2 == 52;
         fprintf(fp1,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24,ch25,ch26,ch27,ch28,ch29,ch30,ch31,ch32,ch33,ch34,ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch44,ch45,ch46,ch47,ch48,ch49,ch50,ch51,ch52\n');
         fprintf(fp2,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24,ch25,ch26,ch27,ch28,ch29,ch30,ch31,ch32,ch33,ch34,ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch44,ch45,ch46,ch47,ch48,ch49,ch50,ch51,ch52\n');
         fprintf(fp3,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24,ch25,ch26,ch27,ch28,ch29,ch30,ch31,ch32,ch33,ch34,ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch44,ch45,ch46,ch47,ch48,ch49,ch50,ch51,ch52\n');
      elseif info(p_cnt).ad_ch_max/2 == 47;
         fprintf(fp1,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24,ch25,ch26,ch27,ch28,ch29,ch30,ch31,ch32,ch33,ch34,ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch44,ch45,ch46,ch47\n');
         fprintf(fp2,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24,ch25,ch26,ch27,ch28,ch29,ch30,ch31,ch32,ch33,ch34,ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch44,ch45,ch46,ch47\n');
         fprintf(fp3,'Frequency[Hz],ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12,ch13,ch14,ch15,ch16,ch17,ch18,ch19,ch20,ch21,ch22,ch23,ch24,ch25,ch26,ch27,ch28,ch29,ch30,ch31,ch32,ch33,ch34,ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch44,ch45,ch46,ch47\n');
      end;
      if para.high_flg == 1 | para.low_flg == 1 | para.moveave_flg == 1;
%         for num=1:ceil(length(fft_data(p_cnt).fft_fil)/2);
         data_len = size(fft_data(p_cnt).fft_fil);
         for num=1:fix(data_len(2)/2);
            if info(p_cnt).ad_ch_max/2 == 24;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(3,num,:));
            elseif info(p_cnt).ad_ch_max/2 == 22;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(3,num,:));
            elseif info(p_cnt).ad_ch_max/2 == 52;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(3,num,:));
            elseif info(p_cnt).ad_ch_max/2 == 47;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_fil(3,num,:));
            end;
         end;
      else;
%         for num=1:ceil(length(fft_data(p_cnt).fft_raw)/2);
         data_len = size(fft_data(p_cnt).fft_raw);
         for num=1:fix(data_len(2)/2);
            if info(p_cnt).ad_ch_max/2 == 24;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(3,num,:));
            elseif info(p_cnt).ad_ch_max/2 == 22;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(3,num,:));
            elseif info(p_cnt).ad_ch_max/2 == 52;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(3,num,:));
            elseif info(p_cnt).ad_ch_max/2 == 47;
                               %1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 
               fprintf(fp1,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(1,num,:));
               fprintf(fp2,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(2,num,:));
               fprintf(fp3,'%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f\n',w(num),fft_data(p_cnt).fft_raw(3,num,:));
            end;
         end;
      end;

      fclose(fp1);
      fclose(fp2);
      fclose(fp3);
%    end;
% end;
clear num;clear ch;
clear fft_oxy;clear fft_deo;clear fft_tot;
clear w;clear Fs;
