%*******************************************************
%*                    RAW File Out                     *
%*                     (HTS) H.K                       *
%*                     2007/3/1                        *
%*******************************************************
function fout_raw(info,para,para_p,mark,ad_data,p_cnt);

[fname, putname]=uiputfile('*_fit.csv','Input file name');
if fname==0;
   clear fname;
   clear putname;
   return;
end;
%*** File out ***
if info(1).sys_ver >= 7;
   match=findstr(fname,'_fit.csv');
   work=sprintf('%s',fname(1:match(length(match))-1));
   fname=work;
end;
clear work;clear match;
% 
% for p_cnt=1:para_p.max_prb;  % for 5 probe
%    if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
%    elseif (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) | (p_cnt==4 & para_p.load_prb4 ~=1) | (p_cnt==5 & para_p.load_prb5 ~=1);
%    else;

      % File check
      raw_name1=sprintf('%s%s_Probe%d_fit.csv',putname,fname,p_cnt);
      fp1 = fopen(raw_name1,'r+');
      if fp1 ~= -1;
         warndlg(['The file of the same name already exists.',fname],'Warning !!');
         fclose(fp1);
         clear ans;
         clear j;clear cnt;
         clear fp1;clear fig_no;
         clear raw_name1;clear fname;clear putname;
         return;
      end;
      
      % File open
      fp1 = fopen(raw_name1,'w');
      if fp1 ==-1; 
         warndlg(['File open err.Please check disk.'],'Warning !!');
         clear ans;
         clear cnt;clear j;
         clear fp1;clear fig_no;
         clear raw_name1;clear raw_name2;clear raw_name3;clear fname;clear putname;
         return;
      end;

      %***** Text Fileout ******
      fprintf(fp1,'Header,AD Fitting Data\n');
    
%      fprintf(fp1,'File Version,2.08\n');
      fprintf(fp1,'File Version,%f\n',info(p_cnt).version);
      %****** Patient Information ********
      fprintf(fp1,'Patient Information\n');
      fprintf(fp1,'ID,%s\n',deblank(info(p_cnt).id));                % ID
      fprintf(fp1,'Name,%s\n',deblank(info(p_cnt).name));            % Name
      fprintf(fp1,'Comment,%s\n',info(p_cnt).comment);      % Comment
      fprintf(fp1,'Age,%s',info(p_cnt).age);                % age
      fprintf(fp1,'Sex,%s',info(p_cnt).sex);                % sex
      fprintf(fp1,'Analyze Information\n');                 % Analyze Information
      fprintf(fp1,'AnalyzeMode,%s\n',para.analyze_org);     % AnalyzeMode
      fprintf(fp1,'Pre Time[s],%-4.1f\n',para.pre_org*info(p_cnt).smpl_period/1000);            % Pre Time[s]
      fprintf(fp1,'Post Time[s],%-4.1f\n',para.post_org*info(p_cnt).smpl_period/1000);          % Post Time[s]
%**********************************
% relax ?
%**********************************
      fprintf(fp1,'Recovery Time[s],%-4.1f\n',para.relax_org*info(p_cnt).smpl_period/1000);     % Recovery Time[s]
%      fprintf(fp1,'Base Time[s],%-4.1f\n',para.base*info(p_cnt).smpl_period/1000);          % Base Time[s]
%      fprintf(fp2,'Base Time[s],%-4.1f\n',para.base*info(p_cnt).smpl_period/1000);
%      fprintf(fp3,'Base Time[s],%-4.1f\n',para.base*info(p_cnt).smpl_period/1000);
      fprintf(fp1,'Base Start[s],%-4.1f\n',para.base_st*info(p_cnt).smpl_period/1000);      % Base Start[s]
      fprintf(fp1,'Base End[s],%-4.1f\n',para.base_ed*info(p_cnt).smpl_period/1000);        % Base End[s]
      fprintf(fp1,'Fitting Degree,%s\n','');        % Fitting
%      fprintf(fp1,'%s\n','');        % Fitting no dout
      % filter
      if para.high_flg == 1 | para.low_flg == 1 | para.moveave_flg == 1;
         fprintf(fp1,'HighPass filter');
         if para.high_flg == 1;
            fprintf(fp1,',%f\n',para.high_val);
         else;
            fprintf(fp1,',%f\n',0);
         end;
         fprintf(fp1,'LowPass filter');
         if para.low_flg == 1;
            fprintf(fp1,',%f\n',para.low_val);
         else;
            fprintf(fp1,',%f\n',0);
         end;
         fprintf(fp1,'Moving Average');         % Moving Average
         if para.moveave_flg == 1;
            fprintf(fp1,',%f\n',para.move_val);
         else;
            fprintf(fp1,',%f\n',0);
         end;
      else;
         fprintf(fp1,'HighPass filter,0\n');
         fprintf(fp1,'LowPass filter,0\n');
         fprintf(fp1,'Moving Average,0\n');
      end;

      if para.sel_move == 1;
         fprintf(fp1,'Body move,ON\n');
      else;
         fprintf(fp1,'Body move,OFF\n');
      end;
      %****************************
      % Measure Info
      %****************************
      fprintf(fp1,'Measure Information\n');
      fprintf(fp1,'Date,%s\n',deblank(info(p_cnt).date));          % date
      if info(p_cnt).probe_mode==1;work=sprintf('%s','3x3');end;   % 3x3
      if info(p_cnt).probe_mode==2;work=sprintf('%s','4x4');end;   % 4x4
      if info(p_cnt).probe_mode==3;work=sprintf('%s','3x5');end;   % 3x5
      if info(p_cnt).probe_mode==4;work=sprintf('%s','3x11');end;  % 3x11
      if info(p_cnt).probe_mode==5;work=sprintf('%s','3x10');end;  % 3x10
      fprintf(fp1,'Wave[nm],%s,%s\n',ad_data(p_cnt).title1,ad_data(p_cnt).title2);        % Wave[nm],
      fprintf(fp1,'Mode,%s\n',work);        % mode
      fprintf(fp1,'Wave Length,');                                  % Wave Length
      cnt=0;
      for num=1:info(p_cnt).ad_ch_max;
        if (rem(num,2)) == 1;   % amari
            cnt = cnt+1; 
         end;
         fprintf(fp1,'CH%d(%5.1f),',cnt,info(p_cnt).wlen(num));
      end;
      fprintf(fp1,'\n');
      
      fprintf(fp1,'Analog Gain\n');
      fprintf(fp1,'Digital Gain\n');
      
      fprintf(fp1,'Sampling Period[s],%f\n',info(p_cnt).smpl_period/1000);        % smpl_period
      if info(p_cnt).measure_mode(1)==1; %****** Stim Mode *******
         work =sprintf('%s','STIM');
      elseif info(p_cnt).measure_mode(1)==2; %****** Stim Mode *******
         work =sprintf('%s','Event');
      end;
      fprintf(fp1,'StimType,%s\n',work);

      if para_p.del_ch == 1;                    %* ch delete
         fprintf(fp1,'Exception Ch,ON\n');
      else;
         fprintf(fp1,'Exception Ch,OFF\n');
      end;
      fprintf(fp1,'Exception,');
      for i=1:info(p_cnt).ad_ch_max/2;
         fprintf(fp1,' %d',info(p_cnt).err_ch(i));
      end; 
      fprintf(fp1,'\n');
%      
%      if info(p_cnt).ad_ch_max/2 == 24;
%         fprintf(fp1,'No.,ch1(%f),ch1(%f),ch2(%f),ch2(%f),ch3(%f),ch3(%f),ch4(%f),ch4(%f),ch5(%f),ch5(%f),ch6(%f),ch6(%f),ch7(%f),ch7(%f),ch8(%f),ch8(%f),ch9(%f),ch9(%f),ch10(%f),ch10(%f),ch11(%f),ch11(%f),ch12(%f),ch12(%f),ch13(%f),ch13(%f),ch14(%f),ch14(%f),ch15(%f),ch15(%f),ch16(%f),ch16(%f),ch17(%f),ch17(%f),ch18(%f),ch18(%f),ch19(%f),ch19(%f),ch20(%f),ch20(%f),ch21(%f),ch21(%f),ch22(%f),ch22(%f),ch23(%f),ch23(%f),ch24(%f),ch24(%f),BodyMovement,Mark,RemovalMark,PreScan\n',...
%                     info(p_cnt).wlen(1),info(p_cnt).wlen(2),info(p_cnt).wlen(3),info(p_cnt).wlen(4),info(p_cnt).wlen(5),info(p_cnt).wlen(6),info(p_cnt).wlen(7),info(p_cnt).wlen(8),info(p_cnt).wlen(9),info(p_cnt).wlen(10),info(p_cnt).wlen(11),info(p_cnt).wlen(12),info(p_cnt).wlen(13),info(p_cnt).wlen(14),info(p_cnt).wlen(15),info(p_cnt).wlen(16),info(p_cnt).wlen(17),info(p_cnt).wlen(18),info(p_cnt).wlen(19),info(p_cnt).wlen(20),info(p_cnt).wlen(21),info(p_cnt).wlen(22),info(p_cnt).wlen(23),info(p_cnt).wlen(24),...
%                     info(p_cnt).wlen(25),info(p_cnt).wlen(26),info(p_cnt).wlen(27),info(p_cnt).wlen(28),info(p_cnt).wlen(29),info(p_cnt).wlen(30),info(p_cnt).wlen(31),info(p_cnt).wlen(32),info(p_cnt).wlen(33),info(p_cnt).wlen(34),info(p_cnt).wlen(35),info(p_cnt).wlen(36),info(p_cnt).wlen(37),info(p_cnt).wlen(38),info(p_cnt).wlen(39),info(p_cnt).wlen(40),info(p_cnt).wlen(41),info(p_cnt).wlen(42),info(p_cnt).wlen(43),info(p_cnt).wlen(44),info(p_cnt).wlen(45),info(p_cnt).wlen(46),info(p_cnt).wlen(47),info(p_cnt).wlen(48));
%      elseif info(p_cnt).ad_ch_max/2 == 22;
%         fprintf(fp1,'No.,ch1(%f),ch1(%f),ch2(%f),ch2(%f),ch3(%f),ch3(%f),ch4(%f),ch4(%f),ch5(%f),ch5(%f),ch6(%f),ch6(%f),ch7(%f),ch7(%f),ch8(%f),ch8(%f),ch9(%f),ch9(%f),ch10(%f),ch10(%f),ch11(%f),ch11(%f),ch12(%f),ch12(%f),ch13(%f),ch13(%f),ch14(%f),ch14(%f),ch15(%f),ch15(%f),ch16(%f),ch16(%f),ch17(%f),ch17(%f),ch18(%f),ch18(%f),ch19(%f),ch19(%f),ch20(%f),ch20(%f),ch21(%f),ch21(%f),ch22(%f),ch22(%f),BodyMovement,Mark,RemovalMark,PreScan\n',...
%                     info(p_cnt).wlen(1),info(p_cnt).wlen(2),info(p_cnt).wlen(3),info(p_cnt).wlen(4),info(p_cnt).wlen(5),info(p_cnt).wlen(6),info(p_cnt).wlen(7),info(p_cnt).wlen(8),info(p_cnt).wlen(9),info(p_cnt).wlen(10),info(p_cnt).wlen(11),info(p_cnt).wlen(12),info(p_cnt).wlen(13),info(p_cnt).wlen(14),info(p_cnt).wlen(15),info(p_cnt).wlen(16),info(p_cnt).wlen(17),info(p_cnt).wlen(18),info(p_cnt).wlen(19),info(p_cnt).wlen(20),info(p_cnt).wlen(21),info(p_cnt).wlen(22),info(p_cnt).wlen(23),info(p_cnt).wlen(24),...
%                     info(p_cnt).wlen(25),info(p_cnt).wlen(26),info(p_cnt).wlen(27),info(p_cnt).wlen(28),info(p_cnt).wlen(29),info(p_cnt).wlen(30),info(p_cnt).wlen(31),info(p_cnt).wlen(32),info(p_cnt).wlen(33),info(p_cnt).wlen(34),info(p_cnt).wlen(35),info(p_cnt).wlen(36),info(p_cnt).wlen(37),info(p_cnt).wlen(38),info(p_cnt).wlen(39),info(p_cnt).wlen(40),info(p_cnt).wlen(41),info(p_cnt).wlen(42),info(p_cnt).wlen(43),info(p_cnt).wlen(44));
%      elseif info(p_cnt).ad_ch_max/2 == 52;
%         fprintf(fp1,'No.,ch1(%f),ch1(%f),ch2(%f),ch2(%f),ch3(%f),ch3(%f),ch4(%f),ch4(%f),ch5(%f),ch5(%f),ch6(%f),ch6(%f),ch7(%f),ch7(%f),ch8(%f),ch8(%f),ch9(%f),ch9(%f),ch10(%f),ch10(%f),ch11(%f),ch11(%f),ch12(%f),ch12(%f),ch13(%f),ch13(%f),ch14(%f),ch14(%f),ch15(%f),ch15(%f),ch16(%f),ch16(%f),ch17(%f),ch17(%f),ch18(%f),ch18(%f),ch19(%f),ch19(%f),ch20(%f),ch20(%f),ch21(%f),ch21(%f),ch22(%f),ch22(%f),ch23(%f),ch23(%f),ch24(%f),ch24(%f),ch25(%f),ch25(%f),ch26(%f),ch26(%f),ch27(%f),ch27(%f),ch28(%f),ch28(%f),ch29(%f),ch29(%f),ch30(%f),ch30(%f),ch31(%f),ch31(%f),ch32(%f),ch32(%f),ch33(%f),ch33(%f),ch34(%f),ch34(%f),ch35(%f),ch35(%f),ch36(%f),ch36(%f),ch37(%f),ch37(%f),ch38(%f),ch39(%f),ch39(%f),ch40(%f),ch40(%f),ch41(%f),ch41(%f),ch42(%f),ch42(%f),ch43(%f),ch43(%f),ch44(%f),ch44(%f),ch45(%f),ch45(%f),ch46(%f),ch46(%f),ch47(%f),ch47(%f),ch48(%f),ch48(%f),ch49(%f),ch49(%f),ch50(%f),ch50(%f),ch51(%f),ch51(%f),ch52(%f),ch52(%f),BodyMovement,Mark,RemovalMark,PreScan\n',...
%                     info(p_cnt).wlen(1),info(p_cnt).wlen(2),info(p_cnt).wlen(3),info(p_cnt).wlen(4),info(p_cnt).wlen(5),info(p_cnt).wlen(6),info(p_cnt).wlen(7),info(p_cnt).wlen(8),info(p_cnt).wlen(9),info(p_cnt).wlen(10),info(p_cnt).wlen(11),info(p_cnt).wlen(12),info(p_cnt).wlen(13),info(p_cnt).wlen(14),info(p_cnt).wlen(15),info(p_cnt).wlen(16),info(p_cnt).wlen(17),info(p_cnt).wlen(18),info(p_cnt).wlen(19),info(p_cnt).wlen(20),info(p_cnt).wlen(21),info(p_cnt).wlen(22),info(p_cnt).wlen(23),info(p_cnt).wlen(24),...
%                     info(p_cnt).wlen(25),info(p_cnt).wlen(26),info(p_cnt).wlen(27),info(p_cnt).wlen(28),info(p_cnt).wlen(29),info(p_cnt).wlen(30),info(p_cnt).wlen(31),info(p_cnt).wlen(32),info(p_cnt).wlen(33),info(p_cnt).wlen(34),info(p_cnt).wlen(35),info(p_cnt).wlen(36),info(p_cnt).wlen(37),info(p_cnt).wlen(38),info(p_cnt).wlen(39),info(p_cnt).wlen(40),info(p_cnt).wlen(41),info(p_cnt).wlen(42),info(p_cnt).wlen(43),info(p_cnt).wlen(44),info(p_cnt).wlen(45),info(p_cnt).wlen(46),info(p_cnt).wlen(47),info(p_cnt).wlen(48),...
%                                          info(p_cnt).wlen(49),info(p_cnt).wlen(50),info(p_cnt).wlen(51),info(p_cnt).wlen(52),info(p_cnt).wlen(53),info(p_cnt).wlen(54),info(p_cnt).wlen(55),info(p_cnt).wlen(56),info(p_cnt).wlen(57),info(p_cnt).wlen(58),info(p_cnt).wlen(59),info(p_cnt).wlen(60),info(p_cnt).wlen(61),info(p_cnt).wlen(62),info(p_cnt).wlen(63),info(p_cnt).wlen(64),info(p_cnt).wlen(65),info(p_cnt).wlen(66),info(p_cnt).wlen(67),info(p_cnt).wlen(68),info(p_cnt).wlen(69),info(p_cnt).wlen(70),info(p_cnt).wlen(71),info(p_cnt).wlen(72),...
%                                                               info(p_cnt).wlen(73),info(p_cnt).wlen(74),info(p_cnt).wlen(75),info(p_cnt).wlen(76),info(p_cnt).wlen(77),info(p_cnt).wlen(78),info(p_cnt).wlen(79),info(p_cnt).wlen(80),info(p_cnt).wlen(81),info(p_cnt).wlen(82),info(p_cnt).wlen(83),info(p_cnt).wlen(84),info(p_cnt).wlen(85),info(p_cnt).wlen(86),info(p_cnt).wlen(87),info(p_cnt).wlen(88),info(p_cnt).wlen(89),info(p_cnt).wlen(90),info(p_cnt).wlen(91),info(p_cnt).wlen(92),info(p_cnt).wlen(93),info(p_cnt).wlen(94),info(p_cnt).wlen(95),info(p_cnt).wlen(96),...
%                                                               info(p_cnt).wlen(97),info(p_cnt).wlen(98),info(p_cnt).wlen(99),info(p_cnt).wlen(100),info(p_cnt).wlen(101),info(p_cnt).wlen(102),info(p_cnt).wlen(103),info(p_cnt).wlen(104) );
%      elseif info(p_cnt).ad_ch_max/2 == 47;
%         fprintf(fp1,'No.,ch1(%f),ch1(%f),ch2(%f),ch2(%f),ch3(%f),ch3(%f),ch4(%f),ch4(%f),ch5(%f),ch5(%f),ch6(%f),ch6(%f),ch7(%f),ch7(%f),ch8(%f),ch8(%f),ch9(%f),ch9(%f),ch10(%f),ch10(%f),ch11(%f),ch11(%f),ch12(%f),ch12(%f),ch13(%f),ch13(%f),ch14(%f),ch14(%f),ch15(%f),ch15(%f),ch16(%f),ch16(%f),ch17(%f),ch17(%f),ch18(%f),ch18(%f),ch19(%f),ch19(%f),ch20(%f),ch20(%f),ch21(%f),ch21(%f),ch22(%f),ch22(%f),ch23(%f),ch23(%f),ch24(%f),ch24(%f),ch25(%f),ch25(%f),ch26(%f),ch26(%f),ch27(%f),ch27(%f),ch28(%f),ch28(%f),ch29(%f),ch29(%f),ch30(%f),ch30(%f),ch31(%f),ch31(%f),ch32(%f),ch32(%f),ch33(%f),ch33(%f),ch34(%f),ch34(%f),ch35(%f),ch35(%f),ch36(%f),ch36(%f),ch37(%f),ch37(%f),ch38(%f),ch39(%f),ch39(%f),ch40(%f),ch40(%f),ch41(%f),ch41(%f),ch42(%f),ch42(%f),ch43(%f),ch43(%f),ch44(%f),ch44(%f),ch45(%f),ch45(%f),ch46(%f),ch46(%f),ch47(%f),ch47(%f),ch48(%f),ch48(%f),ch49(%f),ch49(%f),BodyMovement,Mark,RemovalMark,PreScan\n',...
%                     info(p_cnt).wlen(1),info(p_cnt).wlen(2),info(p_cnt).wlen(3),info(p_cnt).wlen(4),info(p_cnt).wlen(5),info(p_cnt).wlen(6),info(p_cnt).wlen(7),info(p_cnt).wlen(8),info(p_cnt).wlen(9),info(p_cnt).wlen(10),info(p_cnt).wlen(11),info(p_cnt).wlen(12),info(p_cnt).wlen(13),info(p_cnt).wlen(14),info(p_cnt).wlen(15),info(p_cnt).wlen(16),info(p_cnt).wlen(17),info(p_cnt).wlen(18),info(p_cnt).wlen(19),info(p_cnt).wlen(20),info(p_cnt).wlen(21),info(p_cnt).wlen(22),info(p_cnt).wlen(23),info(p_cnt).wlen(24),...
%                     info(p_cnt).wlen(25),info(p_cnt).wlen(26),info(p_cnt).wlen(27),info(p_cnt).wlen(28),info(p_cnt).wlen(29),info(p_cnt).wlen(30),info(p_cnt).wlen(31),info(p_cnt).wlen(32),info(p_cnt).wlen(33),info(p_cnt).wlen(34),info(p_cnt).wlen(35),info(p_cnt).wlen(36),info(p_cnt).wlen(37),info(p_cnt).wlen(38),info(p_cnt).wlen(39),info(p_cnt).wlen(40),info(p_cnt).wlen(41),info(p_cnt).wlen(42),info(p_cnt).wlen(43),info(p_cnt).wlen(44),info(p_cnt).wlen(45),info(p_cnt).wlen(46),info(p_cnt).wlen(47),info(p_cnt).wlen(48),...
%                                          info(p_cnt).wlen(49),info(p_cnt).wlen(50),info(p_cnt).wlen(51),info(p_cnt).wlen(52),info(p_cnt).wlen(53),info(p_cnt).wlen(54),info(p_cnt).wlen(55),info(p_cnt).wlen(56),info(p_cnt).wlen(57),info(p_cnt).wlen(58),info(p_cnt).wlen(59),info(p_cnt).wlen(60),info(p_cnt).wlen(61),info(p_cnt).wlen(62),info(p_cnt).wlen(63),info(p_cnt).wlen(64),info(p_cnt).wlen(65),info(p_cnt).wlen(66),info(p_cnt).wlen(67),info(p_cnt).wlen(68),info(p_cnt).wlen(69),info(p_cnt).wlen(70),info(p_cnt).wlen(71),info(p_cnt).wlen(72),...
%                                                               info(p_cnt).wlen(73),info(p_cnt).wlen(74),info(p_cnt).wlen(75),info(p_cnt).wlen(76),info(p_cnt).wlen(77),info(p_cnt).wlen(78),info(p_cnt).wlen(79),info(p_cnt).wlen(80),info(p_cnt).wlen(81),info(p_cnt).wlen(82),info(p_cnt).wlen(83),info(p_cnt).wlen(84),info(p_cnt).wlen(85),info(p_cnt).wlen(86),info(p_cnt).wlen(87),info(p_cnt).wlen(88),info(p_cnt).wlen(89),info(p_cnt).wlen(90),info(p_cnt).wlen(91),info(p_cnt).wlen(92),info(p_cnt).wlen(93),info(p_cnt).wlen(94));
%      end;


      %***********************************************************
      if para.sel_move == 0;
         add_mark  = find(mark.ave==1);
      else;
         add_mark  = find(mark.ave==1 & mark.move==0);
      end;
      m_cnt=length(add_mark);
      if info(p_cnt).measure_mode(1)==1;block = mark.point(add_mark(1),3)-mark.point(add_mark(1),2)+para.pre+para.post+para.relax;end;
      if info(p_cnt).measure_mode(1)==2;block = 1+para.pre+para.post+para.relax;end;
      %***********************************************************
      fprintf(fp1,'No.');
      for num=1:m_cnt;
         fprintf(fp1,',Mark %d (%s nm[V])',num,ad_data(p_cnt).title1);
         fprintf(fp1,',Mark %d (%s nm[V])',num,ad_data(p_cnt).title2);
         fprintf(fp1,',FIT %d (%s nm[V])',num,ad_data(p_cnt).title1);
         fprintf(fp1,',FIT %d (%s nm[V])',num,ad_data(p_cnt).title2);
      end;
      fprintf(fp1,',Mark',ad_data(p_cnt).title2,num);
      fprintf(fp1,'\n');
      data_len = size(ad_data(p_cnt).seg);
      for num=1:data_len(1);
         fprintf(fp1,'%d',num);
         for cnt=1:m_cnt;
            fprintf(fp1,',%f',ad_data(p_cnt).seg(num,info(p_cnt).adnmpn(2*info(p_cnt).sel_ch-1)+1,cnt)); % 695 or 785
            fprintf(fp1,',%f',ad_data(p_cnt).seg(num,info(p_cnt).adnmpn(2*info(p_cnt).sel_ch)+1,cnt));   % 830
            fprintf(fp1,',%f',ad_data(p_cnt).fit(num,info(p_cnt).adnmpn(2*info(p_cnt).sel_ch-1)+1,cnt)); % 695 or 785
            fprintf(fp1,',%f',ad_data(p_cnt).fit(num,info(p_cnt).adnmpn(2*info(p_cnt).sel_ch)+1,cnt));   % 830
         end;
         if info(p_cnt).measure_mode(1)==1; % stim
            if num == para.pre;
               fprintf(fp1,',%d',1);
            elseif num == block-para.relax-para.post;
               fprintf(fp1,',%d',1);
            else;
               fprintf(fp1,',%d',0);
            end;
         else;
            if num == para.pre;
               fprintf(fp1,',%d',1);
            else;
               fprintf(fp1,',%d',0);
            end;
         end;
         
         fprintf(fp1,'\n');
      end;

      fclose(fp1);
%    end;
% end;
clear num;clear ch;
clear raw_oxy;clear raw_deo;clear raw_tot;
clear w;clear Fs;
