% hb_map310
%
% Input  : para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph
% Output : hb_map_h
% Example: [hb_map_h] = hb_map310(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph); 

%*******************************************************
%*               Plot Hb Map310 Function               *
%*                   Hiroaki Kusabuka                  *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF05.06.30 Ver2.05  Kusabuka@new

function [hb_map_h] = hb_map310(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop); 

%fprintf('hb_map310 Sel_graph=%d \n\n', Sel_graph);
% hen a designated point is illegal, it comes out y the function z.@<- Ver2.00
if para.sel_point <= 0 | hb_graph_h(Sel_graph).time_max < para.sel_point;
   return;
end;
if hb_data(Sel_graph).calc_flg==2;
   if isfield(hb_data(Sel_graph),'fil' ) ~= 1;
      warndlg('Please set and re-calculate a filter.','Warning');
      return;
   end;
end;
%************ Hb310 MAP ****************
[x,y]     = meshgrid(1:1:11);
[xi,yi]   = meshgrid(1:0.1:11);

% except_ch data 0 (local)
for i=1:(info(Sel_graph).ad_ch_max/2);
   if info(Sel_graph).err_ch(i)==1 & para_p.del_ch ==1;
      if hb_data(Sel_graph).calc_flg==2;
         hb_data(Sel_graph).fil(1,:,i)=0;
         hb_data(Sel_graph).fil(2,:,i)=0;
         hb_data(Sel_graph).fil(3,:,i)=0;
      else;
         hb_data(Sel_graph).raw(1,:,i)=0;
         hb_data(Sel_graph).raw(2,:,i)=0;
         hb_data(Sel_graph).raw(3,:,i)=0;
      end;
   end;
end;
%************ Topo View ************** 
%move_stop=1;
view_flg=1;
hb_map_h(Sel_graph).topo_fig=figure(12+(Sel_graph-1));
set(gca,'drawmode','fast');
set(0,'CurrentFigure',hb_map_h(Sel_graph).topo_fig);
clf;
plotedit(hb_map_h(Sel_graph).topo_fig,'hidetoolsmenu');
posi = get(hb_map_h(Sel_graph).topo_fig,'Position'); 
set(hb_map_h(Sel_graph).topo_fig,'Name',sprintf('Topography Probe%d',Sel_graph),'Position',posi,'ToolBar','none');
set(hb_map_h(Sel_graph).topo_fig,'CloseRequestFcn','move_play=1;closereq;');
%set(hb_map_h(Sel_graph).topo_fig,'DeleteFcn','move_play=1;');
%************ Movie Start **************
hb_map_h(Sel_graph).raw.play = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 35 40 14],...
            'String','Play',...
            'Style','togglebutton',...
            'Visible','on',...
            'Callback',['if move_stop == 1;',...
                           'move_stop = 0;',...
                           'Sel_graph=get(gca,''Parent'')-(12-1);'...
                           'if move_stop == 0;',...
                              'if  move_stop == 0;',...
                                 'set(hb_map_h(Sel_graph).raw.play,''Visible'',''off'');',...
                                 'set(hb_map_h(Sel_graph).raw.stop,''Visible'',''on'');',...
                              'end;',...
                              'if para.sel_point > hb_graph_h(Sel_graph).time_max;',...
                                 'para.sel_point = hb_graph_h(Sel_graph).time_min;',...
                              'end;',... 
                              'if info(Sel_graph).probe_mode==1;',...
                                    '[hb_map_h] = hb_map33(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==2;',...
                                    '[hb_map_h] = hb_map44(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==3;',...
                                    '[hb_map_h] = hb_map35(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==4;',...
                                    '[hb_map_h] = hb_map311(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==5;',...
                                    '[hb_map_h] = hb_map310(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop);',...
                              'end;',...
                              'move_stop = 1;',...
                           'end;',...
                           'set(hb_map_h(Sel_graph).raw.play,''Value'',0);',...
                           'clear m_cnt;clear fig_no;',...
                        'else;',...
                            'set(hb_map_h(Sel_graph).raw.play,''Value'',0);',...
                            'warndlg(''Please push a stop button.'',''Warning !!'');',...
                        'end;',...
                        ],...
            'Tag','Pushbutton1');

%************ Movie Stop **************
hb_map_h(Sel_graph).raw.stop = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'Style','togglebutton',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 20 40 14],...
            'String','Stop',...
            'Callback',['Sel_graph=get(gca,''Parent'')-(12-1);'...
                        'if move_stop == 1;',...
                           'move_stop = 1;',...
                           'set(hb_map_h(Sel_graph).raw.stop,''Value'',0);',...
                        'else;',...
                           'move_stop = 1;',...
                        'end;',...
                        ],...
            'Tag','Pushbutton2');

move_stop ~= get(hb_map_h(Sel_graph).raw.stop,'Value');
   
while(1);
   fig_no = findobj('Type','figure');
   fig_flg=0;
   for cnt=1:length(fig_no);
      if (fig_no(cnt) == Sel_graph+(12-1));
         fig_flg=1;
         break;
      end;
   end;
   if fig_flg == 0;
      move_stop=1;
      break;
   end;
   if move_stop ~= 1;
      move_stop = get(hb_map_h(Sel_graph).raw.stop,'Value');
      if move_stop == 1;
         break;
      end;
   end;
   set(0,'CurrentFigure',hb_map_h(Sel_graph).topo_fig);
   set(hb_map_h(Sel_graph).raw.play,'Value',0);
   posi=get(hb_map_h(Sel_graph).topo_fig,'Position');
   if move_stop ~= 1;
      move_stop = get(hb_map_h(Sel_graph).raw.stop,'Value');
   end;
   if hb_data(Sel_graph).calc_flg==2;
      hb_map(1,:)  = hb_data(Sel_graph).fil(1,para.sel_point,:);
      hb_map(2,:)  = hb_data(Sel_graph).fil(2,para.sel_point,:);
      hb_map(3,:)  = hb_data(Sel_graph).fil(3,para.sel_point,:);
   else;
      hb_map(1,:)  = hb_data(Sel_graph).raw(1,para.sel_point,:);
      hb_map(2,:)  = hb_data(Sel_graph).raw(2,para.sel_point,:);
      hb_map(3,:)  = hb_data(Sel_graph).raw(3,para.sel_point,:); 
   end;

   %*******************************************
   for i=1:3;
   %******* It turns around the watch at 45 and interpolates. ******* 
      m(1,1) =(hb_map(i,10)+hb_map(i,29))/2;
      m(1,2) = hb_map(i,10);
      m(1,3) = hb_map(i,1);
      m(1,4) =(hb_map(i,1)+hb_map(i,2))/2;
      m(1,5) =(hb_map(i,1)+hb_map(i,2)*2+hb_map(i,3))/4;
      m(1,6) =(hb_map(i,1)+hb_map(i,2)*3+hb_map(i,3)*3+hb_map(i,4))/8;
      m(1,7) =(hb_map(i,1)+hb_map(i,2)*4+hb_map(i,3)*6+hb_map(i,4)*4+hb_map(i,5))/16; %
      m(1,8) =(hb_map(i,1)+hb_map(i,2)*5+hb_map(i,3)*10+hb_map(i,4)*10+hb_map(i,5)*5+hb_map(i,6))/32; %
      m(1,9) =(hb_map(i,1)+hb_map(i,2)*6+hb_map(i,3)*15+hb_map(i,4)*20+hb_map(i,5)*15+hb_map(i,6)*6+hb_map(i,7))/64; %
      m(1,10) =(hb_map(i,1)+hb_map(i,2)*7+hb_map(i,3)*21+hb_map(i,4)*35+hb_map(i,5)*35+hb_map(i,6)*21+hb_map(i,7)*7+hb_map(i,8))/128; %
      m(1,11) =(hb_map(i,1)+hb_map(i,2)*8+hb_map(i,3)*28+hb_map(i,4)*56+hb_map(i,5)*70+hb_map(i,6)*56+hb_map(i,7)*28+hb_map(i,8)*8+hb_map(i,9))/256; %

      m(2,1) =(hb_map(i,29));
      m(2,2) = hb_map(i,20);
      m(2,3) = hb_map(i,11);
      m(2,4) = hb_map(i,2);
      m(2,5) =(hb_map(i,2)+hb_map(i,3))/2;
      m(2,6) =(hb_map(i,2)+hb_map(i,3)*2+hb_map(i,4))/4;
      m(2,7) =(hb_map(i,2)+hb_map(i,3)*3+hb_map(i,4)*3+hb_map(i,5))/8;
      m(2,8) =(hb_map(i,2)+hb_map(i,3)*4+hb_map(i,4)*6+hb_map(i,5)*4+hb_map(i,6))/16; %   
      m(2,9) =(hb_map(i,2)+hb_map(i,3)*5+hb_map(i,4)*10+hb_map(i,5)*10+hb_map(i,6)*5+hb_map(i,7))/32; %
      m(2,10) =(hb_map(i,2)+hb_map(i,3)*6+hb_map(i,4)*15+hb_map(i,5)*20+hb_map(i,6)*15+hb_map(i,7)*6+hb_map(i,8))/64; %
      m(2,11) =(hb_map(i,2)+hb_map(i,3)*7+hb_map(i,4)*21+hb_map(i,5)*35+hb_map(i,6)*35+hb_map(i,7)*21+hb_map(i,8)*7+hb_map(i,9))/128; %
   
      m(3,1) =(hb_map(i,39));
      m(3,2) = hb_map(i,30);
      m(3,3) = hb_map(i,21);
      m(3,4) = hb_map(i,12);
      m(3,5) = hb_map(i,3);
      m(3,6) =(hb_map(i,3)+hb_map(i,4))/2;
      m(3,7) =(hb_map(i,3)+hb_map(i,4)*2+hb_map(i,5))/4;
      m(3,8) =(hb_map(i,3)+hb_map(i,4)*3+hb_map(i,5)*3+hb_map(i,6))/8;
      m(3,9) =(hb_map(i,3)+hb_map(i,4)*4+hb_map(i,5)*6+hb_map(i,6)*4+hb_map(i,7))/16; %   
      m(3,10) =(hb_map(i,3)+hb_map(i,4)*5+hb_map(i,5)*10+hb_map(i,6)*10+hb_map(i,7)*5+hb_map(i,8))/32; %
      m(3,11) =(hb_map(i,3)+hb_map(i,4)*6+hb_map(i,5)*15+hb_map(i,6)*20+hb_map(i,7)*15+hb_map(i,8)*6+hb_map(i,9))/64; %
   
      m(4,1) =(hb_map(i,39)+hb_map(i,40))/2;
      m(4,2) =(hb_map(i,40));
      m(4,3) = hb_map(i,31);
      m(4,4) = hb_map(i,22);
      m(4,5) = hb_map(i,13);
      m(4,6) = hb_map(i,4);
      m(4,7) =(hb_map(i,4)+hb_map(i,5))/2;
      m(4,8) =(hb_map(i,4)+hb_map(i,5)*2+hb_map(i,6))/4;
      m(4,9) =(hb_map(i,4)+hb_map(i,5)*3+hb_map(i,6)*3+hb_map(i,7))/8;
      m(4,10) =(hb_map(i,4)+hb_map(i,5)*4+hb_map(i,6)*6+hb_map(i,7)*4+hb_map(i,8))/16; %   
      m(4,11) =(hb_map(i,4)+hb_map(i,5)*5+hb_map(i,6)*10+hb_map(i,7)*10+hb_map(i,8)*5+hb_map(i,9))/32; %
   
      m(5,1) =(hb_map(i,39)+hb_map(i,40)*2+hb_map(i,41))/4;
      m(5,2) =(hb_map(i,40)+hb_map(i,41))/2;
      m(5,3) =(hb_map(i,41));
      m(5,4) = hb_map(i,32);
      m(5,5) = hb_map(i,23);
      m(5,6) = hb_map(i,14);
      m(5,7) = hb_map(i,5);
      m(5,8) =(hb_map(i,5)+hb_map(i,6))/2;
      m(5,9) =(hb_map(i,5)+hb_map(i,6)*2+hb_map(i,7))/4;
      m(5,10) =(hb_map(i,5)+hb_map(i,6)*3+hb_map(i,7)*3+hb_map(i,8))/8;
      m(5,11) =(hb_map(i,5)+hb_map(i,6)*4+hb_map(i,7)*6+hb_map(i,8)*4+hb_map(i,9))/16; %   
   
      m(6,1) =(hb_map(i,39)+hb_map(i,40)*3+hb_map(i,41)*3+hb_map(i,42))/8;
      m(6,2) =(hb_map(i,40)+hb_map(i,41)*2+hb_map(i,42))/4;
      m(6,3) =(hb_map(i,41)+hb_map(i,42))/2;
      m(6,4) =(hb_map(i,42));
      m(6,5) = hb_map(i,33);
      m(6,6) = hb_map(i,24);
      m(6,7) = hb_map(i,15);
      m(6,8) = hb_map(i,6);
      m(6,9) =(hb_map(i,6)+hb_map(i,7))/2;
      m(6,10) =(hb_map(i,6)+hb_map(i,7)*2+hb_map(i,8))/4;
      m(6,11) =(hb_map(i,6)+hb_map(i,7)*3+hb_map(i,8)*3+hb_map(i,9))/8;
   
      m(7,1) =(hb_map(i,39)+hb_map(i,40)*4+hb_map(i,41)*6+hb_map(i,42)*4+hb_map(i,43))/16; %   
      m(7,2) =(hb_map(i,40)+hb_map(i,41)*3+hb_map(i,42)*3+hb_map(i,43))/8;
      m(7,3) =(hb_map(i,41)+hb_map(i,42)*2+hb_map(i,43))/4;
      m(7,4) =(hb_map(i,42)+hb_map(i,43))/2;
      m(7,5) =(hb_map(i,43));
      m(7,6) = hb_map(i,34);
      m(7,7) = hb_map(i,25);
      m(7,8) = hb_map(i,16);
      m(7,9) = hb_map(i,7);
      m(7,10) =(hb_map(i,7)+hb_map(i,8))/2;
      m(7,11) =(hb_map(i,7)+hb_map(i,8)*2+hb_map(i,9))/4;
   
      m(8,1) =(hb_map(i,39)+hb_map(i,40)*5+hb_map(i,41)*10+hb_map(i,42)*10+hb_map(i,43)*5+hb_map(i,44))/32; %
      m(8,2) =(hb_map(i,40)+hb_map(i,41)*4+hb_map(i,42)*6+hb_map(i,43)*4+hb_map(i,44))/16; %   
      m(8,3) =(hb_map(i,41)+hb_map(i,42)*3+hb_map(i,43)*3+hb_map(i,44))/8;
      m(8,4) =(hb_map(i,42)+hb_map(i,43)*2+hb_map(i,44))/4;
      m(8,5) =(hb_map(i,43)+hb_map(i,44))/2;
      m(8,6) =(hb_map(i,44));
      m(8,7) = hb_map(i,35);
      m(8,8) = hb_map(i,26);
      m(8,9) = hb_map(i,17);
      m(8,10) = hb_map(i,8);
      m(8,11) =(hb_map(i,8)+hb_map(i,9))/2;
   
      m(9,1) =(hb_map(i,39)+hb_map(i,40)*6+hb_map(i,41)*15+hb_map(i,42)*20+hb_map(i,43)*15+hb_map(i,44)*6+hb_map(i,45))/64; %
      m(9,2) =(hb_map(i,40)+hb_map(i,41)*5+hb_map(i,42)*10+hb_map(i,43)*10+hb_map(i,44)*5+hb_map(i,45))/32; %
      m(9,3) =(hb_map(i,41)+hb_map(i,42)*4+hb_map(i,43)*6+hb_map(i,44)*4+hb_map(i,45))/16; %   
      m(9,4) =(hb_map(i,42)+hb_map(i,43)*3+hb_map(i,44)*3+hb_map(i,45))/8;
      m(9,5) =(hb_map(i,43)+hb_map(i,44)*2+hb_map(i,45))/4;
      m(9,6) =(hb_map(i,44)+hb_map(i,45))/2;
      m(9,7) =(hb_map(i,45));
      m(9,8) = hb_map(i,36);
      m(9,9) = hb_map(i,27);
      m(9,10) = hb_map(i,18);
      m(9,11) = hb_map(i,9);
   
      m(10,1) =(hb_map(i,39)+hb_map(i,40)*7+hb_map(i,41)*21+hb_map(i,42)*35+hb_map(i,43)*35+hb_map(i,44)*21+hb_map(i,45)*7+hb_map(i,46))/128; %
      m(10,2) =(hb_map(i,40)+hb_map(i,41)*6+hb_map(i,42)*15+hb_map(i,43)*20+hb_map(i,44)*15+hb_map(i,45)*6+hb_map(i,46))/32; %
      m(10,3) =(hb_map(i,41)+hb_map(i,42)*5+hb_map(i,43)*10+hb_map(i,44)*10+hb_map(i,45)*5+hb_map(i,46))/24; %
      m(10,4) =(hb_map(i,42)+hb_map(i,43)*4+hb_map(i,44)*6+hb_map(i,45)*4+hb_map(i,46))/16; %   
      m(10,5) =(hb_map(i,43)+hb_map(i,44)*3+hb_map(i,45)*3+hb_map(i,46))/8;
      m(10,6) =(hb_map(i,44)+hb_map(i,45)*2+hb_map(i,46))/4;
      m(10,7) =(hb_map(i,45)+hb_map(i,46))/2;
      m(10,8) =(hb_map(i,46));
      m(10,9) = hb_map(i,37);
      m(10,10) = hb_map(i,28);
      m(10,11) = hb_map(i,19);
   
      m(11,1) =(hb_map(i,39)+hb_map(i,40)*8+hb_map(i,41)*28+hb_map(i,42)*56+hb_map(i,43)*70+hb_map(i,44)*56+hb_map(i,45)*28+hb_map(i,46)*8+hb_map(i,47))/256; %
      m(11,2) =(hb_map(i,40)+hb_map(i,41)*7+hb_map(i,42)*21+hb_map(i,43)*35+hb_map(i,44)*35+hb_map(i,45)*21+hb_map(i,46)*7+hb_map(i,47))/128; %
      m(11,3) =(hb_map(i,41)+hb_map(i,42)*6+hb_map(i,43)*15+hb_map(i,44)*20+hb_map(i,45)*15+hb_map(i,46)*6+hb_map(i,47))/64; %
      m(11,4) =(hb_map(i,42)+hb_map(i,43)*5+hb_map(i,44)*10+hb_map(i,45)*10+hb_map(i,46)*5+hb_map(i,47))/32; %
      m(11,5) =(hb_map(i,43)+hb_map(i,44)*4+hb_map(i,45)*6+hb_map(i,46)*4+hb_map(i,47))/16; %   
      m(11,6) =(hb_map(i,44)+hb_map(i,45)*3+hb_map(i,46)*3+hb_map(i,47))/8;
      m(11,7) =(hb_map(i,45)+hb_map(i,46)*2+hb_map(i,47))/4;
      m(11,8) =(hb_map(i,46)+hb_map(i,47))/2;
      m(11,9) =(hb_map(i,47));
      m(11,10) = hb_map(i,38);
      m(11,11) =(hb_map(i,38)+hb_map(i,19))/2;
   
      pol = interp2(x,y,m,xi,yi,'spline');
      %pol = griddata(x,y,m,xi,yi,'nearest');
        
      %'linear'   The line form interpolation (default) of the triangle base  
      %'cubic'    The cubic interpolation of the triangle base
      %'nearest'  Recently, interpolation by the side point 
      %'invdist'  Reverse distance law 
      if move_stop ~= 1;
         move_stop = get(hb_map_h(Sel_graph).raw.stop,'Value');
      end;   
      for a=1:size(pol,1);  %x
         for b=1:size(pol,2); %y
            if a<11  & b<(-a+11);pol(a,b)=NaN;end;  % left 
            if a<101 & b>(a+21);pol(a,b)=NaN;end;   % upper
            if a>21  & b<(a-21);pol(a,b)=NaN;end;   % lower
            if a>90 & b>(-a+195);pol(a,b)=NaN;end;  % right
         end;
      end;
      if move_stop ~= 1;
         move_stop = get(hb_map_h(Sel_graph).raw.stop,'Value');
      end;
      %******* It is returned, and it draws. *******
      set(0,'CurrentFigure',hb_map_h(Sel_graph).topo_fig);
      if view_flg == 1;
         axes_fig(i)=axes('Position',hb_graph_h(Sel_graph).map(i).m);
      else;
         set(axes_fig(i),'Position',hb_graph_h(Sel_graph).map(i).m);
      end;
      set(gcf,'CurrentAxes',axes_fig(i));
      axes_pcol(i) = pcolor(pol);
      if move_stop ~= 1;
         move_stop = get(hb_map_h(Sel_graph).raw.stop,'Value');
      end;
      hold on;
      axis square;
      axis ij;
      axis off;
      shading interp;
      caxis([hb_map_h(Sel_graph).topo_min hb_map_h(Sel_graph).topo_max]);
      
      if para_p.angle(Sel_graph).angle1==1; % 0
         view(-45,90);
         if i==1; text(-5,-5,'Oxy');end;
         if i==2; text(-5,-5,'Deoxy');end;
         if i==3; text(-5,-5,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==2; % 90
         view(45,90);
         if i==1; text(30,70,'Oxy');end;
         if i==2; text(30,70,'Deoxy');end;
         if i==3; text(30,70,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==3; % 180
         view(135,90);
         if i==1; text(118,118,'Oxy');end;
         if i==2; text(118,118,'Deoxy');end;
         if i==3; text(118,118,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==4; % 270
         view(225,90);
         if i==1; text(80,40,'Oxy');end;
         if i==2; text(80,40,'Deoxy');end;
         if i==3; text(80,40,'Total');end;
      else;
         view(-45,90);
         if i==1; text(-5,-5,'Oxy');end;
         if i==2; text(-5,-5,'Deoxy');end;
         if i==3; text(-5,-5,'Total');end;
      end;
      zoom(3);
      plot3(15.0,-5.0,0,'ok','MarkerSize',3,'MarkerFaceColor','r');       % left up
      plot3(-5.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % left down
      plot3(85.0,105.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);       % right down
      plot3(105.0,85.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);       % right up

      if i==3;
         hb_map_h(Sel_graph).map_col=colorbar;
         set(hb_map_h(Sel_graph).map_col,'Position',[0.89 0.1 0.03 0.4]);
         set(hb_map_h(Sel_graph).map_col,'FontSize',7);
      end;
      hold off;

      clear pol;
      clear m;
   end;

   clear hb_map;

   if   view_flg == 1;
      hb_map_h(Sel_graph).raw.lab2 = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig, ...
               'Units','points', ...
               'BackgroundColor',[0.8 0.8 0.8], ...
               'Position',[posi(3)/1.35-posi(3)/10/1.35 15 30 10], ...
               'String','mMmm', ...
               'Style','text');

%      movie = ['drawnow;hb_data(Sel_graph).sel_point=hb_data(Sel_graph).sel_point+10;[hb_map_h] = hb_map35(para,info,hb_data,hb_graph_h,hb_map_h,Sel_graph);'];

      hb_map_h(Sel_graph).raw.min = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14],...
               'Style','edit',...
               'Interruptible','off',...
               'String',hb_map_h(Sel_graph).topo_min,...
               'Callback',['Sel_graph=get(gca,''Parent'')-(12-1);',...
                           'if move_stop == 1;',...
                              'h=findobj(gcf,''type'',''axes'');',...
                              'val=str2num(get(hb_map_h(Sel_graph).raw.min,''string''));',...
                              'if length(val) ~= 0;',...
                                 'ret=strchknum(get(hb_map_h(Sel_graph).raw.min,''string''));',...
                                 'val = round(val*100)/100;',...
                                 'if ret > 0;',...
                                    'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                 'elseif val >= hb_map_h(Sel_graph).topo_max | val < -1000;',...
                                    'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                 'else;',...
                                    'hb_map_h(Sel_graph).topo_min = val;',...
                                    'for i=1:4;',...
                                       'set(h(i),''Clim'',[hb_map_h(Sel_graph).topo_min hb_map_h(Sel_graph).topo_max]);',...
                                    'end;',...
                                    'clear i;',...
                                    'delete (hb_map_h(Sel_graph).map_col);',...
                                    'hb_map_h(Sel_graph).map_col=colorbar;',...  
                                    'set(hb_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                    'set(hb_map_h(Sel_graph).map_col,''FontSize'',7);',...
                                 'end;',...
                                 'set(hb_map_h(Sel_graph).raw.min,''string'', hb_map_h(Sel_graph).topo_min);',...
                                 'clear ret;',...
                              'else;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                 'set(hb_map_h(Sel_graph).raw.min,''string'', hb_map_h(Sel_graph).topo_min);',...
                              'end;',...
                           'end;',...
                           'clear val;clear h;'],...
                'Tag','EditText1');

      hb_map_h(Sel_graph).raw.lab1 = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String','mMmm',...% Ver 2.00 -><-
               'Tag','tag2');

      hb_map_h(Sel_graph).raw.max = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14],...
               'String',hb_map_h(Sel_graph).topo_max,...
               'Style','edit',...
               'Interruptible','off',...
               'Callback',['Sel_graph=get(gca,''Parent'')-(12-1);',...
                           'if move_stop == 1;',...
                              'h=findobj(gcf,''type'',''axes'');',...
   			                  'val=str2num(get(hb_map_h(Sel_graph).raw.max,''string''));',...
                              'if length(val) ~= 0;',...
                                 'ret=strchknum(get(hb_map_h(Sel_graph).raw.max,''string''));',...
                                 'val = round(val*100)/100;',...
                                 'if ret > 0;',...
                                    'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                 'elseif val <= hb_map_h(Sel_graph).topo_min | val > 1000;',...
                                    'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                 'else;',...
                                    'hb_map_h(Sel_graph).topo_max = val;',...
                                    'for i=1:4;',...
                                       'set(h(i),''Clim'',[hb_map_h(Sel_graph).topo_min hb_map_h(Sel_graph).topo_max]);',...
                                    'end;',...
                                    'clear i;',...
                                    'delete (hb_map_h(Sel_graph).map_col);',...
                                    'hb_map_h(Sel_graph).map_col=colorbar;',...  
                                    'set(hb_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                    'set(hb_map_h(Sel_graph).map_col,''FontSize'',7);',...
                                 'end;',...
                                 'set(hb_map_h(Sel_graph).raw.max,''string'', hb_map_h(Sel_graph).topo_max);',...
                                 'clear ret;',...
                              'else;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                 'set(hb_map_h(Sel_graph).raw.max,''string'', hb_map_h(Sel_graph).topo_max);',...
                              'end;',...
                           'end;',...
                           'clear val;clear h;'],...
               'Tag','EditText2');

      hb_map_h(Sel_graph).raw.t_lab = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
               'Position',[posi(3)/2-40 15 30 10],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String','sec',...% Ver 2.00 -><-
               'Tag','tag2');

      hb_map_h(Sel_graph).raw.time = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig,...
               'Position',[posi(3)/2 15 40 10],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String',para.sel_point*info(Sel_graph).smpl_period/1000,...% Ver 2.00 -><-
               'Tag','tag2');
   
      %************ Movie Start **************b1 = uicontrol('Parent',graph_h.Hb_fig, ...

      %************** refresh **************
      hb_map_h(Sel_graph).raw_ref = uicontrol('Parent',hb_map_h(Sel_graph).topo_fig, ...
           'Units','points', ...
           'BackgroundColor',[1.0 0.9 0.1], ...
           'Position',[1 0 35 14], ...
           'Interruptible','off',...
           'String','Refresh',...
           'Callback',['Sel_graph=get(gca,''Parent'')-(12-1);'...
                       'posi=get(gcf,''Position'');',...
                       'if move_stop == 1;',...
                          'set(hb_map_h(Sel_graph).raw.max,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14]);',...
                          'set(hb_map_h(Sel_graph).raw.min,''Position'',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14]);',...
                          'set(hb_map_h(Sel_graph).raw.lab1,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14]);',...
                          'set(hb_map_h(Sel_graph).raw.lab2,''Position'',[posi(3)/1.35-posi(3)/10/1.35 15 30 10]);',...
                          'set(hb_map_h(Sel_graph).raw.t_lab,''Position'',[posi(3)/2-40 15 30 10]);',...
                          'set(hb_map_h(Sel_graph).raw.time,''Position'',[posi(3)/2 15 40 10]);',...
                       'end;',...
                       'clear posi;',...
                       ],...
                      'Tag','Pushbutton3');

      fig_no=findobj('Type','figure');
      for cnt=1:length(fig_no);
         %***** AD ****
         if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** topo ****
         if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            if fig_no(cnt) ~= Sel_graph+(12-1);
               obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
               set(obj,'Enable','off');
            end;
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** fft ****
         if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** PCA ****
         if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
         end;
         %***** weight ****
         if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl topo ****
         if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl ****
         if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** spect ****
         if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         % 3D map
         if (fig_no(cnt) == (80));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
            set(obj,'Enable','off');
         end;
      end;
   end;

   view_flg=0;

   if move_stop ~= 1;
%      for cnt=1:5;
 %        if (cnt==1 & para_p.sel_prb1 ~=1) | (cnt==2 & para_p.sel_prb2 ~=1) | (cnt==3 & para_p.sel_prb3 ~=1) |(cnt==4 & para_p.sel_prb4 ~=1) |(cnt==5 & para_p.sel_prb5 ~=1);
 %        elseif (cnt==1 & para_p.load_prb1 ~=1 ) | (cnt==2 & para_p.load_prb2 ~=1) | (cnt==3 & para_p.load_prb3 ~=1) | (cnt==4 & para_p.load_prb4 ~=1) | (cnt==5 & para_p.load_prb5 ~=1);
 %        else;
            if isfield(hb_map_h(Sel_graph).raw,'stop') == 1;
               move_stop = get(hb_map_h(Sel_graph).raw.stop,'Value');
            end;
            if move_stop == 1;
               break;
            end;
%         end;
%      end;
      if move_stop ~= 1;
         drawnow;
      end;
   end;

   if move_stop == 1;
      break;
   else;
      para.sel_point =para.sel_point+2;
      if para.sel_point > hb_graph_h(Sel_graph).time_max;
         para.sel_point = round(hb_graph_h(Sel_graph).time_min);
      end;
      set(hb_map_h(Sel_graph).raw.time,'String',para.sel_point*info(Sel_graph).smpl_period/1000);
   end;
   clear hb_map;clear m;
%fprintf('1@%f@\n',hb_map_h(Sel_graph).raw.stop);
end;

fig_no=findobj('Type','figure');
for cnt=1:length(fig_no);
   if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;   
   %***** PCA ****
   if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
   end;
   %***** weight ****
   if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   %***** kl topo ****
   if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) == (80));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
      set(obj,'Enable','on');
   end;
end;   
   
clear cnt;
move_stop = 1;
return;
