%*******************************************************
%*                Spactgram Analysis                   *
%*                  Shingo Kawasaki                    *
%*                     2006/3/1                        *
%*******************************************************
function [hb_graph_h] = hb_spect(info,para,para_p,mark,hb_data,hb_graph_h,Sel_graph);

p_cnt = Sel_graph;
if hb_data(Sel_graph).calc_flg==2;
    if isfield(hb_data(Sel_graph),'fil') ~= 1;
        warndlg('Please set and re-calculate a filter.','Warning');
        return;
    end;
end;

Fs       = 1000/info(Sel_graph).smpl_period;
nfft     = round(length(hb_data(Sel_graph).raw(1,:,1))/10);
spec_fig = figure(75+(Sel_graph-1));
clf;
hb_graph_h(Sel_graph).spec_fig = spec_fig;

if hb_data(Sel_graph).calc_flg==2;
    if isfield(hb_data(Sel_graph),'fil') == 1;
        if hb_graph_h(Sel_graph).spect_chk_val == 1;
            set(spec_fig,'Name',sprintf('Spectgram Probe %d Oxy(Filter)',Sel_graph),'ToolBar','none');
        elseif hb_graph_h(Sel_graph).spect_chk_val == 2;
            set(spec_fig,'Name',sprintf('Spectgram Probe %d Dexy(Filter)',Sel_graph),'ToolBar','none');
        elseif hb_graph_h(Sel_graph).spect_chk_val == 3;
            set(spec_fig,'Name',sprintf('Spectgram Probe %d Total(Filter)',Sel_graph),'ToolBar','none');
        end;
    else;
        warndlg('Please set and re-calculate a filter.','Warning');
        return;
    end;
else;
    if hb_graph_h(Sel_graph).spect_chk_val == 1;
        set(spec_fig,'Name',sprintf('Spectgram Probe %d Oxy',Sel_graph),'ToolBar','none');
    elseif hb_graph_h(Sel_graph).spect_chk_val == 2;
        set(spec_fig,'Name',sprintf('Spectgram Probe %d deoxy',Sel_graph),'ToolBar','none');
    elseif hb_graph_h(Sel_graph).spect_chk_val == 3;
        set(spec_fig,'Name',sprintf('Spectgram Probe %d Total',Sel_graph),'ToolBar','none');
    end;
end;
plotedit(spec_fig,'hidetoolsmenu');

%************ Button **************
%************** check **************
hb_graph_h(Sel_graph).spect_chk = uicontrol('Parent',hb_graph_h(Sel_graph).spec_fig,...
    'Units','points',...
    'Position',[1 15 41 15], ...
    'BackgroundColor',[1 1 1], ...
    'Style','popupmenu',...
    'String','Oxy  |Deoxy|Total',...
    'Value',hb_graph_h(Sel_graph).spect_chk_val,...
    'Callback',['Sel_graph=get(gca,''Parent'')-(75-1);',...
    'hb_graph_h(Sel_graph).spect_chk_val = get(hb_graph_h(Sel_graph).spect_chk,''value'');',...
    '[hb_graph_h] = hb_spect(info,para,para_p,mark,hb_data,hb_graph_h,Sel_graph);',...
    'clear ch;',...
    ],...
    'Tag','Checkbox1');

%************** refresh **************
hb_graph_h(Sel_graph).spect_ref = uicontrol('Parent',hb_graph_h(Sel_graph).spec_fig, ...
    'Units','points', ...
    'BackgroundColor',[1.0 0.9 0.1], ...
    'Position',[1 0 35 14], ...
    'String','Refresh',...
    'Callback',['Sel_graph=get(gca,''Parent'')-(75-1);'...
    'posi=get(hb_graph_h(Sel_graph).spec_fig,''Position'');',...
    'set(hb_graph_h(Sel_graph).spect_lab,''Position'',[posi(3)/1.35-posi(3)/10/1.35 1 45 10]);',...
    'clear posi;',...
    ],...
    'tag','Pushbutton3');

set(0,'CurrentFigure',hb_graph_h(Sel_graph).spec_fig);

%***************** Plot ********************
for ch=1:info(Sel_graph).ad_ch_max/2;
    h = axes('Position',hb_graph_h(Sel_graph).graph_posi(ch).p);
    if hb_data(Sel_graph).calc_flg==2;
        if hb_graph_h(Sel_graph).spect_chk_val == 1;
            specgram(hb_data(Sel_graph).fil(1,:,ch),nfft,Fs);
        elseif hb_graph_h(Sel_graph).spect_chk_val == 2;
            specgram(hb_data(Sel_graph).fil(2,:,ch),nfft,Fs);
        elseif hb_graph_h(Sel_graph).spect_chk_val == 3;
            specgram(hb_data(Sel_graph).fil(3,:,ch),nfft,Fs);
        end;
    else;
        if hb_graph_h(Sel_graph).spect_chk_val == 1;
            specgram(hb_data(Sel_graph).raw(1,:,ch),nfft,Fs);
        elseif hb_graph_h(Sel_graph).spect_chk_val == 2;
            specgram(hb_data(Sel_graph).raw(2,:,ch),nfft,Fs);
        elseif hb_graph_h(Sel_graph).spect_chk_val == 3;
            specgram(hb_data(Sel_graph).raw(3,:,ch),nfft,Fs);
        end;
    end;
    hold on;
    title(['CH',num2str(ch)],'FontSize',para_p.fsize);
    if hb_data(Sel_graph).ana_mode == 1; % Continuaus
        for num=1:mark.num;
            plot([mark.point(num,2)*info(Sel_graph).smpl_period/1000 mark.point(num,2)*info(Sel_graph).smpl_period/1000],[0 Fs/2],':k');
            if info(Sel_graph).measure_mode(1) ==1; % STIM
                plot([mark.point(num,3)*info(Sel_graph).smpl_period/1000 mark.point(num,3)*info(Sel_graph).smpl_period/1000],[0 Fs/2],':k');
            end;
        end;
    elseif hb_data(Sel_graph).ana_mode == 2;  % Integral
        if info(Sel_graph).measure_mode(1) == 1;  % STIM
            if para.sel_move == 0;
                add_mark  = find(mark.ave==1);
            else;
                add_mark  = find(mark.ave==1 & mark.move==0);
            end;
            block = mark.point(add_mark(1),3)-mark.point(add_mark(1),2)+para.pre+para.post+para.relax;
            plot([para.pre/10 para.pre/10],[0 Fs/2],'Color',[0.1 0.1 0.1]);
            plot([(block-para.relax-para.post)/10 (block-para.relax-para.post)/10],[0 Fs/2],'Color',[0.1 0.1 0.1]);
        elseif info(Sel_graph).measure_mode(1)==2;
            block = 1+para.pre+para.post+para.relax;
            plot([para.pre/10 para.pre/10],[0 Fs/2],'Color',[0.1 0.1 0.1]);
        end;
    end;
    axis([0 length(hb_data(Sel_graph).raw)*info(Sel_graph).smpl_period/1000 0 Fs/2]);
    set(gca,'ytick',[0 Fs/4 Fs/2]);
    set(gca,'yticklabel',[0 Fs/4 Fs/2 ]);
    set(gca,'xtick',[0 length(hb_data(Sel_graph).raw)*info(Sel_graph).smpl_period/1000/2 length(hb_data(Sel_graph).raw)*info(Sel_graph).smpl_period/1000]);
    set(gca,'xticklabel',[0 length(hb_data(Sel_graph).raw)*info(Sel_graph).smpl_period/1000/2 length(hb_data(Sel_graph).raw)*info(Sel_graph).smpl_period/1000]);
    set(gca,'Fontsize',para_p.fsize);
    label_put(info,hb_graph_h,para,para_p,Sel_graph,ch,spec_fig,h);
    hold off;
end;

hb_graph_h(Sel_graph).spect_color = colorbar;
set(hb_graph_h(Sel_graph).spect_color,'Position',[0.93 0.05 0.02 0.15]);
set(hb_graph_h(Sel_graph).spect_color,'FontSize',para_p.fsize);
set(h,'Position',hb_graph_h(Sel_graph).graph_posi(ch).p);
posi = get(hb_graph_h(Sel_graph).spec_fig,'Position');
hb_graph_h(Sel_graph).spect_lab = uicontrol('Parent',hb_graph_h(Sel_graph).spec_fig, ...
    'Units','points', ...
    'BackgroundColor',[0.8 0.8 0.8], ...
    'Position',[posi(3)/1.35-posi(3)/10/1.35 1 45 10], ...
    'String','Frequency', ...
    'Style','text');
clear posi;
clear Fs;
clear ch;

%***********************************************************
function pos_reset(info,para_p,hb_graph_h,p_cnt,ch,h);
% graph size Resetting  for ver 7 under
if info(1).sys_ver >= 7;
    posi_tilt = [ 0 0 0 0];
else;
    posi_tilt = [ 0 0 0.02 0];
end;
if info(p_cnt).probe_mode==1;    % 3x3
    if para_p.angle(p_cnt).angle2==1;  % 0
        if ch == 24;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle2==2;  % 90
        if ch == 17;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle2==3;  % 180
        if ch == 13;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle2==3;  % 270
        if ch == 20;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    end;
elseif info(p_cnt).probe_mode==2;    % 4x4
    if para_p.angle(p_cnt).angle1==1;  % 0
        if ch == 24;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==2;  % 90
        if ch == 7;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 180
        if ch == 1;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 270
        if ch == 18;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    end;
elseif info(p_cnt).probe_mode==3;    % 3x5
    if para_p.angle(p_cnt).angle1==1;  % 0
        if ch == 22;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==2;  % 90
        if ch == 9;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 180
        if ch == 1;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 270
        if ch == 14;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    end;
elseif info(p_cnt).probe_mode==4;    % 3x11
    if para_p.angle(p_cnt).angle1==1;  % 0
        if ch == 52;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==2;  % 90
        if ch == 21;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 180
        if ch == 1;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 270
        if ch == 32;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    end;
elseif info(p_cnt).probe_mode==4;    % 3x10
    if para_p.angle(p_cnt).angle1==1;  % 0
        if ch == 47;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==2;  % 90
        if ch == 19;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 180
        if ch == 1;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    elseif para_p.angle(p_cnt).angle1==3;  % 270
        if ch == 29;
            set(h,'Position',hb_graph_h(p_cnt).graph_posi(ch).p+posi_tilt);
        end;
    end;
end;
