% input_para(Not Function)
%
% Input : none
% Output: none
% Example: input_para;

%*******************************************************
%*            Input Parameter(Not Function)            *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% history?F02.11.11 Ver1.01  futahashi KL A conversion function is added.
% history?F03.05.06 Ver2.00 Isawa      ETG7000 Correspondence
% history :03.11.07 Ver2.01 Kusabuka   5 Probe load
%********** Initial Value ***********

%fprintf('input_para\n');
if Mode == MOD_INIT;
   para.pre      = '';
   para.relax    = '';
   para.post     = '';
else;
%070302
%   para.pre      = round(10*1000/info(dis_no).smpl_period);
%   para.relax    = round(10*1000/info(dis_no).smpl_period);
%   para.post     = round(10*1000/info(dis_no).smpl_period);
end;

% It is indicated without storing data at the time of the initialization.
  
if Mode == MOD_INIT;
   para.base_st  = '';
   para.base_ed  = '';
   para.high_val = '';
   para.low_val  = '';
   para.high_flg = '';
   para.low_flg  = '';
   para.fit_val  = '';
   para.sel_topo = '';
   para.sel_move=0;
   para.high_flg = 0;
   para.low_flg  = 0;
   para_p.sel_prb1 = 1;
   para_p.sel_prb2 = 1;
   para_p.sel_prb3 = 1;
   para_p.sel_prb4 = 1;
   para_p.sel_prb5 = 1;
   para_p.max_prb = 5;
   para.moveave_flg = 0;
   para.move_val  = '';
   para_p.del_ch = 0;
else;
%   para.base_st  = 1;
%   para.base_ed  = round(10*1000/info(dis_no).smpl_period);
   para.high_val = 0.01;
   para.low_val  = 0.5;
   para.high_flg = 0;
   para.low_flg  = 1;
   para.fit_val  = 1;
   para.sel_topo = 1;
   para.sel_move=0;
   para.moveave_flg = 1;
%   para.move_val  = info(dis_no).smpl_period/1000*2;
   para.move_val  = info(dis_no).smpl_period/1000*10;
   para_p.del_ch = 0;
end;

% base posi
pos_left  = 250;
pos_top = 110;

%**** Frame ****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left pos_top-50 340 220],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','frame',...
              'Tag','Frame1');

%*********** Analyze continuous ***********
%**** Frame Analyze param ****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+10 pos_top-5-4 100 165+4],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','frame',...
              'Tag','Frame1');

%***** Text Continuous[s] *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+20 pos_top+140 80 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Continuous[s]',...
              'Tag','StaticText1');
%***** Text Base Start *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+12 pos_top+130 50 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Base Start',...
              'Tag','StaticText1');

%***** Edit Base Start *****
main_h.base_st = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+62 pos_top+130 40 15],...
              'Style','edit',...
              'String', para.base_st*info(dis_no).smpl_period/1000,...
              'Callback',['val=str2num(get(gcbo,''string''));',...
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...                                      % string 0 data 
                                'ret=strchknum(get(gcbo,''string''));',...
                                'if ret > 0;',...
                                   'set(main_h.base_st,''string'',para.base_st*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= 0 | para.base_ed <= val/(info(dis_no).smpl_period/1000);',... 
                                   'set(main_h.base_st,''string'',para.base_st*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif rem(val*1000,info(dis_no).smpl_period) == 0;',...    % 
                                   'para.base_st = val*inv(info(dis_no).smpl_period/1000);',... 
                                'else;',...
                                   'set(main_h.base_st,''string'',para.base_st*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'end;',...
                             'else;',...
                                'set(main_h.base_st,''string'',para.base_st*info(dis_no).smpl_period/1000);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.base_st,''string'',para.base_st*info(dis_no).smpl_period/1000);',...
                          'end;',...
                          'clear val;clear ret;'],...
              'Tag','base1');
           
%***** Text Base End*****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+12 pos_top+110 50 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Base End  ',...
              'Tag','StaticText1');

%***** Edit Base End *****
main_h.base_ed = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+62 pos_top+110 40 15],...
              'Style','edit',...
              'String', para.base_ed*info(dis_no).smpl_period/1000,...
              'Callback',['val=str2num(get(gcbo,''string''));',... 
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(gcbo,''string''));',...
                                'if ret > 0;',...
                                   'set(main_h.base_ed,''string'',para.base_ed*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val/(info(dis_no).smpl_period/1000) <= para.base_st | val/(info(dis_no).smpl_period/1000) > info(dis_no).datanum;',...% 0 data 
                                   'set(main_h.base_ed,''string'',para.base_ed*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif rem(val*1000,info(dis_no).smpl_period) == 0;',...
                                   'para.base_ed = val*inv(info(dis_no).smpl_period/1000);',... 
                                'else;',...
                                   'set(main_h.base_ed,''string'',para.base_ed*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'end;',...
                             'else;',...
                                'set(main_h.base_ed,''string'',para.base_ed*info(dis_no).smpl_period/1000);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.base_ed,''string'',para.base_ed*info(dis_no).smpl_period/1000);',...
                          'end;',...
                          'clear val;clear ret;'],...
              'Tag','base2');
          
%*********** Analyze int ***********
%***** Text Integral[s] *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+20 pos_top+90 80 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Integral[s]',...
              'Tag','StaticText1');
           
%***** Text Pre Time  *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+12 pos_top+78 50 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Pre Time  ',...
              'Tag','StaticText1');

%***** Text Relax Time *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+12 pos_top+58 50 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Relax Time',...
              'Tag','StaticText1');

%***** Text Post Time *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+12 pos_top+38 50 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Post Time ',...
              'Tag','StaticText1');

%***** Edit pre Time *****
main_h.pre = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+62 pos_top+78 40 15],...
              'Style','edit',...
              'String',para.pre*info(dis_no).smpl_period/1000,...
              'Callback',['val=str2num(get(gcbo,''string''));',... 
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(gcbo,''string''));',...
                                'if ret > 0;',...
                                   'set(main_h.pre,''string'',para.pre*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= 0 | val/(info(dis_no).smpl_period/1000) > info(dis_no).datanum;',...
                                   'set(main_h.pre,''string'',para.pre*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif rem(val*1000,info(dis_no).smpl_period) == 0;',...
                                   'para.pre = val*inv(info(dis_no).smpl_period/1000);',... 
                                'else;',...
                                   'set(main_h.pre,''string'',para.pre*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'end;',...
                             'else;',...
                                'set(main_h.pre,''string'',para.pre*info(dis_no).smpl_period/1000);',...
                                'warndlg(''4An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.pre,''string'',para.pre*info(dis_no).smpl_period/1000);',...
                          'end;',...
                          'clear val;clear ret;'],...
              'Tag','pre1');

%***** Edit relax Time *****
main_h.relax = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+62 pos_top+58 40 15],...
              'Style','edit',...
              'String',para.relax*info(dis_no).smpl_period/1000,...
              'Callback',['val=str2num(get(gcbo,''string''));',... 
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(gcbo,''string''));',...
                                'if ret > 0;',...
                                   'set(main_h.relax,''string'',para.relax*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= 0 | val/(info(dis_no).smpl_period/1000) > info(dis_no).datanum;',...
                                   'set(main_h.relax,''string'',para.relax*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif rem(val*1000,info(dis_no).smpl_period) == 0;',...
                                   'para.relax = val*inv(info(dis_no).smpl_period/1000);',... 
                                'else;',...
                                   'set(main_h.relax,''string'',para.relax*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'end;',...
                             'else;',...
                                'set(main_h.relax,''string'',para.relax*info(dis_no).smpl_period/1000);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.relax,''string'',para.relax*info(dis_no).smpl_period/1000);',...
                          'end;',...
                          'clear val;clear ret;'],...
              'Tag','relax1');

%***** Edit post Time *****
main_h.post = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+62 pos_top+38 40 15],...
              'Style','edit',...
              'String',para.post*info(dis_no).smpl_period/1000,...
              'Callback',['val=str2num(get(gcbo,''string''));',... 
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(gcbo,''string''));',...
                                'if ret > 0;',...
                                   'set(main_h.post,''string'',para.post*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= 0 | val/(info(dis_no).smpl_period/1000) > info(dis_no).datanum;',...
                                   'set(main_h.post,''string'',para.post*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif rem(val*1000,info(dis_no).smpl_period) == 0;',...
                                   'para.post = val*inv(info(dis_no).smpl_period/1000);',... 
                                'else;',...
                                   'set(main_h.post,''string'',para.post*info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'end;',...
                             'else;',...
                                'set(main_h.post,''string'',para.post*info(dis_no).smpl_period/1000);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.post,''string'',para.post*info(dis_no).smpl_period/1000);',...
                          'end;',...
                          'clear val;clear ret;'],...
              'Tag','post1');

%*********** Set Filter ***********
%**** Frame Filter parameter ****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+120 pos_top+105-15 100 55+15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','frame',...
              'Tag','Frame1');

%***** Text Filter[Hz] Average[sec] *****
h = uicontrol('Parent',MainFigure,...
	           'Units','points',...
              'Position',[pos_left+123 pos_top+140 93 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Filter[Hz] Average[sec]',...
              'Tag','StaticText1');

%***** Check HighPass *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+123.5 pos_top+130 50 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','HighPass',...
              'Value',para.high_flg,...
              'Callback',['if get(gcbo,''value'')==1;',...
                             'para.high_flg=1;',...
                             'if para_p.cal_flg1~=0;hb_data(1).calc_flg=2;end;',...
                             'if para_p.cal_flg2~=0;hb_data(2).calc_flg=2;end;',...
                             'if para_p.cal_flg3~=0;hb_data(3).calc_flg=2;end;',...
                             'if para_p.cal_flg4~=0;hb_data(4).calc_flg=2;end;',...
                             'if para_p.cal_flg5~=0;hb_data(5).calc_flg=2;end;',...
                          'end;',... 
                          'if get(gcbo,''value'')==0;',...
                             'para.high_flg=0;',...
                             'if para_p.cal_flg1~=0 & para.low_flg==0; hb_data(1).calc_flg=1;end;',...
                             'if para_p.cal_flg2~=0 & para.low_flg==0; hb_data(2).calc_flg=1;end;',...
                             'if para_p.cal_flg3~=0 & para.low_flg==0; hb_data(3).calc_flg=1;end;',...
                             'if para_p.cal_flg4~=0 & para.low_flg==0; hb_data(4).calc_flg=1;end;',...
                             'if para_p.cal_flg5~=0 & para.low_flg==0; hb_data(5).calc_flg=1;end;',...
                          'end;',...
                         ],... 
              'Tag','Checkbox1');
           
%***** Check LowPass *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+123.5 pos_top+110.5+2 50.75 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','LowPass',...
              'Value',para.low_flg,...
              'Callback',['if get(gcbo,''value'')==1;',...
                             'para.low_flg=1;',...
                             'if para_p.cal_flg1~=0;hb_data(1).calc_flg=2;end;',...
                             'if para_p.cal_flg2~=0;hb_data(2).calc_flg=2;end;',...
                             'if para_p.cal_flg3~=0;hb_data(3).calc_flg=2;end;',...
                             'if para_p.cal_flg4~=0;hb_data(4).calc_flg=2;end;',...
                             'if para_p.cal_flg5~=0;hb_data(5).calc_flg=2;end;',...
                          'end;',... 
                          'if get(gcbo,''value'')==0;',...
                             'para.low_flg=0;',...
                             'if para_p.cal_flg1~=0 & para.high_flg==0; hb_data(1).calc_flg=1;end;',...
                             'if para_p.cal_flg2~=0 & para.high_flg==0; hb_data(2).calc_flg=1;end;',...
                             'if para_p.cal_flg3~=0 & para.high_flg==0; hb_data(3).calc_flg=1;end;',...
                             'if para_p.cal_flg4~=0 & para.high_flg==0; hb_data(4).calc_flg=1;end;',...
                             'if para_p.cal_flg5~=0 & para.high_flg==0; hb_data(5).calc_flg=1;end;',...
                          'end;',...
                          ],... 
              'Tag','Checkbox1');

%***** Edit High Pass val *****
main_h.high_val = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+175+5 pos_top+130-1 40-5 15],...
              'Style','edit',...
              'String',para.high_val,...
              'Callback',['val=str2num(get(main_h.high_val,''string''));',...
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(main_h.high_val,''string''));',...
                                'val = round(val*100)/100;',...
                                'if ret > 0;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= 0 | val > 5;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val >= (1000/info(dis_no).smpl_period)/2;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'else;',...
                                   'para.high_val = val;',... 
                                'end;',...
                                'set(main_h.high_val,''string'',para.high_val);',...
                             'else;',...
                                'set(main_h.high_val,''string'',para.high_val);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.high_val,''string'',para.high_val);',...
                          'end;',...
                          'clear val;clear ret;'],...
              'Tag','high1');

%***** Edit Low Pass val *****
main_h.low_val = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+175+5 pos_top+110.5+2 35 15],...
              'Style','edit',...
              'String',para.low_val,...
              'Callback',['val=str2num(get(main_h.low_val,''string''));',...
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(main_h.low_val,''string''));',...
                                'val = round(val*100)/100;',...
                                'if ret > 0;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= 0 | val > 5;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val >= (1000/info(dis_no).smpl_period)/2;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'else;',...
                                   'para.low_val = val;',... 
                                'end;',...
                                'set(main_h.low_val,''string'',para.low_val);',...
                             'else;',...
                                'set(main_h.low_val,''string'',para.low_val);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.low_val,''string'',para.low_val);',...
                          'end;',...
                          'clear val;clear ret;'],...
         		'Tag','low1');

%***** Check Moving Average *****
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+123.5 pos_top+130-35 60 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','MovingAve',...
              'Value',para.moveave_flg,...
              'Callback',['if get(gcbo,''value'')==1;',...
                             'para.moveave_flg=1;',...
                             'if para_p.cal_flg1~=0;hb_data(1).calc_flg=2;end;',...
                             'if para_p.cal_flg2~=0;hb_data(2).calc_flg=2;end;',...
                             'if para_p.cal_flg3~=0;hb_data(3).calc_flg=2;end;',...
                             'if para_p.cal_flg4~=0;hb_data(4).calc_flg=2;end;',...
                             'if para_p.cal_flg5~=0;hb_data(5).calc_flg=2;end;',...
                          'end;',... 
                          'if get(gcbo,''value'')==0;',...
                             'para.moveave_flg=0;',...
                             'if para_p.cal_flg1~=0 & para.moveave_flg==0; hb_data(1).calc_flg=1;end;',...
                             'if para_p.cal_flg2~=0 & para.moveave_flg==0; hb_data(2).calc_flg=1;end;',...
                             'if para_p.cal_flg3~=0 & para.moveave_flg==0; hb_data(3).calc_flg=1;end;',...
                             'if para_p.cal_flg4~=0 & para.moveave_flg==0; hb_data(4).calc_flg=1;end;',...
                             'if para_p.cal_flg5~=0 & para.moveave_flg==0; hb_data(5).calc_flg=1;end;',...
                          'end;',...
                         ],... 
              'Tag','Checkbox3');

%***** Edit Moving Average *****
main_h.move_val = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[1 1 1],...
              'Position',[pos_left+175+5 pos_top+130.5-35 35 15],...
              'Style','edit',...
              'String',para.move_val,...
              'Callback',['val=str2num(get(main_h.move_val,''string''));',...
                          'if Mode ~= MOD_INIT;',...
                             'if length(val) ~= 0;',...
                                'ret=strchknum(get(main_h.move_val,''string''));',...
                                'val = round(val*100)/100;',...
                                'if ret > 0;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val <= info(1).smpl_period/1000;',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'elseif val >= info(Sel_graph).datanum*(info(dis_no).smpl_period/1000);',...
                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                'else;',...
                                   'para.move_val = val;',... 
                                'end;',...
                                'set(main_h.move_val,''string'',para.move_val);',...
                             'else;',...
                                'set(main_h.move_val,''string'',para.move_val);',...
                                'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                             'end;',...
                          'else;',...
                             'set(main_h.move_val,''string'',para.move_val);',...
                          'end;',...
                          'clear val;clear ret;'],...
         		'Tag','low1');
            
%*************** Select Add Mark *******************
%****** Initialyzation *******
para_h.mark_sel  = 1;

%***** Text Select Mark *****
h = uicontrol('Parent',MainFigure,... 
              'Units','points',...
              'Position',[pos_left+228 pos_top+135 100 20],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','text',...
              'String','Select Mark(DoubleClick)',...
              'Tag','StaticText1');

%***** Mark make ********
input_mark;
para_h.mark_p = uicontrol('Parent',MainFigure,...
                          'Units','points',...
                          'BackgroundColor',[1 1 1],...
                          'Position',[250+227 110+20 105 105+20],...
                          'String',mark.char,...
                          'Style','listbox',...
                          'Tag','Listbox2',...
                          'ListboxTop',para_h.mark_sel,...
                          'Value',para_h.mark_sel,...
                          'Callback',['if strcmp(get(MainFigure,''SelectionType''),''open'');',...   %double click
                                         'para_h.mark_sel = get(gcbo,''value'');',...
                                         'if mark.num~=0;',...                                % data cnt
                                            'if mark.ave(para_h.mark_sel)==0;',...           % mark set on
                                                'mark.ave(para_h.mark_sel)=1;',...
                                                'ret = inttmchk(info,para,mark,hb_data,Sel_graph,para.pre,para.post,para.relax);',...
                                                'if ret > 0;',...                            % integral time err
                                                   'mark.ave(para_h.mark_sel)=0;',...
                                                   'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                                                'else;',...
                                                'end;',...
                                            'elseif mark.ave(para_h.mark_sel)==1;',...       % mark set off
                                               'mark.ave(para_h.mark_sel)=0;',...
                                            'end;',...
                                            'input_mark;',...   
                                            'set(para_h.mark_p,''String'',squeeze(mark.char(:,:)));',...
                                         'end;',...
                                      'end;',...
                                      'clear fig;clear ret;']);

%*********** Frame Display paramater ***********
h = uicontrol('Parent',MainFigure,... 
              'Units','points',...
              'Position',[pos_left+120 pos_top-9 100 100],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','frame',...
              'Tag','Frame1');

%****** Check Topo *********   
t = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+170 pos_top+38-5-3 45 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Topo',...
              'Visible','off',...
              'Value',1,...
              'Callback',['if get(gcbo,''value'')==1;para.sel_topo=1;end;',...
                          'if get(gcbo,''value'')==0;para.sel_topo=0;end;'],... 
              'Tag','Checkbox2');

%****** Check Body move *********   
main_h.move = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+123.5 pos_top+16.75-5+2 75 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Body Movement',...
              'Value',0,...
              'Callback',['if get(gcbo,''value'')==1;para.sel_move=1;end;',...
                          'if get(gcbo,''value'')==0;para.sel_move=0;end;',...
                          'p_cnt=1;',...
                          'para_h.mark_sel=1;',...
                          'input_move;',...
                          'input_mark;',...
                          'set(para_h.mark_p,''String'',squeeze(mark.char(:,:)));',...
                          'clear p_cnt;'],...
              'Tag','Checkbox3');

%****** Check Exception Ch *********  
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+123.5 pos_top-0.5-5+4 65 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Exception Ch',...
              'Value',0,...
              'Callback',['if get(gcbo,''value'')==1;para_p.del_ch=1;end;',...
                          'if get(gcbo,''value'')==0;para_p.del_ch=0;end;',...
                         ],...
              'Tag','Checkbox4'); 
%                          'del_fig(7,11);',...   % hb graph
%                          'del_fig(58,62);',...  % reconstruct hb graph
%                          'del_fig(12,16);',...  % topo
%                          'del_fig(63,67);',...  % reconstruct topo

%***************** Calc Bottun ********************
% Dummy data are made because there is no hb_data and becomes an error when it is called before the analysis.
hb_data = 0;

%****** Button PCA Analaysis *********  
b1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+260 pos_top-35 60 20],...
               'BackgroundColor',[80/255 255/255 120/255], ...
               'String','PCA Analysis',...
               'Visible','off',...
               'Callback',['if move_stop == 1;',...
                              'if para_p.cal_flg1 ~= 0 | para_p.cal_flg2 ~= 0 | para_p.cal_flg3 ~= 0 | para_p.cal_flg4 ~= 0 | para_p.cal_flg5 ~= 0;',...
                                 'kl_flg=0;',...
                                 'del_fig(28,72);',...
                                 'del_fig(74,74);',...
                                 '[hb_data,kl_graph_h,kl_map_h,sParaKL] = kl_para(info,para,mark,hb_data,para_p,Sel_graph);',...
                              'else;',...
                                 'warndlg(''Please calculate before performing PCA analysis.'',''Warning'');',...
                              'end;',...
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;',...
                          ],... 
               'Tag','Pushbutton4');
% 28-32:PCA oxy,    33-37:weight oxy,
% 38-42:PCA deoxy,  43-47:weight deoxy,
% 48-52:PCA total,  53-57:weight total,
% 58-62:recontruct, 63-67:recontruct topo, 68-72:recontruct int

%****** Button Continuous Hb *********  
b2 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+15 pos_top-35 60 20],...
               'BackgroundColor',[80/255 255/255 120/255], ...
               'String','Continuous Hb',...
               'Visible','off',...
               'Callback',['if move_stop == 1;',...
                              'del_fig(74,74);',...
                              '[hb_data,para_p,err_flg] = calc_cont(info,ad_data,para,para_p);',...
                              'if err_flg==0;',...
                                 '[para,hb_data,hb_graph_h,hb_map_h] = hb_graph(info,mark,para,hb_data,para_p,Sel_graph);',...
                                 'set(main_h.hb3,''Visible'',''on'');',...
                              'end;',...
                              'clear err_flg;',...
                              'Mode = MOD_HB;',...
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],... 
               'Tag','Pushbutton1');

%****** Button Integral Hb *********  
b3 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+100 pos_top-35 60 20],...
               'BackgroundColor',[80/255 255/255 120/255], ...
               'String','Integral Hb',...
               'Visible','off',...
               'Callback',['if move_stop == 1;',...
                              'del_fig(74,74);',...
                              '[hb_data,ad_data,para_p,err_flg] = calc_int(info,mark,para,ad_data,para_p);',...
                              'if err_flg==0;',...
                                 '[para,hb_data,hb_graph_h,hb_map_h] = hb_graph(info,mark,para,hb_data,para_p,Sel_graph);',...
                                 'set(main_h.hb3,''Visible'',''on'');',...
                              'end;',... 
                              'clear err_flg;',...
                              'Mode = MOD_HB;',...
                           'else;',...
                              'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],... 
               'Tag','Pushbutton2');
%****** Button cuixu Integral Hb  *********  
b7 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+100 pos_top-65 60 20],...
               'BackgroundColor',[80/255 255/255 120/255], ...
               'String','cuixu Integral Hb',...
               'Visible','off',...
               'Callback',[...
                            'if move_stop == 1;',...
                              'del_fig(74,74);',...
                              '[hb_data,ad_data,para_p,err_flg] = cuixu_calc_int(info,mark,para,ad_data,para_p,continuous_data);',...
                              'if err_flg==0;',...
                                 '[para,hb_data,hb_graph_h,hb_map_h] = hb_graph(info,mark,para,hb_data,para_p,Sel_graph);',...
                                 'set(main_h.hb3,''Visible'',''on'');',...
                              'end;',... 
                              'clear err_flg;',...
                              'Mode = MOD_HB;',...
                           'else;',...
                              'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],... 
               'Tag','Pushbutton2');
%****** Button AD Graph *********  
b4 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+180 pos_top-35 60 20],...
               'BackgroundColor',[80/255 255/255 120/255], ...
               'String','AD Graph',...
               'Visible','off',...
               'Callback',['if move_stop == 1;',...
                            'del_fig(74,74);',...
                             '[ad_graph_h] = ad_graph(info,ad_data,mark,para_p);',...
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],... 
               'Tag','Pushbutton3');

%****** Button Select All *********  
b5 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+285 pos_top-5 50 20],...
               'BackgroundColor',[0.75 0.75 0.75], ...               
               'Style','pushbutton',...
               'String','Select Mark',...
               'Visible','off',...
               'Callback',['SelectAllMark'],... 
               'Tag','MarkAllSelectButton');

%****** Button Angle Set *********  
b6 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'Position',[pos_left+225 pos_top-5 50 20],...
               'BackgroundColor',[0.75 0.75 0.75], ...               
               'Style','pushbutton',...
               'String','Angle Set',...
               'Visible','off',...
               'Callback',['[para_p]=set_angle(info,para_p);'],... 
               'Tag','AngleButton');

%****** Text Display *********  
h1 = uicontrol('Parent',MainFigure, ...
	'Units','points', ...
	'BackgroundColor',[0.75 0.75 0.75], ...
	'ListboxTop',0, ...
	'Position',[379.5 198.75-10 76.5-5 9.75], ...
	'String','Display', ...
	'Style','text', ...
	'Tag','StaticText1');

%****** Check Probe1 *********  
h_p1 = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+125 pos_top+70-5-3 45 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Probe1',...
              'Value',para_p.sel_prb1,...
              'Visible','off',...
              'Callback',['if get(gcbo,''value'')==1;para_p.sel_prb1=1;dis_no=1;end;',...
                         'if get(gcbo,''value'')==0;para_p.sel_prb1=0;end;'],... 
              'Tag','pbCheckbox1');
%****** Check Probe2 *********  
h_p2 = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+125 pos_top+54-5-3 45 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Probe2',...
              'Value',para_p.sel_prb2,...
              'Visible','off',...
              'Callback',['if get(gcbo,''value'')==1;para_p.sel_prb2=1;dis_no=2;end;',...
                          'if get(gcbo,''value'')==0;para_p.sel_prb2=0;end;'],... 
              'Tag','pbCheckbox2');
%****** Check Probe3 *********  
h_p3 = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+125 pos_top+38-5-3 45 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Probe3',...
              'Value',para_p.sel_prb3,...
              'Visible','off',...
              'Callback',['if get(gcbo,''value'')==1;para_p.sel_prb3=1;dis_no=3;end;',...
                          'if get(gcbo,''value'')==0;para_p.sel_prb3=0;end;'],... 
              'Tag','pbCheckbox3');
%****** Check Probe4 *********  
h_p4 = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+170 pos_top+70-5-3 45 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Probe4',...
              'Value',para_p.sel_prb4,...
              'Visible','off',...
              'Callback',['if get(gcbo,''value'')==1;para_p.sel_prb4=1;dis_no=4;end;',...
                          'if get(gcbo,''value'')==0;para_p.sel_prb4=0;end;'],... 
              'Tag','pbCheckbox4');
%****** Check Probe5 *********  
h_p5 = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'Position',[pos_left+170 pos_top+54-5-3 45 15],...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Style','checkbox',...
              'String','Probe5',...
              'Value',para_p.sel_prb5,...
              'Visible','off',...
              'Callback',['if get(gcbo,''value'')==1;para_p.sel_prb5=1;dis_no=5;end;',...
                          'if get(gcbo,''value'')==0;para_p.sel_prb5=0;end;'],... 
              'Tag','pbCheckbox5');
           
%% Head Button
main_h.hb3 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1.0 0.9 0.1], ...
               'FontSize',11,...
               'Position',[260 17 75 26],...
               'String','3D Topography',...
               'Visible','off',...
               'Callback',['if move_stop == 1;',...
                              'move_stop=1;',...
                              'if para_p.cal_flg1 == 0 & para_p.cal_flg2 == 0 & para_p.cal_flg3 == 0 & para_p.cal_flg4 == 0 & para_p.cal_flg5 == 0;',...
                                 'warndlg(''Please calculate before performing 3D Topography.'',''Warning'');',...
                                 'del_fig(80,80);',...
                                 'return;',...
                              'end;',...
                              'pos_get;',...           % position get
                              'if mode_err == 2;',...  %cancel
                                 'del_fig(80,80);',...
                                 'return;',...
                              'end;',...
                              'if mode_err == 1;return;end;',...
                              'hb_map_h = map_3d(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop,pos,0);',...
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],...
               'Tag','Pushbutton1'); 
           
% It becomes possible ?y after data are loaded, it uses ?z.
if Mode == MOD_LOAD;
   
   set(b1,'Visible','on');
   set(b2,'Visible','on');
   set(b3,'Visible','on');
   set(b4,'Visible','on');
   set(b5,'Visible','on');
   set(b6,'Visible','on');
   set(b7,'Visible','on');
   set(t,'Visible','on');

   if para_p.load_prb1==1;
      set(h_p1,'Visible','on');         
   end;
   if para_p.load_prb2==1;
      set(h_p2,'Visible','on');         
   end;
   if para_p.load_prb3==1;
      set(h_p3,'Visible','on');         
   end;
   if para_p.load_prb4==1;
      set(h_p4,'Visible','on');         
   end;
   if para_p.load_prb5==1;
      set(h_p5,'Visible','on');         
   end;
end;

%********** Load E_coef File **********
fp = fopen('ALL_E_coef.txt','r');
dum = fgets(fp);
for j=1:300;
   para.e_coef(j,:) = str2num(dum);
   dum = fgets(fp);
end;
fclose(fp);
clear fp;

clear dum;
clear j;
clear h;
clear b1;
clear b2;
clear b3;
clear b4;
clear b5;
clear b6;
clear b7;
clear h_p1;
clear h_p2;
clear h_p3;
clear h_p4;
clear h_p5;
clear t;
clear pos_left;
clear pos_top;
clear h1;
