% inttmchk
%
% Input  : info,para,mark,hb_data,Sel_graph,str
% Output : ret
% Example: [ret] = inttmchk(info,para,mark,hb_data,Sel_graph,str)

%*******************************************************
%*                  Shingo Kawasaki                    *
%*                  HITACHI MEDICAL                    *
%*******************************************************
% historyF04.11.24 Ver2.04 kusabuka  
% History :06.06.28 Ver 2.05 Kusabuka    mark check bugu
function [rtn] = inttmchk(info,para,mark,hb_data,Sel_graph,pre,post,relax);

rtn=0;

if para.sel_move == 0;
   add_mark  = find(mark.ave==1);
else;
   if isfield(mark,'move') == 1;
      add_mark  = find(mark.ave==1 & mark.move==0);
   else;
      add_mark  = find(mark.ave==1);
   end;
end;

mark_len = length(add_mark);
if mark_len ==0;
   rtn = 3;
   return;  
end;
last_mark = add_mark(length(add_mark));
for cnt=1:mark_len;
   if info(Sel_graph).measure_mode == 1;       % Stim 
      mark_size = mark.point(add_mark(1),3)-mark.point(add_mark(1),2);
      if mark_len == 1;                    % mark == 1
         if (mark.point(add_mark(cnt),2)-pre)<=0;
            rtn=1;
         end;
         if (mark.point(cnt,3)+relax+post)>info(Sel_graph).datanum;
            rtn=1;
         end;
      else;                                % mark < mark_len
         if (mark.point(add_mark(cnt),2)-pre)<=0;
            rtn=1;
         end;
         if (mark.point(add_mark(cnt),3)+relax+post)>info(Sel_graph).datanum;
            rtn=1;
         end;
         if cnt > 1;
            if (mark.point(add_mark(cnt),2)-pre) < mark.point(add_mark(cnt-1),2)+mark_size+relax; % chenge
               rtn=2;                         % overlaps
            end;
         end;
      end;
   else info(Sel_graph).measure_mode == 2;     % Event eve_time
      if mark_len == 1;                        % maek == 1
         if (mark.point(add_mark(cnt),2)-para.pre)<=0;
            rtn=1;
         end;
         if (mark.point(add_mark(cnt),2)+relax+post)>info(Sel_graph).datanum;
            rtn=1;
         end;
      else;                                    % mark < mark_len
         if (mark.point(add_mark(cnt),2)-para.pre)<=0;
            rtn=1;
         end;
         if (mark.point(cnt,2)+relax+post)>info(Sel_graph).datanum;
            rtn=1;
         end;
         if cnt > 1;
            if ((mark.point(add_mark(cnt),2)-pre) < mark.point(add_mark(cnt-1),2)+relax);
               rtn=2;                         % overlaps
            end;
         end;
      end;
   end;
end;

return;   