% kl_exec
%
% Input  : info,para,mark,sParaKL,hb_data,para_p
% Output : hb_data,kl_graph_h,kl_map_h,pca_data
% Example: [hb_data,kl_graph_h,kl_map_h,pca_data] = kl_exec(info,para,mark,sParaKL,hb_data,para_p);
%*******************************************************
%*Multi-channel data is contracted by KL conversion. kl6.m     *
%*                  Shingo Kawasaki                    *
%*                  HITACHI MEDICAL                    *
%*******************************************************
% historyF02.11.11 Ver1.01  futahashi 	 KL conversion function is added.
% historyF02.11.27 Ver1.01  Kawasaki  Graph Color Change
% historyF03.05.06 Ver2.00  Isawa@	 Display point->sec
% historyF03.11.06 Ver2.01  Kusabuka@pca_data(p_cnt)[oxy,deox,total]->pca_data(p_cnt)[probeno].xx[oxy,deox,total]
%                                      continuous Rectangle wave all make
% historyF03.4.28 Ver2.03  Kawasaki  Change corrcoef position

function [hb_data,kl_graph_h,kl_map_h,pca_data,kl_flg] = kl_exec(info,para,mark,sParaKL,hb_data,para_p,kl_flg);
wh = waitbar(0,'Please wait...');

clear pca_data;

% Parameter
thre = 0;							% thre = input('Input Threshould(-1`1): ');
pos_flg=0;
data_cnt = 0;
clear rect;
diff_err=0;
mark_err = 0;

% 28-32:PCA oxy,    33-37:weight oxy,
% 38-42:PCA deoxy,  43-47:weight deoxy,
% 48-52:PCA total,  53-57:weight total,
% 58-62:recontruct, 63-67:recontruct topo, 68-72:recontruct int
del_fig(28,72);

if para.sel_move == 0;
   add_mark  = find(mark.ave==1);
else;
   if isfield(mark,'move') == 1;
      add_mark  = find(mark.ave==1 & mark.move==0);
   else;
      add_mark  = find(mark.ave==1);
   end;
end;
if length(add_mark) > 0;
   last_mark = add_mark(length(add_mark));
end;

for p_cnt=1:para_p.max_prb;
   waitbar(p_cnt/para_p.max_prb,wh);
   if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
   elseif(p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) |(p_cnt==4 & para_p.load_prb4 ~=1) |(p_cnt==5 & para_p.load_prb5 ~=1);
   elseif(p_cnt==1 & para_p.cal_flg1 ==0 ) | (p_cnt==2 & para_p.cal_flg2 ==0) | (p_cnt==3 & para_p.cal_flg3 ==0) |(p_cnt==4 & para_p.cal_flg4 ==0) |(p_cnt==5 & para_p.cal_flg5 ==0);
   else;
      if mark.num==0;
         warndlg('Nonexistent Mark!','Warning');
         break;
      end;
      %*********** data Select ***********
      data_cnt = data_cnt +1;
      ch_num = info(p_cnt).ad_ch_max/2;
      if length(add_mark) ==0;
         if p_cnt==1 & para_p.cal_flg1 ==2;mark_err=1;end;
         if p_cnt==2 & para_p.cal_flg2 ==2;mark_err=1;end;
         if p_cnt==3 & para_p.cal_flg3 ==2;mark_err=1;end;
         if p_cnt==4 & para_p.cal_flg4 ==2;mark_err=1;end;
         if p_cnt==5 & para_p.cal_flg5 ==2;mark_err=1;end;
         if mark_err ==1;
            warndlg('Nonexistent Mark!','Warning');
            break;
         end;
      end;

      if info(p_cnt).flg == 1;                 % ETG-100
         eve_time_rate = 10;
      else                                     % ETG-4000 ETG-7000
         eve_time_rate = 10;
      end;
      if mark.num == 0;
         kl_flg = 0;
         kl_graph_h(p_cnt).time_min = 1;
         kl_map_h(p_cnt).topo_max=0.2;
         pca_data(p_cnt).weight='';
         pca_data(p_cnt).graph='';
         pca_data(p_cnt).corr='';
         pca_data(p_cnt).relat='';
         close(wh);
         clear wh;
         warndlg('Warning Mark!  There is no mark information.','Warning');
         return;
      end;
      if hb_data(p_cnt).calc_flg == 2;            % filter
         if isfield(hb_data(p_cnt),'fil' ) ~= 1;
            kl_flg = 0;
            kl_graph_h(p_cnt).time_min = 1;
            kl_map_h(p_cnt).topo_max=0.2;
            pca_data(p_cnt).weight='';
            pca_data(p_cnt).graph='';
            pca_data(p_cnt).corr='';
            pca_data(p_cnt).relat='';
            close(wh);
            clear wh;
            warndlg('Please set and calculate a filter before performing PCA analysis.','Warning');
            return;
         end;
      end;

      %///////////////////////////////////////////
      if pos_flg == 0;                          % frist time only
         pos_flg = 1;
        
         if  hb_data(p_cnt).ana_mode == 1;  % Continuous
            % The preparation of the mark
            if info(p_cnt).measure_mode == 1;       % Stim 
               mark_kl = [para.pre para.pre+mark.point(add_mark(1),3)-mark.point(add_mark(1),2)];
            else info(p_cnt).measure_mode == 2;     % Event eve_time
               mark_kl = [para.pre para.pre+mark.point(add_mark(1),2)+sParaKL.eve_time*eve_time_rate ];
            end;

            %******************************************
            %*         Rectangle wave preparation     *
            %****************************************** 
            % A structure is changed to the ms unit.
            pos.start_time  = sParaKL.start_time * 1000;
            pos.start_delay = sParaKL.start_delay * 1000;

            pos.end_time    = sParaKL.end_time * 1000;
            pos.end_delay   = sParaKL.end_delay * 1000;                          % Each point is calculated.
            
            data_num = length(hb_data(p_cnt).raw(1,:,1)); 	
   
            % The maximum value of the wave
            pos.max_point = 0;
            cnt = 1;	
            % Point several-minutes loop
            for i = 1:data_num;
               pos.point1 = mark.point(cnt,2);										     % From 0
               pos.point2 = mark.point(cnt,2) + (pos.start_delay/info(p_cnt).smpl_period);	% Until the start 
               pos.point3 = pos.point2 + (pos.start_time/info(p_cnt).smpl_period);      	% % From the start, to 1
               if info(p_cnt).measure_mode == 1;                                              % Stim 
                  pos.point4 = mark.point(cnt,3);									    % From 1
               else info(p_cnt).measure_mode == 2;                                          % Event eve_time
                  pos.point4 = mark.point(cnt,2)+sParaKL.eve_time*eve_time_rate;
               end;

               pos.point5 = pos.point4 + (pos.end_delay/info(p_cnt).smpl_period);	% It until the descent  
               pos.point6 = pos.point5 + (pos.end_time/info(p_cnt).smpl_period);		% descent to 1
               % From the left end of the graph, to the mark 1
               if i < pos.point1;
                  rect(i) = 0;
                  pos.max_point = 0;         
               end;
               % From the mark 1, to the inclination start (start delay)
               if i >= pos.point1 & i < pos.point2;
                  rect(i) = 0;
               end;
               % From the inclination start, to the inclination end (It rises and slopes.)
               % <if it goes to the inclination end or the mark 2, inclination end>
               if i >= pos.point2 & i < pos.point3 & pos.point4 >= i;
                  rect(i) = (i-pos.point2)/(pos.start_time/info(p_cnt).smpl_period);
                  pos.max_point = ((i+1)-pos.point2)/(pos.start_time/info(p_cnt).smpl_period);
               end;
               % From the inclination end, to the mark 2
               if i >= pos.point3 & i < pos.point4;
                  rect(i) = pos.max_point;
               end;
               %From the mark 2, to the inclination start (finishing delay)
               if i >= pos.point4 & i < pos.point5;
                  rect(i) = pos.max_point;
               end;
               % From the inclination start, to the inclination end (it stands up, descent inclination) 
               % <When it isn't raised completely, it becomes a pyramidal wave.>
               if i >= pos.point5 & i < pos.point6;
                  rect(i) = 1-(i-(pos.point5))/(pos.end_time/info(p_cnt).smpl_period);
                  rect(i) = rect(i) - (1-pos.max_point);
                  if rect(i) < 0;
                     rect(i) = 0;
                  end;
               end;
               % From the inclination end, to the right end of the graph,
               if i >= pos.point6 & i <= data_num;
                  rect(i) = 0;
                  if cnt < length(mark.point(:,2));
                     cnt=cnt+1;
                  end;
               end;  
               %%%%%%%
               % delay none
               %%%%%%%
               if i >= pos.point2 & pos.point2 == pos.point3 & i <= pos.point3; % pulse delay 0
                  rect(i) = 1;
                  pos.max_point = 1;
               end;
               if i >= pos.point4 & pos.point4 == pos.point5 & i <= pos.point5; % mark delay 0
                  rect(i) = 1;
                  pos.max_point = 1;
               end;
               if i >= pos.point5 & pos.point5 == pos.point6 & i <= pos.point6; % pulse delay 0
                  rect(i) = 0;
                  pos.max_point = 0;
               end;
               %%%%%%%%
            end;                 % for data num
         elseif  hb_data(p_cnt).ana_mode == 2;    % integral
            % The preparation of the mark
            if info(p_cnt).measure_mode == 1;       % Stim 
              mark_kl = [para.pre para.pre+mark.point(add_mark(1),3)-mark.point(add_mark(1),2)];
            else info(p_cnt).measure_mode == 2;     % Event eve_time
              mark_kl = [para.pre para.pre+sParaKL.eve_time*eve_time_rate ];
            end;
            
            %******************************************
            %*         Rectangle wave preparation     *
            %****************************************** 
            % A structure is changed to the ms unit.
            pos.start_time  = sParaKL.start_time * 1000;
            pos.start_delay = sParaKL.start_delay * 1000;

            pos.end_time    = sParaKL.end_time * 1000;
            pos.end_delay   = sParaKL.end_delay * 1000;                             % Each point is calculated.
            pos.point1 = mark_kl(1);										        % From 0

            pos.point2 = pos.point1 + (pos.start_delay/info(p_cnt).smpl_period);	% Until the start 
            pos.point3 = pos.point2 + (pos.start_time/info(p_cnt).smpl_period);	    % % From the start, to 1
            pos.point4 = mark_kl(2);										        % From 1
            pos.point5 = pos.point4 + (pos.end_delay/info(p_cnt).smpl_period);	    % It until the descent  
            pos.point6 = pos.point5 + (pos.end_time/info(p_cnt).smpl_period);		% descent to 1
   
            data_num = length(hb_data(p_cnt).raw(1,:,1)); 	
            % The maximum value of the wave
            pos.max_point = 0;
            cnt = 1;	
            % Point several-minutes loop
            for i = 1:data_num;
               % From the left end of the graph, to the mark 1
               if i < pos.point1;
                  rect(i) = 0;
                  pos.max_point = 0;         
               end;
               % From the mark 1, to the inclination start (start delay)
               if i >= pos.point1 & i < pos.point2;
                  rect(i) = 0;
               end;
               % From the inclination start, to the inclination end (It rises and slopes.)
               % <if it goes to the inclination end or the mark 2, inclination end>
               if i >= pos.point2 & i < pos.point3 & pos.point4 >= i;
                  rect(i) = (i-pos.point2)/(pos.start_time/info(p_cnt).smpl_period);
                  pos.max_point = ((i+1)-pos.point2)/(pos.start_time/info(p_cnt).smpl_period);
               end;
               % From the inclination end, to the mark 2
               if i >= pos.point3 & i < pos.point4;
                  rect(i) = pos.max_point;
               end;
               %From the mark 2, to the inclination start (finishing delay)
               if i >= pos.point4 & i < pos.point5;
                  rect(i) = pos.max_point;
               end;
               % From the inclination start, to the inclination end (it stands up, descent inclination) 
               % <When it isn't raised completely, it becomes a pyramidal wave.>
               if i >= pos.point5 & i < pos.point6;
                  rect(i) = 1-(i-(pos.point5))/(pos.end_time/info(p_cnt).smpl_period);
                  rect(i) = rect(i) - (1-pos.max_point);
                  if rect(i) < 0;
                     rect(i) = 0;
                  end;
               end;

               % From the inclination end, to the right end of the graph,
               if i >= pos.point6 & i <= data_num;
                  rect(i) = 0;
               end;
               %%%%%%%
               % delay none
               %%%%%%%
               if i >= pos.point2 & pos.point2 == pos.point3 & i <= pos.point3; % pulse delay 0
                  rect(i) = 1;
                  pos.max_point = 1;
               end;
               if i >= pos.point4 & pos.point4 == pos.point5 & i <= pos.point5; % mark delay 0
                  rect(i) = 1;
                  pos.max_point = 1;
               end;
               if i >= pos.point5 & pos.point5 == pos.point6 & i <= pos.point6; % pulse delay 0
                  rect(i) = 0;
                  pos.max_point = 0;
               end;
               %%%%%%%%
            end;                 % for data num
         end;                    % integral
      end;	                     % pos_flg

      % Figure and the settlement of the title
      figure_no    = 0;
      figure_title = '';

      figure_no = 28+(p_cnt-1);
      figure_title = sprintf('Result from PCA Analysis Probe %d',p_cnt);
      %************************************
      % eigenvalues
      %************************************
      figure_h = figure(figure_no);
      clf reset;
      
      set(figure_h,'Name',figure_title,'ToolBar','none');
      plotedit(figure_h,'hidetoolsmenu');
      set(figure_h,'Units','points');
      pca_posi = get(figure_h,'Position'); 
      clear figure_no;
      clear figure_title;
      kl_graph_h(p_cnt).pca_chk_val = 1;
      kl_graph_h(p_cnt).time_min    = 0;
      kl_map_h(p_cnt).topo_max      = 0.2;
      
      %************** check **************
      kl_graph_h(p_cnt).pca.chk = uicontrol('Parent',(p_cnt+28-1), ...
                     'Units','points', ...
                     'Position',[1 15 40 15], ...
                     'BackgroundColor',[1 1 1], ...
                     'Style','popupmenu', ...
                     'String','Oxy  |Deoxy|Total',...
                     'Value',kl_graph_h(p_cnt).pca_chk_val,...
                     'Callback',['if move_stop == 1;',...
                                    'Sel_graph=get(gca,''Parent'')-(28-1);',...
                                    'kl_graph_h(Sel_graph).pca_chk_val = get(gcbo,''value'');',...
                                    'if kl_graph_h(Sel_graph).pca_chk_val == 1;',... 
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,1),''Marker'',''o'',''LineStyle'',''-'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,1),''Marker'',''o'',''LineStyle'',''-'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,2),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,2),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,3),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,3),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'for i=1:6;',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(1,i),''LineStyle'',''-'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(1,i),''Visible'',''on'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(1,i),''LineStyle'',''-'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(1,i),''FaceColor'',[1 0 0]);',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(2,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(2,i),''Visible'',''off'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(2,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(2,i),''FaceColor'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(3,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(3,i),''Visible'',''off'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(3,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(3,i),''FaceColor'',''none'');',...
                                       'end;',...
                                    'elseif kl_graph_h(Sel_graph).pca_chk_val == 2;',... 
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,1),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,1),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,2),''Marker'',''o'',''LineStyle'',''-'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,2),''Marker'',''o'',''LineStyle'',''-'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,3),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,3),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'for i=1:6;',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(1,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(1,i),''Visible'',''off'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(1,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(1,i),''FaceColor'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(2,i),''LineStyle'',''-'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(2,i),''Visible'',''on'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(2,i),''LineStyle'',''-'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(2,i),''FaceColor'',[0 0 1]);',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(3,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(3,i),''Visible'',''off'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(3,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(3,i),''FaceColor'',''none'');',...
                                       'end;',...
                                    'elseif kl_graph_h(Sel_graph).pca_chk_val == 3;',... 
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,1),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,1),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,2),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,2),''Marker'',''none'',''LineStyle'',''none'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(1,3),''Marker'',''o'',''LineStyle'',''-'');',...
                                       'set(kl_graph_h(Sel_graph).pca.relat_plot(2,3),''Marker'',''o'',''LineStyle'',''-'');',...
                                       'for i=1:6;',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(1,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(1,i),''Visible'',''off'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(1,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(1,i),''FaceColor'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(2,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(2,i),''Visible'',''off'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(2,i),''LineStyle'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(2,i),''FaceColor'',''none'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_plot(3,i),''LineStyle'',''-'');',...
                                          'set(kl_graph_h(Sel_graph).pca.ch_text(3,i),''Visible'',''on'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(3,i),''LineStyle'',''-'');',...
                                          'set(kl_graph_h(Sel_graph).pca.bar_plot(3,i),''FaceColor'',[0 1 0]);',...
                                       'end;',...
                                    'end;',...
                                    'clear i;',...
                                 'else;',...
                                    'warndlg(''Please push a stop button.'',''Warning !!'');',...
                                 'end;',...
                                ],...
                                'tag','Checkbox1');
      %************** file out **************
      kl_graph_h(p_cnt).pca.fout = uicontrol('Parent',(p_cnt+28-1),...
          'Units','points',...
          'BackgroundColor',[0.75 0.75 0.75], ...
          'Position',[pca_posi(3)-35 2 35 14],...
          'String','FileOut',...
          'Callback',['if move_stop == 1;',...
                        'Sel_graph=get(gca,''Parent'')-(28-1);',...
                        'fout_pca(info,para,para_p,hb_data,mark,ad_data,kl_data,Sel_graph);',...
                      'else;',...
                        'warndlg(''Please push a stop button.'',''Warning !!'');',...
                      'end;',...
          ],...
          'Tag','Pushbutton1');

   %************** refresh **************
   kl_graph_h(p_cnt).pca.ref = uicontrol('Parent',(p_cnt+28-1), ...
               'Units','points', ...
               'BackgroundColor',[1.0 0.9 0.1], ...
               'Position',[1 0 35 14], ...
               'String','Refresh',...
               'Callback',['pca_posi=get(gcf,''Position'');',...
                           'Sel_graph=get(gca,''Parent'')-(28-1);'...
                           'set(kl_graph_h(Sel_graph).pca.fout,''Position'',[pca_posi(3)-35 16 35 14]);',...
                           'clear pca_posi;',...
                          ],...
                          'tag','Pushbutton3');

      % Hb_data is made. (The data which wore a filter ring at the time of use of a filter are overwritten.)
      %******************************************
      %*       Oxy,Deoxy,Total Roop             *
      %****************************************** 
      for hb=1:3;

         if hb==1;fprintf('---------------- Oxy Hb ----------------\n');end;
         if hb==2;fprintf('--------------- Deoxy Hb ---------------\n');end;
         if hb==3;fprintf('--------------- Total Hb ---------------\n');end;
         %******************************
         % Ch Reject
         %******************************
         for i=1:(info(p_cnt).ad_ch_max/2);
            if info(p_cnt).err_ch(i)==1 & para_p.del_ch ==1;
               if hb_data(p_cnt).calc_flg==2;
                  hb_data(p_cnt).fil(hb,:,i)=0;
               end;
               hb_data(p_cnt).raw(hb,:,i)=0;
            end;
         end;
         %******************************************************************
         %*     The computation of the eigen value and the eigen vector    *
         %****************************************************************** 
         if hb_data(p_cnt).calc_flg==1;
         	w(:,1:ch_num) = squeeze(hb_data(p_cnt).raw(hb,:,1:ch_num));  % normal 	
         elseif hb_data(p_cnt).calc_flg==2;   
            w(:,1:ch_num) = squeeze(hb_data(p_cnt).fil(hb,:,1:ch_num));  % Filter 	
         end;   

         [m,comp_num] = size(w);
         [pca_data(p_cnt).weight(hb,:,:),U]=eig(w'*w);            %weight that eigen value is calculated : the line which becomes the line which consists of eigen vectors, U: from the eigen value

         %*********************************************
         %*     Rate of contribution computation      *
         %********************************************* 
         %It normalizes by the value in total after characteristic value is extracted and stored in uu.

         uu=zeros(comp_num,1);
         ss=0;
         for i=1:comp_num;
            uu(i,1)=U(i,i);
            ss=ss+U(i,i);
         end;
         uu=uu/ss;

         ss=0;
         is=0;
         for i=comp_num:-1:1;
            ss=ss+uu(i);
            if is==0 & ss>0.9;
               iis=i;
               is=1;
            end;
         end;
         pca_data(p_cnt).relat(hb,:)=uu;            % relative values
         %******************************************
         %*     A representative wave form is formed
         %*       from the characteristic vector.  
         %******************************************  
         pca_data(p_cnt).graph(hb,:,:)=w*(squeeze(pca_data(p_cnt).weight(hb,:,:)));
         
         %****** A representative wave form ****** 
         %************************************
         % Channel(1->ch_num)
         %************************************
         for i=1:ch_num;
            if mean(pca_data(p_cnt).weight(hb,:,ch_num+1-i))<0;
               pca_data(p_cnt).weight(hb,:,ch_num+1-i) = -pca_data(p_cnt).weight(hb,:,ch_num+1-i);
               pca_data(p_cnt).graph(hb,:,ch_num+1-i)  = -pca_data(p_cnt).graph(hb,:,ch_num+1-i);  
            end;
            
            % The preparation of the degree of correlation
            wk = corrcoef(pca_data(p_cnt).graph(hb,:,ch_num+1-i),rect);
            pca_data(p_cnt).corr(hb,i)=wk(2,1);               
         end;
         
         if sParaKL.weight_absolute==1;   %The absolute value of the weight is taken.
            pca_data(p_cnt).weight(hb,:,:)=abs(pca_data(p_cnt).weight(hb,:,:));
         end;    
         
         hb_max=max(max(max(pca_data(p_cnt).graph(:,:,:))));
         hb_min=min(min(min(pca_data(p_cnt).graph(:,:,:))));
         if hb_max < 1;
            hb_max = 1.2;
         else;
            hb_max = hb_max + hb_max*0.2;
         end;
         if hb_min > -1;
            hb_min = -1.2;
         else;
            hb_min = hb_min + hb_min*0.2;
         end;
         
         %*********************************
         %********  Graph Display *********
         %*********************************

         %************************************
         % eigenvalues
         % Rate of contribution 
         %************************************

         t=1:1:comp_num;
         if hb == 1;
            kl_graph_h(p_cnt).pca.relat = axes('Unit','normalized','position',[0.13+0.05 0.8492 0.7750 0.0758]);
            set(kl_graph_h(p_cnt).pca.relat,'xtick',1:1:6);                              % graph memori 1
            axis([1 6 0 1]);
            title('No. of eigenvalues','FontSize',10);
            ylabel('Relative values','FontSize',8);
         else;
            set(gcf,'CurrentAxes',kl_graph_h(p_cnt).pca.relat);
         end;
         box on;
         hold on;
         kl_graph_h(p_cnt).pca.relat_plot(1,hb) = plot(uu(comp_num:-1:comp_num-5),'-bo','LineWidth',0.5);   %Beyond 0.9
         kl_graph_h(p_cnt).pca.relat_plot(2,hb) = plot(uu(comp_num:-1:iis),'-ro','LineWidth',0.5);   %Beyond 0.9

         if hb == 1;
            if kl_graph_h(p_cnt).pca_chk_val == 1; 
               set(kl_graph_h(p_cnt).pca.relat_plot(1,1),'LineStyle','-');
               set(kl_graph_h(p_cnt).pca.relat_plot(2,1),'LineStyle','-');
            else;
               set(kl_graph_h(p_cnt).pca.relat_plot(1,1),'Marker','none','LineStyle','none');
               set(kl_graph_h(p_cnt).pca.relat_plot(2,1),'Marker','none','LineStyle','none');
            end;
         end;
         if hb == 2;
            if kl_graph_h(p_cnt).pca_chk_val == 2; 
               set(kl_graph_h(p_cnt).pca.relat_plot(1,2),'LineStyle','-');
               set(kl_graph_h(p_cnt).pca.relat_plot(2,2),'LineStyle','-');
            else;
               set(kl_graph_h(p_cnt).pca.relat_plot(1,2),'Marker','none','LineStyle','none');
               set(kl_graph_h(p_cnt).pca.relat_plot(2,2),'Marker','none','LineStyle','none');
            end;
         end;
         if hb == 3;            
            if kl_graph_h(p_cnt).pca_chk_val == 3; 
               set(kl_graph_h(p_cnt).pca.relat_plot(1,3),'LineStyle','-');
               set(kl_graph_h(p_cnt).pca.relat_plot(2,3),'LineStyle','-');
            else;
               set(kl_graph_h(p_cnt).pca.relat_plot(1,3),'Marker','none','LineStyle','none');
               set(kl_graph_h(p_cnt).pca.relat_plot(2,3),'Marker','none','LineStyle','none');
            end;
         end;
            
         hold off;   

         %************************************
         % Channel(1`ch_num)
         %************************************
         fprintf('%s\n','(Correlation)');	
         for i=1:6;                                     % ch_num->6
            if hb == 1;
               kl_graph_h(p_cnt).pca.ch(i)=axes('position',[0.1300+0.05 0.7279-(0.1189*(i-1)) 0.3347 0.0737]);
            else;
               set(gcf,'CurrentAxes',kl_graph_h(p_cnt).pca.ch(i));
            end;
            box on;
            % Ver 2.00 -> [sec]
            if i==6;xlabel('sec','FontSize',8);end;     % 5->6
            hold on;
            %############################# plot data %#########################
            kl_graph_h(p_cnt).pca.ch_text(hb,i) =text(1,-0.4,num2str(pca_data(p_cnt).corr(hb,i)),'FontSize',para_p.fsize,'Position',[5 0.5]);
            ylabel(strcat('C',num2str(i)),'FontSize',8);
            if hb == 1;
               plot(rect*(floor(hb_max/1.2)),'Color',[0.5 0.5 0.5]);
               kl_graph_h(p_cnt).pca.ch_plot(hb,i) = plot(pca_data(p_cnt).graph(hb,:,ch_num+1-i),'r','LineWidth',0.5);
               if kl_graph_h(p_cnt).pca_chk_val == 1; 
                  set(kl_graph_h(p_cnt).pca.ch_plot(hb,i),'LineStyle','-');
                  set(kl_graph_h(p_cnt).pca.ch_text(hb,i),'Visible','on');
               else;
                  set(kl_graph_h(p_cnt).pca.ch_plot(hb,i),'LineStyle','none');
                  set(kl_graph_h(p_cnt).pca.ch_text(hb,i),'Visible','on');
               end;
            end;
            if hb == 2;
               kl_graph_h(p_cnt).pca.ch_plot(hb,i) = plot(pca_data(p_cnt).graph(hb,:,ch_num+1-i),'b','LineWidth',0.5);
               if kl_graph_h(p_cnt).pca_chk_val == 2; 
                  set(kl_graph_h(p_cnt).pca.ch_plot(hb,i),'LineStyle','-');
                  set(kl_graph_h(p_cnt).pca.ch_text(hb,i),'Visible','on');
               else;
                  set(kl_graph_h(p_cnt).pca.ch_plot(hb,i),'LineStyle','none');
                  set(kl_graph_h(p_cnt).pca.ch_text(hb,i),'Visible','off');
               end;
            end;
            if hb == 3;
               kl_graph_h(p_cnt).pca.ch_plot(hb,i) = plot(pca_data(p_cnt).graph(hb,:,ch_num+1-i),'g','LineWidth',0.5);
               if kl_graph_h(p_cnt).pca_chk_val == 3; 
                  set(kl_graph_h(p_cnt).pca.ch_plot(hb,i),'LineStyle','-');
                  set(kl_graph_h(p_cnt).pca.ch_text(hb,i),'Visible','on');
               else;
                  set(kl_graph_h(p_cnt).pca.ch_plot(hb,i),'LineStyle','none');
                  set(kl_graph_h(p_cnt).pca.ch_text(hb,i),'Visible','off');
               end;
            end;

            %########## mark IN plot ###################
            if hb_data(p_cnt).ana_mode == 2;   % Integral
               j=1;
               if mark.num ~= 0;
                  plot([mark_kl(j,1) mark_kl(j,1)],[hb_min hb_max],'Color',[0.1 0.1 0.1]);
                  if info(p_cnt).measure_mode(1)==1;  %Stim
                     plot([mark_kl(j,2) mark_kl(j,2)],[hb_min hb_max],'Color',[0.1 0.1 0.1]);
                  end;
               end;
            elseif hb_data(p_cnt).ana_mode == 1;   % Continuous
               for j=1:mark.num;
                  if mark.point(j)==1;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[0 1 0]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[0 1 0]);end;
                  end;
                  if mark.point(j)==2;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[1 1 0]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[1 1 0]);end;
                  end;
                  if mark.point(j)==3;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[0 1 1]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[0 1 1]);end;
                  end;
                  if mark.point(j)==4;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[1 0.7 0]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[1 0.7 0]);end;
                  end;
                  if mark.point(j)==5;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[0.7 0.35 0.35]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[0.7 0.35 0.35]);end;
                  end;
                  if mark.point(j)==6;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[0 0.54 1]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[0 0.54 1]);end;
                  end;
                  if mark.point(j)==7;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[1 0.3 0]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[1 0.3 0]);end;
                  end;
                  if mark.point(j)==8;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[0.5 0.5 0]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[0.5 0.5 0]);end;
                  end;
                  if mark.point(j)==9;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[0 0.5 0.5]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[0 0.5 0.5]);end;
                  end;
                  if mark.point(j)==10;
                     plot([mark.point(j,2)' mark.point(j,2)'],[hb_min hb_max],'Color',[1 0 0.9]);
                     if info(p_cnt).measure_mode(1)==1;plot([mark.point(j,3)' mark.point(j,3)'],[hb_min hb_max],'Color',[1 0 0.9]);end;
                  end;
               end;  % for
            end;     % else

            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            leng=size(pca_data(p_cnt).graph(hb,:,:));
            axis ([0 leng(2) hb_min hb_max]);
 
            hold off;
            % Ver 2.00 ->  It is indicated with sec.
            if i <= 6;            % 5->6
               TimeMin = 1*(info(p_cnt).smpl_period/1000);
               TimeMax = leng(2)*(info(p_cnt).smpl_period/1000);
               TimeStep = round((TimeMax -TimeMin)/4*10)/10;
               for k=0:4;
                  lab(k+1) = TimeMin + TimeStep * k;
               end;
               set(kl_graph_h(p_cnt).pca.ch(i),'YLim',[hb_min hb_max]);
               set(kl_graph_h(p_cnt).pca.ch(i),'XLim',[1 leng(2)]);
               set(kl_graph_h(p_cnt).pca.ch(i),'xtick',1:floor((leng(2)-0)/4):length(pca_data(p_cnt).graph(hb,:,:)));
               set(kl_graph_h(p_cnt).pca.ch(i),'xticklabel',lab);
               set(kl_graph_h(p_cnt).pca.ch(i),'Fontsize',para_p.fsize);
            end;
         end;
         %****** Weight Bar *******************    	
         % weight
         %**************************************
         for i=1:6;               % 5->6
            if hb == 1;
               kl_graph_h(p_cnt).pca.ber(hb,i) = axes('position',[0.5703+0.05 0.7279-(0.1189*(i-1)) 0.3347 0.0737]);
            else;
               set(gcf,'CurrentAxes',kl_graph_h(p_cnt).pca.ber(i));
            end;
            box on;
            hold on;
            if hb == 1;
               kl_graph_h(p_cnt).pca.bar_plot(hb,i) = bar(pca_data(p_cnt).weight(hb,:,ch_num+1-i));set(kl_graph_h(p_cnt).pca.bar_plot(hb,i),'FaceColor',[1 0 0]);
               if kl_graph_h(p_cnt).pca_chk_val == 1; 
                  set(kl_graph_h(p_cnt).pca.bar_plot(1,i),'LineStyle','-');
                  set(kl_graph_h(p_cnt).pca.bar_plot(1,i),'FaceColor',[1 0 0]);        
               else;
                  set(kl_graph_h(p_cnt).pca.bar_plot(1,i),'LineStyle','none');
                  set(kl_graph_h(p_cnt).pca.bar_plot(1,i),'FaceColor','none');        
               end;
            end;
            if hb == 2;
               kl_graph_h(p_cnt).pca.bar_plot(hb,i) = bar(pca_data(p_cnt).weight(hb,:,ch_num+1-i));set(kl_graph_h(p_cnt).pca.bar_plot(hb,i),'FaceColor',[0 0 1]);
               if kl_graph_h(p_cnt).pca_chk_val == 2; 
                  set(kl_graph_h(p_cnt).pca.bar_plot(2,i),'LineStyle','-');
                  set(kl_graph_h(p_cnt).pca.bar_plot(2,i),'FaceColor',[0 0 1]);        
               else;
                  set(kl_graph_h(p_cnt).pca.bar_plot(2,i),'LineStyle','none');
                  set(kl_graph_h(p_cnt).pca.bar_plot(2,i),'FaceColor','none');        
               end;
            end;
            if hb == 3;
               kl_graph_h(p_cnt).pca.bar_plot(hb,i) = bar(pca_data(p_cnt).weight(hb,:,ch_num+1-i));set(kl_graph_h(p_cnt).pca.bar_plot(hb,i),'FaceColor',[0 1 0]);
               if kl_graph_h(p_cnt).pca_chk_val == 3; 
                  set(kl_graph_h(p_cnt).pca.bar_plot(3,i),'LineStyle','-');
                  set(kl_graph_h(p_cnt).pca.bar_plot(3,i),'FaceColor',[0 1 0]);        
               else;
                  set(kl_graph_h(p_cnt).pca.bar_plot(3,i),'LineStyle','none');
                  set(kl_graph_h(p_cnt).pca.bar_plot(3,i),'FaceColor','none');        
               end;
            end;
            axis([1 ch_num -1 1]);
            set(gca,'FontSize',para_p.fsize);
            ylabel(strcat(strcat('C',num2str(i)),' Weight'),'FontSize',8);
            hold off;
               
            if i==6;xlabel('Channel no.','FontSize',8);end;  % 5->6
         end; 
         
         %****** Re-construct hb ***** 
         for i=1:ch_num;
            for ch=1:ch_num;
               buff(i,:,ch)=pca_data(p_cnt).graph(hb,:,ch_num+1-i)*pca_data(p_cnt).weight(hb,ch,ch_num+1-i);
            end;
         end;

         % Main compornent select
         sel_auto(1:ch_num) = 0;
         sel_manu(1:5)        = 0;

         % Auto select: Check correlation value (over the r Threshould).
         if sParaKL.sel_compo == 0;
            fprintf('\n[Auto select compornents using r Threshold]\n\n');
            for ch=1:ch_num;
               if pca_data(p_cnt).corr(hb,ch) >= sParaKL.threshold;
                  sel_auto(ch) = 1;
                  fprintf('[Hit] No.%d: %+f\n',ch,pca_data(p_cnt).corr(hb,ch));
               else;
                  sel_auto(ch) = 0;
                  %fprintf('[Non] No.%d: %+f\n',ch,pca_data(p_cnt).corr(hb,ch));
               end;
            end;       
            sum_data = squeeze(sum(buff([find(sel_auto==1)],:,:),1));

            % Make Re-construct Hb
            if length(find(sel_auto>0))==0;
               % Chosen data make dummy data when they are unusual
               hb_data(p_cnt).const(hb,:,:) = zeros(length(pca_data(p_cnt).graph),ch_num);
               clear dum;
               fprintf('\nNone selected Compornents!\n\n');
            else;
               hb_data(p_cnt).const(hb,:,:) = sum_data(:,1:ch_num);
            end;	     
         end;
         
         % Manual select
         if sParaKL.sel_compo == 1;
           % An element is chosen with a check box and added.
            fprintf('\n[Manual select compornents]\n');
            sel_manu = find([sParaKL.compo1 sParaKL.compo2 sParaKL.compo3 sParaKL.compo4 sParaKL.compo5]==1);
            fprintf('No.%d\n',sel_manu);
            sum_data = squeeze(sum(buff([sel_manu],:,:),1));
            if sParaKL.compo6to24==1;
               sel_manu(6)=6;
               sum_data = sum_data + squeeze(sum(buff(6:ch_num,:,:),1));
               fprintf('No.6-%d\n',ch_num);
            end;
            % Make Re-construct Hb
            if length(find(sel_manu>0))==0;
               % Chosen data make dummy data when they are unusual
               hb_data(p_cnt).const(hb,:,:) = zeros(length(pca_data(p_cnt).graph),ch_num);
               clear dum;
               fprintf('\nNone selected Compornents!\n\n');
            else;
               hb_data(p_cnt).const(hb,:,:) = sum_data(:,1:ch_num);%Probe1
            end;
         end;
         
      end;  % hb
 
      % -------------------------------------------------------------------------------
      %			Topo map indication
      % -------------------------------------------------------------------------------
      %**** The computation of Total which Oxy+Deoxy after the re-composition was used for
      hb_data(p_cnt).const(4,:,:)=hb_data(p_cnt).const(1,:,:)+hb_data(p_cnt).const(2,:,:);
      %Indication is chosen with a check box. 
      [kl_map_h] = kl_map_w(sParaKL,pca_data,p_cnt,hb,info,para_p,kl_map_h);

      % delete    
      clear i;	clear iis;   clear is;       clear j;          clear jj;
      clear m;	clear m1;    clear n;        clear n1;         clear pname;

      clear ss;	clear t;     clear uu;       clear w;          clear w1;
      clear x1;	clear y;     clear z;        clear C;          clear M;  
      clear S;	clear U;     clear ch;	      clear buff;       clear data_num;
      clear a_l;	clear a_r;   clear sum_data; clear dummy_data; clear cnt;

      %******************************************
      %*       Plot Re-construct hb_graph       *
      %****************************************** 
      [hb_data,kl_graph_h,kl_map_h,sParaKL] = kl_graph(info,mark,para,hb_data,kl_graph_h,kl_map_h,pca_data(p_cnt),sParaKL,para_p,p_cnt);
   end;                  % if Probe select
end;                     % for probe cnt



clear pos;

clear hb;
clear pre;
clear post;
clear file;  
clear figure_h;
clear ch_num;
clear i;

close(wh);
clear wh;

if length(add_mark) <= 0;
   kl_flg = 0;
   kl_graph_h(1).time_min = 1;
   kl_map_h(1).topo_max=0.2;
   pca_data(1).weight='';
   pca_data(1).graph='';
   pca_data(1).corr='';
   warndlg('Please Select Mark!','Warning'); 
   return;
elseif data_cnt == 0;
   kl_flg = 0;
   kl_graph_h(1).time_min = 1;
   kl_map_h(1).topo_max=0.2;
   pca_data(1).weight='';
   pca_data(1).graph='';
   pca_data(1).corr='';
   if diff_err ~= 1;
      warndlg('Warning Probe Select!  Please choose analyzed Probe No.','Warning');
   end;
   return;
end;

