% kl_graph
%
% Input  : info,mark,para,hb_data,kl_graph_h,kl_map_h,kl_data,sParaKL,para_p,p_cnt
% Output : hb_data,kl_graph_h,kl_map_h,sParaKL
% Example: [hb_data,kl_graph_h,kl_map_h,sParaKL] = kl_graph(info,mark,para,hb_data,kl_graph_h,kl_map_h,kl_data,sParaKL,para_p,p_cnt)

%*******************************************************
%*               Plot Hb Graph Function                *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF02.11.11 Ver1.01  futahashi KL conversion function is added
% HistoryF02.11.27 Ver1.01  Kawasaki  The Total calculation method is amended and Graph Color is changed.
% HistoryF03.05.06 Ver2.00  Isawa     A display is changed into point->sec.
% HistoryF03.12.26 Ver2.01  Kusabuka@many probe 


function [hb_data,kl_graph_h,kl_map_h,sParaKL] = kl_graph(info,mark,para,hb_data,kl_graph_h,kl_map_h,kl_data,sParaKL,para_p,p_cnt); 
%kl_graph_h
%fprintf('kl_graph p_cnt=%d\n',p_cnt);
% init
% hb_min    = -0.3;
% hb_max    = 0.3;

if para.sel_move == 0;
   add_mark  = find(mark.ave==1);
else;
   add_mark  = find(mark.ave==1 & mark.move==0);
end;

%********* kl_graph Init *********
if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
elseif(p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) |(p_cnt==4 & para_p.load_prb4 ~=1) |(p_cnt==5 & para_p.load_prb5 ~=1);
else;
   Sel_graph = p_cnt;
   kl_graph_h(p_cnt).time_min =1;
   kl_graph_h(p_cnt).oxy_val=1;
   kl_graph_h(p_cnt).deoxy_val=1;
   kl_graph_h(p_cnt).total_val=1;
   %****** 33hb ******
   %****** 44hb ******
   %****** 35hb ******
   [kl_graph_h]=graph_posi(info,kl_graph_h,p_cnt,para_p);

   %******** init ********
   if hb_data(p_cnt).ana_mode == 1; %*** Continuous Hb ***
      kl_graph_h(p_cnt).time_max = info(p_cnt).datanum;
      sParaKL.sel_point   = (floor((kl_graph_h(p_cnt).time_max-kl_graph_h(p_cnt).time_min)/2)*10)/10; 
      kl_map_h(p_cnt).topo_min   = -1;
      kl_map_h(p_cnt).topo_max   = 1;  
      kl_graph_h(p_cnt).hb_min   = -1;
      kl_graph_h(p_cnt).hb_max   = 1;
   end;

   if hb_data(p_cnt).ana_mode == 2; %*** Integral Hb ***
      if info(p_cnt).measure_mode(1)==1;block = mark.point(add_mark(1),3)-mark.point(add_mark(1),2)+para.pre+para.post+para.relax;end;
      if info(p_cnt).measure_mode(1)==2;block = 1+para.pre+para.post+para.relax;end;
      kl_graph_h(p_cnt).time_max = block;
      sParaKL.sel_point   = floor((kl_graph_h(p_cnt).time_max-kl_graph_h(p_cnt).time_min)/2);
      kl_map_h(p_cnt).topo_min   = -0.2;
      kl_map_h(p_cnt).topo_max   = 0.2;
      kl_graph_h(p_cnt).hb_min   = -0.2;
      kl_graph_h(p_cnt).hb_max   = 0.2;
   end;

   %******** Plot Graph(PCA) ********
   kl_graph_h(p_cnt).hb_fig = figure(58+(p_cnt-1));
   set(kl_graph_h(p_cnt).hb_fig,'Units','points');
   clf reset;
   if hb_data(p_cnt).calc_flg==2;   
      set(kl_graph_h(p_cnt).hb_fig,'Name',sprintf('Reconstruct Hb Graph Probe %d(Filter)',p_cnt));
   else;
      set(kl_graph_h(p_cnt).hb_fig,'Name',sprintf('Reconstruct Hb Graph Probe %d',p_cnt));
   end;
   kl_posi = get(kl_graph_h(p_cnt).hb_fig,'Position'); 
   kl_posi(1) = kl_posi(1)+((p_cnt-1)*10);
   set(kl_graph_h(p_cnt).hb_fig,'Position',kl_posi);
   plotedit(kl_graph_h(p_cnt).hb_fig,'hidetoolsmenu');
   set(kl_graph_h(p_cnt).hb_fig,'Interruptible','off');
   set(kl_graph_h(p_cnt).hb_fig,'CloseRequestFcn','move_stop=1;closereq;');
   
   for i=1:info(p_cnt).ad_ch_max/2;
      set(0,'CurrentFigure',kl_graph_h(p_cnt).hb_fig);
%      kl_graph_h(p_cnt).map_gco(i) = axes(kl_graph_h(p_cnt).hb_y,kl_graph_h(p_cnt).hb_x,kl_graph_h(p_cnt).graph_posi(i));
      kl_graph_h(p_cnt).map_gco(i) = axes('Position',kl_graph_h(p_cnt).graph_posi(i).p);
      box on;
      hold on;
      title(['CH',int2str(i)],'Fontsize',para_p.fsize);

      if info(p_cnt).err_ch(i)==1 & para_p.del_ch ==1;set(findobj(gca,'type','axes'),'color',[0.8 0.8 0.8]);end;

      % A tag is attached and put on graph.
      set(kl_graph_h(p_cnt).map_gco(i),'Tag','axes');
   
%       kl_graph_h(p_cnt).con_graph(1,i) = plot(hb_data(p_cnt).const(1,:,i),'r');
%       kl_graph_h(p_cnt).con_graph(2,i) = plot(hb_data(p_cnt).const(2,:,i),'b');
      % It chooses whether oxy+deoxy after reconstruction is used for Total_Hb data, using Total.
%       if sParaKL.sel_total_hb == 0;
%          kl_graph_h(p_cnt).con_graph(3,i) = plot(hb_data(p_cnt).const(3,:,i),'g');
%       else;
%          kl_graph_h(p_cnt).con_graph(3,i) = plot(hb_data(p_cnt).const(4,:,i),'Color',[0.8 0.8 0]);
%       end;
      plot([sParaKL.sel_point sParaKL.sel_point],[-10 10],':m');       
      
      plot([0 kl_graph_h(p_cnt).time_max],[0 0],':','Color',[0.1 0.1 0.1]);  
      mark_line(info,para,para_p,mark,hb_data,0,kl_data,kl_graph_h,p_cnt,i,2);  % Mark line
      [kl_graph_h] = drow_pca(info,para,para_p,mark,hb_data,kl_data,kl_graph_h,sParaKL,p_cnt,i);  % Mark line
%      axis ([0 length(kl_data.graph) hb_min hb_max]);
      label_put(info,kl_graph_h,para,para_p,p_cnt,i,kl_graph_h(p_cnt).hb_fig,kl_graph_h(p_cnt).map_gco(i));
      hold off;
   end;

   %************ Button **************
   %************** check **************
   kl_graph_h(p_cnt).oxy_chk = uicontrol('Parent',kl_graph_h(p_cnt).hb_fig, ...
                     'Units','points', ...
                     'Position',[1 48 40 15], ...
                     'BackgroundColor',[0.8 0.8 0.8], ...
                     'Style','checkbox', ...
                     'String','Oxy',...
                     'Value',kl_graph_h(p_cnt).oxy_val,...
                     'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                                 'kl_graph_h(Sel_graph).oxy_val = get(gcbo,''value'');',...
                                 'if move_stop == 1;',...
                                    'if kl_graph_h(Sel_graph).oxy_val == 1;',... 
                                        'set(kl_graph_h(Sel_graph).con_graph(1,:),''Visible'',''on'');',...
                                    'else;',... 
                                        'set(kl_graph_h(Sel_graph).con_graph(1,:),''Visible'',''off'');',...
                                    'end;',...
                                 'else;',...
                                    'if kl_graph_h(Sel_graph).oxy_val == 1;',...
                                       'set(kl_graph_h(Sel_graph).oxy_chk,''Value'',0);',...
                                       'kl_graph_h(Sel_graph).oxy_val  = 0;',...
                                    'else;',...
                                       'set(kl_graph_h(Sel_graph).oxy_chk,''Value'',1);',...
                                       'kl_graph_h(Sel_graph).oxy_val  = 1;',...
                                    'end;',...
                                    'warndlg(''Please push a stop button.'',''Warning !!'');',...
                                 'end;',...
                               ]);
   kl_graph_h(p_cnt).deoxy_chk = uicontrol('Parent',kl_graph_h(p_cnt).hb_fig, ...
                     'Units','points', ...
                     'Position',[1 33 40 15], ...
                     'BackgroundColor',[0.8 0.8 0.8], ...
                     'Style','checkbox', ...
                     'String','Deoxy',...
                     'Value',kl_graph_h(p_cnt).deoxy_val,...
                     'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                                 'kl_graph_h(Sel_graph).deoxy_val = get(gcbo,''value'');',...
                                 'if move_stop == 1;',...
                                    'if kl_graph_h(Sel_graph).deoxy_val == 1;',... 
                                        'set(kl_graph_h(Sel_graph).con_graph(2,:),''Visible'',''on'');',...
                                    'else;',... 
                                        'set(kl_graph_h(Sel_graph).con_graph(2,:),''Visible'',''off'');',...
                                    'end;',...
                                 'else;',...
                                    'if kl_graph_h(Sel_graph).deoxy_val == 1;',...
                                       'set(kl_graph_h(Sel_graph).deoxy_chk,''Value'',0);',...
                                       'kl_graph_h(Sel_graph).deoxy_val = 0;',...
                                    'else;',...
                                       'set(kl_graph_h(Sel_graph).deoxy_chk,''Value'',1);',...
                                       'kl_graph_h(Sel_graph).deoxy_val = 1;',...
                                    'end;',...
                                    'warndlg(''Please push a stop button.'',''Warning !!'');',...
                                 'end;',...
                                ]);
   kl_graph_h(p_cnt).total_chk = uicontrol('Parent',kl_graph_h(p_cnt).hb_fig, ...
                     'Units','points', ...
                     'Position',[1 18 40 15], ...
                     'BackgroundColor',[0.8 0.8 0.8], ...
                     'Style','checkbox', ...
                     'String','Total',...
                     'Value',kl_graph_h(p_cnt).total_val,...
                     'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                                 'kl_graph_h(Sel_graph).total_val = get(gcbo,''value'');',...
                                 'if move_stop == 1;',...
                                    'if kl_graph_h(Sel_graph).total_val == 1;',... 
                                        'set(kl_graph_h(Sel_graph).con_graph(3,:),''Visible'',''on'');',...
                                    'else;',... 
                                        'set(kl_graph_h(Sel_graph).con_graph(3,:),''Visible'',''off'');',...
                                    'end;',...
                                 'else;',...
                                    'if kl_graph_h(Sel_graph).total_val == 1;',...
                                       'set(kl_graph_h(Sel_graph).total_chk,''Value'',0);',...
                                       'kl_graph_h(Sel_graph).total_val = 0;',...
                                    'else;',...
                                       'set(kl_graph_h(Sel_graph).total_chk,''Value'',1);',...
                                       'kl_graph_h(Sel_graph).total_val = 1;',...
                                    'end;',...
                                    'warndlg(''Please push a stop button.'',''Warning !!'');',...
                                 'end;',...
                                ]);

   %************ edit **************
   kl_graph_h(Sel_graph).kl.y_min = uicontrol('Parent',kl_graph_h(p_cnt).hb_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 kl_posi(4)/2-kl_posi(4)/4+6 40 14],...
               'Style','edit',...
               'String',kl_graph_h(Sel_graph).hb_min,...
               'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                           'h=findobj(gcf,''type'',''axes'');',...
                           'TmpData=str2num(get(gcbo,''string''));',...% Ver 2.00 ->
                           'if length(TmpData) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                              'TmpData = round(TmpData*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif TmpData >= kl_graph_h(Sel_graph).hb_max | TmpData < -1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_graph_h(Sel_graph).hb_min=TmpData;',...% Ver 2.00 <-
                                 'if isfield(kl_graph_h(Sel_graph),''con_graph'')==1;',...
                                    'set(kl_graph_h(Sel_graph).con_graph(:,:),''Visible'',''off'');',...
                                 'end;',...
                                 'for i=1:info(Sel_graph).ad_ch_max/2;',...
                                    'mark_line(info,para,para_p,mark,hb_data,0,kl_data,kl_graph_h,Sel_graph,i,2);',...  % Mark line
                                    '[kl_graph_h] = drow_pca(info,para,para_p,mark,hb_data,kl_data,kl_graph_h,sParaKL,Sel_graph,i);',...  % graph
                                    'set(kl_graph_h(Sel_graph).hb_fig,''CurrentAxes'',h(info(Sel_graph).ad_ch_max/2-(i-1)));',...
                                    'label_put(info,kl_graph_h,para,para_p,Sel_graph,i,kl_graph_h(Sel_graph).hb_fig,h(info(Sel_graph).ad_ch_max/2-(i-1)));',...   % label drow
                                 'end;',...
                              'end;',...
                              'set(gcbo,''string'', kl_graph_h(Sel_graph).hb_min);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_graph_h(Sel_graph).hb_min);',...
                           'end;',...
                           'clear TmpData;clear i;'],...
               'Tag','EditText1');
   %************ max Renge ***********
   kl_graph_h(Sel_graph).kl.y_unit  = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
              'Units','points',...
              'Position',[2 kl_posi(4)/2+kl_posi(4)/4+14 30 10],...
              'BackgroundColor',[0.8 0.8 0.8],...
	           'Style','text',...
              'String','mMmm',...% Ver 2.00 -><-
              'Tag','tag2');

   kl_graph_h(Sel_graph).kl.y_max = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 kl_posi(4)/2+kl_posi(4)/4 40 14],...
               'Style','edit',...
               'String',kl_graph_h(Sel_graph).hb_max,...
               'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                           'h=findobj(gcf,''type'',''axes'');',...
                           'TmpData=str2num(get(gcbo,''string''));',...% Ver 2.00 ->
                           'if length(TmpData) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                              'TmpData = round(TmpData*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif TmpData <= kl_graph_h(Sel_graph).hb_min | TmpData > 1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_graph_h(Sel_graph).hb_max=TmpData;',...% Ver 2.00 <-
                                 'if isfield(kl_graph_h(Sel_graph),''con_graph'')==1;',...
                                    'set(kl_graph_h(Sel_graph).con_graph(:,:),''Visible'',''off'');',...
                                 'end;',...
                                 'for i=1:info(Sel_graph).ad_ch_max/2;',...
                                    'mark_line(info,para,para_p,mark,hb_data,0,kl_data,kl_graph_h,Sel_graph,i,2);',...  % Mark line
                                    '[kl_graph_h] = drow_pca(info,para,para_p,mark,hb_data,kl_data,kl_graph_h,sParaKL,Sel_graph,i);',...  % Mark line
                                    'set(kl_graph_h(Sel_graph).hb_fig,''CurrentAxes'',h(info(Sel_graph).ad_ch_max/2-(i-1)));',...
                                    'label_put(info,kl_graph_h,para,para_p,Sel_graph,i,kl_graph_h(Sel_graph).hb_fig,h(info(Sel_graph).ad_ch_max/2-(i-1)));',...   % label drow
                                 'end;',...
                              'end;',...
                              'set(gcbo,''string'', kl_graph_h(Sel_graph).hb_max);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_graph_h(Sel_graph).hb_max);',...
                           'end;',...
                           'clear TmpData;clear i;'],...
               'Tag','EditText2');

      kl_graph_h(Sel_graph).kl.t_min = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[kl_posi(3)/2-kl_posi(3)/4-40 2 40 14],...
               'Style','edit',...
               'String',kl_graph_h(Sel_graph).time_min*info(Sel_graph).smpl_period/1000,...
               'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                           'h=findobj(gcf,''type'',''axes'');',...
                           'TmpData=str2num(get(kl_graph_h(Sel_graph).kl.t_min,''string''));',...% Ver 2.00 ->
                           'if length(TmpData) ~= 0;',...
                              'ret=strchknum(get(kl_graph_h(Sel_graph).kl.t_min,''string''));',...
                              'TmpData = round(TmpData*10)/10;',...
                              'TmpData = round(TmpData/(info(Sel_graph).smpl_period/1000)*10)/10;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif TmpData >= kl_graph_h(Sel_graph).time_max | TmpData < 1;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_graph_h(Sel_graph).time_min=TmpData;',...
                                 'TimeMin = round(kl_graph_h(Sel_graph).time_min*(info(Sel_graph).smpl_period/1000)*10)/10;',...
                                 'TimeMax = round(kl_graph_h(Sel_graph).time_max*(info(Sel_graph).smpl_period/1000)*10)/10;',...
                                 'TimeStep = round(((kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min)*(info(Sel_graph).smpl_period/1000))/2*10)/10;',...
                                 'lab(1)=TimeMin; lab(2)=TimeMin+TimeStep; lab(3)=TimeMax;',...
                                 'for i=1:(info(Sel_graph).ad_ch_max/2);',...
                                    'set(h(i),''XLim'',[kl_graph_h(Sel_graph).time_min kl_graph_h(Sel_graph).time_max]);',...
                                    'set(h(i),''xtick'',kl_graph_h(Sel_graph).time_min:floor((kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min)/2):kl_graph_h(Sel_graph).time_max);',...
                                    'set(h(i),''xticklabel'',lab);',...
                                    'set(h(i),''fontsize'',para_p.fsize);',...
                                    'set(kl_graph_h(Sel_graph).hb_fig,''CurrentAxes'',h(i));',...
                                    'label_put(info,kl_graph_h,para,para_p,Sel_graph,(info(Sel_graph).ad_ch_max/2)-(i-1),kl_graph_h(Sel_graph).hb_fig,h(i));',...   % label drow
                                 'end;',...
                              'end;',...
                              'clear ret;',...
                              'set(kl_graph_h(Sel_graph).kl.t_min,''string'',round(kl_graph_h(Sel_graph).time_min*info(Sel_graph).smpl_period/1000*10)/10);',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(kl_graph_h(Sel_graph).kl.t_min,''string'', kl_graph_h(Sel_graph).time_min*info(Sel_graph).smpl_period/1000);',...
                           'end;',...
                           'clear h;clear i;clear TimeMax; clear TimeMin; clear TimeStep; clear lab; clear TmpData;'],...% Ver 2.00 <-
               'Tag','EditText3');
 
      kl_graph_h(Sel_graph).kl.t_max = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[kl_posi(3)/2+kl_posi(3)/4 2 40 14],...
               'Style','edit',...
               'String',kl_graph_h(Sel_graph).time_max*info(Sel_graph).smpl_period/1000,...
               'Callback',['Sel_graph=get(gca,''Parent'')-(58-1);',...
                           'h=findobj(gcf,''type'',''axes'');',...
                           'TmpData=str2num(get(kl_graph_h(Sel_graph).kl.t_max,''string''));',...% Ver 2.00 ->
                           'if length(TmpData) ~= 0;',...
                              'if hb_data(Sel_graph).ana_mode == 2;',...    % integral
                                 'if info(Sel_graph).measure_mode(1)==1;',...
                                    'max_t = mark.point(1,3)-mark.point(1,2)+para.pre+para.post+para.relax;',...
                                 'elseif info(Sel_graph).measure_mode(1)==2;',...
                                    'max_t = 1+para.pre+para.post+para.relax;',...
                                 'end;',...
                              'else;',...
                                 'max_t=info(Sel_graph).datanum;',...
                              'end;',...
                              'ret=strchknum(get(kl_graph_h(Sel_graph).kl.t_max,''string''));',...
                              'TmpData = round(TmpData*10)/10;',...
                              'TmpData = round(TmpData/(info(Sel_graph).smpl_period/1000)*10)/10;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif TmpData <= kl_graph_h(Sel_graph).time_min | TmpData > max_t;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_graph_h(Sel_graph).time_max=TmpData;',...
                                 'TimeMin = round(kl_graph_h(Sel_graph).time_min*(info(Sel_graph).smpl_period/1000)*10)/10;',...
                                 'TimeMax = round(kl_graph_h(Sel_graph).time_max*(info(Sel_graph).smpl_period/1000)*10)/10;',...
                                 'TimeStep = round((((kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min)*(info(Sel_graph).smpl_period/1000))/2)*10)/10;',...
                                 'lab(1)=TimeMin; lab(2)=TimeMin+TimeStep; lab(3)=TimeMax;',...
                                 'for i=1:(info(Sel_graph).ad_ch_max/2);',...
                                    'set(h(i),''XLim'',[kl_graph_h(Sel_graph).time_min kl_graph_h(Sel_graph).time_max]);',...
                                    'set(h(i),''xtick'',kl_graph_h(Sel_graph).time_min:(kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min)/2:kl_graph_h(Sel_graph).time_max);',...
                                    'set(h(i),''xticklabel'',lab);',...
                                    'set(h(i),''fontsize'',para_p.fsize);',...
                                    'set(kl_graph_h(Sel_graph).hb_fig,''CurrentAxes'',h(i));',...
                                    'label_put(info,kl_graph_h,para,para_p,Sel_graph,(info(Sel_graph).ad_ch_max/2)-(i-1),kl_graph_h(Sel_graph).hb_fig,h(i));',...   % label drow
                                 'end;',...
                              'end;',...
                              'set(kl_graph_h(Sel_graph).kl.t_max,''string'', round(kl_graph_h(Sel_graph).time_max*(info(Sel_graph).smpl_period/1000)*10)/10);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(kl_graph_h(Sel_graph).kl.t_max,''string'', kl_graph_h(Sel_graph).time_max*info(Sel_graph).smpl_period/1000);',...
                           'end;',...
                           'clear h;clear i;clear TimeMax; clear TimeMin; clear TimeStep; clear lab; clear TmpData;clear max_t;'],...% Ver 2.00 <-
               'Tag','EditText4');

     kl_graph_h(Sel_graph).kl.time = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
                          'Units','points',...
                          'Position',[kl_posi(3)/2 15 40 10],...
                          'BackgroundColor',[0.8 0.8 0.8],...
                          'Style','text',...
                          'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000,...% Ver 2.00 -><-
                          'Tag','tag2');  

      kl_graph_h(Sel_graph).kl.t_unit = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
               'Units','points',...
               'Position',[kl_posi(3)/2-40 15 40 10],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String','sec',...
               'Tag','tag2');     

      kl_graph_h(Sel_graph).kl.sl1 = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
                           'Units','points',...
                           'Position',[kl_posi(3)/4+15 2 kl_posi(3)/2-45 12],...
                           'Style','slider',...
                           'Min',kl_graph_h(Sel_graph).time_min,...
                           'Max',kl_graph_h(Sel_graph).time_max,...
                           'Interruptible','off',...
                           'Sliderstep',[1/(kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min) 10/(kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min)],...
                           'Value',floor(kl_graph_h(Sel_graph).time_max-kl_graph_h(Sel_graph).time_min)/2,...
                           'Tag','sl_bar',...
                           'Callback',['if move_stop == 1;',...
                                          'Sel_graph=get(gca,''Parent'')-(58-1);',...
                                          '[kl_graph_h]=graph_posi(info,kl_graph_h,Sel_graph,para_p);',...
                                          'sParaKL.sel_point=floor(get(kl_graph_h(Sel_graph).kl.sl1,''Value''));',...
                                          'if sParaKL.sel_point < 1;sParaKL.sel_point = 1;end;',...
                                          'h = findobj(gcf,''Color'',''m'');',...
                                          'delete(h);',...
                                          'if isfield(kl_graph_h(Sel_graph),''con_graph'')==1;',...
                                             'set(kl_graph_h(Sel_graph).con_graph(:,:),''Visible'',''off'');',...
                                          'end;',...
                                          'for i=1:info(Sel_graph).ad_ch_max/2;',...
                                             'mark_line(info,para,para_p,mark,hb_data,0,kl_data,kl_graph_h,Sel_graph,i,2);',...  % Mark line
                                             '[kl_graph_h] = drow_pca(info,para,para_p,mark,hb_data,kl_data,kl_graph_h,sParaKL,Sel_graph,i);',...  % Mark line
                                             'label_put(info,kl_graph_h,para,para_p,Sel_graph,i,kl_graph_h(Sel_graph).hb_fig,kl_graph_h(Sel_graph).map_gco(i));',...   % label drow
                                          'end;',...
                                          'clear h;clear i;',...
                                          'set(kl_graph_h(Sel_graph).kl.time,''String'',sParaKL.sel_point*(info(Sel_graph).smpl_period/1000));',...  % Ver 2.00 -><-
                                          '[hb_data]=except_ch(info,para_p,hb_data,Sel_graph);',...
                                          'if para.sel_topo==1 & info(Sel_graph).probe_mode==1;[kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                                          'if para.sel_topo==1 & info(Sel_graph).probe_mode==2;[kl_map_h,sParaKL] = kl_map44(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                                          'if para.sel_topo==1 & info(Sel_graph).probe_mode==3;[kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                                          'if para.sel_topo==1 & info(Sel_graph).probe_mode==4;[kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                                          'if para.sel_topo==1 & info(Sel_graph).probe_mode==5;[kl_map_h,sParaKL] = kl_map310(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                                       'else;',...
                                          'warndlg(''Please push a stop button.'',''Warning !!'');',...
                                       'end;',...
                                      ]);     

   kl_graph_h(Sel_graph).kl.int= uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[kl_posi(3)-40 2 40 14],...
               'String','Integral',...
               'Callback',[   'Sel_graph=get(gca,''Parent'')-(58-1);',...
                              '[kl_graph_h,hb_data] = kl_int(info,Sel_graph,mark,para,kl_graph_h,hb_data,para_p);',...
                          ],...
               'Tag','Pushbutton1');

   if hb_data(Sel_graph).ana_mode == 1;
      set(kl_graph_h(Sel_graph).kl.int,'Visible','on');
   else
      set(kl_graph_h(Sel_graph).kl.int,'Visible','off');
   end;

      %************** file out **************
      kl_graph_h(Sel_graph).kl.fout = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig,...
          'Units','points',...
          'BackgroundColor',[0.75 0.75 0.75], ...
          'Position',[kl_posi(3)-35 16 35 14],...
          'String','FileOut',...
          'Callback',['if move_stop == 1;',...
                        'Sel_graph=get(gca,''Parent'')-(58-1);',...
                        'fout_kl(info,para,para_p,hb_data,mark,ad_data,Sel_graph);',...
                      'else;',...
                        'warndlg(''Please push a stop button.'',''Warning !!'');',...
                      'end;',...
          ],...
          'Tag','Pushbutton1');

   %****** The range by the mouse, drawing point setup ***********
   mouse = ['if move_stop==1;',...
               'Sel_graph=get(gca,''Parent'')-(58-1);',...  
               'if strcmp(get(kl_graph_h(Sel_graph).hb_fig,''SelectionType''),''normal'');',...
                  '[kl_graph_h]=graph_posi(info,kl_graph_h,Sel_graph,para_p);',...
                  'pt=get(gca,''currentpoint'');',...
                  'MousePointData = floor(pt(1,1));',...                 % Ver 2.00 -><- A mouse click position is judged and, in besides graph, it does not update.
                  'if MousePointData > kl_graph_h(Sel_graph).time_min & MousePointData<= kl_graph_h(Sel_graph).time_max;',...	
                     'sParaKL.sel_point = MousePointData;',...
                     'set(kl_graph_h(Sel_graph).kl.sl1,''Value'',sParaKL.sel_point);',...
                     'h = findobj(gcf,''Color'',''m'');',...
                     'delete(h);',...
                     'if isfield(kl_graph_h(Sel_graph),''con_graph'')==1;',...
                        'set(kl_graph_h(Sel_graph).con_graph(:,:),''Visible'',''off'');',...
                     'end;',...
                     'for i=1:info(Sel_graph).ad_ch_max/2;',...
                        'mark_line(info,para,para_p,mark,hb_data,0,kl_data,kl_graph_h,Sel_graph,i,2);',...  % Mark line
                        '[kl_graph_h] = drow_pca(info,para,para_p,mark,hb_data,kl_data,kl_graph_h,sParaKL,Sel_graph,i);',...  % Mark line
                        'label_put(info,kl_graph_h,para,para_p,Sel_graph,i,kl_graph_h(Sel_graph).hb_fig,kl_graph_h(Sel_graph).map_gco(i));',...   % label drow
                     'end;',...
                     'set(kl_graph_h(Sel_graph).kl.time,''String'',sParaKL.sel_point*info(Sel_graph).smpl_period/1000);',...% Ver 2.00 -><-
                     '[hb_data]=except_ch(info,para_p,hb_data,Sel_graph);',...                 
                     'if para.sel_topo==1 & info(Sel_graph).probe_mode==1;[kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...   
                     'if para.sel_topo==1 & info(Sel_graph).probe_mode==2;[kl_map_h,sParaKL] = kl_map44(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                     'if para.sel_topo==1 & info(Sel_graph).probe_mode==3;[kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                     'if para.sel_topo==1 & info(Sel_graph).probe_mode==4;[kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                     'if para.sel_topo==1 & info(Sel_graph).probe_mode==5;[kl_map_h,sParaKL] = kl_map310(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);end;',...
                  'end;',...
                  'clear i;clear pt;clear h;clear MousePointData;'...   
               'end;',...
            'else;',...
               'warndlg(''Please push a stop button.'',''Warning !!'');',...
            'end;',...
           ];

   set(gcf,'WindowButtonDownFcn',mouse);
   

   %************** refresh **************
   kl_graph_h(Sel_graph).kl.ad_ref = uicontrol('Parent',kl_graph_h(Sel_graph).hb_fig, ...
               'Units','points', ...
               'BackgroundColor',[1.0 0.9 0.1], ...
               'Position',[1 0 35 14], ...
               'String','Refresh',...
               'Callback',['kl_posi=get(gcf,''Position'');',...
                           'Sel_graph=get(gca,''Parent'')-(58-1);'...
                           'set(kl_graph_h(Sel_graph).kl.y_min,''Position'',[1 kl_posi(4)/2-kl_posi(4)/4 40 14]);',...
                           'set(kl_graph_h(Sel_graph).kl.y_max,''Position'',[1 kl_posi(4)/2+kl_posi(4)/4 40 14]);',...
                           'set(kl_graph_h(Sel_graph).kl.y_unit,''Position'',[2 kl_posi(4)/2+kl_posi(4)/4+14 30 10]);',...
                           'set(kl_graph_h(Sel_graph).kl.t_min,''Position'',[kl_posi(3)/2-kl_posi(3)/4-40 2 40 14]);',...
                           'set(kl_graph_h(Sel_graph).kl.t_max,''Position'',[kl_posi(3)/2+kl_posi(3)/4 2 40 14]);',...
                           'set(kl_graph_h(Sel_graph).kl.t_unit,''Position'',[kl_posi(3)/2-40 15 40 10]);',...
                           'set(kl_graph_h(Sel_graph).kl.time,''Position'',[kl_posi(3)/2 15 40 10]);',...
                           'set(kl_graph_h(Sel_graph).kl.sl1,''Position'',[kl_posi(3)/4+15 2 kl_posi(3)/2-45 12]);',...
                           'set(kl_graph_h(Sel_graph).kl.int,''Position'',[kl_posi(3)-40 2 40 14]);',...
                           'set(kl_graph_h(Sel_graph).kl.fout,''Position'',[kl_posi(3)-35 16 35 14]);',...
                           'clear kl_posi;',...
                          ],...
                          'tag','Pushbutton3');

end;

