% kl_map311
%
% Input  : sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph
% Output : kl_map_h,sParaKL
% Example: [kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph); 

%*******************************************************
%*               Plot Hb Map44 Function                *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF04.02.02 Ver2.01  Kusabuka@new


function [kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop); 

%fprintf('kl_map311\n');
%fprintf(sParaKL.sel_point=%d \n\n', sParaKL.sel_point);
% When a specification point is inaccurate, it escapes from a function.@@@<- Ver2.00
if sParaKL.sel_point <= 0 | kl_graph_h(Sel_graph).time_max < sParaKL.sel_point;
   return;
end;

% It is made to move_stop, when a STOP flag is stood to the [Play] button and it is under processing.
%move_stop=1;
view_flg=1;
%************ Hb311 MAP ****************
[x,y]     = meshgrid(1:1:12);
[xi,yi]   = meshgrid(1:0.1:12);

%************ Topo View ************** 
kl_map_h(Sel_graph).topo_fig=figure(63+(Sel_graph-1));
set(gca,'drawmode','fast');
clf;
plotedit(kl_map_h(Sel_graph).topo_fig,'hidetoolsmenu');
posi = get(kl_map_h(Sel_graph).topo_fig,'Position'); 
%posi.Position(1) = posi.Position(1)+((Sel_graph-1)*10);
set(kl_map_h(Sel_graph).topo_fig,'Position',posi);
set(kl_map_h(Sel_graph).topo_fig,'Name',sprintf('Reconstruct Topography Probe %d',Sel_graph));
set(kl_map_h(Sel_graph).topo_fig,'CloseRequestFcn','move_stop=1;closereq;');
%set(kl_map_h(Sel_graph).topo_fig,'DeleteFcn','move_play=1;');

uicontrol('Units','normalized',...
          'BackgroundColor',[0.8 0.8 0.8],...
          'Position',[0.35 0.95 0.3 0.05],...
          'FontSize',15,...
          'Style','text');

%************ Movie Start **************
kl_map_h(Sel_graph).kl.play = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 35 40 14],...
            'String','Play',...
            'Style','togglebutton',...
            'Visible','on',...
            'Callback',['if move_stop == 1;',...
                           'move_stop = 0;',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);'...
                           'if move_stop == 0;',...
                              'if sParaKL.sel_point > kl_map_h(Sel_graph).kl.max;',...
                                 'sParaKL.sel_point = hb_graph_h(Sel_graph).time_min;',...
                              'end;',... 
                              'if info(Sel_graph).probe_mode==1;',...
                                    '[kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==2;',...
                                    '[kl_map_h,sParaKL] = kl_map44(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==3;',...
                                    '[kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==4;',...
                                    '[kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==5;',...
                                    '[kl_map_h,sParaKL] = kl_map310(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'end;',...
                              'move_stop = 1;',...
                           'end;',...
                           'set(kl_map_h(Sel_graph).kl.play,''Value'',0);',...
                           'clear m_cnt;clear fig_no;',...
                        'else;',...
                            'set(kl_map_h(Sel_graph).kl.play,''Value'',0);',...
                            'warndlg(''Please push a stop button.'',''Warning !!'');',...
                        'end;',...
                        ],...
            'Tag','Pushbutton1');

%************ Movie Stop **************
kl_map_h(Sel_graph).kl.stop = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'Style','togglebutton',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 20 40 14],...
            'String','Stop',...
            'Callback',['Sel_graph=get(gca,''Parent'')-(63-1);'...
                        'if move_stop == 1;',...
                           'move_stop = 1;',...
                           'set(kl_map_h(Sel_graph).kl.stop,''Value'',0);',...
                        'else;',...
                           'move_stop = 1;',...
                        'end;',...
                        ],...
            'Tag','Pushbutton2');

move_stop ~= get(kl_map_h(Sel_graph).kl.stop,'Value');
while(1);
   fig_no = findobj('Type','figure');
   fig_flg=0;
   for cnt=1:length(fig_no);
      if (fig_no(cnt) == Sel_graph+(63-1));
         fig_flg=1;
         break;
      end;
   end;
   if fig_flg == 0;
      move_stop=1;
      break;
   end;
   if move_stop ~= 1;
      move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      if move_stop == 1;
         break;
      end;
   end;
   set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
   set(kl_map_h(Sel_graph).kl.play,'Value',0);
   posi=get(kl_map_h(Sel_graph).topo_fig,'Position');
   if move_stop ~= 1;
      move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
   end;
   
   hb_map(1,:)  = hb_data(Sel_graph).const(1,sParaKL.sel_point,:);
   hb_map(2,:)  = hb_data(Sel_graph).const(2,sParaKL.sel_point,:);
   % It chooses whether oxy-deoxy is used for Total_Hb data, using Total.
   if sParaKL.sel_total_hb == 0;
      hb_map(3,:)  = hb_data(Sel_graph).const(3,sParaKL.sel_point,:);
   else;
      hb_map(3,:)  = hb_data(Sel_graph).const(4,sParaKL.sel_point,:); 
   end;

   for i=1:3;
      %******* 45 degrees rotates to the circumference of a clock. ******* 
      m(1,1) =(hb_map(i,11)+hb_map(i,32))/2;
      m(1,2) = hb_map(i,11);
      m(1,3) = hb_map(i,1);
      m(1,4) =(hb_map(i,1)+hb_map(i,2))/2;
      m(1,5) =(hb_map(i,1)+hb_map(i,2)*2+hb_map(i,3))/4;
      m(1,6) =(hb_map(i,1)+hb_map(i,2)*3+hb_map(i,3)*3+hb_map(i,4))/8;
      m(1,7) =(hb_map(i,1)+hb_map(i,2)*4+hb_map(i,3)*6+hb_map(i,4)*4+hb_map(i,5))/16; %
      m(1,8) =(hb_map(i,1)+hb_map(i,2)*5+hb_map(i,3)*10+hb_map(i,4)*10+hb_map(i,5)*5+hb_map(i,6))/32; %
      m(1,9) =(hb_map(i,1)+hb_map(i,2)*6+hb_map(i,3)*15+hb_map(i,4)*20+hb_map(i,5)*15+hb_map(i,6)*6+hb_map(i,7))/64; %
      m(1,10) =(hb_map(i,1)+hb_map(i,2)*7+hb_map(i,3)*21+hb_map(i,4)*35+hb_map(i,5)*35+hb_map(i,6)*21+hb_map(i,7)*7+hb_map(i,8))/128; %
      m(1,11) =(hb_map(i,1)+hb_map(i,2)*8+hb_map(i,3)*28+hb_map(i,4)*56+hb_map(i,5)*70+hb_map(i,6)*56+hb_map(i,7)*28+hb_map(i,8)*8+hb_map(i,9))/256; %
      m(1,12) =(hb_map(i,1)+hb_map(i,2)*9+hb_map(i,3)*36+hb_map(i,4)*84+hb_map(i,5)*126+hb_map(i,6)*126+hb_map(i,7)*84+hb_map(i,8)*36+hb_map(i,9)*9+hb_map(i,10))/512; %

      m(2,1) =(hb_map(i,32));
      m(2,2) = hb_map(i,22);
      m(2,3) = hb_map(i,12);
      m(2,4) = hb_map(i,2);
      m(2,5) =(hb_map(i,2)+hb_map(i,3))/2;
      m(2,6) =(hb_map(i,2)+hb_map(i,3)*2+hb_map(i,4))/4;
      m(2,7) =(hb_map(i,2)+hb_map(i,3)*3+hb_map(i,4)*3+hb_map(i,5))/8;
      m(2,8) =(hb_map(i,2)+hb_map(i,3)*4+hb_map(i,4)*6+hb_map(i,5)*4+hb_map(i,6))/16; %   
      m(2,9) =(hb_map(i,2)+hb_map(i,3)*5+hb_map(i,4)*10+hb_map(i,5)*10+hb_map(i,6)*5+hb_map(i,7))/32; %
      m(2,10) =(hb_map(i,2)+hb_map(i,3)*6+hb_map(i,4)*15+hb_map(i,5)*20+hb_map(i,6)*15+hb_map(i,7)*6+hb_map(i,8))/64; %
      m(2,11) =(hb_map(i,2)+hb_map(i,3)*7+hb_map(i,4)*21+hb_map(i,5)*35+hb_map(i,6)*35+hb_map(i,7)*21+hb_map(i,8)*7+hb_map(i,9))/128; %
      m(2,12) =(hb_map(i,2)+hb_map(i,3)*8+hb_map(i,4)*28+hb_map(i,5)*56+hb_map(i,6)*70+hb_map(i,7)*56+hb_map(i,8)*28+hb_map(i,9)*8+hb_map(i,10))/256; %
   
      m(3,1) =(hb_map(i,43));
      m(3,2) = hb_map(i,33);
      m(3,3) = hb_map(i,23);
      m(3,4) = hb_map(i,13);
      m(3,5) = hb_map(i,3);
      m(3,6) =(hb_map(i,3)+hb_map(i,4))/2;
      m(3,7) =(hb_map(i,3)+hb_map(i,4)*2+hb_map(i,5))/4;
      m(3,8) =(hb_map(i,3)+hb_map(i,4)*3+hb_map(i,5)*3+hb_map(i,6))/8;
      m(3,9) =(hb_map(i,3)+hb_map(i,4)*4+hb_map(i,5)*6+hb_map(i,6)*4+hb_map(i,7))/16; %   
      m(3,10) =(hb_map(i,3)+hb_map(i,4)*5+hb_map(i,5)*10+hb_map(i,6)*10+hb_map(i,7)*5+hb_map(i,8))/32; %
      m(3,11) =(hb_map(i,3)+hb_map(i,4)*6+hb_map(i,5)*15+hb_map(i,6)*20+hb_map(i,7)*15+hb_map(i,8)*6+hb_map(i,9))/64; %
      m(3,12) =(hb_map(i,3)+hb_map(i,4)*7+hb_map(i,5)*21+hb_map(i,6)*35+hb_map(i,7)*35+hb_map(i,8)*21+hb_map(i,9)*7+hb_map(i,10))/128; %
   
      m(4,1) =(hb_map(i,43)+hb_map(i,44))/2;
      m(4,2) =(hb_map(i,44));
      m(4,3) = hb_map(i,34);
      m(4,4) = hb_map(i,24);
      m(4,5) = hb_map(i,14);
      m(4,6) = hb_map(i,4);
      m(4,7) =(hb_map(i,4)+hb_map(i,5))/2;
      m(4,8) =(hb_map(i,4)+hb_map(i,5)*2+hb_map(i,6))/4;
      m(4,9) =(hb_map(i,4)+hb_map(i,5)*3+hb_map(i,6)*3+hb_map(i,7))/8;
      m(4,10) =(hb_map(i,4)+hb_map(i,5)*4+hb_map(i,6)*6+hb_map(i,7)*4+hb_map(i,8))/16; %   
      m(4,11) =(hb_map(i,4)+hb_map(i,5)*5+hb_map(i,6)*10+hb_map(i,7)*10+hb_map(i,8)*5+hb_map(i,9))/32; %
      m(4,12) =(hb_map(i,4)+hb_map(i,5)*6+hb_map(i,6)*15+hb_map(i,7)*20+hb_map(i,8)*15+hb_map(i,9)*3+hb_map(i,10))/64; %
   
      m(5,1) =(hb_map(i,43)+hb_map(i,44)*2+hb_map(i,45))/4;
      m(5,2) =(hb_map(i,44)+hb_map(i,45))/2;
      m(5,3) =(hb_map(i,45));
      m(5,4) = hb_map(i,35);
      m(5,5) = hb_map(i,25);
      m(5,6) = hb_map(i,15);
      m(5,7) = hb_map(i,5);
      m(5,8) =(hb_map(i,5)+hb_map(i,6))/2;
      m(5,9) =(hb_map(i,5)+hb_map(i,6)*2+hb_map(i,7))/4;
      m(5,10) =(hb_map(i,5)+hb_map(i,6)*3+hb_map(i,7)*3+hb_map(i,8))/8;
      m(5,11) =(hb_map(i,5)+hb_map(i,6)*4+hb_map(i,7)*6+hb_map(i,8)*4+hb_map(i,9))/16; %   
      m(5,12) =(hb_map(i,5)+hb_map(i,6)*5+hb_map(i,7)*10+hb_map(i,8)*10+hb_map(i,9)*5+hb_map(i,10))/32; %
   
      m(6,1) =(hb_map(i,43)+hb_map(i,44)*3+hb_map(i,45)*3+hb_map(i,46))/8;
      m(6,2) =(hb_map(i,44)+hb_map(i,45)*2+hb_map(i,46))/4;
      m(6,3) =(hb_map(i,45)+hb_map(i,46))/2;
      m(6,4) =(hb_map(i,46));
      m(6,5) = hb_map(i,36);
      m(6,6) = hb_map(i,26);
      m(6,7) = hb_map(i,16);
      m(6,8) = hb_map(i,6);
      m(6,9) =(hb_map(i,6)+hb_map(i,7))/2;
      m(6,10) =(hb_map(i,6)+hb_map(i,7)*2+hb_map(i,8))/4;
      m(6,11) =(hb_map(i,6)+hb_map(i,7)*3+hb_map(i,8)*3+hb_map(i,9))/8;
      m(6,12) =(hb_map(i,6)+hb_map(i,7)*4+hb_map(i,8)*6+hb_map(i,9)*4+hb_map(i,10))/16; %   
   
      m(7,1) =(hb_map(i,43)+hb_map(i,44)*4+hb_map(i,45)*6+hb_map(i,46)*4+hb_map(i,47))/16; %   
      m(7,2) =(hb_map(i,44)+hb_map(i,45)*3+hb_map(i,46)*3+hb_map(i,47))/8;
      m(7,3) =(hb_map(i,45)+hb_map(i,46)*2+hb_map(i,47))/4;
      m(7,4) =(hb_map(i,46)+hb_map(i,47))/2;
      m(7,5) =(hb_map(i,47));
      m(7,6) = hb_map(i,37);
      m(7,7) = hb_map(i,27);
      m(7,8) = hb_map(i,17);
      m(7,9) = hb_map(i,7);
      m(7,10) =(hb_map(i,7)+hb_map(i,8))/2;
      m(7,11) =(hb_map(i,7)+hb_map(i,8)*2+hb_map(i,9))/4;
      m(7,12) =(hb_map(i,7)+hb_map(i,8)*3+hb_map(i,9)*3+hb_map(i,10))/8;
   
      m(8,1) =(hb_map(i,43)+hb_map(i,44)*5+hb_map(i,45)*10+hb_map(i,46)*10+hb_map(i,47)*5+hb_map(i,48))/32; %
      m(8,2) =(hb_map(i,44)+hb_map(i,45)*4+hb_map(i,46)*6+hb_map(i,47)*4+hb_map(i,48))/16; %   
      m(8,3) =(hb_map(i,45)+hb_map(i,46)*3+hb_map(i,47)*3+hb_map(i,48))/8;
      m(8,4) =(hb_map(i,46)+hb_map(i,47)*2+hb_map(i,48))/4;
      m(8,5) =(hb_map(i,47)+hb_map(i,48))/2;
      m(8,6) =(hb_map(i,48));
      m(8,7) = hb_map(i,38);
      m(8,8) = hb_map(i,28);
      m(8,9) = hb_map(i,18);
      m(8,10) = hb_map(i,8);
      m(8,11) =(hb_map(i,8)+hb_map(i,9))/2;
      m(8,12) =(hb_map(i,8)+hb_map(i,9)*2+hb_map(i,10))/4;
   
      m(9,1) =(hb_map(i,43)+hb_map(i,44)*6+hb_map(i,45)*15+hb_map(i,46)*20+hb_map(i,47)*15+hb_map(i,48)*6+hb_map(i,49))/64; %
      m(9,2) =(hb_map(i,44)+hb_map(i,45)*5+hb_map(i,46)*10+hb_map(i,47)*10+hb_map(i,48)*5+hb_map(i,49))/32; %
      m(9,3) =(hb_map(i,45)+hb_map(i,46)*4+hb_map(i,47)*6+hb_map(i,48)*4+hb_map(i,49))/16; %   
      m(9,4) =(hb_map(i,46)+hb_map(i,47)*3+hb_map(i,48)*3+hb_map(i,49))/8;
      m(9,5) =(hb_map(i,47)+hb_map(i,48)*2+hb_map(i,49))/4;
      m(9,6) =(hb_map(i,48)+hb_map(i,49))/2;

      m(9,7) =(hb_map(i,49));
      m(9,8) = hb_map(i,39);
      m(9,9) = hb_map(i,29);
      m(9,10) = hb_map(i,19);
      m(9,11) = hb_map(i,9);
      m(9,12) =(hb_map(i,9)+hb_map(i,10))/2;
   
      m(10,1) =(hb_map(i,43)+hb_map(i,44)*7+hb_map(i,45)*21+hb_map(i,46)*35+hb_map(i,47)*35+hb_map(i,48)*21+hb_map(i,49)*7+hb_map(i,50))/128; %
      m(10,2) =(hb_map(i,44)+hb_map(i,45)*6+hb_map(i,46)*15+hb_map(i,47)*20+hb_map(i,48)*15+hb_map(i,49)*6+hb_map(i,50))/32; %
      m(10,3) =(hb_map(i,45)+hb_map(i,46)*5+hb_map(i,47)*10+hb_map(i,48)*10+hb_map(i,49)*5+hb_map(i,50))/24; %
      m(10,4) =(hb_map(i,46)+hb_map(i,47)*4+hb_map(i,48)*6+hb_map(i,49)*4+hb_map(i,50))/16; %   
      m(10,5) =(hb_map(i,47)+hb_map(i,48)*3+hb_map(i,49)*3+hb_map(i,50))/8;
      m(10,6) =(hb_map(i,48)+hb_map(i,49)*2+hb_map(i,50))/4;
      m(10,7) =(hb_map(i,49)+hb_map(i,50))/2;
      m(10,8) =(hb_map(i,50));
      m(10,9) = hb_map(i,40);
      m(10,10) = hb_map(i,30);
      m(10,11) = hb_map(i,20);
      m(10,12) = hb_map(i,10);
   
      m(11,1) =(hb_map(i,43)+hb_map(i,44)*8+hb_map(i,45)*28+hb_map(i,46)*56+hb_map(i,47)*70+hb_map(i,48)*56+hb_map(i,49)*28+hb_map(i,50)*8+hb_map(i,51))/256; %
      m(11,2) =(hb_map(i,44)+hb_map(i,45)*7+hb_map(i,46)*21+hb_map(i,47)*35+hb_map(i,48)*35+hb_map(i,49)*21+hb_map(i,50)*7+hb_map(i,51))/128; %
      m(11,3) =(hb_map(i,45)+hb_map(i,46)*6+hb_map(i,47)*15+hb_map(i,48)*20+hb_map(i,49)*15+hb_map(i,50)*6+hb_map(i,51))/64; %
      m(11,4) =(hb_map(i,46)+hb_map(i,47)*5+hb_map(i,48)*10+hb_map(i,49)*10+hb_map(i,50)*5+hb_map(i,51))/32; %
      m(11,5) =(hb_map(i,47)+hb_map(i,48)*4+hb_map(i,49)*6+hb_map(i,50)*4+hb_map(i,51))/16; %   
      m(11,6) =(hb_map(i,48)+hb_map(i,49)*3+hb_map(i,50)*3+hb_map(i,51))/8;
      m(11,7) =(hb_map(i,49)+hb_map(i,50)*2+hb_map(i,51))/4;
      m(11,8) =(hb_map(i,50)+hb_map(i,51))/2;
      m(11,9) =(hb_map(i,51));
      m(11,10) = hb_map(i,41);
      m(11,11) = hb_map(i,31);
      m(11,12) = hb_map(i,21);
   
      m(12,1) =(hb_map(i,43)+hb_map(i,44)*9+hb_map(i,45)*36+hb_map(i,46)*84+hb_map(i,47)*126+hb_map(i,48)*126+hb_map(i,49)*84+hb_map(i,50)*36+hb_map(i,51)*9+hb_map(i,52))/512; %
      m(12,2) =(hb_map(i,44)+hb_map(i,45)*8+hb_map(i,46)*28+hb_map(i,47)*56+hb_map(i,48)*70+hb_map(i,49)*56+hb_map(i,50)*28+hb_map(i,51)*8+hb_map(i,52))/256; %
      m(12,3) =(hb_map(i,45)+hb_map(i,46)*7+hb_map(i,47)*21+hb_map(i,48)*35+hb_map(i,49)*35+hb_map(i,50)*21+hb_map(i,51)*7+hb_map(i,52))/128; %
      m(12,4) =(hb_map(i,46)+hb_map(i,47)*6+hb_map(i,48)*15+hb_map(i,49)*20+hb_map(i,50)*15+hb_map(i,51)*6+hb_map(i,52))/64; %
      m(12,5) =(hb_map(i,47)+hb_map(i,48)*5+hb_map(i,49)*10+hb_map(i,50)*10+hb_map(i,51)*5+hb_map(i,52))/32; %
      m(12,6) =(hb_map(i,48)+hb_map(i,49)*4+hb_map(i,50)*6+hb_map(i,51)*4+hb_map(i,52))/16; %   
      m(12,7) =(hb_map(i,49)+hb_map(i,50)*3+hb_map(i,51)*3+hb_map(i,52))/8;
      m(12,8) =(hb_map(i,50)+hb_map(i,51)*2+hb_map(i,52))/4;
      m(12,9) =(hb_map(i,51)+hb_map(i,52))/2;
      m(12,10) =(hb_map(i,52));
      m(12,11) = hb_map(i,42);
      m(12,12) =(hb_map(i,21)+hb_map(i,42))/2;
   
      pol = interp2(x,y,m,xi,yi,'spline');
      %pol = griddata(x,y,m,xi,yi,'nearest');
   
      %'linear'   Between alignment assistant [ of a triangle base ] (default) 
      %'cubic'    Between cubic assistant [ of a triangle base ]  
      %'nearest'  according to a dot recently  
      %'invdist'  Reverse distance method 
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;   
      for a=1:size(pol,1);
         for b=1:size(pol,2);
            if a<11  & b<(-a+11);pol(a,b)=NaN;end;  % left 
            if a<101 & b>(a+21);pol(a,b)=NaN;end;   % upper
            if a>21  & b<(a-21);pol(a,b)=NaN;end;   % under
            if a>104 & b>(-a+215);pol(a,b)=NaN;end; % right
         end;
      end;
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;   
      %******* It returns and draws. *******3
      set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
%      if i~=3;axes(3,2,2*i-0.52);end;
%      if i==3;axes(3,2,2*i-0.45);end;
      if view_flg == 1;
         axes_fig(i)=axes('Position',kl_graph_h(Sel_graph).map(i).m);
      else;
         set(axes_fig(i),'Position',kl_graph_h(Sel_graph).map(i).m);
      end;

      set(kl_map_h(Sel_graph).topo_fig,'CurrentAxes',axes_fig(i));
      axes_pcol(i) = pcolor(pol);
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;
   
      hold on;
      axis square;
      axis ij;
      axis off;
      shading interp;
      caxis([kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);
      if para_p.angle(Sel_graph).angle1==1; % 0
         view(-45,90);
         if i==1; text(-5,-5,'Oxy');end;
         if i==2; text(-5,-5,'Deoxy');end;
         if i==3; text(-5,-5,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==2; % 90
         view(45,90);
         if i==1; text(30,70,'Oxy');end;
         if i==2; text(30,70,'Deoxy');end;
         if i==3; text(30,70,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==3; % 180
         view(135,90);
         if i==1; text(118,118,'Oxy');end;
         if i==2; text(118,118,'Deoxy');end;
         if i==3; text(118,118,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==4; % 270
         view(225,90);
         if i==1; text(80,40,'Oxy');end;
         if i==2; text(80,40,'Deoxy');end;
         if i==3; text(80,40,'Total');end;
      else;
         view(-45,90);
         if i==1; text(-5,-5,'Oxy');end;
         if i==2; text(-5,-5,'Deoxy');end;
         if i==3; text(-5,-5,'Total');end;
      end;
      zoom(4);    
      if i==3;
         kl_map_h(Sel_graph).map_col=colorbar;
         set(kl_map_h(Sel_graph).map_col,'Position',[0.89 0.1 0.03 0.4]); 
         set(kl_map_h(Sel_graph).map_col,'FontSize',7);
%       if para_p.angle(Sel_graph).angle1==1; % 0
%          text(155,78,'mMmm');
%       elseif para_p.angle(Sel_graph).angle1==2; % 90
%          text(85,25,'mMmm');
%       elseif para_p.angle(Sel_graph).angle1==3; % 180
%          text(-43,34,'mMmm');         
%       elseif para_p.angle(Sel_graph).angle1==4; % 270
%          text(27,87,'mMmm');
%       else;
%          text(155,78,'mMmm');
%       end;
      end;
   
      plot3(15.0,-5.0,0,'ok','MarkerSize',3,'MarkerFaceColor','r');       % left up
      plot3(-5.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % left down
      plot3(95.0,115.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);       % right down
      plot3(153.0,60.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);       % right up
   
      hold off;
      clear pol;
      clear m;
   end;

   clear hb_map;

   if   view_flg == 1;
      kl_map_h(Sel_graph).kl.lab2 = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig, ...
               'Units','points', ...
               'BackgroundColor',[0.8 0.8 0.8], ...
               'Position',[posi(3)/1.35-posi(3)/10/1.35 15 30 10], ...
               'String','mMmm', ...
               'Style','text');

%      movie = ['drawnow;sParaKL.sel_point=sParaKL.sel_point+10;[kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph);'];
   
      kl_map_h(Sel_graph).kl.min = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14],...
               'Style','edit',...
               'String',kl_map_h(Sel_graph).topo_min,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);',...
                           'val=str2num(get(gcbo,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                              'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val >= kl_map_h(Sel_graph).topo_max | val < -1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_map_h(Sel_graph).topo_min = val;',...
                                 'for i=1:4;',...
                                    'set(h(i),''Clim'',[kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);',...
                                 'end;',...
                                 'clear i;',...
                                 'delete (kl_map_h(Sel_graph).map_col);',...
                                 'kl_map_h(Sel_graph).map_col=colorbar;',...  
                                 'set(kl_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                 'set(kl_map_h(Sel_graph).map_col,''FontSize'',7);',...
                              'end;',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_min);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_min);',...
                           'end;',...
                           'clear val;clear h;'],...
              'Tag','EditText1');

      kl_map_h(Sel_graph).kl.lab1 = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String','mMmm',...% Ver 2.00 -><-
               'Tag','tag2');

      kl_map_h(Sel_graph).kl.max  = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14],...
               'String',kl_map_h(Sel_graph).topo_max,...
               'Style','edit',...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);',...
   			               'val=str2num(get(gcbo,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                           'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val <= kl_map_h(Sel_graph).topo_min | val > 1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_map_h(Sel_graph).topo_max = val;',...
                                 'for i=1:4;',...
                                    'set(h(i),''Clim'',[kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);',...
                                 'end;',...
                                 'clear i;',...
                                 'delete (kl_map_h(Sel_graph).map_col);',...
                                 'kl_map_h(Sel_graph).map_col=colorbar;',...  
                                 'set(kl_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                 'set(kl_map_h(Sel_graph).map_col,''FontSize'',7);',...
                              'end;',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_max);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_max);',...
                           'end;',...
                           'clear val;clear h;'],...
              'Tag','EditText2');

      kl_map_h(Sel_graph).kl.t_lab = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
	          'Position',[posi(3)/2-40 15 30 10],...
             'BackgroundColor',[0.8 0.8 0.8],...
             'Style','text',...
             'String','sec',...% Ver 2.00 -><-
	          'Tag','tag2');
      kl_map_h(Sel_graph).kl.time = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
	           'Position',[posi(3)/2 15 40 10],...
              'BackgroundColor',[0.8 0.8 0.8],...
              'Style','text',...             
              'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000,...% Ver 2.00 -><-
              'Tag','tag2');

      %************** refresh **************
      kl_map_h(Sel_graph).kl.ref = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig, ...
           'Units','points', ...
           'BackgroundColor',[1.0 0.9 0.1], ...
           'Position',[1 0 35 14], ...
           'String','Refresh',...
           'Callback',['posi=get(gcf,''Position'');',...
                       'Sel_graph=get(gca,''Parent'')-(63-1);'...
                       'set(kl_map_h(Sel_graph).kl.max,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.min,''Position'',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.lab1,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.lab2,''Position'',[posi(3)/1.35-posi(3)/10/1.35 15 30 10]);',...
                       'set(kl_map_h(Sel_graph).kl.t_lab,''Position'',[posi(3)/2-40 15 30 10]);',...
                       'set(kl_map_h(Sel_graph).kl.time,''Position'',[posi(3)/2 15 40 10]);',...
                       'clear posi;',...
                       ],...
                      'Tag','Pushbutton3');

      fig_no=findobj('Type','figure');
      for cnt=1:length(fig_no);
         %***** raw ****
         %***** AD ****
         if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** fft ****
         if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** PCA ****
         if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
         end;
         %***** weight ****
         if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl topo ****
         if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl ****
         if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            if fig_no(cnt) ~= Sel_graph+(63-1);
               obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
               set(obj,'Enable','off');
            end;
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** spect ****
         if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         % 3D map
         if (fig_no(cnt) == (80));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
            set(obj,'Enable','off');
         end;
      end;
   end;

   view_flg=0;
   set(kl_map_h(Sel_graph).kl.time,'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000);
   
   if move_stop ~= 1;
%      for cnt=1:5;
%         if (cnt==1 & para_p.sel_prb1 ~=1) | (cnt==2 & para_p.sel_prb2 ~=1) | (cnt==3 & para_p.sel_prb3 ~=1) |(cnt==4 & para_p.sel_prb4 ~=1) |(cnt==5 & para_p.sel_prb5 ~=1);
%         elseif (cnt==1 & para_p.load_prb1 ~=1 ) | (cnt==2 & para_p.load_prb2 ~=1) | (cnt==3 & para_p.load_prb3 ~=1) | (cnt==4 & para_p.load_prb4 ~=1) | (cnt==5 & para_p.load_prb5 ~=1);
%         else;
            if isfield(kl_map_h(Sel_graph).kl,'stop') == 1;
               move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
            end;
            if move_stop == 1;
               break;
            end;
%         end;
%      end;
      if move_stop ~= 1;
         drawnow;
      end;
   end;

   if move_stop == 1;
      break;
   else;
      sParaKL.sel_point =sParaKL.sel_point+2;
      if sParaKL.sel_point > kl_graph_h(Sel_graph).time_max;
         sParaKL.sel_point = round(kl_graph_h(Sel_graph).time_min);
      end;
   end;
   clear hb_map;clear m;
%fprintf('1@%f@\n',hb_map_h(Sel_graph).raw.stop);
end;

fig_no=findobj('Type','figure');
for cnt=1:length(fig_no);
   if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;   
   %***** PCA ****
   if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
   end;
   %***** weight ****
   if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   %***** kl topo ****
   if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) == (80));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
      set(obj,'Enable','on');
   end;
end;  

clear cnt;
move_stop = 1;
return;
