% kl_map33
%
% Input  : sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph
% Output : kl_map_h,sParaKL
% Example: [kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph); 

%*******************************************************
%*               Plot Hb Map33 Function                *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF02.11.11 Ver1.01  futahashi KL conversion function is added
% HistoryF03.05.06 Ver2.00  Isawa@A display is changed into point->sec.
% HistoryF03.11.12 Ver2.01 Kusabuka  multi probe

function [kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop); 

%fprintf('kl_map33\n');
%fprintf(sParaKL.sel_point=%d \n\n', sParaKL.sel_point);
% When a specification point is inaccurate, it escapes from a function@@@<- Ver2.00
if sParaKL.sel_point <= 0 | kl_graph_h(Sel_graph).time_max < sParaKL.sel_point;
   return;
end;

% It is made to move_stop, when a STOP flag is stood to the [Play] button and it is under processing.
%move_stop=1;
view_flg=1;
%************ Hb33 MAP ****************
[x,y]     = meshgrid(1:1:4);
[xi,yi]   = meshgrid(1:0.1:4);

%************ Topo View ************** 
kl_map_h(Sel_graph).topo_fig=figure(63+(Sel_graph-1));
set(gca,'drawmode','fast');
set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
clf;
plotedit(kl_map_h(Sel_graph).topo_fig,'hidetoolsmenu');
posi = get(kl_map_h(Sel_graph).topo_fig,'Position'); 
%posi.Position(1) = posi.Position(1)+((Sel_graph-1)*10);
set(kl_map_h(Sel_graph).topo_fig,'Name',sprintf('Reconstruct Topography Probe %d',Sel_graph),'Position',posi,'ToolBar','none');
set(kl_map_h(Sel_graph).topo_fig,'CloseRequestFcn','move_stop=1;closereq;');
%set(kl_map_h(Sel_graph).topo_fig,'DeleteFcn','move_play=1;');
uicontrol('Units','normalized',...
          'BackgroundColor',[0.8 0.8 0.8],...
          'Position',[0.35 0.95 0.3 0.05],...
          'FontSize',15,...
          'Style','text');

%************ Movie Start **************
kl_map_h(Sel_graph).kl.play = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 35 40 14],...
            'String','Play',...
            'Style','togglebutton',...
            'Visible','on',...
            'Callback',['if move_stop == 1;',...
                           'move_stop = 0;',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);'...
                           'if move_stop == 0;',...
                              'if sParaKL.sel_point > kl_map_h(Sel_graph).kl.max;',...
                                 'sParaKL.sel_point = hb_graph_h(Sel_graph).time_min;',...
                              'end;',... 
                              'if info(Sel_graph).probe_mode==1;',...
                                    '[kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==2;',...
                                    '[kl_map_h,sParaKL] = kl_map44(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==3;',...
                                    '[kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==4;',...
                                    '[kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==5;',...
                                    '[kl_map_h,sParaKL] = kl_map310(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'end;',...
                              'move_stop = 1;',...
                           'end;',...
                           'set(kl_map_h(Sel_graph).kl.play,''Value'',0);',...
                           'clear m_cnt;clear fig_no;',...
                        'else;',...
                            'set(kl_map_h(Sel_graph).kl.play,''Value'',0);',...
                            'warndlg(''Please push a stop button.'',''Warning !!'');',...
                        'end;',...
                        ],...
            'Tag','Pushbutton1');

%************ Movie Stop **************
kl_map_h(Sel_graph).kl.stop = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'Style','togglebutton',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 20 40 14],...
            'String','Stop',...
            'Callback',['Sel_graph=get(gca,''Parent'')-(63-1);'...
                        'if move_stop == 1;',...
                           'move_stop = 1;',...
                           'set(kl_map_h(Sel_graph).kl.stop,''Value'',0);',...
                        'else;',...
                           'move_stop = 1;',...
                        'end;',...
                        ],...
            'Tag','Pushbutton2');

move_stop ~= get(kl_map_h(Sel_graph).kl.stop,'Value');
while(1);
   fig_no = findobj('Type','figure');
   fig_flg=0;
   for cnt=1:length(fig_no);
      if (fig_no(cnt) == Sel_graph+(63-1));
         fig_flg=1;
         break;
      end;
   end;
   if fig_flg == 0;
      move_stop=1;
      break;
   end;
   if move_stop ~= 1;
      move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      if move_stop == 1;
         break;
      end;
   end;
   set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
   set(kl_map_h(Sel_graph).kl.play,'Value',0);
   posi=get(gcf,'Position');
   if move_stop ~= 1;
      move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
   end;

   hb_map(1,:)  = hb_data(Sel_graph).const(1,sParaKL.sel_point,:);
   hb_map(2,:)  = hb_data(Sel_graph).const(2,sParaKL.sel_point,:);
   % It chooses whether oxy-deoxy is used for Total_Hb data, using Total.
   if sParaKL.sel_total_hb == 0;
      hb_map(3,:)  = hb_data(Sel_graph).const(3,sParaKL.sel_point,:);
   else;
      hb_map(3,:)  = hb_data(Sel_graph).const(4,sParaKL.sel_point,:); 
   end;

   for i=1:3;
      %***************** left plate ********************
      %******* 45 degrees rotates to the circumference of a clock. ******* 
      ml(1,1) =(hb_map(i,3)+hb_map(i,8))/2;
      ml(1,2) = hb_map(i,3);
      ml(1,3) = hb_map(i,1);
      ml(1,4) =(hb_map(i,1)+hb_map(i,2))/2;
      ml(2,1) = hb_map(i,8);	
      ml(2,2) = hb_map(i,6);
      ml(2,3) = hb_map(i,4);
      ml(2,4) = hb_map(i,2);
      ml(3,1) = hb_map(i,11);
      ml(3,2) = hb_map(i,9);
      ml(3,3) = hb_map(i,7);
      ml(3,4) = hb_map(i,5);
      ml(4,1) =(hb_map(i,11)+hb_map(i,12))/2;
      ml(4,2) = hb_map(i,12);
      ml(4,3) = hb_map(i,10);
      ml(4,4) =(hb_map(i,5) +hb_map(i,10))/2;
   
      pol_l = interp2(x,y,ml,xi,yi,'spline');
   
      for a=1:size(pol_l,1);
         for b=1:size(pol_l,2);
            if a<11 & b<(-a+11);pol_l(a,b)=NaN;end;
            if a<11 & b>(a+21);pol_l(a,b)=NaN;end;
            if a>21 & b<(a-21);pol_l(a,b)=NaN;end;
            if a>21 & b>(-a+53);pol_l(a,b)=NaN;end;
         end;
      end;
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;   
   %******* It returns and draws  *******
      set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
%   axes(3,2,2*i-1);
      if view_flg == 1;
         axes_fig(1,i)=axes('Position',kl_graph_h(Sel_graph).map(i).ml);
      else;
         set(axes_fig(1,i),'Position',kl_graph_h(Sel_graph).map(i).ml);
      end;
      set(gcf,'CurrentAxes',axes_fig(1,i));
      axes_pcol(1,i) = pcolor(pol_l);
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;
   
      hold on;
      axis square;
      axis ij;
      axis off;
      shading interp;
      caxis([kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);
      if para_p.angle(Sel_graph).angle1==1; % 0
         view(-45,90);
         if i==1; text(23,-1,'Oxy A');end;
         if i==2; text(23,-1,'Deoxy A');end;
         if i==3; text(23,-1,'Total A');end;
      elseif para_p.angle(Sel_graph).angle1==2; % 90
         view(45,90);
         if i==1; text(0,8,'Oxy A');end;
         if i==2; text(-2,9,'Deoxy A');end;
         if i==3; text(-1,9,'Total A');end;
      elseif para_p.angle(Sel_graph).angle1==3; % 180
         view(135,90);
         if i==1; text(8,32,'Oxy A');end;
         if i==2; text(9,33,'Deoxy A');end;
         if i==3; text(9,33,'Total A');end;
      elseif para_p.angle(Sel_graph).angle1==4; % 270
         view(-135,90);
         if i==1; text(32,24,'Oxy A');end;
         if i==2; text(33,23,'Deoxy A');end;
         if i==3; text(33,23,'Total A');end;
      else;
         view(-45,90);
         if i==1; text(23,-1,'Oxy A');end;
         if i==2; text(23,-1,'Deoxy A');end;
         if i==3; text(23,-1,'Total A');end;
      end;
      zoom(1.5);
   
       plot3(15.0,-5.0,0,'ok','MarkerSize',3,'MarkerFaceColor','r');       % left up
       plot3(-5.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % left down
       plot3(15.0,35.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % right down
       plot3(35.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % right up
      hold off;
      %******* 45 degrees rotates to the circumference of a clock. ******* 
      mr(1,1) =(hb_map(i,15)+hb_map(i,20))/2;
      mr(1,2) = hb_map(i,15);
      mr(1,3) = hb_map(i,13);
      mr(1,4) =(hb_map(i,13)+hb_map(i,14))/2;
      mr(2,1) = hb_map(i,20);
      mr(2,2) = hb_map(i,18);
      mr(2,3) = hb_map(i,16);
      mr(2,4) = hb_map(i,14);
      mr(3,1) = hb_map(i,23);
      mr(3,2) = hb_map(i,21);
      mr(3,3) = hb_map(i,19);
      mr(3,4) = hb_map(i,17);
      mr(4,1) =(hb_map(i,23)+hb_map(i,24))/2;
      mr(4,2) = hb_map(i,24);
      mr(4,3) = hb_map(i,22);
      mr(4,4) =(hb_map(i,17) +hb_map(i,22))/2;
   
      pol_r = interp2(x,y,mr,xi,yi,'spline');
   
      for a=1:size(pol_r,1);
         for b=1:size(pol_r,2);
            if a<11 & b<(-a+11);pol_r(a,b)=NaN;end;
            if a<11 & b>(a+21);pol_r(a,b)=NaN;end;
            if a>21 & b<(a-21);pol_r(a,b)=NaN;end;
            if a>21 & b>(-a+53);pol_r(a,b)=NaN;end;
         end;
      end;
   
      %******* It returns and draws*******
      set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
%      if i~=3;axes(3,2,2*i-0.07);end;
%      if i==3;axes(3,2,2*i);end;
      if view_flg == 1;
         axes_fig(2,i)=axes('Position',kl_graph_h(Sel_graph).map(i).mr);
      else;
         set(axes_fig(2,i),'Position',kl_graph_h(Sel_graph).map(i).mr);
      end;
      set(kl_map_h(Sel_graph).topo_fig,'CurrentAxes',axes_fig(2,i));
      axes_pcol(2,i) = pcolor(pol_r);
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;
   
      hold on;
      axis square;
      axis ij;
      axis off;
      shading interp;
      caxis([kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);
      if para_p.angle(Sel_graph).angle2==1; % 0
         view(-45,90);
         if i==1; text(23,-1,'Oxy B');end;
         if i==2; text(23,-1,'Deoxy B');end;
         if i==3; text(23,-1,'Total B');end;
      elseif para_p.angle(Sel_graph).angle2==2; % 90
         view(45,90);
         if i==1; text(0,8,'Oxy B');end;
         if i==2; text(-2,9,'Deoxy B');end;
         if i==3; text(-1,9,'Total B');end;
      elseif para_p.angle(Sel_graph).angle2==3; % 180
         view(135,90);
         if i==1; text(8,32,'Oxy B');end;
         if i==2; text(9,33,'Deoxy B');end;
         if i==3; text(9,33,'Total B');end;
      elseif para_p.angle(Sel_graph).angle2==4; % 270
         view(-135,90);
         if i==1; text(32,24,'Oxy B');end;
         if i==2; text(33,23,'Deoxy B');end;
         if i==3; text(33,23,'Total B');end;
      else;
         view(-45,90);
         if i==1; text(23,-1,'Oxy B');end;
         if i==2; text(23,-1,'Deoxy B');end;
         if i==3; text(23,-1,'Total B');end;
      end;
      zoom(1.5);

      plot3(15.0,-5.0,0,'ok','MarkerSize',3,'MarkerFaceColor','r');       % left up
      plot3(-5.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % left down
      plot3(15.0,35.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % right down
      plot3(35.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % right up
      hold off;
      if i==3;
         kl_map_h(Sel_graph).map_col=colorbar;
         set(kl_map_h(Sel_graph).map_col,'Position',[0.89 0.1 0.03 0.4]); 
         set(kl_map_h(Sel_graph).map_col,'FontSize',7);
%       if para_p.angle(Sel_graph).angle2==1; % 0
%          text(63,8,'mMmm');
%       elseif para_p.angle(Sel_graph).angle2==2; % 90
%          text(8,-32,'mMmm');
%       elseif para_p.angle(Sel_graph).angle2==3; % 180
%          text(-32,25,'mMmm');         
%       elseif para_p.angle(Sel_graph).angle2==4; % 270
%          text(24,64,'mMmm');
%       else;
%          text(65,6,'mMmm');
%       end;

%      text(65,5,'mMmm');
      end;
      clear pol;
      clear m;
   end;

   clear hb_map;

   if   view_flg == 1;
      kl_map_h(Sel_graph).kl.lab2 = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig, ...
               'Units','points', ...
               'BackgroundColor',[0.8 0.8 0.8], ...
               'Position',[posi(3)/1.35-posi(3)/10/1.35 15 30 10], ...
               'String','mMmm', ...
               'Style','text');
            
%      movie = ['drawnow;sParaKL.sel_point=sParaKL.sel_point+10;[kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph);'];

      kl_map_h(Sel_graph).kl.min = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14],...
               'Style','edit',...
               'String',kl_map_h(Sel_graph).topo_min,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);',...
                           'val=str2num(get(gcbo,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                              'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val >= kl_map_h(Sel_graph).topo_max | val < -1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_map_h(Sel_graph).topo_min = val;',...
                                 'for i=1:7;',...
                                    'set(h(i),''Clim'',[kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);',...
                                 'end;',...
                                 'clear i;',...
                                 'delete (kl_map_h(Sel_graph).map_col);',...
                                 'kl_map_h(Sel_graph).map_col=colorbar;',...  
                                 'set(kl_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                 'set(kl_map_h(Sel_graph).map_col,''FontSize'',7);',...
                              'end;',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_min);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_min);',...
                           'end;',...
                           'clear val;clear h;'],...
              'Tag','EditText1');

      kl_map_h(Sel_graph).kl.lab1 = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String','mMmm',...% Ver 2.00 -><-
               'Tag','tag2');
            
      kl_map_h(Sel_graph).kl.max  = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14],...
               'String',kl_map_h(Sel_graph).topo_max,...
               'Style','edit',...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);',...
   			               'val=str2num(get(gcbo,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                           'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val <= kl_map_h(Sel_graph).topo_min | val > 1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_map_h(Sel_graph).topo_max = val;',...
                                 'for i=1:7;',...
                                    'set(h(i),''Clim'',[kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);',...
                                 'end;',...
                                 'clear i;',...
                                 'delete (kl_map_h(Sel_graph).map_col);',...
                                 'kl_map_h(Sel_graph).map_col=colorbar;',...  
                                 'set(kl_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                 'set(kl_map_h(Sel_graph).map_col,''FontSize'',7);',...
                              'end;',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_max);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_max);',...
                           'end;',...
                           'clear val;clear h;'],...
              'Tag','EditText2');

      kl_map_h(Sel_graph).kl.t_lab = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
	          'Position',[posi(3)/2-40 15 30 10],...
             'BackgroundColor',[0.8 0.8 0.8],...
             'Style','text',...
             'String','sec',...% Ver 2.00 -><-
	          'Tag','tag2');
      kl_map_h(Sel_graph).kl.time = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
	           'Position',[posi(3)/2 15 40 10],...
              'BackgroundColor',[0.8 0.8 0.8],...
              'Style','text',...             
              'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000,...% Ver 2.00 -><-
              'Tag','tag2');
            
      %************** refresh **************
      kl_map_h(Sel_graph).kl.ref = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig, ...
           'Units','points', ...
           'BackgroundColor',[1.0 0.9 0.1], ...
           'Position',[1 0 35 14], ...
           'String','Refresh',...
           'Callback',['posi=get(gcf,''Position'');',...
                       'Sel_graph=get(gca,''Parent'')-(63-1);'...
                       'set(kl_map_h(Sel_graph).kl.max,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.min,''Position'',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.lab1,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.lab2,''Position'',[posi(3)/1.35-posi(3)/10/1.35 15 30 10]);',...
                       'set(kl_map_h(Sel_graph).kl.t_lab,''Position'',[posi(3)/2-40 15 30 10]);',...
                       'set(kl_map_h(Sel_graph).kl.time,''Position'',[posi(3)/2 15 40 10]);',...
                       'clear posi;',...
                       ],...
                      'Tag','Pushbutton3');

      fig_no=findobj('Type','figure');
      for cnt=1:length(fig_no);
         %***** AD ****
         if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** fft ****
         if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** PCA ****
         if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
         end;
         %***** weight ****
         if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl topo ****
         if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl ****
         if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            if fig_no(cnt) ~= Sel_graph+(63-1);
               obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
               set(obj,'Enable','off');
            end;
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** spect ****
         if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         % 3D map
         if (fig_no(cnt) == (80));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
            set(obj,'Enable','off');
         end;
      end;
   end;

   set(kl_map_h(Sel_graph).kl.time,'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000);
   view_flg=0;

   if move_stop ~= 1;
%      for cnt=1:5;
%         if (cnt==1 & para_p.sel_prb1 ~=1) | (cnt==2 & para_p.sel_prb2 ~=1) | (cnt==3 & para_p.sel_prb3 ~=1) |(cnt==4 & para_p.sel_prb4 ~=1) |(cnt==5 & para_p.sel_prb5 ~=1);
%         elseif (cnt==1 & para_p.load_prb1 ~=1 ) | (cnt==2 & para_p.load_prb2 ~=1) | (cnt==3 & para_p.load_prb3 ~=1) | (cnt==4 & para_p.load_prb4 ~=1) | (cnt==5 & para_p.load_prb5 ~=1);
%         else;
            if isfield(kl_map_h(Sel_graph).kl,'stop') == 1;
               move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
            end;
            if move_stop == 1;
               break;
            end;
%         end;
%      end;
      if move_stop ~= 1;
         drawnow;
      end;
   end;

   if move_stop == 1;
      break;
   else;
      sParaKL.sel_point =sParaKL.sel_point+2;
      if sParaKL.sel_point > kl_graph_h(Sel_graph).time_max;
         sParaKL.sel_point = round(kl_graph_h(Sel_graph).time_min);
      end;
%      sParaKL.sel_point = round(kl_graph_h(Sel_graph).time_min);
   end;
   clear hb_map;clear m;
%fprintf('1@%f@\n',hb_map_h(Sel_graph).raw.stop);
end;

fig_no=findobj('Type','figure');
for cnt=1:length(fig_no);
   if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;   
   %***** PCA ****
   if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
   end;
   %***** weight ****
   if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   %***** kl topo ****
   if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) == (80));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
      set(obj,'Enable','on');
   end;
end;  
   
clear cnt;
move_stop = 1;
return;
