% kl_map35
%
% Input  : sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph
% Output : kl_map_h,sParaKL
% Example: [kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph); 

%*******************************************************
%*               Plot Hb Map44 Function                *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF02.11.11 Ver1.01  futahashi KL conversion function is added.
% HistoryF03.05.06 Ver2.00  Isawa@A  display is changed into point->sec.
% HistoryF03.11.06 Ver2.01  Kusabuka@multi probe 

function [kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop); 

%fprintf('kl_map35\n');
%fprintf(sParaKL.sel_point=%d \n\n', sParaKL.sel_point);
% When a specification point is inaccurate, it escapes from a function.@@@<- Ver2.00
if sParaKL.sel_point <= 0 | kl_graph_h(Sel_graph).time_max < sParaKL.sel_point;
   return;
end;

% It is made to move_stop, when a STOP flag is stood to the [Play] button and it is under processing.
%move_stop=1;
view_flg=1;
%************ Hb35 MAP ****************
[x,y]     = meshgrid(1:1:6);
[xi,yi]   = meshgrid(1:0.1:6);

% hb_map(1,:)  = hb_data(Sel_graph).const(1,sParaKL.sel_point,:);
% hb_map(2,:)  = hb_data(Sel_graph).const(2,sParaKL.sel_point,:);
% % It chooses whether oxy-deoxy is used for Total_Hb data, using Total.
% if sParaKL.sel_total_hb == 0;
%    hb_map(3,:)  = hb_data(Sel_graph).const(3,sParaKL.sel_point,:);
% else
%    hb_map(3,:)  = hb_data(Sel_graph).const(4,sParaKL.sel_point,:); 
% end;

%************ Topo View ************** 
kl_map_h(Sel_graph).topo_fig=figure(63+(Sel_graph-1));
set(gca,'drawmode','fast');
set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
clf;
plotedit(kl_map_h(Sel_graph).topo_fig,'hidetoolsmenu');
posi = get(kl_map_h(Sel_graph).topo_fig,'Position'); 
%posi.Position(1) = posi.Position(1)+((Sel_graph-1)*10);
set(kl_map_h(Sel_graph).topo_fig,'Name',sprintf('Reconstruct Topography Probe %d',Sel_graph),'Position',posi,'ToolBar','none');
set(kl_map_h(Sel_graph).topo_fig,'CloseRequestFcn','move_stop=1;closereq;');
%set(kl_map_h(Sel_graph).topo_fig,'DeleteFcn','move_play=1;');

uicontrol('Units','normalized',...
          'BackgroundColor',[0.8 0.8 0.8],...
          'Position',[0.35 0.95 0.3 0.05],...
          'FontSize',15,...
          'Style','text');

%************ Movie Start **************
kl_map_h(Sel_graph).kl.play = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 35 40 14],...
            'String','Play',...
            'Style','togglebutton',...
            'Visible','on',...
            'Callback',['if move_stop == 1;',...
                           'move_stop = 0;',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);'...
                           'if move_stop == 0;',...
                              'if sParaKL.sel_point > kl_map_h(Sel_graph).kl.max;',...
                                 'sParaKL.sel_point = hb_graph_h(Sel_graph).time_min;',...
                              'end;',... 
                              'if info(Sel_graph).probe_mode==1;',...
                                    '[kl_map_h,sParaKL] = kl_map33(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==2;',...
                                    '[kl_map_h,sParaKL] = kl_map44(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==3;',...
                                    '[kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==4;',...
                                    '[kl_map_h,sParaKL] = kl_map311(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'elseif info(Sel_graph).probe_mode==5;',...
                                    '[kl_map_h,sParaKL] = kl_map310(sParaKL,info,hb_data,kl_graph_h,kl_map_h,para_p,Sel_graph,move_stop);',...
                              'end;',...
                              'move_stop = 1;',...
                           'end;',...
                           'set(kl_map_h(Sel_graph).kl.play,''Value'',0);',...
                           'clear m_cnt;clear fig_no;',...
                        'else;',...
                            'set(kl_map_h(Sel_graph).kl.play,''Value'',0);',...
                            'warndlg(''Please push a stop button.'',''Warning !!'');',...
                        'end;',...
                        ],...
            'Tag','Pushbutton1');

%************ Movie Stop **************
kl_map_h(Sel_graph).kl.stop = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
            'Units','points',...
            'Style','togglebutton',...
            'BackgroundColor',[0.75 0.75 0.75], ...
            'Position',[1 20 40 14],...
            'String','Stop',...
            'Callback',['Sel_graph=get(gca,''Parent'')-(63-1);'...
                        'if move_stop == 1;',...
                           'move_stop = 1;',...
                           'set(kl_map_h(Sel_graph).kl.stop,''Value'',0);',...
                        'else;',...
                           'move_stop = 1;',...
                        'end;',...
                        ],...
            'Tag','Pushbutton2');

move_stop ~= get(kl_map_h(Sel_graph).kl.stop,'Value');
while(1);
   fig_no = findobj('Type','figure');
   fig_flg=0;
   for cnt=1:length(fig_no);
      if (fig_no(cnt) == Sel_graph+(63-1));
         fig_flg=1;
         break;
      end;
   end;
   if fig_flg == 0;
      move_stop=1;
      break;
   end;
   if move_stop ~= 1;
      move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      if move_stop == 1;
         break;
      end;
   end;
   set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
   set(kl_map_h(Sel_graph).kl.play,'Value',0);
   posi=get(kl_map_h(Sel_graph).topo_fig,'Position');
   if move_stop ~= 1;
      move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
   end;
   
   hb_map(1,:)  = hb_data(Sel_graph).const(1,sParaKL.sel_point,:);
   hb_map(2,:)  = hb_data(Sel_graph).const(2,sParaKL.sel_point,:);
   % It chooses whether oxy-deoxy is used for Total_Hb data, using Total.
   if sParaKL.sel_total_hb == 0;
      hb_map(3,:)  = hb_data(Sel_graph).const(3,sParaKL.sel_point,:);
   else;
      hb_map(3,:)  = hb_data(Sel_graph).const(4,sParaKL.sel_point,:); 
   end;
   
   for i=1:3;
      %******* 45 degrees rotates to the circumference of a clock. ******* 
      m(1,1) =(hb_map(i,5)+hb_map(i,14))/2;
      m(1,2) = hb_map(i,5);

      m(1,3) = hb_map(i,1);
      m(1,4) =(hb_map(i,1)+hb_map(i,2))/2;
      m(1,5) =(hb_map(i,1)+hb_map(i,2)*2+hb_map(i,3))/4;
      m(1,6) =(hb_map(i,1)+hb_map(i,2)*3+hb_map(i,3)*3+hb_map(i,4))/8;
   
      m(2,1) = hb_map(i,14);	
      m(2,2) = hb_map(i,10);
      m(2,3) = hb_map(i,6);
      m(2,4) = hb_map(i,2);
      m(2,5) =(hb_map(i,2)+hb_map(i,3))/2;
      m(2,6) =(hb_map(i,2)+hb_map(i,3)*2+hb_map(i,4))/4;
   
      m(3,1) = hb_map(i,19);
      m(3,2) = hb_map(i,15);
      m(3,3) = hb_map(i,11);
      m(3,4) = hb_map(i,7);
      m(3,5) = hb_map(i,3);
      m(3,6) =(hb_map(i,3)+hb_map(i,4))/2;
   
      m(4,1) =(hb_map(i,19)+hb_map(i,20))/2;
      m(4,2) = hb_map(i,20);
      m(4,3) = hb_map(i,16);
      m(4,4) = hb_map(i,12);
      m(4,5) = hb_map(i,8);
      m(4,6) = hb_map(i,4);
   
      m(5,1) =(hb_map(i,19)+hb_map(i,20)*2+hb_map(i,21))/4;
      m(5,2) =(hb_map(i,20)+hb_map(i,21))/2;
      m(5,3) = hb_map(i,21);
      m(5,4) = hb_map(i,17);
      m(5,5) = hb_map(i,13);
      m(5,6) = hb_map(i,9);
   
      m(6,1) =(hb_map(i,19)+hb_map(i,20)*3+hb_map(i,21)*3+hb_map(i,22))/8;
      m(6,2) =(hb_map(i,20)+hb_map(i,21)*2+hb_map(i,22))/4;
      m(6,3) =(hb_map(i,21)+hb_map(i,22))/2;
      m(6,4) = hb_map(i,22);
      m(6,5) = hb_map(i,18);
      m(6,6) =(hb_map(i,9)+hb_map(i,18))/2;
   
      pol = interp2(x,y,m,xi,yi,'spline');
      %pol = griddata(x,y,m,xi,yi,'nearest');
   
      %'linear'    Between alignment assistant [ of a triangle base ] (default) 
      %'cubic'    Between cubic assistant [ of a triangle base ]  
      %'nearest'  according to a dot recently
      %'invdist'  Reverse distance method 
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;   
      for a=1:size(pol,1);
         for b=1:size(pol,2);
            if a<11 & b<(-a+11);pol(a,b)=NaN;end;
            if a<31 & b>(a+21);pol(a,b)=NaN;end;
            if a>21 & b<(a-21);pol(a,b)=NaN;end;
            if a>41 & b>(-a+93);pol(a,b)=NaN;end;
         end;
      end;
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;   
      %*******It returns and draws.   *******
      set(0,'CurrentFigure',kl_map_h(Sel_graph).topo_fig);
%      if i~=3;axes(3,2,2*i-0.52);end;
%      if i==3;axes(3,2,2*i-0.45);end;
      if view_flg == 1;
         axes_fig(i)=axes('Position',kl_graph_h(Sel_graph).map(i).m);
      else;
         set(axes_fig(i),'Position',kl_graph_h(Sel_graph).map(i).m);
      end;

      set(kl_map_h(Sel_graph).topo_fig,'CurrentAxes',axes_fig(i));
      axes_pcol(i) = pcolor(pol);
      if move_stop ~= 1;
         move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
      end;

      hold on;
      axis square;
      axis ij;
      axis off;
      shading interp;
      caxis([kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);
      if para_p.angle(Sel_graph).angle1==1; % 0
         view(-45,90);
         if i==1; text(-6,-6,'Oxy');end;
         if i==2; text(-6,-6,'Deoxy');end;
         if i==3; text(-6,-6,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==2; % 90
         view(45,90);
         if i==1; text(2,50,'Oxy');end;
         if i==2; text(2,50,'Deoxy');end;
         if i==3; text(2,50,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==3; % 180
         view(135,90);
         if i==1; text(58,58,'Oxy');end;
         if i==2; text(58,58,'Deoxy');end;
         if i==3; text(58,58,'Total');end;
      elseif para_p.angle(Sel_graph).angle1==4; % 270
         view(-135,90);
         if i==1; text(50,2,'Oxy');end;
         if i==2; text(50,2,'Deoxy');end;
         if i==3; text(50,2,'Total');end;
      else;
         view(-45,90);
         if i==1; text(-6,-6,'Oxy');end;
         if i==2; text(-6,-6,'Deoxy');end;
         if i==3; text(-6,-6,'Total');end;
      end;
      zoom(1.5);
      plot3(15.0,-5.0,0,'ok','MarkerSize',3,'MarkerFaceColor','r');       % left up
      plot3(-5.0,15.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % left down
      plot3(35.0,55.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % right down
      plot3(55.0,35.0,0,'o','MarkerSize',1,'Color',[0.8 0.8 0.8]);        % right up
      if i==3;
         kl_map_h(Sel_graph).map_col=colorbar;
         set(kl_map_h(Sel_graph).map_col,'Position',[0.89 0.1 0.03 0.4]); 
         set(kl_map_h(Sel_graph).map_col,'FontSize',7);
%          if para_p.angle(Sel_graph).angle1==1; % 0
%             text(145,52,'mMmm');
%          elseif para_p.angle(Sel_graph).angle1==2; % 90
%             text(60,-15,'mMmm');
%          elseif para_p.angle(Sel_graph).angle1==3; % 180
%             text(-95,0,'mMmm');         
%          elseif para_p.angle(Sel_graph).angle1==4; % 270
%             text(-10,65,'mMmm');
%          else;
%             text(145,52,'mMmm');
%          end;
      end;

      hold off;
      clear pol;
      clear m;
   end;

   clear hb_map;
   
   if   view_flg == 1;
      kl_map_h(Sel_graph).kl.lab2 = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig, ...
               'Units','points', ...
               'BackgroundColor',[0.8 0.8 0.8], ...
               'Position',[posi(3)/1.35-posi(3)/10/1.35 15 30 10], ...
               'String','mMmm', ...
               'Style','text');
            
%      movie = ['drawnow;sParaKL.sel_point=sParaKL.sel_point+10;[kl_map_h,sParaKL] = kl_map35(sParaKL,info,hb_data,kl_graph_h,kl_map_h,Sel_graph);'];

      kl_map_h(Sel_graph).kl.min = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14],...
               'Style','edit',...
               'String',kl_map_h(Sel_graph).topo_min,...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);',...
                           'val=str2num(get(gcbo,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                              'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val >= kl_map_h(Sel_graph).topo_max | val < -1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_map_h(Sel_graph).topo_min = val;',...
                                 'for i=1:4;',...
                                    'set(h(i),''Clim'',[kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);',...
                                 'end;',...
                                 'clear i;',...
                                 'delete (kl_map_h(Sel_graph).map_col);',...
                                 'kl_map_h(Sel_graph).map_col=colorbar;',...  
                                 'set(kl_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                 'set(kl_map_h(Sel_graph).map_col,''FontSize'',7);',...
                              'end;',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_min);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_min);',...
                           'end;',...
                           'clear val;clear h;'],...
              'Tag','EditText1');

      kl_map_h(Sel_graph).kl.lab1 = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14],...
               'BackgroundColor',[0.8 0.8 0.8],...
               'Style','text',...
               'String','mMmm',...% Ver 2.00 -><-
               'Tag','tag2');

      kl_map_h(Sel_graph).kl.max  = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14],...
               'String',kl_map_h(Sel_graph).topo_max,...
               'Style','edit',...
               'Callback',['h=findobj(gcf,''type'',''axes'');',...
                           'Sel_graph=get(gca,''Parent'')-(63-1);',...
   			               'val=str2num(get(gcbo,''string''));',...
                           'if length(val) ~= 0;',...
                              'ret=strchknum(get(gcbo,''string''));',...
                           'val = round(val*100)/100;',...
                              'if ret > 0;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'elseif val <= kl_map_h(Sel_graph).topo_min | val > 1000;',...
                                 'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'else;',...
                                 'kl_map_h(Sel_graph).topo_max = val;',...
                                 'for i=1:4;',...
                                    'set(h(i),''Clim'',[kl_map_h(Sel_graph).topo_min kl_map_h(Sel_graph).topo_max]);',...
                                 'end;',...
                                 'clear i;',...
                                 'delete (kl_map_h(Sel_graph).map_col);',...
                                 'kl_map_h(Sel_graph).map_col=colorbar;',...  
                                 'set(kl_map_h(Sel_graph).map_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                                 'set(kl_map_h(Sel_graph).map_col,''FontSize'',7);',...
                              'end;',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_max);',...
                              'clear ret;',...
                           'else;',...
                              'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                              'set(gcbo,''string'', kl_map_h(Sel_graph).topo_max);',...
                           'end;',...
                           'clear val;clear h;'],...
              'Tag','EditText2');

      kl_map_h(Sel_graph).kl.t_lab = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
	          'Position',[posi(3)/2-40 15 30 10],...
             'BackgroundColor',[0.8 0.8 0.8],...
             'Style','text',...
             'String','sec',...% Ver 2.00 -><-
	          'Tag','tag2');
      kl_map_h(Sel_graph).kl.time = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig,...
	           'Position',[posi(3)/2 15 40 10],...
              'BackgroundColor',[0.8 0.8 0.8],...
              'Style','text',...             
              'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000,...% Ver 2.00 -><-
              'Tag','tag2');

      %************** refresh **************
      kl_map_h(Sel_graph).kl.ref = uicontrol('Parent',kl_map_h(Sel_graph).topo_fig, ...
           'Units','points', ...
           'BackgroundColor',[1.0 0.9 0.1], ...
           'Position',[1 0 35 14], ...
           'String','Refresh',...
           'Callback',['posi=get(gcf,''Position'');',...
                       'Sel_graph=get(gca,''Parent'')-(63-1);'...
                       'set(kl_map_h(Sel_graph).kl.max,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.min,''Position'',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.lab1,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14]);',...
                       'set(kl_map_h(Sel_graph).kl.lab2,''Position'',[posi(3)/1.35-posi(3)/10/1.35 15 30 10]);',...
                       'set(kl_map_h(Sel_graph).kl.t_lab,''Position'',[posi(3)/2-40 15 30 10]);',...
                       'set(kl_map_h(Sel_graph).kl.time,''Position'',[posi(3)/2 15 40 10]);',...
                       'clear posi;',...
                       ],...
                      'Tag','Pushbutton3');


      fig_no=findobj('Type','figure');
      for cnt=1:length(fig_no);
         %***** AD ****
         if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** raw ****
         if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** fft ****
         if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** PCA ****
         if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
         end;
         %***** weight ****
         if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl topo ****
         if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
         end;
         %***** kl ****
         if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            if fig_no(cnt) ~= Sel_graph+(63-1);
               obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
               set(obj,'Enable','off');
            end;
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         %***** spect ****
         if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
         end;
         % 3D map
         if (fig_no(cnt) == (80));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
            set(obj,'Enable','off');
         end;
      end;
   end;

   view_flg=0;
   set(kl_map_h(Sel_graph).kl.time,'String',sParaKL.sel_point*info(Sel_graph).smpl_period/1000);
      
   if move_stop ~= 1;
%      for cnt=1:5;
%         if (cnt==1 & para_p.sel_prb1 ~=1) | (cnt==2 & para_p.sel_prb2 ~=1) | (cnt==3 & para_p.sel_prb3 ~=1) |(cnt==4 & para_p.sel_prb4 ~=1) |(cnt==5 & para_p.sel_prb5 ~=1);
%         elseif (cnt==1 & para_p.load_prb1 ~=1 ) | (cnt==2 & para_p.load_prb2 ~=1) | (cnt==3 & para_p.load_prb3 ~=1) | (cnt==4 & para_p.load_prb4 ~=1) | (cnt==5 & para_p.load_prb5 ~=1);
%         else;
            if isfield(kl_map_h(Sel_graph).kl,'stop') == 1;
               move_stop = get(kl_map_h(Sel_graph).kl.stop,'Value');
            end;
            if move_stop == 1;
               break;
            end;
%         end;
%      end;
      if move_stop ~= 1;
         drawnow;
      end;
   end;
   
   if move_stop == 1;
      break;
   else;
      sParaKL.sel_point =sParaKL.sel_point+2;
      if sParaKL.sel_point > kl_graph_h(Sel_graph).time_max;
         sParaKL.sel_point = round(kl_graph_h(Sel_graph).time_min);
      end;
   end;
   
   clear hb_map;clear m;
%fprintf('1@%f@\n',hb_map_h(Sel_graph).raw.stop);
end;

fig_no=findobj('Type','figure');
for cnt=1:length(fig_no);
   if (fig_no(cnt) >= (2)) & (fig_no(cnt) <= (6));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (7)) & (fig_no(cnt) <= (11));
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min,time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max,time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (17)) & (fig_no(cnt) <= (21));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % fout
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refuresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;   
   %***** PCA ****
   if (fig_no(cnt) >= (28)) & (fig_no(cnt) <= (32));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
   end;
   %***** weight ****
   if (fig_no(cnt) >= (33)) & (fig_no(cnt) <= (37));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   %***** kl topo ****
   if (fig_no(cnt) >= (58)) & (fig_no(cnt) <= (62));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % int
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText3');  % time min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText4');  % time max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      set(obj,'Value',0);
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) >= (75)) & (fig_no(cnt) <= (79));
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % check
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
   end;
   if (fig_no(cnt) == (80));
      obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText1');  % min
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','EditText2');  % max
      set(obj,'Enable','on');
      obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
      set(obj,'Enable','on');
   end;
end;   

clear cnt;
move_stop = 1;
return;
 