% graph_posi 
%
% Input  : info,hb_graph_h,set_posi
% Output : hb_graph_h
% Example: [hb_graph_h] = kl_posi(info,hb_graph_h,set_posi); 

%*******************************************************
%*               Plot Hb Map Function                  *
%*                   Hiroaki Kusabuka                  *
%*                  HITACHI MECICAL                    *
%*******************************************************
% HistoryF03.11.17 Ver2.01  Kusabuka multi probe

function [map] = kl_posi(info,para_p,set_posi);

% Version get
% work=findstr(info(1).sys_ver(1).Version,'.');
% if length(work) == 0;
%    sys_ver=str2num(info(1).sys_ver(1).Version);
% else;
%    sys_ver=str2num(info(1).sys_ver(1).Version(1:work(1)-1));
% end;
%****** 33hb ******
%fprintf('graph_posi set_posi=%d\n',set_posi);
if info(set_posi).probe_mode==1;
   map(1).wl  = [0.1300    0.8178    0.3270    0.1072];
   map(2).wl  = [0.1300    0.6663    0.3270    0.1072];
   map(3).wl  = [0.1300    0.5147    0.3270    0.1072];
   map(4).wl  = [0.1300    0.3631    0.3270    0.1072];
   map(5).wl  = [0.1300    0.2116    0.3270    0.1072];
   map(6).wl  = [0.1300    0.0600    0.3270    0.1072];
         
   map(1).wr  = [0.5466    0.8178    0.3270    0.1072];
   map(2).wr  = [0.5466    0.6663    0.3270    0.1072];
   map(3).wr  = [0.5466    0.5147    0.3270    0.1072];
   map(4).wr  = [0.5466    0.3631    0.3270    0.1072];
   map(5).wr  = [0.5466    0.2116    0.3270    0.1072];
   if info(set_posi).sys_ver >= 7;
      map(6).wr  = [0.5466    0.0600    0.3270    0.1072];
   else;
      map(6).wr  = [0.5780    0.0600    0.3270    0.1072];
   end;
end;
   %****** 44hb ******
if info(set_posi).probe_mode==2;
   map(1).w  = [0.3450    0.8178    0.3270    0.1072];
   map(2).w  = [0.3450    0.6763    0.3270    0.1072];
   map(3).w  = [0.3450    0.5347    0.3270    0.1072];
   map(4).w  = [0.3450    0.3931    0.3270    0.1072];
   map(5).w  = [0.3450    0.2516    0.3270    0.1072];
   if info(set_posi).sys_ver >= 7;
      map(6).w  = [0.3450    0.1100    0.3270    0.1072];
   else;
      map(6).w  = [0.3764    0.1100    0.3270    0.1072];
   end;
end;
%****** 35hb ******
if info(set_posi).probe_mode==3;
   if para_p.angle(set_posi).angle1==1 | para_p.angle(set_posi).angle1==3; % 0,180
      map(1).w  = [0.3450    0.8178    0.3270    0.1072];
      map(2).w  = [0.3450    0.6763    0.3270    0.1072];
      map(3).w  = [0.3450    0.5347    0.3270    0.1072];
      map(4).w  = [0.3450    0.3931    0.3270    0.1072];
      map(5).w  = [0.3450    0.2516    0.3270    0.1072];
      if info(set_posi).sys_ver >= 7;
         map(6).w  = [0.3450    0.1100    0.3270    0.1072];
      else;
         map(6).w  = [0.3764    0.1100    0.3270    0.1072];
      end;
   else;                                       % 90 270
      map(1).w  = [0.05    0.4056    0.1072    0.2238];
      map(2).w  = [0.19    0.4056    0.1072    0.2238];
      map(3).w  = [0.33    0.4056    0.1072    0.2238];
      map(4).w  = [0.47   0.4056    0.1072    0.2238];
      map(5).w  = [0.61    0.4056    0.1072    0.2238];
      if info(set_posi).sys_ver >= 7;
         map(6).w  = [0.75    0.4056    0.1072    0.2238];
      else;
         map(6).w  = [0.75    0.4056    0.1372    0.2238];
      end;
   end;
end;
      
   %****** 311hb ******
if info(set_posi).probe_mode==4;
   if para_p.angle(set_posi).angle1==1 | para_p.angle(set_posi).angle1==3; % 0,180
      map(1).w  = [0.3450    0.8178    0.3270    0.1072];
      map(2).w  = [0.3450    0.6763    0.3270    0.1072];
      map(3).w  = [0.3450    0.5347    0.3270    0.1072];
      map(4).w  = [0.3450    0.3931    0.3270    0.1072];
      map(5).w  = [0.3450    0.2516    0.3270    0.1072];
      if info(set_posi).sys_ver >= 7;
         map(6).w  = [0.3450    0.1100    0.3270    0.1072];
      else;
         map(6).w  = [0.3764    0.1100    0.3270    0.1072];
      end;
   else;                                       % 90 270
      map(1).w  = [0.05    0.4056    0.12    0.2238];
      map(2).w  = [0.18    0.4056    0.12    0.2238];
      map(3).w  = [0.31    0.4056    0.12    0.2238];
      map(4).w  = [0.44    0.4056    0.12    0.2238];
      map(5).w  = [0.57    0.4056    0.12    0.2238];
      if info(set_posi).sys_ver >= 7;
         map(6).w  = [0.7    0.4056    0.12    0.2238];
      else;
         map(6).w  = [0.7    0.4056    0.15    0.2238];
      end;
   end;
end;
   %****** 310hb ******
if info(set_posi).probe_mode==5;
   if para_p.angle(set_posi).angle1==1 | para_p.angle(set_posi).angle1==3; % 0,180
      map(1).w  = [0.3450    0.8178    0.3270    0.1072];
      map(2).w  = [0.3450    0.6763    0.3270    0.1072];
      map(3).w  = [0.3450    0.5347    0.3270    0.1072];
      map(4).w  = [0.3450    0.3931    0.3270    0.1072];
      map(5).w  = [0.3450    0.2516    0.3270    0.1072];
      if info(set_posi).sys_ver >= 7;
         map(6).w  = [0.3450    0.1100    0.3270    0.1072];
      else;
         map(6).w  = [0.3764    0.1100    0.3270    0.1072];
      end;
   else;                                       % 90 270
      map(1).w  = [0.05    0.4056    0.12    0.2238];
      map(2).w  = [0.18    0.4056    0.12    0.2238];
      map(3).w  = [0.31    0.4056    0.12    0.2238];
      map(4).w  = [0.44    0.4056    0.12    0.2238];
      map(5).w  = [0.57    0.4056    0.12    0.2238];
      if info(set_posi).sys_ver >= 7;
         map(6).w  = [0.7    0.4056    0.12    0.2238];
      else;
         map(6).w  = [0.7    0.4056    0.15    0.2238];
      end;
   end;
end;

clear work;
      
      