% load_ad
%
% Input  : fname,MainFigure,para,para_p,para_h,dis_no
% Output : info,ad_data,mark,para_p
% Example: [info,ad_data,mark,para_p] = load_ad(fname,MainFigure,para,para_p,para_h,dis_no)

%*******************************************************
%*             Topo AD Data Load Function              *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% history:03.03.03 Ver 1.02 futahasi    File ver 4.03 Correspondence
% history:03.03.05 Ver 1.02 Kawasaki    File ver 4.03 read Reper
% history:03.05.26 Ver 1.03 Kawasaki	   3*5 Mode add
% history:03.04.23 Ver 2.00 Isawa(HTS)  ETG7000 Correspondence
% history:03.08.18 Ver 2.01 Kawasaki    BaseLine read remake(let me Vanderbilt)
% history:03.11.07 Ver 2.01 Kusabuka    many probe
% history:04.01.12 Ver 2.00 Kawasaki    Ver4.04 read errifrom Vanderbiltj
% history:04.02.04 Ver 2.02 Kawasaki    ana load select
% history:04.06.16 Ver 2.03 Kudabuka    Fixed Data load

function [info,ad_data,mark,para,para_p] = load_ad(fname,MainFigure,para,para_p,para_h,dis_no);

%######################################
%   ETG-100 or@ETG-7000
%fprintf('load_ad fname=%s\n',fname);

p_cnt = 1;                          % ETG-100
para_p.load_prb1 =0;
para_p.load_prb2 =0;
para_p.load_prb3 =0;
para_p.load_prb4 =0;
para_p.load_prb5 =0;

%********** Probe Select No.*************
if para_p.sel_prb1 == 1;
   dis_no = 1;
elseif para_p.sel_prb2 == 1;
   dis_no = 2;
elseif para_p.sel_prb3 == 1;
   dis_no = 3;
elseif para_p.sel_prb4 == 1;
   dis_no = 4;
elseif para_p.sel_prb5 == 1;
   dis_no = 5;
else;
   dis_no = 1;
end;
para_p.angle= struct('angle1',{1,1,1,1,1},'angle2',{1,1,1,1,1});

% fopen
fp = fopen(fname,'r');
if fp == -1;  % Open err
   fprintf('*** return fp=%d,fname =%s\n',fp,fname);
   warndlg(['File open err.Please check disk.'],'Warning !!');
   info(p_cnt).file_name = '';info(p_cnt).version = '';info(p_cnt).id = '';
   info(p_cnt).name = '';info(p_cnt).comment = '';info(p_cnt).age = '';info(p_cnt).sex = '';
   info(p_cnt).probe_mode = 0;info(p_cnt).measure_mode = 0;
   info(p_cnt).date = '';info(p_cnt).adnmpn = '';info(p_cnt).wlen = '';info(p_cnt).adrng = '';
   info(p_cnt).amprng = '';info(p_cnt).ampset = '';info(p_cnt).smpl_period = 0;
   info(p_cnt).datanum = 0;
   mark.num = 0;mark.point = 0;
   mark.ave = 0;mark.char = '';
   ad_data(p_cnt).raw = '';
   return;
end;

% MATLAB system version
%info(1).sys_ver=ver;
work = version;
info(1).sys_ver = str2num(strtok(work,'.'));
clear work;

% When there is a [Header]. ETG-7000 or ETG4000  
dum = fgets(fp);
fclose(fp);

if strncmp(dum, 'Header', 6)==1;
   %******* maluch Probe ******
   info(p_cnt).flg=2;
   [info, ad_data, mark,para,para_p] = load_ad_etg7000(fname,MainFigure,para,para_p,para_h,dis_no);
elseif strncmp(dum(13:length(dum)), 'Ver', 3)==0;
   % file format error
   info(p_cnt).flg=0;
   para_p.max_prb=1;				% reset defult 5
   info(p_cnt).file_name = '';info(p_cnt).version = '';info(p_cnt).id = '';
   info(p_cnt).name = '';info(p_cnt).comment = '';info(p_cnt).age = '';info(p_cnt).sex = '';
   info(p_cnt).probe_mode = 0;info(p_cnt).measure_mode = 0;
   info(p_cnt).date = '';info(p_cnt).adnmpn = '';info(p_cnt).wlen = '';info(p_cnt).adrng = '';
   info(p_cnt).amprng = '';info(p_cnt).ampset = '';info(p_cnt).smpl_period = 0;
   info(p_cnt).datanum = 0;
   mark.num = 0;mark.point = 0;
   mark.ave = 0;mark.char = '';
   ad_data(p_cnt).raw = '';

   warndlg('Warning file format!  Please choose the right format file','Warning');
   return;
else;
   %######################################
   % It deletes for the above-mentioned processing addition.@remake
   %info.file_name = dum;
   info(p_cnt).file_name=fname;
   info(p_cnt).flg=1;
   info(p_cnt).sel_ch=1;
   info(p_cnt).mark_ana=0;

   len = length(fname);				   % File Name 
%   ana_name = sprintf('%s',fname);
%   for cnt1=1:len;                          % end to top
%      w_len = len-(cnt1-1);
%      if (strncmp(ana_name(w_len),'.',1) == 1) 
%          ana_name=sprintf('%sana',fname(1:w_len));
%         break;
%      end;
%   end;
% analyze data load
%   fp2=fopen(ana_name,'r');
%   if (fp2 ~= -1);
%      button = questdlg('Analyze file is exist. Use analyze file mark information?','Select','Yes');
%      if strcmp(button,'Yes');
%         info(p_cnt).mark_ana=1;
%         info(p_cnt).ana_file=ana_name;
%      end;   
%      fclose(fp2);
%   end;
   
   % file open
   fp = fopen(info(p_cnt).file_name,'r');
   %************ Header Load **************
   ad_data(p_cnt).title1='780'; % AD graph Wave Title1 
   ad_data(p_cnt).title2='830'; % AD graph Wave Title2

%***********************************************************
   for line_cnt=1:180;                 % header max 180 line
      dum = fgets(fp);
      len = length(dum)-2;
      %soft_version:\tgo[W
      if len-3 > 0  & strcmp(dum(len-3+1:len),'Ver');
        info(p_cnt).version = str2num(dum(6:9));
      end;
      %id
      if len-2 > 0 & strcmp(dum(len-2+1:len),'ID');
          work = sscanf(dum,'%c');
          info(p_cnt).id = sprintf('%s\n',work(1:len-4) );
      end;
      %name               
      if len-4 > 0 & strcmp(dum(len-4+1:len),'Name');
         if (len-12 > 0 & strcmp(dum(len-12+1:len),'PCI Dio Name'));
         else;
%            info(p_cnt).name = sscanf(dum,'%c');
             work = sscanf(dum,'%c');
             info(p_cnt).name = sprintf('%s\n',work(1:len-6) );
         end;
      end;
      %comment
      if len-7 > 0 & strcmp(dum(len-7+1:len),'Comment');
%         info(p_cnt).comment = sscanf(dum,'%c');
         work = sscanf(dum,'%c');
         work = deblank(work);
         info(p_cnt).comment = sprintf('%s',work(1:len-9) );
      end;
      %age
      if len-3 > 0 & strcmp(dum(len-3+1:len),'Age');
%         info(p_cnt).age = sscanf(dum,'%d');
         age = sscanf(dum,'%d');
         if size(age,1)>1;
            w_age=age(1)+age(2)/12+age(3)/365*7+age(4)/365;
%            info(p_cnt).age=w_age;
            info(p_cnt).age=sprintf('%d\n',w_age);
         else;
            age(2)=0;
            age(3)=0;
            age(4)=0;
            w_age=age(1);
            info(p_cnt).age=sprintf('%d\n',w_age);
         end;
         clear w_age;
      end;
      %sex
      if len-3 > 0 & strcmp(dum(len-3+1:len),'Sex');
         work = sscanf(dum,'%d');
         if work == 0; info(p_cnt).sex = sprintf('%s\n','Male'); end;
         if work == 1; info(p_cnt).sex = sprintf('%s\n','Female'); end;
         clear work;
      end;

      %:Probe mode
      if len-9 > 0 & strcmp(dum(len-9+1:len),'Meas Mode');
         info(p_cnt).probe_mode = sscanf(dum,'%d');
         if info(p_cnt).probe_mode==1 | info(p_cnt).probe_mode==2;info(p_cnt).ad_ch_max=48;end;
         if info(p_cnt).probe_mode==3;info(p_cnt).ad_ch_max=44;end;
     end;
      
      %:Measeure mode         stim event
      if len-13 > 0 & strcmp(dum(len-13+1:len),'Measeure Mode');
         info(p_cnt).measure_mode = sscanf(dum,'%d');
      end;
      
      %:Exception Mode
      cnt1=1;
      if len-16 > 0 & strcmp(dum(len-16+1:len),'Exception Select');
         for cnt=1:info(p_cnt).ad_ch_max/2;
            if dum(cnt*2-1)=='1';
               info(p_cnt).err_ch(cnt)=1;                   % err_ch_flg
            else;
               info(p_cnt).err_ch(cnt)=0;                   % err_ch_flg
            end;
%            cnt=cnt+1;   
         end;
      end;
            
      %:date
      if len-4 > 0 & strcmp(dum(len-4+1:len),'Date');
          work = sscanf(dum,'%c');
          info(p_cnt).date = sprintf('%s\n',work(2:len-8) );
          %adnmpn:To which A/Dch does a measurement channel number correspond?(It has stood in a line in order of the measurement channel.)
          dum = fgets(fp);info(p_cnt).adnmpn = str2num(dum);
          %wlen:It has stood in a line wavelength / in order of A/Dch of each channel.
          dum = fgets(fp);info(p_cnt).wlen = str2num(dum);
          %adrng:It has stood in a line in order of A/Dgain[V]/A/Dch of each channel.
          dum = fgets(fp);info(p_cnt).adrng = str2num(dum);
          %amprng:It has stood in a line in order of lockin-amp gain/A/Dch of each channel.
          dum = fgets(fp);info(p_cnt).amprng = str2num(dum);
          %ampset:The lockin-amp state of each channel(-1:Under,0:Nomal,1:Over,-9:NotUsej
          dum = fgets(fp);info(p_cnt).ampset = str2num(dum);
      end;
      
      % smpl_period
%      if len-15 > 0 & strcmp(dum(len-15+1:len),'Sampling Period');
%         info(p_cnt).smpl_period = sscanf(dum,'%d');
%      end;
      if len-11 > 0 & strcmp(dum(len-11+1:len),'Data Period');
         if info(p_cnt).version == 2.02 & strcmp(info(p_cnt).file_name(length(info(p_cnt).file_name)-3:length(info(p_cnt).file_name)),'.DAT')==0;
            info(p_cnt).datanum = sscanf(dum,'%d');
            break;
         else;
            info(p_cnt).smpl_period = sscanf(dum,'%d');
         end;
      end;
      %070307
      %pre time
      if len-8 > 0  & strcmp(dum(len-8+1:len),'Pre Time');
        para.pre = sscanf(dum,'%d');
      end;
      %post time
      if len-9 > 0  & strcmp(dum(len-9+1:len),'Post Time');
        para.post = sscanf(dum,'%d');
      end;
      %relax time
      if len-10 > 0  & strcmp(dum(len-10+1:len),'Relax Time');
        para.relax = sscanf(dum,'%d');
      end;
      %base start time
      if len-15 > 0  & strcmp(dum(len-15+1:len),'Base Start Time');
        para.base_st = sscanf(dum,'%d');
      end;
      %base start time
      if len-13 > 0  & strcmp(dum(len-13+1:len),'Base End Time');
        para.base_ed = sscanf(dum,'%d');
      end;
      %Analyze Mode
      if len-12 > 0  & strcmp(dum(len-12+1:len),'Analyze Mode');
        work = sscanf(dum,'%d');
        if work == 1;
           para.analyze = sprintf('%s','Continuas');
        else;
           para.analyze = sprintf('%s','Integral');
        end;
        para.analyze_org = para.analyze;
      end;
      
      
      % datanum:Mark of measurement data
      if len-14 > 0 & strcmp(dum(len-14+1:len),'Number of data');
         if info(p_cnt).version == 2.02 & strcmp(info(p_cnt).file_name(length(info(p_cnt).file_name)-3:length(info(p_cnt).file_name)),'.DAT')==0;
            info(p_cnt).smpl_period = sscanf(dum,'%d');
         else;
           info(p_cnt).datanum = sscanf(dum,'%d')+1;
           break;
         end;
      end;
   end;             % header serch end
   % time s->ms
   para.pre = (para.pre*1000/info(p_cnt).smpl_period);
   para.pre_org = para.pre;
   para.post = (para.post*1000/info(p_cnt).smpl_period);
   para.post_org = para.post;
   para.relax = (para.relax*1000/info(p_cnt).smpl_period);
   para.relax_org = para.relax;
   para.base_st = (para.base_st*1000/info(p_cnt).smpl_period);
   para.base_ed = (para.base_ed*1000/info(p_cnt).smpl_period);

   %********** non data make ********************
   if isfield(info(p_cnt),'measure_mode') == 0;
      info(p_cnt).measure_mode = 1;
   end;
   if info(p_cnt).measure_mode == 0;  % Ver2.02 
      info(p_cnt).measure_mode = 1;
   end;
   %********* err chanel ******************
   if isfield(info(p_cnt),'err_ch') == 0;
      for cnt=1:info(p_cnt).ad_ch_max/2;
         info(p_cnt).err_ch(cnt)=0;                   % err_ch_flg
      end;
   end;
   %********* date ******************
   if isfield(info(p_cnt),'date') == 0;
      info(p_cnt).date='0000/00/00';                 % date
   end;
   
   
   %********* A/D ad Data Load ******:*****
%   if info(p_cnt).version == 2.02;
%      ad_data(p_cnt).raw= fscanf(fp, '%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,', [65,info(p_cnt).datanum])'; 
%   else;
      ad_data(p_cnt).raw= fscanf(fp, '%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f', [66,info(p_cnt).datanum])'; 
%   end;
   fclose(fp);
   para_p.load_prb1 = 1;
   %ad_data.raw
   mark.num = 0;mark.point = 0;
   mark.ave = 0;mark.char = '';
   %************** Marker Check ***************
   mark.num = 0;
   
   if (info(p_cnt).mark_ana==0);
      if info(p_cnt).measure_mode(1)==1;      %***** Stim Mode *****
         input_move;
      elseif info(p_cnt).measure_mode(1)==2;  %***** Event Mode *****
         input_move;
      end;
%      %****** Add Mark Infomation ******
%      mark.ave(1:mark.num) = 1;
   else (info(p_cnt).mark_ana==1)   %****** ana data load ******
         input_move;
%     [ad_data,mark]=load_an(info,ad_data,mark);
   end; 
end;				              % load ETG-100 data
