% load_an
%
% Input  : info,ad_data,mark
% Output : ad_data,mark
% Example: [ad_data,mark] = load_an(info,ad_data,mark)

%*******************************************************
%*             Topo Ana Data Load Function             *
%*                  Hiroaki Kusabuka                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% history:04.02.04 Ver 2.02 Kusabuka   ana Data load

function [ad_data,mark] = load_an(info,ad_data,mark)

%######################################
%   ETG-100 mark data
%######################################
p_cnt=1;

fp2 = fopen(info(p_cnt).ana_file,'r');
if fp2 == -1;  % Open err
   return;
else
   %######################################
   % It deletes for the above-mentioned processing addition.@isawa
   dum = fgets(fp2);   %Ver
   dum = fgets(fp2);   %ID
   if strcmp(info(p_cnt).id ,dum) ~=0; fclose(fp2);return;end;
   dum = fgets(fp2);   %Name
   if strcmp(info(p_cnt).name ,dum) ~=0; fclose(fp2);return;end;
   dum = fgets(fp2);   %comment
   dum = fgets(fp2);   %age I)@3.03 after
   if strcmp(info(p_cnt).age ,dum) ~=0; fclose(fp2);return;end;
   dum = fgets(fp2);   %sex
   dum = fgets(fp2);   %Operation Mode
   dum = fgets(fp2);   %Analize Mode
   dum = fgets(fp2);   %Selected Probe Mode
   if strcmp(info(p_cnt).probe_mode ,dum ) ~=0; fclose(fp2);return;end;

   if info(p_cnt).version == 2.02;swap = 146;end;
   if info(p_cnt).version == 3.02;swap = 91;end;
   if info(p_cnt).version == 3.03;swap = 91;end;
   if info(p_cnt).version == 4.00;swap = 91;end;
   if info(p_cnt).version == 4.03;swap = 91;end;
   if info(p_cnt).version == 4.04;swap = 91;end;
   for i = 1:swap;fgets(fp2);end;   %Header Swap

   %Header Swap
   if info(p_cnt).version == 3.02;swap = 29;for i=1:swap;fgets(fp2);end;end;
   if info(p_cnt).version == 3.03;swap = 37;for i=1:swap;fgets(fp2);end;end;
   if info(p_cnt).version == 4.00;swap = 25;for i=1:swap;fgets(fp2);end;end;
   if info(p_cnt).version == 4.03;swap = 25;for i=1:swap;fgets(fp2);end;end;
   if info(p_cnt).version == 4.04;swap = 25;for i=1:swap;fgets(fp2);end;end;

   %Load Base Line Information
   if info(p_cnt).version == 4.00 | info(p_cnt).version == 4.03| info(p_cnt).version == 4.04;
      dum = fgets(fp2);
      if str2num(dum(1))>0;fgets(fp2);end;
      for i=1:4;fgets(fp2);end;    
   end;

   %Load Application Inforamtion
   if info(p_cnt).version == 4.00 | info(p_cnt).version == 4.03 | info(p_cnt).version == 4.04;
      dum = fgets(fp2);   %app Num
      if info(p_cnt).app_num>0;
         for i=1:info(p_cnt).app_num*2;fgets(fp2);end;
      end;

      for i=1:2;fgets(fp2);end;
   end;
   %Load Exception Inforamtion
   if info(p_cnt).version == 4.04;
      for i=1:2;fgets(fp2);end;
   end;
   dum = fgets(fp2);   %Exception Select
   dum = fgets(fp2);   %date
   dum = fgets(fp2);   %Period

   dum = fgets(fp2);   %datanum

   if info(p_cnt).datanum ~= str2num(dum); fclose(fp2);return;end;

   %********* A/D ad Data Load ******:*****
   mark_ad= fscanf(fp2, '%f,%f,%f,%f', [4,info(p_cnt).datanum])'; 
   fclose(fp2);
%   ad_data(p_cnt).raw(150:info(p_cnt).datanum+150,64:66,) = mark_ad(143:info(p_cnt).datanum+143,2:4);
%   ad_data(p_cnt).raw(64:66,150:info(p_cnt).datanum+150) = mark_ad(2:4,143:info(p_cnt).datanum+143);
%   ad_data(p_cnt).raw(150,64) = mark_ad(143,2);
%   ad_data(p_cnt).raw(150,65) = mark_ad(143,3);
%   ad_data(p_cnt).raw(150,66) = mark_ad(143,4);
   mark.num = 0;mark.point = 0;
   mark.ave = 0;mark.char = '';
   %************** Marker Check ***************
   mark.num = 0;

   %***** Stim Mode *****
   if info(p_cnt).measure_mode(1)==1;
      if size(find( (ad_data(p_cnt).raw(:,65)>0 & ad_data(p_cnt).raw(:,65)<=10) | (ad_data(p_cnt).raw(:,65)>100 & ad_data(p_cnt).raw(:,65)<=110))~=0);
         dum = find( (ad_data(p_cnt).raw(:,65)>0 & ad_data(p_cnt).raw(:,65)<=10) | (ad_data(p_cnt).raw(:,65)>100 & ad_data(p_cnt).raw(:,65)<=110));
         mark.num = length(dum)/2;
         for j = 1:mark.num;
            if ad_data(p_cnt).raw(dum(2*j-1),65)> 100;
               mark.point(j,1) = ad_data(p_cnt).raw(dum(2*j-1),65)-100;
            else 
               mark.point(j,1) = ad_data(p_cnt).raw(dum(2*j-1),65);
            end;
            mark.point(j,2) = dum(2*j-1);
            mark.point(j,3) = dum(2*j);
         end;
      end;      
   end;

   %***** Event Mode *****
   if info(p_cnt).measure_mode(1)==2;
      if size(find( (ad_data(p_cnt).raw(:,65)>0 & ad_data(p_cnt).raw(:,65)<=10) | (ad_data(p_cnt).raw(:,65)>100 & ad_data(p_cnt).raw(:,65)<=110))~=0);
         dum = find( (ad_data(p_cnt).raw(:,65)>0 & ad_data(p_cnt).raw(:,65)<=10) | (ad_data(p_cnt).raw(:,65)>100 & ad_data(p_cnt).raw(:,65)<=110));
         mark.num = length(dum);
         for j = 1:mark.num;
            if ad_data(p_cnt).raw(dum(j),65) > 100;
               mark.point(j,1) = ad_data(p_cnt).raw(dum(j),65)-100;
            else 
               mark.point(j,1) = ad_data(p_cnt).raw(dum(j),65);
            end;
            mark.point(j,2) = dum(j);
         end;
      end;      
   end;

   %****** Add Mark Infomation ******
   mark.ave(1:mark.num) = 1;
end;				              % load ETG-100 data
