% map_3d
%
% Input  : para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop,pos,call_flg
% Output : hb_map_h
% Example: [hb_map_h] = map_3d(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop,pos,call_flg);

%*******************************************************
%* 3D Map Function                                     *
%* H.K                                                 *
%* HITACHI MECICAL                                     *
%*******************************************************
% HistoryF06.05.09 Ver2.06  Kusabuka@new

function [hb_map_h] = map_3d(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop,pos,call_flg);

if hb_data(Sel_graph).calc_flg==2;
    if isfield(hb_data(Sel_graph),'fil' ) ~= 1;
        warndlg('Please set and re-calculate a filter.','Warning');
        return;
    end;
end;

opengl autoselect; % ATȈꍇopenglőIݒ肳
if info(1).sys_ver >= 7;
    opengl('software'); % R14ȏopengl('software');ƋLq openGL̎\tgōs
elseif info(1).sys_ver >= 6;
    feature('UseGenericOpenGL',1);
end;

if info(1).sys_ver >= 7;
    set(gcf,'Renderer','zbuffer'); % R14
elseif info(1).sys_ver >= 6;
    set(gcf,'Renderer','opengl'); % R13
else;
    set(gcf,'Renderer','zbuffer'); % ȊO
end;
%************ Topo View **************
Sel_graph=1;

if call_flg == 0;
    %****************
    % figure
    %****************
%    del_fig(90,90);
    hb_map_h(Sel_graph).map_3d_fig = figure(80);
    clf;
    %****************
    % HEAD polygon
    %****************
    hb_map_h = head(para,info,para_p,hb_data,hb_graph_h,hb_map_h,Sel_graph,move_stop,pos);
    hold on;
    box on;
    set(gca,'drawmode','fast');
    set(0,'CurrentFigure',hb_map_h(Sel_graph).map_3d_fig);

    posi = get(hb_map_h(Sel_graph).map_3d_fig,'Position');
    set(hb_map_h(Sel_graph).map_3d_fig,'Name',sprintf('3D Topography'),'Position',posi,'ToolBar','figure');
    set(hb_map_h(Sel_graph).map_3d_fig,'CloseRequestFcn','move_play=1;closereq;');

    %************** color bar unit **************
    hb_map_h(Sel_graph).map3d.lab2 = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig, ...
        'Units','points', ...
        'BackgroundColor',[0.8 0.8 0.8], ...
        'Position',[posi(3)/1.35-posi(3)/10/1.35 15 30 10], ...
        'String','mMmm', ...
        'Style','text');

    %************** min **************
    hb_map_h(Sel_graph).map3d.min = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Units','points',...
        'BackgroundColor',[1 1 1],...
        'Position',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14],...
        'Style','edit',...
        'Interruptible','off',...
        'String',hb_map_h(Sel_graph).topo3d_min,...
        'Callback',['Sel_graph=1;',...
                    'if move_stop == 1;',...
                       'h=findobj(gcf,''type'',''axes'');',...
                       'val=str2num(get(hb_map_h(Sel_graph).map3d.min,''string''));',...
                       'if length(val) ~= 0;',...
                          'ret=strchknum(get(hb_map_h(Sel_graph).map3d.min,''string''));',...
                          'val = round(val*100)/100;',...
                          'if ret > 0;',...
                             'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                          'elseif val >= hb_map_h(1).topo3d_max | val < -1000;',...
                             'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                          'else;',...
                             'hb_map_h(Sel_graph).topo3d_min = val;',...
                             'set(h,''Clim'',[hb_map_h(Sel_graph).topo3d_min hb_map_h(Sel_graph).topo3d_max]);',...
                             'clear i;',...
                             'delete (hb_map_h(Sel_graph).map3d_col);',...
                             'hb_map_h(Sel_graph).map3d_col=colorbar;',...
                             'set(hb_map_h(Sel_graph).map3d_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                             'set(hb_map_h(Sel_graph).map3d_col,''FontSize'',7);',...
                         'end;',...
                         'set(hb_map_h(Sel_graph).map3d.min,''string'', hb_map_h(Sel_graph).topo3d_min);',...
                         'clear ret;',...
                     'else;',...
                        'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                        'set(hb_map_h(Sel_graph).map3d.min,''string'', hb_map_h(Sel_graph).topo3d_min);',...
                     'end;',...
                  'end;',...
                  'clear val;clear h;'],...
                  'Tag','EditText1');

    %************** max unit **************
    hb_map_h(1).map3d.lab1 = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Units','points',...
        'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14],...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','text',...
        'String','mMmm',...% Ver 2.00 -><-
        'Tag','tag2');

    %************** max **************
    hb_map_h(1).map3d.max = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Units','points',...
        'BackgroundColor',[1 1 1],...
        'Position',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14],...
        'String',hb_map_h(Sel_graph).topo3d_max,...
        'Style','edit',...
        'Interruptible','off',...
        'Callback',['Sel_graph=1;',...
                    'if move_stop == 1;',...
                       'h=findobj(gcf,''type'',''axes'');',...
                       'val=str2num(get(hb_map_h(Sel_graph).map3d.max,''string''));',...
                       'if length(val) ~= 0;',...
                          'ret=strchknum(get(hb_map_h(Sel_graph).map3d.max,''string''));',...
                          'val = round(val*100)/100;',...
                          'if ret > 0;',...
                             'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                          'elseif val <= hb_map_h(1).topo3d_min | val > 1000;',...
                             'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                          'else;',...
                             'hb_map_h(1).topo3d_max = val;',...
                             'set(h,''Clim'',[hb_map_h(Sel_graph).topo3d_min hb_map_h(Sel_graph).topo3d_max]);',...
                             'clear i;',...
                             'delete (hb_map_h(Sel_graph).map3d_col);',...
                             'hb_map_h(Sel_graph).map3d_col=colorbar;',...
                             'set(hb_map_h(Sel_graph).map3d_col,''Position'',[0.89 0.1 0.03 0.4]);',...
                             'set(hb_map_h(Sel_graph).map3d_col,''FontSize'',7);',...
                          'end;',...
                          'set(hb_map_h(Sel_graph).map3d.max,''string'', hb_map_h(Sel_graph).topo3d_max);',...
                          'clear ret;',...
                       'else;',...
                       'warndlg(''An input value is inaccurate.'',''Warning !!'');',...
                       'set(hb_map_h(Sel_graph).map3d.max,''string'', hb_map_h(Sel_graph).topo3d_max);',...
                    'end;',...
                 'end;',...
                 'clear val;clear h;'],...
                 'Tag','EditText2');

    %************** check **************
    hb_map_h(Sel_graph).map3d.chk = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Units','points',...
        'Position',[1 51 41 15], ...
        'BackgroundColor',[1 1 1], ...
        'Style','popupmenu',...
        'String','Oxy  |Deoxy|Total',...
        'Value',hb_map_h(Sel_graph).map3d_oxy,...
        'Callback',['Sel_graph=1;',...
                    'hb_map_h(Sel_graph).map3d_oxy=get(hb_map_h(Sel_graph).map3d.chk,''value'');',...
                    '[hb_map_h] = map_3d(para,info,para_p,hb_data,hb_graph_h,hb_map_h,1,move_stop,pos,1); ',...
                   ],...
        'Tag','Checkbox1');
%        'Position',[1 posi(4)/2/1.35-posi(4)/4/1.35-15 41 15], ...

    %************** refresh **************
    hb_map_h(Sel_graph).map3d.ref = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig, ...
        'Units','points', ...
        'BackgroundColor',[1.0 0.9 0.1], ...
        'Position',[1 0 35 14], ...
        'Interruptible','off',...
        'String','Refresh',...
        'Callback',['Sel_graph=1;'...
                    'posi=get(gcf,''Position'');',...
                    'if move_stop == 1;',...
                       'set(hb_map_h(Sel_graph).map3d.max,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35 40 14]);',...
                       'set(hb_map_h(Sel_graph).map3d.min,''Position'',[1 posi(4)/2/1.35-posi(4)/4/1.35 40 14]);',...
                       'set(hb_map_h(Sel_graph).map3d.lab1,''Position'',[1 posi(4)/2/1.35+posi(4)/4/1.35+15 40 14]);',...
                       'set(hb_map_h(Sel_graph).map3d.lab2,''Position'',[posi(3)/1.35-posi(3)/10/1.35 15 30 10]);',...
                       'set(hb_map_h(Sel_graph).map3d.t_lab,''Position'',[posi(3)/2-40 15 30 10]);',...
                       'set(hb_map_h(Sel_graph).map3d.time,''Position'',[posi(3)/2 15 40 10]);',...
                    'end;',...
                    'clear posi;',...
                    ],...
        'Tag','Pushbutton3');
%                       'set(hb_map_h(Sel_graph).map3d.chk,''Position'',[1 posi(4)/2/1.35-posi(4)/4/1.35-15 41 15]);',...
    %************** time unit **************
    hb_map_h(Sel_graph).map3d.t_lab = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Position',[posi(3)/2-40 15 30 10],...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','text',...
        'String','sec',...% Ver 2.00 -><-
        'Tag','tag2');

    %************** time **************
    hb_map_h(Sel_graph).map3d.time = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Position',[posi(3)/2 15 40 10],...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','text',...
        'String',para.sel_point*info(Sel_graph).smpl_period/1000,...% Ver 2.00 -><-
        'Tag','tag2');

    %************ Movie Start **************
    hb_map_h(Sel_graph).map3d.play = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Units','points',...
        'BackgroundColor',[0.75 0.75 0.75], ...
        'Position',[1 35 40 14],...
        'String','Play',...
        'Style','togglebutton',...
        'Visible','on',...
        'Callback',['if move_stop == 1;',...
                       'move_stop = 0;',...
                       'Sel_graph=1;'...
                       'if move_stop == 0;',...
                          'if para.sel_point > hb_graph_h(Sel_graph).time_max;',...
                             'para.sel_point = hb_graph_h(Sel_graph).time_min;',...
                          'end;',...
                          '[hb_map_h] = map_3d(para,info,para_p,hb_data,hb_graph_h,hb_map_h,1,move_stop,pos,1); ',...
                          'move_stop = 1;',...
                       'end;',...
                       'set(hb_map_h(Sel_graph).map3d.play,''Value'',0);',...
                       'clear m_cnt;clear fig_no;',...
                    'else;',...
                       'set(hb_map_h(Sel_graph).map3d.play,''Value'',0);',...
                       'warndlg(''Please push a stop button.'',''Warning !!'');',...
                    'end;',...
                    ],...
        'Tag','Pushbutton1');

    %************ Movie Stop **************
    hb_map_h(Sel_graph).map3d.stop = uicontrol('Parent',hb_map_h(Sel_graph).map_3d_fig,...
        'Units','points',...
        'Style','togglebutton',...
        'BackgroundColor',[0.75 0.75 0.75], ...
        'Position',[1 20 40 14],...
        'String','Stop',...
        'Callback',['Sel_graph=1;'...
                    'if move_stop == 1;',...
                       'move_stop = 1;',...
                       'set(hb_map_h(Sel_graph).map3d.stop,''Value'',0);',...
                    'else;',...
                       'move_stop = 1;',...
                    'end;',...
                       ],...
        'Tag','Pushbutton2');
    move_stop ~= get(hb_map_h(Sel_graph).map3d.stop,'Value');
end;

while(1);   % play repeat
    fig_no = findobj('Type','figure');
    fig_flg=0;
    Sel_graph=1;
    set(hb_map_h(Sel_graph).map3d.play,'Value',0);
    for cnt=1:length(fig_no);
        if (fig_no(cnt) == 80);
            fig_flg=1;   % allredy figure play repeat
            break;
        end;
    end;
    if fig_flg == 0;
        move_stop=1;
        break;
    end;
    if move_stop ~= 1;
        move_stop = get(hb_map_h(Sel_graph).map3d.stop,'Value');
        if move_stop == 1;
            break;
        end;
    end;
    set(hb_map_h(1).map3d.time,'String',para.sel_point*info(Sel_graph).smpl_period/1000);
    for p_cnt=1:5;      % probe count
        if (p_cnt==1 & para_p.sel_prb1 ~=1) | (p_cnt==2 & para_p.sel_prb2 ~=1) | (p_cnt==3 & para_p.sel_prb3 ~=1) |(p_cnt==4 & para_p.sel_prb4 ~=1) |(p_cnt==5 & para_p.sel_prb5 ~=1);
        elseif (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) | (p_cnt==4 & para_p.load_prb4 ~=1) | (p_cnt==5 & para_p.load_prb5 ~=1);
        else;
            set(0,'CurrentFigure',hb_map_h(1).map_3d_fig);
            %         set(hb_map_h(1).raw.play,'Value',0);
            posi=get(hb_map_h(Sel_graph).map_3d_fig,'Position');
            if move_stop ~= 1;
                move_stop = get(hb_map_h(Sel_graph).map3d.stop,'Value');
            end;
            clear hb_map;
            if hb_data(p_cnt).calc_flg==2;  % filter on
                hb_map(1,:)  = hb_data(p_cnt).fil(1,para.sel_point,:);
                hb_map(2,:)  = hb_data(p_cnt).fil(2,para.sel_point,:);
                hb_map(3,:)  = hb_data(p_cnt).fil(3,para.sel_point,:);
            else;                                 % filter off
                hb_map(1,:)  = hb_data(p_cnt).raw(1,para.sel_point,:);
                hb_map(2,:)  = hb_data(p_cnt).raw(2,para.sel_point,:);
                hb_map(3,:)  = hb_data(p_cnt).raw(3,para.sel_point,:);
            end;
            % except_ch data 0 (local)
            for i=1:(info(p_cnt).ad_ch_max/2);
                if info(p_cnt).err_ch(i)==1 & para_p.del_ch ==1;
                    hb_map(:,i) = 0;
                end;
            end;

            clear m_pos_x;
            clear m_pos_y;
            clear m_pos_z;

            %*************
            % position
            %*************
            if info(p_cnt).probe_mode==1;          % 3x3
                cnt_x=1;cnt_y=1;cnt_z=1;
                for cnt=1:18;
                    m_pos_x(cnt_x,cnt_y) = pos(p_cnt).ch_x(cnt);
                    m_pos_y(cnt_x,cnt_y) = pos(p_cnt).ch_y(cnt);
                    m_pos_z(cnt_x,cnt_y) = pos(p_cnt).ch_z(cnt);
                    if cnt == 3 | cnt == 6 | cnt == 9 | cnt == 12 | cnt == 15;
                        cnt_y = cnt_y+1;
                        cnt_x = 1;
                    else;
                        cnt_x = cnt_x+1;
                    end;
                end;
            elseif info(p_cnt).probe_mode==2;          % 4x4
                cnt_x=1;cnt_y=1;cnt_z=1;
                for cnt=1:16;
                    m_pos_x(cnt_x,cnt_y) = pos(p_cnt).ch_x(cnt);
                    m_pos_y(cnt_x,cnt_y) = pos(p_cnt).ch_y(cnt);
                    m_pos_z(cnt_x,cnt_y) = pos(p_cnt).ch_z(cnt);
                    if cnt == 4 | cnt == 8 | cnt == 12;
                        cnt_y = cnt_y+1;
                        cnt_x = 1;
                    else;
                        cnt_x = cnt_x+1;
                    end;
                end;
            elseif info(p_cnt).probe_mode==3;          % 3x5
                cnt_x=1;cnt_y=1;cnt_z=1;
                for cnt=1:15;
                    m_pos_x(cnt_x,cnt_y) = pos(p_cnt).ch_x(cnt);
                    m_pos_y(cnt_x,cnt_y) = pos(p_cnt).ch_y(cnt);
                    m_pos_z(cnt_x,cnt_y) = pos(p_cnt).ch_z(cnt);
                    if cnt == 5 | cnt == 10;
                        cnt_y = cnt_y+1;
                        cnt_x = 1;
                    else;
                        cnt_x = cnt_x+1;
                    end;
                end;

            elseif info(p_cnt).probe_mode==4;          % 3x11
                cnt_x=1;cnt_y=1;cnt_z=1;
                for cnt=1:33;
                    m_pos_x(cnt_x,cnt_y) = pos(p_cnt).ch_x(cnt);
                    m_pos_y(cnt_x,cnt_y) = pos(p_cnt).ch_y(cnt);
                    m_pos_z(cnt_x,cnt_y) = pos(p_cnt).ch_z(cnt);
                    if cnt == 11 | cnt == 22;
                        cnt_y = cnt_y+1;
                        cnt_x = 1;
                    else;
                        cnt_x = cnt_x+1;
                    end;
                end;
            elseif info(p_cnt).probe_mode==5;          % 3x10
                cnt_x=1;cnt_y=1;cnt_z=1;
                for cnt=1:30;
                    m_pos_x(cnt_x,cnt_y) = pos(p_cnt).ch_x(cnt);
                    m_pos_y(cnt_x,cnt_y) = pos(p_cnt).ch_y(cnt);
                    m_pos_z(cnt_x,cnt_y) = pos(p_cnt).ch_z(cnt);
                    if cnt == 10 | cnt == 20;
                        cnt_y = cnt_y+1;
                        cnt_x = 1;
                    else;
                        cnt_x = cnt_x+1;
                    end;
                end;
            end;

            %********************
            % hb oxy deoxy total
            %********************
            i = hb_map_h(1).map3d_oxy;             % 1:oxy,2:deoxy,3:total
            if info(p_cnt).probe_mode==1;          % 3x3
                %*************
                % data
                %*************
                % A
                m(1,1) =(hb_map(i,1)+hb_map(i,3))/2;
                m(2,1) =hb_map(i,1);
                m(3,1) =(hb_map(i,1)+hb_map(i,2)+hb_map(i,4))/3;
                m(4,1) =hb_map(i,2);
                m(5,1) =(hb_map(i,2)+hb_map(i,5))/2;
                m(1,2) =hb_map(i,3);
                m(2,2) =(hb_map(i,1)+hb_map(i,3)+hb_map(i,4)+hb_map(i,6))/4;
                m(3,2) =hb_map(i,4);
                m(4,2) =(hb_map(i,2)+hb_map(i,4)+hb_map(i,5)+hb_map(i,7))/4;
                m(5,2) =hb_map(i,5);
                m(1,3) =(hb_map(i,3)+hb_map(i,6)+hb_map(i,8))/3;
                m(2,3) =hb_map(i,6);
                m(3,3) =(hb_map(i,4)+hb_map(i,6)+hb_map(i,7)+hb_map(i,9))/4;
                m(4,3) =hb_map(i,7);
                m(5,3) =(hb_map(i,5)+hb_map(i,7)+hb_map(i,10))/3;
                m(1,4) =hb_map(i,8);
                m(2,4) =(hb_map(i,6)+hb_map(i,8)+hb_map(i,9)+hb_map(i,11))/4;
                m(3,4) =hb_map(i,9);
                m(4,4) =(hb_map(i,7)+hb_map(i,9)+hb_map(i,10)+hb_map(i,12))/4;
                m(5,4) =hb_map(i,10);
                m(1,5) =(hb_map(i,8)+hb_map(i,11))/2;
                m(2,5) =hb_map(i,11);
                m(3,5) =(hb_map(i,9)+hb_map(i,11)+hb_map(i,12))/3;
                m(4,5) =hb_map(i,12);
                m(5,5) =(hb_map(i,10)+hb_map(i,12))/2;
                % B
                m(1,6) =(hb_map(i,13)+hb_map(i,15))/2;
                m(2,6) =hb_map(i,13);
                m(3,6) =(hb_map(i,13)+hb_map(i,14)+hb_map(i,16))/3;
                m(4,6) =hb_map(i,14);
                m(5,6) =(hb_map(i,14)+hb_map(i,17))/2;
                m(1,7) =hb_map(i,15);
                m(2,7) =(hb_map(i,13)+hb_map(i,15)+hb_map(i,16)+hb_map(i,18))/4;
                m(3,7) =hb_map(i,16);
                m(4,7) =(hb_map(i,14)+hb_map(i,16)+hb_map(i,17)+hb_map(i,19))/4;
                m(5,7) =hb_map(i,17);
                m(1,8) =(hb_map(i,15)+hb_map(i,18)+hb_map(i,20))/3;
                m(2,8) =hb_map(i,18);
                m(3,8) =(hb_map(i,16)+hb_map(i,18)+hb_map(i,19)+hb_map(i,21))/4;
                m(4,8) =hb_map(i,19);
                m(5,8) =(hb_map(i,17)+hb_map(i,19)+hb_map(i,22))/3;
                m(1,9) =hb_map(i,20);
                m(2,9) =(hb_map(i,18)+hb_map(i,20)+hb_map(i,21)+hb_map(i,23))/4;
                m(3,9) =hb_map(i,21);
                m(4,9) =(hb_map(i,19)+hb_map(i,21)+hb_map(i,22)+hb_map(i,24))/4;
                m(5,9) =hb_map(i,22);
                m(1,10) =(hb_map(i,20)+hb_map(i,23))/2;
                m(2,10) =hb_map(i,23);
                m(3,10) =(hb_map(i,21)+hb_map(i,23)+hb_map(i,24))/3;
                m(4,10) =hb_map(i,24);
                m(5,10) =(hb_map(i,22)+hb_map(i,24))/2;

            elseif  info(p_cnt).probe_mode == 2;      % 4x4
                %*************
                % data
                %*************
                m(1,1) =(hb_map(i,1)+hb_map(i,4))/2;
                m(2,1) =hb_map(i,1);
                m(3,1) =(hb_map(i,1)+hb_map(i,2)+hb_map(i,5))/3;
                m(4,1) =hb_map(i,2);
                m(5,1) =(hb_map(i,2)+hb_map(i,3)+hb_map(i,6))/3;
                m(6,1) =hb_map(i,3);
                m(7,1) =(hb_map(i,3)+hb_map(i,7))/2;
                m(1,2) =hb_map(i,4);
                m(2,2) =(hb_map(i,1)+hb_map(i,4)+hb_map(i,5)+hb_map(i,8))/4;
                m(3,2) =hb_map(i,5);
                m(4,2) =(hb_map(i,2)+hb_map(i,5)+hb_map(i,6)+hb_map(i,9))/4;
                m(5,2) =hb_map(i,6);
                m(6,2) =(hb_map(i,3)+hb_map(i,6)+hb_map(i,7)+hb_map(i,10))/4;
                m(7,2) =hb_map(i,7);
                m(1,3) =(hb_map(i,4)+hb_map(i,8)+hb_map(i,11))/3;
                m(2,3) =hb_map(i,8);
                m(3,3) =(hb_map(i,5)+hb_map(i,8)+hb_map(i,9)+hb_map(i,12))/4;
                m(4,3) =hb_map(i,9);
                m(5,3) =(hb_map(i,6)+hb_map(i,9)+hb_map(i,10)+hb_map(i,13))/4;
                m(6,3) =hb_map(i,10);
                m(7,3) =(hb_map(i,7)+hb_map(i,10)+hb_map(i,14))/3;
                m(1,4) =hb_map(i,11);
                m(2,4) =(hb_map(i,8)+hb_map(i,11)+hb_map(i,12)+hb_map(i,15))/4;
                m(3,4) =hb_map(i,12);
                m(4,4) =(hb_map(i,9)+hb_map(i,12)+hb_map(i,13)+hb_map(i,16))/4;
                m(5,4) =hb_map(i,13);
                m(6,4) =(hb_map(i,10)+hb_map(i,13)+hb_map(i,14)+hb_map(i,17))/4;
                m(7,4) =hb_map(i,14);
                m(1,5) =(hb_map(i,11)+hb_map(i,15)+hb_map(i,18))/3;
                m(2,5) =hb_map(i,15);
                m(3,5) =(hb_map(i,12)+hb_map(i,15)+hb_map(i,16)+hb_map(i,19))/4;
                m(4,5) =hb_map(i,16);
                m(5,5) =(hb_map(i,13)+hb_map(i,16)+hb_map(i,17)+hb_map(i,20))/4;
                m(6,5) =hb_map(i,17);
                m(7,5) =(hb_map(i,14)+hb_map(i,17)+hb_map(i,21))/3;
                m(1,6) =hb_map(i,18);
                m(2,6) =(hb_map(i,15)+hb_map(i,18)+hb_map(i,19)+hb_map(i,22))/4;
                m(3,6) =hb_map(i,19);
                m(4,6) =(hb_map(i,16)+hb_map(i,19)+hb_map(i,20)+hb_map(i,23))/4;
                m(5,6) =hb_map(i,20);
                m(6,6) =(hb_map(i,17)+hb_map(i,20)+hb_map(i,21)+hb_map(i,24))/4;
                m(7,6) =hb_map(i,21);
                m(1,7) =(hb_map(i,18)+hb_map(i,22))/2;
                m(2,7) =hb_map(i,22);
                m(3,7) =(hb_map(i,19)+hb_map(i,22)+hb_map(i,23))/3;
                m(4,7) =hb_map(i,23);
                m(5,7) =(hb_map(i,20)+hb_map(i,23)+hb_map(i,24))/3;
                m(6,7) =hb_map(i,24);
                m(7,7) =(hb_map(i,21)+hb_map(i,24))/2;

            elseif info(p_cnt).probe_mode==3;      % 3x5
                %*************
                % data
                %*************
                m(1,1) =(hb_map(i,1)+hb_map(i,5))/2;
                m(2,1) =hb_map(i,1);
                m(3,1) =(hb_map(i,1)+hb_map(i,2)+hb_map(i,6))/3;
                m(4,1) =hb_map(i,2);
                m(5,1) =(hb_map(i,2)+hb_map(i,3)+hb_map(i,7))/3;
                m(6,1) =hb_map(i,3);
                m(7,1) =(hb_map(i,3)+hb_map(i,4)+hb_map(i,8))/3;
                m(8,1) =hb_map(i,4);
                m(9,1) =(hb_map(i,4)+hb_map(i,9))/2;
                m(1,2) =hb_map(i,5);
                m(2,2) =(hb_map(i,1)+hb_map(i,5)+hb_map(i,6)+hb_map(i,10))/4;
                m(3,2) =hb_map(i,6);
                m(4,2) =(hb_map(i,2)+hb_map(i,6)+hb_map(i,7)+hb_map(i,11))/4;
                m(5,2) =hb_map(i,7);
                m(6,2) =(hb_map(i,3)+hb_map(i,7)+hb_map(i,8)+hb_map(i,12))/4;
                m(7,2) =hb_map(i,8);
                m(8,2) =(hb_map(i,4)+hb_map(i,8)+hb_map(i,9)+hb_map(i,13))/4;
                m(9,2) =hb_map(i,9);
                m(1,3) =(hb_map(i,5)+hb_map(i,10)+hb_map(i,14))/3;
                m(2,3) =hb_map(i,10);
                m(3,3) =(hb_map(i,6)+hb_map(i,10)+hb_map(i,11)+hb_map(i,15))/4;
                m(4,3) =hb_map(i,11);
                m(5,3) =(hb_map(i,7)+hb_map(i,11)+hb_map(i,12)+hb_map(i,16))/4;
                m(6,3) =hb_map(i,12);
                m(7,3) =(hb_map(i,8)+hb_map(i,12)+hb_map(i,13)+hb_map(i,17))/4;
                m(8,3) =hb_map(i,13);
                m(9,3) =(hb_map(i,9)+hb_map(i,13)+hb_map(i,18))/3;
                m(1,4) =hb_map(i,14);
                m(2,4) =(hb_map(i,10)+hb_map(i,14)+hb_map(i,15)+hb_map(i,19))/4;
                m(3,4) =hb_map(i,15);
                m(4,4) =(hb_map(i,11)+hb_map(i,15)+hb_map(i,16)+hb_map(i,20))/4;
                m(5,4) =hb_map(i,16);
                m(6,4) =(hb_map(i,12)+hb_map(i,16)+hb_map(i,17)+hb_map(i,21))/4;
                m(7,4) =hb_map(i,17);
                m(8,4) =(hb_map(i,13)+hb_map(i,17)+hb_map(i,18)+hb_map(i,22))/4;
                m(9,4) =hb_map(i,18);
                m(1,5) =(hb_map(i,14)+hb_map(i,19))/2;
                m(2,5) =hb_map(i,19);
                m(3,5) =(hb_map(i,15)+hb_map(i,19)+hb_map(i,20))/3;
                m(4,5) =hb_map(i,20);
                m(5,5) =(hb_map(i,16)+hb_map(i,20)+hb_map(i,21))/3;
                m(6,5) =hb_map(i,21);
                m(7,5) =(hb_map(i,17)+hb_map(i,21)+hb_map(i,22))/3;
                m(8,5) =hb_map(i,22);
                m(9,5) =(hb_map(i,18)+hb_map(i,22))/2;

            elseif  info(p_cnt).probe_mode == 4;      % 3x11
                %*************
                % data
                %*************
                m(1,1) =(hb_map(i,1)+hb_map(i,11))/2;
                m(2,1) =hb_map(i,1);
                m(3,1) =(hb_map(i,1)+hb_map(i,2)+hb_map(i,12))/3;
                m(4,1) =hb_map(i,2);
                m(5,1) =(hb_map(i,2)+hb_map(i,3)+hb_map(i,13))/3;
                m(6,1) =hb_map(i,3);
                m(7,1) =(hb_map(i,3)+hb_map(i,4)+hb_map(i,14))/3;
                m(8,1) =hb_map(i,4);
                m(9,1) =(hb_map(i,4)+hb_map(i,5)+hb_map(i,15))/3;
                m(10,1) =hb_map(i,5);
                m(11,1) =(hb_map(i,5)+hb_map(i,6)+hb_map(i,16))/3;
                m(12,1) =hb_map(i,6);
                m(13,1) =(hb_map(i,6)+hb_map(i,7)+hb_map(i,17))/3;
                m(14,1) =hb_map(i,7);
                m(15,1) =(hb_map(i,7)+hb_map(i,8)+hb_map(i,18))/3;
                m(16,1) =hb_map(i,8);
                m(17,1) =(hb_map(i,8)+hb_map(i,9)+hb_map(i,19))/3;
                m(18,1) =hb_map(i,9);
                m(19,1) =(hb_map(i,9)+hb_map(i,10)+hb_map(i,20))/3;
                m(20,1) =hb_map(i,10);
                m(21,1) =(hb_map(i,10)+hb_map(i,21))/2;

                m(1,2) =hb_map(i,11);
                m(2,2) =(hb_map(i,1)+hb_map(i,11)+hb_map(i,12)+hb_map(i,22))/4;
                m(3,2) =hb_map(i,12);
                m(4,2) =(hb_map(i,2)+hb_map(i,12)+hb_map(i,13)+hb_map(i,23))/4;
                m(5,2) =hb_map(i,13);
                m(6,2) =(hb_map(i,3)+hb_map(i,13)+hb_map(i,14)+hb_map(i,24))/4;
                m(7,2) =hb_map(i,14);
                m(8,2) =(hb_map(i,4)+hb_map(i,14)+hb_map(i,25)+hb_map(i,25))/4;
                m(9,2) =hb_map(i,15);
                m(10,2) =(hb_map(i,5)+hb_map(i,15)+hb_map(i,16)+hb_map(i,26))/4;
                m(11,2) =hb_map(i,16);
                m(12,2) =(hb_map(i,6)+hb_map(i,16)+hb_map(i,17)+hb_map(i,27))/4;
                m(13,2) =hb_map(i,17);
                m(14,2) =(hb_map(i,7)+hb_map(i,17)+hb_map(i,18)+hb_map(i,28))/4;
                m(15,2) =hb_map(i,18);
                m(16,2) =(hb_map(i,8)+hb_map(i,18)+hb_map(i,19)+hb_map(i,29))/4;
                m(17,2) =hb_map(i,19);
                m(18,2) =(hb_map(i,9)+hb_map(i,19)+hb_map(i,20)+hb_map(i,30))/4;
                m(19,2) =hb_map(i,20);
                m(20,2) =(hb_map(i,10)+hb_map(i,20)+hb_map(i,21)+hb_map(i,31))/4;
                m(21,2) =hb_map(i,21);

                m(1,3) =(hb_map(i,11)+hb_map(i,22)+hb_map(i,32))/3;
                m(2,3) =hb_map(i,22);
                m(3,3) =(hb_map(i,12)+hb_map(i,22)+hb_map(i,23)+hb_map(i,33))/4;
                m(4,3) =hb_map(i,23);
                m(5,3) =(hb_map(i,13)+hb_map(i,23)+hb_map(i,24)+hb_map(i,34))/4;
                m(6,3) =hb_map(i,24);
                m(7,3) =(hb_map(i,14)+hb_map(i,24)+hb_map(i,25)+hb_map(i,35))/4;
                m(8,3) =hb_map(i,25);
                m(9,3) =(hb_map(i,15)+hb_map(i,25)+hb_map(i,26)+hb_map(i,36))/4;
                m(10,3) =hb_map(i,26);
                m(11,3) =(hb_map(i,16)+hb_map(i,26)+hb_map(i,27)+hb_map(i,37))/4;
                m(12,3) =hb_map(i,27);
                m(13,3) =(hb_map(i,17)+hb_map(i,27)+hb_map(i,28)+hb_map(i,38))/4;
                m(14,3) =hb_map(i,28);
                m(15,3) =(hb_map(i,18)+hb_map(i,28)+hb_map(i,29)+hb_map(i,39))/4;
                m(16,3) =hb_map(i,29);
                m(17,3) =(hb_map(i,19)+hb_map(i,29)+hb_map(i,30)+hb_map(i,40))/4;
                m(18,3) =hb_map(i,30);
                m(19,3) =(hb_map(i,20)+hb_map(i,30)+hb_map(i,31)+hb_map(i,41))/4;
                m(20,3) =hb_map(i,31);
                m(21,3) =(hb_map(i,21)+hb_map(i,31)+hb_map(i,42))/3;

                m(1,4) =hb_map(i,32);
                m(2,4) =(hb_map(i,22)+hb_map(i,32)+hb_map(i,33)+hb_map(i,43))/4;
                m(3,4) =hb_map(i,33);
                m(4,4) =(hb_map(i,23)+hb_map(i,33)+hb_map(i,34)+hb_map(i,44))/4;
                m(5,4) =hb_map(i,34);
                m(6,4) =(hb_map(i,24)+hb_map(i,34)+hb_map(i,35)+hb_map(i,45))/4;
                m(7,4) =hb_map(i,35);
                m(8,4) =(hb_map(i,25)+hb_map(i,35)+hb_map(i,36)+hb_map(i,46))/4;
                m(9,4) =hb_map(i,36);
                m(10,4) =(hb_map(i,26)+hb_map(i,36)+hb_map(i,37)+hb_map(i,47))/4;
                m(11,4) =hb_map(i,37);
                m(12,4) =(hb_map(i,27)+hb_map(i,37)+hb_map(i,38)+hb_map(i,48))/4;
                m(13,4) =hb_map(i,38);
                m(14,4) =(hb_map(i,28)+hb_map(i,38)+hb_map(i,39)+hb_map(i,49))/4;
                m(15,4) =hb_map(i,39);
                m(16,4) =(hb_map(i,29)+hb_map(i,39)+hb_map(i,40)+hb_map(i,50))/4;
                m(17,4) =hb_map(i,40);
                m(18,4) =(hb_map(i,30)+hb_map(i,40)+hb_map(i,41)+hb_map(i,51))/4;
                m(19,4) =hb_map(i,41);
                m(20,4) =(hb_map(i,31)+hb_map(i,41)+hb_map(i,42)+hb_map(i,52))/4;
                m(21,4) =hb_map(i,42);

                m(1,5) =(hb_map(i,32)+hb_map(i,43))/2;
                m(2,5) =hb_map(i,43);
                m(3,5) =(hb_map(i,33)+hb_map(i,43)+hb_map(i,44))/3;
                m(4,5) =hb_map(i,44);
                m(5,5) =(hb_map(i,34)+hb_map(i,44)+hb_map(i,45))/3;
                m(6,5) =hb_map(i,45);
                m(7,5) =(hb_map(i,35)+hb_map(i,45)+hb_map(i,46))/3;
                m(8,5) =hb_map(i,46);
                m(9,5) =(hb_map(i,36)+hb_map(i,46)+hb_map(i,47))/3;
                m(10,5) =hb_map(i,47);
                m(11,5) =(hb_map(i,37)+hb_map(i,47)+hb_map(i,48))/3;
                m(12,5) =hb_map(i,48);
                m(13,5) =(hb_map(i,38)+hb_map(i,48)+hb_map(i,49))/3;
                m(14,5) =hb_map(i,49);
                m(15,5) =(hb_map(i,39)+hb_map(i,49)+hb_map(i,50))/3;
                m(16,5) =hb_map(i,50);
                m(17,5) =(hb_map(i,40)+hb_map(i,50)+hb_map(i,51))/3;
                m(18,5) =hb_map(i,51);
                m(19,5) =(hb_map(i,41)+hb_map(i,51)+hb_map(i,52))/3;
                m(20,5) =hb_map(i,52);
                m(21,5) =(hb_map(i,42)+hb_map(i,52))/2;

            elseif  info(p_cnt).probe_mode == 5;      % 3x10
                %*************
                % data
                %*************
                m(1,1) =(hb_map(i,1)+hb_map(i,10))/2;
                m(2,1) = hb_map(i,1);
                m(3,1) =(hb_map(i,1)+hb_map(i,2)+hb_map(i,11))/3;
                m(4,1) = hb_map(i,2);
                m(5,1) =(hb_map(i,2)+hb_map(i,3)+hb_map(i,12))/3;
                m(6,1) = hb_map(i,3);
                m(7,1) =(hb_map(i,3)+hb_map(i,4)+hb_map(i,13))/3;
                m(8,1) = hb_map(i,4);
                m(9,1) =(hb_map(i,4)+hb_map(i,5)+hb_map(i,14))/3;
                m(10,1) = hb_map(i,5);
                m(11,1) =(hb_map(i,5)+hb_map(i,6)+hb_map(i,15))/3;
                m(12,1) = hb_map(i,6);
                m(13,1) =(hb_map(i,6)+hb_map(i,7)+hb_map(i,16))/3;
                m(14,1) = hb_map(i,7);
                m(15,1) =(hb_map(i,7)+hb_map(i,8)+hb_map(i,17))/3;
                m(16,1) = hb_map(i,8);
                m(17,1) =(hb_map(i,8)+hb_map(i,9)+hb_map(i,18))/3;
                m(18,1) = hb_map(i,9);
                m(19,1) =(hb_map(i,9)+hb_map(i,19))/2;

                m(1,2) = hb_map(i,10);
                m(2,2) =(hb_map(i,1)+hb_map(i,10)+hb_map(i,11)+hb_map(i,20))/4;
                m(3,2) = hb_map(i,11);
                m(4,2) =(hb_map(i,2)+hb_map(i,11)+hb_map(i,12)+hb_map(i,21))/4;
                m(5,2) = hb_map(i,12);
                m(6,2) =(hb_map(i,3)+hb_map(i,12)+hb_map(i,13)+hb_map(i,22))/4;
                m(7,2) = hb_map(i,13);
                m(8,2) =(hb_map(i,4)+hb_map(i,13)+hb_map(i,14)+hb_map(i,23))/4;
                m(9,2) = hb_map(i,14);
                m(10,2) =(hb_map(i,5)+hb_map(i,14)+hb_map(i,15)+hb_map(i,24))/4;
                m(11,2) = hb_map(i,15);
                m(12,2) =(hb_map(i,6)+hb_map(i,15)+hb_map(i,16)+hb_map(i,25))/4;
                m(13,2) = hb_map(i,16);
                m(14,2) =(hb_map(i,7)+hb_map(i,16)+hb_map(i,17)+hb_map(i,26))/4;
                m(15,2) = hb_map(i,17);
                m(16,2) =(hb_map(i,8)+hb_map(i,17)+hb_map(i,18)+hb_map(i,27))/4;
                m(17,2) = hb_map(i,18);
                m(18,2) =(hb_map(i,9)+hb_map(i,18)+hb_map(i,19)+hb_map(i,28))/4;
                m(19,2) = hb_map(i,19);

                m(1,3) =(hb_map(i,10)+hb_map(i,20)+hb_map(i,29))/3;
                m(2,3) = hb_map(i,20);
                m(3,3) =(hb_map(i,11)+hb_map(i,20)+hb_map(i,21)+hb_map(i,30))/4;
                m(4,3) = hb_map(i,21);
                m(5,3) =(hb_map(i,12)+hb_map(i,21)+hb_map(i,22)+hb_map(i,31))/4;
                m(6,3) = hb_map(i,22);
                m(7,3) =(hb_map(i,13)+hb_map(i,22)+hb_map(i,23)+hb_map(i,32))/4;
                m(8,3) = hb_map(i,23);
                m(9,3) =(hb_map(i,14)+hb_map(i,23)+hb_map(i,24)+hb_map(i,33))/4;
                m(10,3) = hb_map(i,24);
                m(11,3) =(hb_map(i,15)+hb_map(i,24)+hb_map(i,25)+hb_map(i,34))/4;
                m(12,3) = hb_map(i,25);
                m(13,3) =(hb_map(i,16)+hb_map(i,25)+hb_map(i,26)+hb_map(i,35))/4;
                m(14,3) = hb_map(i,26);
                m(15,3) =(hb_map(i,17)+hb_map(i,26)+hb_map(i,27)+hb_map(i,36))/4;
                m(16,3) = hb_map(i,27);
                m(17,3) =(hb_map(i,18)+hb_map(i,27)+hb_map(i,28)+hb_map(i,37))/4;
                m(18,3) = hb_map(i,28);
                m(19,3) =(hb_map(i,19)+hb_map(i,28)+hb_map(i,38))/4;

                m(1,4) = hb_map(i,29);
                m(2,4) =(hb_map(i,20)+hb_map(i,29)+hb_map(i,30)+hb_map(i,39))/4;
                m(3,4) = hb_map(i,30);
                m(4,4) =(hb_map(i,21)+hb_map(i,30)+hb_map(i,31)+hb_map(i,40))/4;
                m(5,4) = hb_map(i,31);
                m(6,4) =(hb_map(i,22)+hb_map(i,31)+hb_map(i,32)+hb_map(i,41))/4;
                m(7,4) = hb_map(i,32);
                m(8,4) =(hb_map(i,23)+hb_map(i,32)+hb_map(i,33)+hb_map(i,42))/4;
                m(9,4) = hb_map(i,33);
                m(10,4) =(hb_map(i,24)+hb_map(i,33)+hb_map(i,34)+hb_map(i,43))/4;
                m(11,4) = hb_map(i,34);
                m(12,4) =(hb_map(i,25)+hb_map(i,34)+hb_map(i,35)+hb_map(i,44))/4;
                m(13,4) = hb_map(i,35);
                m(14,4) =(hb_map(i,26)+hb_map(i,35)+hb_map(i,36)+hb_map(i,45))/4;
                m(15,4) = hb_map(i,36);
                m(16,4) =(hb_map(i,27)+hb_map(i,36)+hb_map(i,37)+hb_map(i,46))/4;
                m(17,4) = hb_map(i,37);
                m(18,4) =(hb_map(i,28)+hb_map(i,37)+hb_map(i,38)+hb_map(i,47))/4;
                m(19,4) = hb_map(i,38);

                m(1,5) =(hb_map(i,29)+hb_map(i,39))/2;
                m(2,5) = hb_map(i,39);
                m(3,5) =(hb_map(i,30)+hb_map(i,39)+hb_map(i,40))/3;
                m(4,5) = hb_map(i,40);
                m(5,5) =(hb_map(i,31)+hb_map(i,40)+hb_map(i,41))/3;
                m(6,5) = hb_map(i,41);
                m(7,5) =(hb_map(i,32)+hb_map(i,41)+hb_map(i,42))/3;
                m(8,5) = hb_map(i,42);
                m(9,5) =(hb_map(i,33)+hb_map(i,42)+hb_map(i,43))/3;
                m(10,5) = hb_map(i,43);
                m(11,5) =(hb_map(i,34)+hb_map(i,43)+hb_map(i,44))/3;
                m(12,5) = hb_map(i,44);
                m(13,5) =(hb_map(i,35)+hb_map(i,44)+hb_map(i,45))/3;
                m(14,5) = hb_map(i,45);
                m(15,5) =(hb_map(i,36)+hb_map(i,45)+hb_map(i,46))/3;
                m(16,5) = hb_map(i,46);
                m(17,5) =(hb_map(i,37)+hb_map(i,46)+hb_map(i,47))/3;
                m(18,5) = hb_map(i,47);
                m(19,5) =(hb_map(i,38)+hb_map(i,47))/2;
            end;

            if move_stop ~= 1;
                move_stop = get(hb_map_h(Sel_graph).map3d.stop,'Value');
            end;
            set(0,'CurrentFigure',hb_map_h(Sel_graph).map_3d_fig);

            %***********************
            % Hb Probe
            %***********************
            if call_flg == 0;
                if info(p_cnt).probe_mode==1;          % 3x3

                    m_data1 = interp2(interp2(m(:,1:5)));
                    m_data2 = interp2(interp2(m(:,6:10)));

                    pos_x1 = interp2(interp2(interp2(m_pos_x(:,1:3))));
                    pos_y1 = interp2(interp2(interp2(m_pos_y(:,1:3))));
                    pos_z1 = interp2(interp2(interp2(m_pos_z(:,1:3))));
                    pos_x2 = interp2(interp2(interp2(m_pos_x(:,4:6))));
                    pos_y2 = interp2(interp2(interp2(m_pos_y(:,4:6))));
                    pos_z2 = interp2(interp2(interp2(m_pos_z(:,4:6))));
                    
                    %*** Make NaN Area1 ****
                    m_data1(1,1)=NaN;m_data1(1,2)=NaN;m_data1(1,3)=NaN;m_data1(1,4)=NaN;
                    m_data1(2,1)=NaN;m_data1(2,2)=NaN;m_data1(2,3)=NaN;
                    m_data1(3,1)=NaN;m_data1(3,2)=NaN;
                    m_data1(4,1)=NaN;
                    
                    m_data1(16,1)=NaN;m_data1(16,2)=NaN;m_data1(16,3)=NaN;m_data1(16,4)=NaN;
                    m_data1(15,1)=NaN;m_data1(15,2)=NaN;m_data1(15,3)=NaN;
                    m_data1(14,1)=NaN;m_data1(14,2)=NaN;
                    m_data1(13,1)=NaN;
                    
                    m_data1(1,13)=NaN;m_data1(1,14)=NaN;m_data1(1,15)=NaN;m_data1(1,16)=NaN;
                    m_data1(2,14)=NaN;m_data1(2,15)=NaN;m_data1(2,16)=NaN;
                    m_data1(3,15)=NaN;m_data1(3,16)=NaN;
                    m_data1(4,16)=NaN;
                    
                    m_data1(16,13)=NaN;m_data1(16,14)=NaN;m_data1(16,15)=NaN;m_data1(16,16)=NaN;
                    m_data1(15,14)=NaN;m_data1(15,15)=NaN;m_data1(15,16)=NaN;
                    m_data1(14,15)=NaN;m_data1(14,16)=NaN;
                    m_data1(13,16)=NaN;
                    
                     %*** Make NaN Area2 ****
                    m_data2(1,1)=NaN;m_data2(1,2)=NaN;m_data2(1,3)=NaN;m_data2(1,4)=NaN;
                    m_data2(2,1)=NaN;m_data2(2,2)=NaN;m_data2(2,3)=NaN;
                    m_data2(3,1)=NaN;m_data2(3,2)=NaN;
                    m_data2(4,1)=NaN;
                    
                    m_data2(16,1)=NaN;m_data2(16,2)=NaN;m_data2(16,3)=NaN;m_data2(16,4)=NaN;
                    m_data2(15,1)=NaN;m_data2(15,2)=NaN;m_data2(15,3)=NaN;
                    m_data2(14,1)=NaN;m_data2(14,2)=NaN;
                    m_data2(13,1)=NaN;
                    
                    m_data2(1,13)=NaN;m_data2(1,14)=NaN;m_data2(1,15)=NaN;m_data2(1,16)=NaN;
                    m_data2(2,14)=NaN;m_data2(2,15)=NaN;m_data2(2,16)=NaN;
                    m_data2(3,15)=NaN;m_data2(3,16)=NaN;
                    m_data2(4,16)=NaN;
                    
                    m_data2(16,13)=NaN;m_data2(16,14)=NaN;m_data2(16,15)=NaN;m_data2(16,16)=NaN;
                    m_data2(15,14)=NaN;m_data2(15,15)=NaN;m_data2(15,16)=NaN;
                    m_data2(14,15)=NaN;m_data2(14,16)=NaN;
                    m_data2(13,16)=NaN;

                    hb_map_h(p_cnt).map3d_suf1 = surface(pos_x1,pos_y1,pos_z1,m_data1,'EdgeColor','none');
                    hb_map_h(p_cnt).map3d_suf2 = surface(pos_x2,pos_y2,pos_z2,m_data2,'EdgeColor','none');
                
                else;%4*4 
                    m_data = interp2(m);
                    m_data = interp2(m_data);

                    %******** kawasaki *********
                    %*** Make NaN Area ****
                    if info(p_cnt).probe_mode==2; % 4x4   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;m_data(1,4)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;m_data(2,3)=NaN;
                        m_data(3,1)=NaN;m_data(3,2)=NaN;
                        m_data(4,1)=NaN;
                        m_data(24,1)=NaN;m_data(24,2)=NaN;m_data(24,3)=NaN;m_data(24,4)=NaN;
                        m_data(23,1)=NaN;m_data(23,2)=NaN;m_data(23,3)=NaN;
                        m_data(22,1)=NaN;m_data(22,2)=NaN;
                        m_data(21,1)=NaN;
                        m_data(1,21)=NaN;m_data(1,22)=NaN;m_data(1,23)=NaN;m_data(1,24)=NaN;
                        m_data(2,22)=NaN;m_data(2,23)=NaN;m_data(2,24)=NaN;
                        m_data(3,23)=NaN;m_data(3,24)=NaN;
                        m_data(4,24)=NaN;
                        m_data(24,21)=NaN;m_data(24,22)=NaN;m_data(24,23)=NaN;m_data(24,24)=NaN;
                        m_data(23,22)=NaN;m_data(23,23)=NaN;m_data(23,24)=NaN;
                        m_data(22,23)=NaN;m_data(22,24)=NaN;
                        m_data(21,24)=NaN;
                    elseif info(p_cnt).probe_mode==3; % 3x5   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;
                        m_data(3,1)=NaN;
                        m_data(32,1)=NaN;m_data(32,2)=NaN;m_data(32,3)=NaN;
                        m_data(31,1)=NaN;m_data(31,2)=NaN;
                        m_data(30,1)=NaN;
                        m_data(1,14)=NaN;m_data(1,15)=NaN;m_data(1,16)=NaN;
                        m_data(2,15)=NaN;m_data(2,16)=NaN;
                        m_data(3,16)=NaN;
                        m_data(32,14)=NaN;m_data(32,15)=NaN;m_data(32,16)=NaN;
                        m_data(31,15)=NaN;m_data(31,16)=NaN;
                        m_data(30,16)=NaN;
                    elseif info(p_cnt).probe_mode==4; % 3x11   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;
                        m_data(3,1)=NaN;
                        m_data(78,1)=NaN;m_data(79,2)=NaN;m_data(80,3)=NaN;
                        m_data(79,1)=NaN;m_data(80,2)=NaN;
                        m_data(80,1)=NaN;
                        m_data(1,14)=NaN;m_data(1,15)=NaN;m_data(1,16)=NaN;
                        m_data(2,15)=NaN;m_data(2,16)=NaN;
                        m_data(3,16)=NaN;
                        m_data(80,14)=NaN;m_data(80,15)=NaN;m_data(80,16)=NaN;
                        m_data(79,15)=NaN;m_data(79,16)=NaN;
                        m_data(78,16)=NaN;
                    elseif info(p_cnt).probe_mode==5; % 3x10   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;
                        m_data(3,1)=NaN;
                        m_data(70,1)=NaN;m_data(71,2)=NaN;m_data(72,3)=NaN;
                        m_data(71,1)=NaN;m_data(72,2)=NaN;
                        m_data(72,1)=NaN;
                        m_data(1,14)=NaN;m_data(1,15)=NaN;m_data(1,16)=NaN;
                        m_data(2,15)=NaN;m_data(2,16)=NaN;
                        m_data(3,16)=NaN;
                        m_data(72,14)=NaN;m_data(72,15)=NaN;m_data(72,16)=NaN;
                        m_data(71,15)=NaN;m_data(71,16)=NaN;
                        m_data(70,16)=NaN;
                    end;
                    
                    %**** interrp ******
                    pos_x = interp2(interp2(interp2(m_pos_x)));
                    pos_y = interp2(interp2(interp2(m_pos_y)));
                    pos_z = interp2(interp2(interp2(m_pos_z)));

                    hb_map_h(p_cnt).map3d_suf = surface(pos_x,pos_y,pos_z,m_data,'EdgeColor','none');
                end;
            
            else;%call_flg == 1;
                if info(p_cnt).probe_mode==1;          % 3x3
                    m_data1 = interp2(m(:,1:5));
                    m_data2 = interp2(m(:,6:10));
                    m_data1 = interp2(m_data1);
                    m_data2 = interp2(m_data2);

                    pos_x1 = interp2(m_pos_x(:,1:3));
                    pos_y1 = interp2(m_pos_y(:,1:3));
                    pos_z1 = interp2(m_pos_z(:,1:3));
                    pos_x2 = interp2(m_pos_x(:,4:6));
                    pos_y2 = interp2(m_pos_y(:,4:6));
                    pos_z2 = interp2(m_pos_z(:,4:6));
                    pos_x1 = interp2(pos_x1);
                    pos_y1 = interp2(pos_y1);
                    pos_z1 = interp2(pos_z1);
                    pos_x2 = interp2(pos_x2);
                    pos_y2 = interp2(pos_y2);
                    pos_z2 = interp2(pos_z2);
                    pos_x1 = interp2(pos_x1);
                    pos_y1 = interp2(pos_y1);
                    pos_z1 = interp2(pos_z1);
                    pos_x2 = interp2(pos_x2);
                    pos_y2 = interp2(pos_y2);
                    pos_z2 = interp2(pos_z2);
                    
                    %*** Make NaN Area ****
                    m_data1(1,1)=NaN;m_data1(1,2)=NaN;m_data1(1,3)=NaN;
                    m_data1(2,1)=NaN;m_data1(2,2)=NaN;
                    m_data1(3,1)=NaN;
                    m_data1(14,1)=NaN;m_data1(15,1)=NaN;m_data1(16,1)=NaN;
                    m_data1(15,2)=NaN;m_data1(16,2)=NaN;
                    m_data1(16,3)=NaN;
                    m_data1(1,14)=NaN;m_data1(1,15)=NaN;m_data1(1,16)=NaN;
                    m_data1(2,15)=NaN;m_data1(1,16)=NaN;
                    m_data1(3,16)=NaN;
                    m_data1(1,14)=NaN;m_data1(1,15)=NaN;m_data1(1,16)=NaN;
                    m_data1(2,15)=NaN;m_data1(2,16)=NaN;
                    m_data1(3,16)=NaN;
                    m_data1(16,14)=NaN;m_data1(16,15)=NaN;m_data1(16,16)=NaN;
                    m_data1(15,15)=NaN;m_data1(15,16)=NaN;
                    m_data1(14,16)=NaN;

                    set(hb_map_h(p_cnt).map3d_suf1,...
                        'XData',pos_x1,...
                        'YData',pos_y1,...
                        'ZData',pos_z1,...
                        'CData',m_data1);
                    %*** Make NaN Area ****
                    m_data2(1,1)=NaN;m_data2(1,2)=NaN;m_data2(1,3)=NaN;
                    m_data2(2,1)=NaN;m_data2(2,2)=NaN;
                    m_data2(3,1)=NaN;
                    m_data2(14,1)=NaN;m_data2(15,1)=NaN;m_data2(16,1)=NaN;
                    m_data2(15,2)=NaN;m_data2(16,2)=NaN;
                    m_data2(16,3)=NaN;
                    m_data2(1,14)=NaN;m_data2(1,15)=NaN;m_data2(1,16)=NaN;
                    m_data2(2,15)=NaN;m_data2(1,16)=NaN;
                    m_data2(3,16)=NaN;
                    m_data2(1,14)=NaN;m_data2(1,15)=NaN;m_data2(1,16)=NaN;
                    m_data2(2,15)=NaN;m_data2(2,16)=NaN;
                    m_data2(3,16)=NaN;
                    m_data2(16,14)=NaN;m_data2(16,15)=NaN;m_data2(16,16)=NaN;
                    m_data2(15,15)=NaN;m_data2(15,16)=NaN;
                    m_data2(14,16)=NaN;

                    set(hb_map_h(p_cnt).map3d_suf2,...
                        'XData',pos_x2,...
                        'YData',pos_y2,...
                        'ZData',pos_z2,...
                        'CData',m_data2);
                else;
                    m_data = interp2(m);
                    m_data = interp2(m_data);

                    pos_x = interp2(m_pos_x);
                    pos_y = interp2(m_pos_y);
                    pos_z = interp2(m_pos_z);
                    pos_x = interp2(pos_x);
                    pos_y = interp2(pos_y);
                    pos_z = interp2(pos_z);
                    pos_x = interp2(pos_x);
                    pos_y = interp2(pos_y);
                    pos_z = interp2(pos_z);

                    %*** Make NaN Area ****
                    if info(p_cnt).probe_mode==2; % 4x4   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;m_data(1,4)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;m_data(2,3)=NaN;
                        m_data(3,1)=NaN;m_data(3,2)=NaN;
                        m_data(4,1)=NaN;
                        m_data(24,1)=NaN;m_data(24,2)=NaN;m_data(24,3)=NaN;m_data(24,4)=NaN;
                        m_data(23,1)=NaN;m_data(23,2)=NaN;m_data(23,3)=NaN;
                        m_data(22,1)=NaN;m_data(22,2)=NaN;
                        m_data(21,1)=NaN;
                        m_data(1,21)=NaN;m_data(1,22)=NaN;m_data(1,23)=NaN;m_data(1,24)=NaN;
                        m_data(2,22)=NaN;m_data(2,23)=NaN;m_data(2,24)=NaN;
                        m_data(3,23)=NaN;m_data(3,24)=NaN;
                        m_data(4,24)=NaN;
                        m_data(24,21)=NaN;m_data(24,22)=NaN;m_data(24,23)=NaN;m_data(24,24)=NaN;
                        m_data(23,22)=NaN;m_data(23,23)=NaN;m_data(23,24)=NaN;
                        m_data(22,23)=NaN;m_data(22,24)=NaN;
                        m_data(21,24)=NaN;
                    elseif info(p_cnt).probe_mode==3; % 3x5   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;
                        m_data(3,1)=NaN;
                        m_data(32,1)=NaN;m_data(32,2)=NaN;m_data(32,3)=NaN;
                        m_data(31,1)=NaN;m_data(31,2)=NaN;
                        m_data(30,1)=NaN;
                        m_data(1,14)=NaN;m_data(1,15)=NaN;m_data(1,16)=NaN;
                        m_data(2,15)=NaN;m_data(2,16)=NaN;
                        m_data(3,16)=NaN;
                        m_data(32,14)=NaN;m_data(32,15)=NaN;m_data(32,16)=NaN;
                        m_data(31,15)=NaN;m_data(31,16)=NaN;
                        m_data(30,16)=NaN;
                    elseif info(p_cnt).probe_mode==4; % 3x11   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;
                        m_data(3,1)=NaN;
                        m_data(78,1)=NaN;m_data(79,2)=NaN;m_data(80,3)=NaN;
                        m_data(79,1)=NaN;m_data(80,2)=NaN;
                        m_data(80,1)=NaN;
                        m_data(1,14)=NaN;m_data(1,15)=NaN;m_data(1,16)=NaN;
                        m_data(2,15)=NaN;m_data(2,16)=NaN;
                        m_data(3,16)=NaN;
                        m_data(80,14)=NaN;m_data(80,15)=NaN;m_data(80,16)=NaN;
                        m_data(79,15)=NaN;m_data(79,16)=NaN;
                        m_data(78,16)=NaN;
                    elseif info(p_cnt).probe_mode==5; % 3x10   
                        m_data(1,1)=NaN;m_data(1,2)=NaN;m_data(1,3)=NaN;
                        m_data(2,1)=NaN;m_data(2,2)=NaN;
                        m_data(3,1)=NaN;
                        m_data(70,1)=NaN;m_data(71,2)=NaN;m_data(72,3)=NaN;
                        m_data(71,1)=NaN;m_data(72,2)=NaN;
                        m_data(72,1)=NaN;
                        m_data(1,14)=NaN;m_data(1,15)=NaN;m_data(1,16)=NaN;
                        m_data(2,15)=NaN;m_data(2,16)=NaN;
                        m_data(3,16)=NaN;
                        m_data(72,14)=NaN;m_data(72,15)=NaN;m_data(72,16)=NaN;
                        m_data(71,15)=NaN;m_data(71,16)=NaN;
                        m_data(70,16)=NaN;
                    end;
                    set(hb_map_h(p_cnt).map3d_suf,...
                        'XData',pos_x,...
                        'YData',pos_y,...
                        'ZData',pos_z,...
                        'CData',m_data);
                end;
            end;

            caxis([hb_map_h(Sel_graph).topo3d_min hb_map_h(Sel_graph).topo3d_max]);

            hold off;
            box off;
            clear m;
        end;
    end;
    % color bar
    if call_flg == 0;
        hb_map_h(Sel_graph).map3d_col=colorbar;
        set(hb_map_h(Sel_graph).map3d_col,'Position',[0.89 0.1 0.03 0.4]);
        set(hb_map_h(Sel_graph).map3d_col,'FontSize',7);
    end;
    if move_stop ~= 1;
        if isfield(hb_map_h(Sel_graph).map3d,'stop') == 1;
            move_stop = get(hb_map_h(Sel_graph).map3d.stop,'Value');
        end;
        if move_stop == 1;
            break;
        end;

        if move_stop ~= 1;
            drawnow;
        end;
    end;

    if move_stop == 1;
        break;
    else;
        para.sel_point =para.sel_point+2;
        if para.sel_point > hb_graph_h(Sel_graph).time_max;
            para.sel_point = round(hb_graph_h(Sel_graph).time_min);
        end;
        set(hb_map_h(1).map3d.time,'String',para.sel_point*info(Sel_graph).smpl_period/1000);
    end;

    clear hb_map;clear m;

    fig_no=findobj('Type','figure');
    for cnt=1:length(fig_no);
        %***** raw ****
        if (fig_no(cnt) >= (12)) & (fig_no(cnt) <= (16));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
        end;
        %***** kl ****
        if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
        end;
        if (fig_no(cnt) == (80));
            obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
            set(obj,'Enable','off');
            %         obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
            %         set(obj,'Enable','on');
            obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText1');  % min
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','EditText2');  % max
            set(obj,'Enable','off');
            obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
            set(obj,'Enable','off');
        end;
    end;
end;

set(hb_map_h(Sel_graph).map3d.stop,'Value',0);
fig_no=findobj('Type','figure');
for cnt=1:length(fig_no);
    if (fig_no(cnt) >= (11)) & (fig_no(cnt) <= (16));
        obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
        set(obj,'Enable','on');
        set(obj,'Value',0);
        obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','EditText1');  % min
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','EditText2');  % max
        set(obj,'Enable','on');
    end;
    if (fig_no(cnt) >= (63)) & (fig_no(cnt) <= (67));
        obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','EditText1');  % min
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','EditText2');  % max
        set(obj,'Enable','on');
    end;
    if (fig_no(cnt) == (80));
        obj = findobj(fig_no(cnt),'tag','Pushbutton1');  % start
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','Pushbutton2');  % stop
        set(obj,'Enable','on');
        set(obj,'Value',0);
        obj = findobj(fig_no(cnt),'tag','Pushbutton3');  % refresh
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','EditText1');  % min
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','EditText2');  % max
        set(obj,'Enable','on');
        obj = findobj(fig_no(cnt),'tag','Checkbox1');  % oxy,deoxy,total
        set(obj,'Enable','on');
    end;
end;

clear cnt;
move_stop = 1;
return;
