% set_angle
%
% Input  : info,para_p
% Output : info,para_p
% Example: [info,para_p] = set_angle(info,para_p); 

%*******************************************************
%*               Plot Hb Graph Function                *
%*                   Hiroaki Kusabuka                  *
%*                  HITACHI MECICAL                    *
%*******************************************************
% History:04.12.24 Ver1.00  Kusabuka  Probe angle set

function [para_p] = set_angle(info,para_p); 
%fprintf('set_angle\n');
data_cnt=0;
for p_cnt=1:para_p.max_prb;
   if (p_cnt==1 & para_p.load_prb1 ==1 ) | (p_cnt==2 & para_p.load_prb2 ==1) | (p_cnt==3 & para_p.load_prb3 ==1) | (p_cnt==4 & para_p.load_prb4 ==1) | (p_cnt==5 & para_p.load_prb5 ==1);
       data_cnt=data_cnt+1;
   end;
end;
wind_size=77*5+10+20;
data_cnt=5;

set_fig = figure(74);
clf reset;
plotedit(set_fig,'hidetoolsmenu');
set(set_fig,'Name',sprintf('Angle Set'),'ToolBar','none','Resize','on');
set(set_fig,'Position',[50 150 150 wind_size]);

xposi=30;
%yposi=360;
yposi=70;
xsize=40;
ysize=15;

uicontrol('Parent',set_fig,...
          'Position',[40 wind_size-10 80 11],...
          'BackgroundColor',[0.8 0.8 0.8],...
          'Style','text',...
          'String','Angle Set',...
          'Tag','tag1');

count=1;
d_cnt=data_cnt;              
for p_cnt=para_p.max_prb:-1:1;	% Probe loop
   Sel_graph=p_cnt;
   %****** Frame ********
   uicontrol('Parent',set_fig,...
             'Units','points',...
             'BackgroundColor',[0.75 0.75 0.75],...
             'Position',[xposi-15 (55*(data_cnt))-55*(d_cnt)+2*count+18 xsize+45 53],...
             'Style','frame');

   str=sprintf('%s%d %s','probe',p_cnt,'none');
   if (p_cnt==1);
      if para_p.load_prb1~=0;
         if info(p_cnt).probe_mode == 1; % 3x3
            str=sprintf('%s%d %s','probe',p_cnt,'3x3');
         elseif info(p_cnt).probe_mode == 2; % 4x4
            str=sprintf('%s%d %s','probe',p_cnt,'4x4');
         elseif info(p_cnt).probe_mode == 4; % 3x11
            str=sprintf('%s%d %s','probe',p_cnt,'3x11');
         elseif info(p_cnt).probe_mode == 5; % 3x10
            str=sprintf('%s%d %s','probe',p_cnt,'3x10');
         else; % probe_mod:3 3x5
            str=sprintf('%s%d %s','probe',p_cnt,'3x5');
         end;
      end;
   elseif (p_cnt==2);
      if para_p.load_prb2~=0;
         if info(p_cnt).probe_mode == 1; % 3x3
            str=sprintf('%s%d %s','probe',p_cnt,'3x3');
         elseif info(p_cnt).probe_mode == 2; % 4x4
            str=sprintf('%s%d %s','probe',p_cnt,'4x4');
         elseif info(p_cnt).probe_mode == 4; % 3x11
            str=sprintf('%s%d %s','probe',p_cnt,'3x11');
         elseif info(p_cnt).probe_mode == 5; % 3x10
            str=sprintf('%s%d %s','probe',p_cnt,'3x10');
         else; % probe_mod:3 3x5
            str=sprintf('%s%d %s','probe',p_cnt,'3x5');
         end;
      end;
   elseif (p_cnt==3);
      if para_p.load_prb3~=0;
         if info(p_cnt).probe_mode == 1; % 3x3
            str=sprintf('%s%d %s','probe',p_cnt,'3x3');
         elseif info(p_cnt).probe_mode == 2; % 4x4
            str=sprintf('%s%d %s','probe',p_cnt,'4x4');
         elseif info(p_cnt).probe_mode == 4; % 3x11
            str=sprintf('%s%d %s','probe',p_cnt,'3x11');
         elseif info(p_cnt).probe_mode == 5; % 3x10
            str=sprintf('%s%d %s','probe',p_cnt,'3x10');
         else; % probe_mod:3 3x5
            str=sprintf('%s%d %s','probe',p_cnt,'3x5');
         end;
      end;
   elseif (p_cnt==4);
      if para_p.load_prb4~=0;
         if info(p_cnt).probe_mode == 1; % 3x3
            str=sprintf('%s%d %s','probe',p_cnt,'3x3');
         elseif info(p_cnt).probe_mode == 2; % 4x4
            str=sprintf('%s%d %s','probe',p_cnt,'4x4');
         elseif info(p_cnt).probe_mode == 4; % 3x11
            str=sprintf('%s%d %s','probe',p_cnt,'3x11');
         elseif info(p_cnt).probe_mode == 5; % 3x10
            str=sprintf('%s%d %s','probe',p_cnt,'3x10');
         else; % probe_mod:3 3x5
            str=sprintf('%s%d %s','probe',p_cnt,'3x5');
         end;
      end;
   else;                                  %(p_cnt==5);
      if para_p.load_prb5~=0;
         if info(p_cnt).probe_mode == 1; % 3x3
            str=sprintf('%s%d %s','probe',p_cnt,'3x3');
         elseif info(p_cnt).probe_mode == 2; % 4x4
            str=sprintf('%s%d %s','probe',p_cnt,'4x4');
         elseif info(p_cnt).probe_mode == 4; % 3x11
            str=sprintf('%s%d %s','probe',p_cnt,'3x11');
         elseif info(p_cnt).probe_mode == 5; % 3x10
            str=sprintf('%s%d %s','probe',p_cnt,'3x10');
         else; % probe_mod:3 3x5
            str=sprintf('%s%d %s','probe',p_cnt,'3x5');
         end;
      end;
   end;
   %************ angle Probe1 ***************
   uicontrol('Parent',set_fig,...
             'Position',[xposi+15 (81*(data_cnt))-80*(d_cnt-1)-4*count xsize+25 15],...
             'BackgroundColor',[0.75 0.75 0.75], ...
             'Style','text',...
             'String',str,...
             'Tag','tag1');

   if (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) | (p_cnt==4 & para_p.load_prb4 ~=1) | (p_cnt==5 & para_p.load_prb5 ~=1);
   else;
      Sel_graph = p_cnt;
      %************************************* 
      %*                                   *
      %************************************* 

      %****** Mode ********
      if info(p_cnt).probe_mode == 1; % 3x3
         %************ left ***************
         str=sprintf('Ch1-12');
         uicontrol('Parent',set_fig,...
                   'Position',[xposi-5  (76*(data_cnt))-80*(d_cnt-1)-4*count xsize+5 ysize],...
                   'BackgroundColor',[0.75 0.75 0.75], ...
                   'Style','text',...
                   'String',str,...
                   'Tag','tag1');
         %************ right ***************
         str=sprintf('Ch13-24');
         uicontrol('Parent',set_fig,...
                   'Position',[xposi-5  (72*(data_cnt))-80*(d_cnt-1)-4*count xsize+5 ysize],...
                   'BackgroundColor',[0.75 0.75 0.75], ...
                   'Style','text',...
                    'String',str,...
                           'Tag','tag1');
      %****** 3x5,4x4,3x11 *******
      else;
         if info(p_cnt).probe_mode == 2;     % 4x4
            str=sprintf('Ch1-24');
         elseif info(p_cnt).probe_mode == 4; % 3x11
            str=sprintf('Ch1-52');
         elseif info(p_cnt).probe_mode == 5; % 3x10
            str=sprintf('Ch1-47');
         else;                               % probe_mod:3 3x5
            str=sprintf('Ch1-22');
         end;
         %************  ***************
         uicontrol('Parent',set_fig,...
                           'Position',[xposi-5  (75*(data_cnt))-80*(d_cnt-1)-4*count xsize+5 ysize],...
                           'BackgroundColor',[0.75 0.75 0.75], ...
	                        'Style','text',...
                           'String',str,...
	                        'Tag','tag1');
       end;
   end;
   d_cnt=d_cnt-1;
   count=count+1;
end;

for p_cnt=1:para_p.max_prb;	% Probe loop
   if (p_cnt==1 & para_p.load_prb1 ~=1 ) | (p_cnt==2 & para_p.load_prb2 ~=1) | (p_cnt==3 & para_p.load_prb3 ~=1) | (p_cnt==4 & para_p.load_prb4 ~=1) | (p_cnt==5 & para_p.load_prb5 ~=1);
   else;
      if info(p_cnt).probe_mode == 1; % 3x3
         if p_cnt == 1 & para_p.sel_prb1~=0 & para_p.load_prb1~=0;
            %****** Ch1-12 Pull Menu *********
            para_p.angle(1).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 270 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(1).angle1,...
                          'Callback',['para_p.angle(1).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu1a');
%                          'Position',[25+34 (58*(data_cnt))-61*(d_cnt-1)-4*count xsize-5 ysize],...
            %****** Ch13-24 Pull Menu *********
            para_p.angle(1).ch_b = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 253 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(1).angle2,...
                          'Callback',['para_p.angle(1).angle2_w=get(gcbo,''value'');'],...
                          'Tag','menu1b');
%                          'Position',[25+34 (57*(data_cnt))-61*(d_cnt-1)-4*count xsize-5 ysize],...
         end;
         if p_cnt == 2 & para_p.sel_prb2~=0 & para_p.load_prb2~=0;
            %****** Ch1-12 Pull Menu *********
            para_p.angle(2).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 213 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(2).angle1,...
                          'Callback',['para_p.angle(2).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu2a');
            %****** Ch13-24 Pull Menu *********
            para_p.angle(2).ch_b = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 196 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(2).angle2,...
                          'Callback',['para_p.angle(2).angle2_w=get(gcbo,''value'');'],...
                          'Tag','menu2b');
         end;
         if p_cnt == 3 & para_p.sel_prb3~=0 & para_p.load_prb3~=0;
            %****** Ch1-12 Pull Menu *********
            para_p.angle(3).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 157 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(3).angle1,...
                          'Callback',['para_p.angle(3).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu3a');
            %****** Ch13-24 Pull Menu *********
            para_p.angle(3).ch_b = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 140 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(3).angle2,...
                          'Callback',['para_p.angle(3).angle2_w=get(gcbo,''value'');'],...
                          'Tag','menu3b');
         end;
         if p_cnt == 4 & para_p.sel_prb4~=0 & para_p.load_prb4~=0;
            %****** Ch1-12 Pull Menu *********
            para_p.angle(4).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 100 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(4).angle1,...
                          'Callback',['para_p.angle(4).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu4a');
            %****** Ch13-24 Pull Menu *********
            para_p.angle(4).ch_b = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 83 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(4).angle2,...
                          'Callback',['para_p.angle(4).angle2_w=get(gcbo,''value'');'],...
                          'Tag','menu4b');
         end;
         if p_cnt == 5 & para_p.sel_prb5~=0 & para_p.load_prb5~=0;
            %****** Ch1-12 Pull Menu *********
            para_p.angle(5).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 42 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(5).angle1,...
                          'Callback',['para_p.angle(5).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu5a');
            %****** Ch13-24 Pull Menu *********
            para_p.angle(5).ch_b = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 25 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(5).angle2,...
                          'Callback',['para_p.angle(5).angle2_w=get(gcbo,''value'');'],...
                          'Tag','menu5b');
         end;
      else;
         %****** 3x5,4x4,3x11 *******
         %****** Pull Menu *********
         if p_cnt == 1 & para_p.sel_prb1~=0 & para_p.load_prb1~=0;
            para_p.angle(1).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 265 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(1).angle1,...
                          'Callback',['para_p.angle(1).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu1');
         end;
         if p_cnt == 2 & para_p.sel_prb2~=0 & para_p.load_prb2~=0;
            para_p.angle(2).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 208 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(2).angle1,...
                          'Callback',['para_p.angle(2).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu2');
         end;
         if p_cnt == 3 & para_p.sel_prb3~=0 & para_p.load_prb3~=0;
            para_p.angle(3).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 150 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(3).angle1,...
                          'Callback',['para_p.angle(3).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu3');
         end;
         if p_cnt == 4 & para_p.sel_prb4~=0 & para_p.load_prb4~=0;
            para_p.angle(4).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 94 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(4).angle1,...
                          'Callback',['para_p.angle(4).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu4');
         end;
         if p_cnt == 5 & para_p.sel_prb5~=0 & para_p.load_prb5~=0;
            para_p.angle(5).ch_a = uicontrol('Parent',set_fig, ...
                          'Units','points',...
                          'Position',[59 37 35 15],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['0  ';'90 ';'180';'270'],...
                          'Style','popupmenu',...
                          'Value',para_p.angle(5).angle1,...
                          'Callback',['para_p.angle(5).angle1_w=get(gcbo,''value'');'],...
                          'Tag','menu5');
         end;
      end;
   end;
end;

uicontrol('Parent',74,...
               'Units','points',...
               'Position',[65 2 35 15],...
               'BackgroundColor',[0.75 0.75 0.75], ...               
               'Style','pushbutton',...
               'String','Set',...
               'Callback',['if move_stop == 1;',...
                              'if isfield(para_p.angle,''angle1_w'') == 1;',...
                                 'if (length(para_p.angle(1).angle1_w)>0);',...
                                    'para_p.angle(1).angle1=para_p.angle(1).angle1_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(2).angle1_w)>0);',...
                                    'para_p.angle(2).angle1=para_p.angle(2).angle1_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(3).angle1_w)>0);',...
                                    'para_p.angle(3).angle1=para_p.angle(3).angle1_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(4).angle1_w)>0);',...
                                    'para_p.angle(4).angle1=para_p.angle(4).angle1_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(5).angle1_w)>0);',...
                                   'para_p.angle(5).angle1=para_p.angle(5).angle1_w;',...
                                 'end;',...
                              'end;',...
                              'if isfield(para_p.angle,''angle2_w'') == 1;',...
                                 'if (length(para_p.angle(1).angle1_w)>0);',...
                                    'para_p.angle(1).angle2=para_p.angle(1).angle2_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(2).angle1_w)>0);',...
                                    'para_p.angle(2).angle2=para_p.angle(2).angle2_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(3).angle1_w)>0);',...
                                    'para_p.angle(3).angle2=para_p.angle(3).angle2_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(4).angle1_w)>0);',...
                                    'para_p.angle(4).angle2=para_p.angle(4).angle2_w;',...
                                 'end;',...
                                 'if (length(para_p.angle(5).angle1_w)>0);',...
                                    'para_p.angle(5).angle2=para_p.angle(5).angle2_w;',...
                                 'end;',...
                              'end;',...
                              'if isfield(para_p.angle,''angle1_w'') == 1;',...
                                 'rmfield(para_p.angle,''angle1_w'');',...
                              'end;',...
                              'if isfield(para_p.angle,''angle2_w'') == 1;',...
                                 'rmfield(para_p.angle,''angle2_w'');',...
                              'end;',...
                              'del_fig(7,72);',...
                              'del_fig(74,74);',...  % angle
                              'del_fig(75,89);',...  % spect
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;',...
                          ],... 
               'Tag','Ok_button');
uicontrol('Parent',74,...
               'Units','points',...
               'Position',[15 2 35 15],...
               'BackgroundColor',[0.75 0.75 0.75], ...               
               'Style','pushbutton',...
               'String','Close',...
               'Callback',['del_fig(74,74);',...
                           'if isfield(para_p.angle,''angle1_w'') == 1;',...
                              'rmfield(para_p.angle,''angle1_w'');',...
                           'end;',...
                           'if isfield(para_p.angle,''angle2_w'') == 1;',...
                              'rmfield(para_p.angle,''angle2_w'');',...
                           'end;',...
                          ],... 
               'Tag','Can_button');


