% show_info
%
% Input  : info
% Output : none
% Example: show_info(MainFigure,info,para_p,dis_no);

%*******************************************************
%*             Topo Volt Data Load Function            *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% historyF02.11.11 Ver1.01  futahashi	KL A conversion function is added.
% historyF03.05.06 Ver2.00  Isawa@		A display is changed at sec from  point.
% historyF03.05.06 Ver2.01  Kusabuka	Many Probe read


function show_info(MainFigure,info,para_p,dis_no); 

% Control reference point
pos_left = 10;
pos_top  = 60;

%fprintf('show_info dis_no=%d,\n',dis_no);
% Frame
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[0.75 0.75 0.75], ...
              'Position',[pos_left pos_top 225 220],...
              'Style','frame',...
              'Tag','Frame1');

%****** File Ver *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5.75 pos_top+193.75 45 19.5],...
               'String','File Version',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...	
               'Position',[pos_left+57.5 pos_top+194.75 161.25 15],...
               'String', info(dis_no).version,...
               'Style','text',...
               'Tag','EditText1');

%****** ID *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...	
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+172.75 45 15],...
               'String','ID',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...	
               'Position',[pos_left+57.5 pos_top+175.75 161.25 15],...
               'String', info(dis_no).id,...
               'Style','text',...
               'Tag','EditText1');
%               'String', info(dis_no).id(1:(length(info(dis_no).id)-6)),...
%****** Name *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...	
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+155.75 45 15],...
               'String','Name',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...	
               'Position',[pos_left+57.5 pos_top+155.75 161.25 15],...
               'String', info(dis_no).name,...
               'Style','text',...
               'Tag','EditText1');
%               'String', info(dis_no).name(1:(length(info(dis_no).name)-8)),...
%****** Comment *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+135.75 45 15],...
               'String','Comment',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+57.5 pos_top+122.75 161.25 27],...
               'HorizontalAlignment','left',...
               'String', info(dis_no).comment,...
               'Style','text',...
               'Tag','EditText1');
%               'String', info(dis_no).comment(1:(length(info(dis_no).comment)-11)),...
%****** Sex *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+100.75 45 15],...
               'String','Sex',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+57.5 pos_top+101.75 49.5 15],...
               'String', info(dis_no).sex,...
               'Style','text',...
               'Tag','EditText1');

%****** Age *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+117.5 pos_top+101.75 45 15],...
               'String','Age',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+155 pos_top+101.75 63.25 15],...
               'String', info(dis_no).age,...
               'Style','text',...
               'Tag','EditText1');
%               'Position',[pos_left+159.25 pos_top+101.75 59.5 15],...

%****** Date *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+80.75 45 15],...
               'String','Date',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+57.5 pos_top+80 161.25 15],...
               'String', info(dis_no).date,...
               'Style','text',...
               'Tag','EditText1');
%               'String', info(dis_no).date(1:(length(info(dis_no).date)-9)),...

%****** Probe Mode *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+57 46 20],...
               'String','Probe Mode',...
               'Style','text',...
               'Tag','StaticText1');

% '0' is the display at the time of main screen creation.

if info(dis_no).probe_mode==0;dum='';end; 
if info(dis_no).probe_mode==1;dum='3*3';end;
if info(dis_no).probe_mode==2;dum='4*4';end;
if info(dis_no).probe_mode==3;dum='3*5';end;
if info(dis_no).probe_mode==4;dum='3*11';end;
if info(dis_no).probe_mode==5;dum='3*10';end;

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+57.5 pos_top+59.75 49.5 15],...
               'String',dum,...
               'Style','text',...
               'Tag','EditText1');
   
%****** Measure Mode *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+117.5 pos_top+57 45 19.5],...
               'String','Measure Mode',...
               'Style','text',...
               'Tag','StaticText1');

% '0' is the display at the time of main screen creation.
if info(dis_no).measure_mode(1)==0;dum='';end;
if info(dis_no).measure_mode(1)==1;dum='Stim';end;
if info(dis_no).measure_mode(1)==2;dum='Event';end;

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+169.25 pos_top+59.75 49.5 15],...
               'String',dum,...
               'Style','text',...
               'Tag','EditText1');   

%****** Sampling rate *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+36.25 45 19.5],...
               'String','Sampling Rate',...
               'Style','text',...
               'Tag','StaticText1');

h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+57.5 pos_top+38.75 161.25 15],...
               'String', [[int2str(info(dis_no).smpl_period),'[ms/point] : '],[int2str(1000./info(dis_no).smpl_period),'[Hz]']],...
               'Style','text',...
               'Tag','EditText1');

%****** Total point *********
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.75 0.75 0.75], ...
               'Position',[pos_left+5 pos_top+16.25 45 15],...
               'String','Data Num',...
               'Style','text',...
               'Tag','StaticText1');

%**   The number of data is changed from a point at time. **
%**   'String', [int2str(info.datanum),'[point]'],...					**
%**   'String', [int2str(info.datanum*info.smpl_period/1000),'[s]'],...	**
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[1 1 1],...
               'Position',[pos_left+57.5 pos_top+16.75 161.25 15],...
               'String', [num2str(info(dis_no).datanum*info(dis_no).smpl_period/1000),'[s]'],...
               'Style','text',...
               'Tag','EditText1');
