% topo
%
% Input  : none
% Output : none
% Example: topo

%*******************************************************
%*                     Topo Main                       *
%*                   Shingo Kawasaki                   *
%*                  HITACHI MECICAL                    *
%*******************************************************
% history?F02.11.11 Ver1.01  futahashi	KL A conversion function is added.
%          02.11.27 Ver 1.01 Kawasaki 	 4*4 Mode add
%          03.03.03 Ver 1.02 futahashi 	 File version4.03 Correspondence
%          03.04.14 Ver 1.03 Kawasaki 	 3*5 Mode add
%          03.04.23 Ver 2.00 Isawa		 ETG7000 Correspondence
%          03.10.26 Ver 2.01 Kawasaki	 calc_int Analysis improvement in the speed
%          03.11.04 Ver 2.01 Kusabuka    ETG4000 data correspondence multi probe
%          04.02.04 Ver 2.02 Kusabuka    3x11,ana data load
%          04.10.28 Ver 2.03 Kusabuka    Matlab Ver7.0.1
%          04.11.12 Ver 2.04 Kusabuka    PCA Package
%          06.06.28 Ver 2.05 Kusabuka    mark check bugu

% The clearance of a variable, and a figure delete
clear;
close all;

%fprintf('topo_m\n');
% The constant definition in the mode
MOD_INIT = 0;									% At the time of the first stage
MOD_LOAD = 1;									% After a data load
MOD_HB   = 2;									% After a Hb_graph display
Sel_graph= 1;
dis_no = 1;
move_stop=1;                           % move_stop init
kl_flg=0;                              % kl start
mode_err=0;                            % position read
% The present mode is set up.
Mode = MOD_INIT;

%************** Title ************
scrsz = get(0,'ScreenSize');

% the handle of a main screen -- acquisition - it holds as global
figureBKcolor=get(0,'Defaultuicontrolbackgroundcolor');
MainFigure = figure('Color',figureBKcolor,'defaultuicontrolBackgroundColor', figureBKcolor,...
                    'Name','TSP',...
                    'PaperPosition',[18 180 576 432], ...
                    'PaperUnits','points', ...
                    'Position',[scrsz(1)+5 scrsz(4)-500-40 800 500 ], ...
                    'Resize','on',...
                    'Tag','Welcome',...
                    'ToolBar','none');
                    plotedit(MainFigure,'hidetoolsmenu');
set(MainFigure,'DeleteFcn','del_fig(2,90);clear all;');


% Title display
h1 = axes('Parent',MainFigure,'Position',[0 0 1 1],'Visible','Off');
text(0.43,0.93,...
     'xTopo Signal Processing',...
     'Parent',h1,...
     'FontName','Times New Roman',...
     'FontAngle','Italic','FontWeight','Bold',...
     'FontSize',50,...
     'VerticalAlignment','Middle','HorizontalAlignment','Center',...
     'Rotation',0,...
     'Color',[0 0 1]*0.6);

text(0.65,0.8,...
     'by HITACHI and Xu Cui',...
     'Parent',h1,...
     'FontAngle','Italic','FontWeight','Bold',...
     'FontSize',36,...
     'VerticalAlignment','Middle','HorizontalAlignment','Center',...
     'Rotation',0,...
     'Color',[1 1 1]*0.6);

% Version information
text(0.92,0.88,...
     'Ver2.08 ',...
     'Parent',h1,...
     'FontAngle','Italic','FontWeight','Bold',...
     'FontSize',20,...
     'VerticalAlignment','Middle','HorizontalAlignment','Center',...
     'Rotation',0,...
     'Color',[1 1 1]*0.6);

% Dummy information is created and initial control is displayed.
info = struct('file_name',{'','','','',''},'version',{'','','','',''},'id',{'','','','',''},'name',{'','','','',''},'comment',{'','','','',''},'age',{'','','','',''},'sex',{'','','','',''},'probe_mode',{0,0,0,0,0},'measure_mode',{0,0,0,0,0},'date',{'','','','',''},'adnmpn',{'','','','',''},'wlen',{'','','','',''},'adrng',{'','','','',''},'amprng',{'','','','',''},'ampset',{'','','','',''},'smpl_period',{'','','','',''},'datanum',{'','','','',''},'sel_ch',{1,1,1,1,1});
info(1).flg=0;
para_p.sel_prb1=0;para_p.sel_prb2=0;para_p.sel_prb3=0;para_p.sel_prb4=0;para_p.sel_prb5=0;para_p.max_prb=0;
para_p.load_prb1=0;para_p.load_prb2=0;para_p.load_prb3=0;para_p.load_prb4=0;para_p.load_prb5=0;para_p.max_prb=0;
para_p.cal_flg1=0;para_p.cal_flg2=0;para_p.cal_flg3=0;para_p.cal_flg4=0;para_p.cal_flg5=0;
para_p.del_ch=0;
para_p.sel_fsize=3;
para_p.fsize=8;
para_p.angle= struct('angle1',{1,1,1,1,1},'angle2',{1,1,1,1,1});
show_info(MainFigure,info,para_p,dis_no);
mark.num = 0;mark.point = 0;mark.ave = 0;mark.char = '';
input_para;
%paramater_image;

ad_data = struct('raw',{'','','','',''});
para_h.mark_sel=1;para_h.mark_p=0;

% Control reference point
pos_left = 10;
pos_top  = 10;
% Frame
h = uicontrol('Parent',MainFigure,...
              'Units','points',...
              'BackgroundColor',[0.8 0.8 0.8], ...
              'Position',[400 pos_top 190 40],...
              'Style','frame',...
              'Tag','Frame1');

%% DataLoad Button
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[128/255 255/255 255/255], ...
               'FontSize',13,...
               'Position',[pos_left+400 pos_top+7 70 26],...
               'String','Data Load',...
               'Callback',['if move_stop == 1;',...
                              'move_stop=1;',...
                              'set(main_h.hb3,''Visible'',''off'');',...
                              'OnDataLoad;',...
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],...
               'Tag','Pushbutton1'); 

% EXIT Button
h1 = uicontrol('Parent',MainFigure,...
               'Units','points',...
               'BackgroundColor',[0.8 0.8 0.8], ...
               'FontSize',13,...
               'Position',[pos_left+500 pos_top+7 70 26],...
               'String','Exit',...
               'Callback',['if move_stop ==1;',...
                               'move_stop=1;',...
                               'close(1);clear all;',...
                           'else;',...
                               'warndlg(''Please push a stop button.'',''Warning !!'');',...
                           'end;'],... 
               'Tag','Pushbutton3');

% graph font size
h1=uicontrol('Parent',MainFigure,...
               'Position',[10 30 85 10],...
               'BackgroundColor',[0.8 0.8 0.8], ...
               'Style','text',...
               'String','Graph Fontsize',...
               'Tag','fsize');
            
h1 = uicontrol('Parent',MainFigure, ...
                          'Units','points',...
                          'Position',[10 10 30 10],...
                          'BackgroundColor',[1 1 1],...   
                          'String',['4 ';'6 ';'8 ';'10';'12'],...
                          'Style','popupmenu',...
                          'Value',para_p.sel_fsize,...
                          'Callback',['para_p.sel_fsize=get(gcbo,''value'');',...
                                      'if para_p.sel_fsize == 1;para_p.fsize= 4;end;',...
                                      'if para_p.sel_fsize == 2;para_p.fsize= 6;end;',...
                                      'if para_p.sel_fsize == 3;para_p.fsize= 8;end;',...
                                      'if para_p.sel_fsize == 4;para_p.fsize=10;end;',...
                                      'if para_p.sel_fsize == 5;para_p.fsize=12;end;',...
                                      ],...
                          'Tag','menu1a');
           
                         
clear h;clear h1;
clear pos_left;clear pos_top
clear scrsz;

